<?php
/*
Plugin Name: Access Members
Description: Mit Access Member erstellen Sie professionell designte Online-Kurse. Lektionen anlegen und zu einem Produkt zusammenstellen. Fertig. Jetzt auch mit komplettem E-Mail-Marketing System.
Version: 2.1.24
Author: Erfolgs-Faktor
Text Domain: am
*/

// Make sure we don't expose any info if called directly
if ( !function_exists( 'add_action' ) ) {
    echo "Hi there!  I'm just a plugin, not much I can do when called directly.";
    exit;
}
error_reporting(E_ERROR);
define( 'AM_PLUGIN_NAME', __( 'Access Members', 'am' ) );
define( 'AM_PLUGIN_VERSION', '2.1.24' );
define( 'AM_PLUGIN_PATH', plugin_dir_path(__FILE__) );
define( 'AM_PLUGIN_URL', plugin_dir_url(__FILE__) );
define( 'AM_SITE_BASE_URL',get_bloginfo('url'));
define( 'AM_LICENSE_URL','https://accessmember.de');
define( 'AM_LANG_DIR', dirname( plugin_basename(__FILE__) ).'/languages/' );
define( 'AM_LICENSE_KEY_PARENT_URL','https://www.accessmember.de');

require_once AM_PLUGIN_PATH.'includes/ds24_api.php';
require_once AM_PLUGIN_PATH.'includes/am_class.php';
require_once AM_PLUGIN_PATH.'am_admin.php';
require_once AM_PLUGIN_PATH.'includes/plugin-update-checker/plugin-update-checker.php';
//require_once home_url().'/wp-load.php';

$update_checker = PucFactory::buildUpdateChecker(
    AM_LICENSE_URL.'/?am_get_update=yes&key='.AM_LICENSE_KEY.'&web='.AM_SITE_BASE_URL.'&version='.AM_PLUGIN_VERSION,
    __FILE__,
    'access_members'
);

register_activation_hook( __FILE__, array( 'AM', 'am_install' ) );
register_deactivation_hook( __FILE__, array( 'AM', 'am_uninstall' ) );



function allow_nbsp_in_tinymce( $mceInit ) {
    $mceInit['entities'] = '160,nbsp,38,amp,60,lt,62,gt';   
    $mceInit['entity_encoding'] = 'named';
    return $mceInit;
}
add_filter( 'tiny_mce_before_init', 'allow_nbsp_in_tinymce' );


//Function for Removing Admin Bar 
add_action('init', 'remove_admin_bar');

function remove_admin_bar() {
	 if (!current_user_can('administrator') && !is_admin()) {
	  show_admin_bar(false);
	}
}



//////////////////////////////////////////////////////////////////////
/////////***** Custom Login Functions **********************//////////
//////////////////////////////////////////////////////////////////////

add_action('login_headerurl', 'access_member_login_url',9999);
function access_member_login_url()
{
	return home_url();
}


add_filter('login_headertitle', 'access_member_login_text',9999);
function access_member_login_text()
{
	return get_bloginfo();
}


// add_filter('login_headertitle', 'convert_to_csv',9999);
function convert_to_csv($input_array, $output_file_name, $delimiter){
	
    //open raw memory as file, no need for temp files, be careful not to run out of memory thought 
    $f = fopen('php://memory', 'w');
    //loop through array  /
    foreach ($input_array as $line) {
        //default php csv handler /
        fputcsv($f, $line, $delimiter);
    }
    //rewrind the "file" with the csv lines /
    fseek($f, 0);

    //modify header to be downloadable csv file /
    header('Content-Type: application/csv');
	header("Content-Transfer-Encoding: UTF-8");
    header('Content-Disposition: attachement; filename="' . $output_file_name . '";');
    //Send file to browser for download /
    $through =   fpassthru($f);
    fclose($f);
	return ob_get_clean();
}


//add new theme on wp-login.php
add_action('login_enqueue_scripts', 'access_member_login_custom_style');
function access_member_login_custom_style()
{
	echo '<link rel="stylesheet" type="text/css" href="' . plugins_url('access_members/css/Custom_login.css', dirname(__FILE__)) . '" />';
}


//////////////////////////////////////////////////////////////////////
/////////***** End Custom Login Functions **********************//////
//////////////////////////////////////////////////////////////////////



if(isset($_GET['export_csv'])){
	
	//ob_start();
	 ob_end_clean();
	
	$final_array = array();
	$header_row = array();
	$header_row[] = 'Name';
	$header_row[] = 'Email Address';   
	$header_row[] = 'Created Date';   
	$final_array[]= $header_row;
	
	//Get All newsletter Contacts
			 global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE 1=1";
        $contacts_arr  = $wpdb->get_results($sql);
	
	//str_get_html();
    $ID=1; 
	if(count($contacts_arr)!=''){
		
		foreach($contacts_arr as $key=>$value){   
			$temp_array=array();  
			$temp_array[] = $value->name;
			$temp_array[] = $value->email_address;	
			$temp_array[] = date("d/m/Y", strtotime($value->created_date));
			$final_array[]= $temp_array;
			$ID++;  
		}//foreach
				
	}//End if
$contactlist  = 'contactlist.csv';
convert_to_csv($final_array, $contactlist, ',');     
die();
}





/**********Start of Added By Asif 13 March 2017 ********/

if($_GET['action'] == 'am_optin_form_save' && $_GET['form_id'] != '')
{
	
	global $wpdb;
	$sql    = "SELECT * FROM `".$wpdb->prefix."am_contacts`";
	$results=$wpdb->get_results($sql);
	$contact_count=count($results);
	$am_lincense_key=constant('AM_LICENSE_KEY'); 
			
			
			
	if(empty($am_lincense_key) && $contact_count>=500)
	{
		$redirecturl = home_url();
		print('<script>window.location.href="'.$redirecturl.'"</script>');
		exit;
		
	}
	
	$token	=	$am->generateToken();
	
	$optin_id		=	$_GET['form_id'];
	$encode_optionid	=	base64_encode($optin_id);
	$contact_name	=	$_POST['contact_name'];
	$email_address	=	$_POST['email_address'];
	$refferal_url	=	 $_SERVER['HTTP_REFERER'];
	
	$optin_form_arr 		=	$am->am_get_optin_form($optin_id);
	$formtags				=	$optin_form_arr->tags;
	$form_redirect_page_id	=	$optin_form_arr->form_redirect_page_id;
	$optin_confirmation		=	$optin_form_arr->optin_confirmation;
	$email_redirect_page_id	=	$optin_form_arr->email_redirect_page_id;
	$mail_content			=	$optin_form_arr->mail_content;
	$company_name			=	$optin_form_arr->company_name;
	$from_name			    =	$optin_form_arr->from_name;
	$from_email			    =	$optin_form_arr->from_email;
	$address				=	$optin_form_arr->address;
	$subject				=	$optin_form_arr->subject;
	$created_date			=	date("Y-m-d H:i:s");
	$ip_address = get_ip_address();
	$ip_data=explode(".",$ip_address);

	$ip_data[count($ip_data)-1]="00";

	$ip_address="";

	foreach($ip_data as $ipdata)
	{
		$ip_address.=$ipdata.".";

	}

	$ip_address=rtrim($ip_address,".");
	
	
	
	
	
	
	if($optin_confirmation == 1){
		$status = 1;
	}else{
		$status = 0;
	}
	
	//Check No-Of Allowed Contacts
	$isExist=0;
	$allowed_contacts = $am->check_no_of_allowed_contacts();
	if($allowed_contacts =='yes'){
	
	$checkemails = $wpdb->get_row("SELECT id,tags,optin_form_id FROM `".$wpdb->prefix."am_contacts` WHERE email_address = '".$email_address."'");
	
	if(count($checkemails) == 0){
		
		$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` (`token`,`name`,`email_address`,`tags`,`optin_form_id`,`status`,`confirmed_date`,`created_date`,`created_by_ip`,`refferal_url`) VALUES ('".$token."','".$contact_name."', '".$email_address."' , '".$formtags."', '".$optin_id."', ".$status.",'', '".$created_date."', '".$ip_address."', '".$refferal_url."')";
		
		$wpdb->query($sql);
		$lastInsertId = $wpdb->insert_id;
		
		  
		if($optin_confirmation == 1)
		{
			$subcribelink	=	"<a href='".home_url()."/?confirm=".$lastInsertId."&token=".$token."' target='_blank' >Hier E-Mail bestätigen </a>";
			
			if (strpos($mail_content,'[NAME]') !== false)
			{
				$mail_content=str_replace('[NAME]', $contact_name ,$mail_content);
			}
			if (strpos($mail_content,'[EMAIL]') !== false)
			{
				$mail_content=str_replace('[EMAIL]', $email_address ,$mail_content);
			}
			if (strpos($mail_content,'[LINK]') !== false)
			{
				$mail_content=str_replace('[LINK]', $subcribelink ,$mail_content);
			}
			if($company_name != '')
			{
				if (strpos($mail_content,'[COMPANY]') !== false)
				{
					$mail_content=str_replace('[COMPANY]', $company_name ,$mail_content);
				}
			}
			if($address != '')
			{
				if (strpos($mail_content,'[ADDRESS]') !== false)
				{
					$mail_content=str_replace('[ADDRESS]', $address ,$mail_content);
				}
			}
		
			
			$admin_email = $from_email;
			$blogname    = $from_name; 
			
			$body = nl2br($mail_content."<p>Impressum:<br>{accountaddress}</p>");
			$email_address =  array($email_address);
			$response = Send_Elastic_Email($email_address, $subject, $admin_email, $blogname, $text, $body);
			
		}
	}
	else
	{
		
		$upTags=explode(",",$checkemails->tags);
		$formIDs=explode(",",$checkemails->optin_form_id);
		
		if(!in_array($optin_id,$formIDs))
		{
			$formIDs[]=$optin_id;
		}
		
		
		
		$formtags=str_replace(",","",$formtags);
		if(!in_array($formtags,$upTags))
		{
			$upTags[]=$formtags;
		}
		
		$formTags=implode(",",$upTags);
		$optinIds=implode(",",$formIDs);
		
		
		$sql = "UPDATE `".$wpdb->prefix."am_contacts` set name='$contact_name',tags='$formTags',optin_form_id='$optinIds' where email_address = '$email_address'";
		$wpdb->query($sql);
		$isExist=1;
		
	}
	
	///////////////////////////////////////////////////////////////////////
	////////////////******* Email Temaplates Trigger ******////////////////
	$contact_tags = explode(',',trim($formtags,','));
	$am->am_check_registration_templates($contact_tags, $lastInsertId);
	////////////////******* End Email Temaplates Trigger ******////////////
	///////////////////////////////////////////////////////////////////////
	
	///////////////////////////////////////////////////////////////////////
	////////////////******* Email Temaplates Trigger ******////////////////
	$am->am_check_email_series();
	////////////////******* End Email Temaplates Trigger ******////////////
	///////////////////////////////////////////////////////////////////////
	
	}//End if allowed contacts
	
	
	if($isExist)
	{
		$redirectdata	=	get_post($email_redirect_page_id);
		$redirectpage	=	$redirectdata->post_name;
		$redirecturl = home_url()."/".$redirectpage;
	}
	else
	{
	
		$redirectdata	=	get_post($form_redirect_page_id);
		$redirectpage	=	$redirectdata->post_name;
		$redirecturl = home_url()."/".$redirectpage;
	}
	print('<script>window.location.href="'.$redirecturl.'"</script>');
	exit;
}


if((isset($_GET['confirm']) && $_GET['confirm'] != '') && (isset($_GET['token']) && $_GET['token'] != ''))
{
	global $wpdb;
	
	$subscribeid	= $_GET['confirm'];
	$token			= $_GET['token'];
	$confirmed_date	= date("Y-m-d H:i:s");
	
	$allsubscriptions = $wpdb->get_row("SELECT id,optin_form_id FROM `".$wpdb->prefix."am_contacts` WHERE id = '".$subscribeid."' AND token = '".$token."'");
	
	if(count($allsubscriptions)>0){
		
		$sql_update = "UPDATE `".$wpdb->prefix."am_contacts` SET status = 0, confirmed_date = '".$confirmed_date."' WHERE id = '".$subscribeid."' ";
		$wpdb->query($sql_update);
	}
				
	$optin_data = $wpdb->get_row("SELECT email_redirect_page_id FROM `".$wpdb->prefix."am_optin_forms` WHERE id = '".$allsubscriptions->optin_form_id."'");
	$email_redirect_page_id	=	$optin_data->email_redirect_page_id;
	
	$redirectdata	=	get_post($email_redirect_page_id);
	$redirectpage	=	$redirectdata->post_name;
	$redirecturl = home_url()."/".$redirectpage;
	//header("Location: ".home_url()/$redirectpage);
	print('<script>window.location.href="'.$redirecturl.'"</script>');
	exit;
	
}

/********** End of Added By Asif 13 March 2017 ********/

//add new logo on wp-login.php
add_action('login_enqueue_scripts', 'access_member_login_custom_setting');
function access_member_login_custom_setting()
{

	$options = get_option( 'am_settings', array());
	
	$img_url = $options['login_default_logo'];
	$img_background = $options['login_default_bg_image'];
	
	
?>
    <style type="text/css">
        body.login,
        html {
            background: url(<?php echo $img_background;?>) no-repeat center;
            -webkit-background-size: cover;
            -moz-background-size: cover;
            background-size: cover;
        }
        
        body.login div#login h1 a {
            background-image: url(<?php echo $img_url; ?>);
            height: 36px;
            width: 300px;
            background-size: auto;
            margin-top: 10px;
            margin-left: auto;
            margin-right: auto;
            padding-bottom: 10px;
        }
    </style>
    <?php
}
function AM_validate_ip($ip){    if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 | FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE) === false) {        return false;    }    return true;}

function get_ip_address() {    // check for shared internet/ISP IP
    if (!empty($_SERVER['HTTP_CLIENT_IP']) && AM_validate_ip($_SERVER['HTTP_CLIENT_IP'])) {
        return $_SERVER['HTTP_CLIENT_IP'];
    }
    // check for IPs passing through proxies
    if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        // check if multiple ips exist in var
        if (strpos($_SERVER['HTTP_X_FORWARDED_FOR'], ',') !== false) {
            $iplist = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
            foreach ($iplist as $ip) {
                if (AM_validate_ip($ip))
                    return $ip;
            }
        } else {
            if (AM_validate_ip($_SERVER['HTTP_X_FORWARDED_FOR']))
                return $_SERVER['HTTP_X_FORWARDED_FOR'];
        }
    }
    if (!empty($_SERVER['HTTP_X_FORWARDED']) && AM_validate_ip($_SERVER['HTTP_X_FORWARDED']))
        return $_SERVER['HTTP_X_FORWARDED'];
    if (!empty($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']) && AM_validate_ip($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']))
        return $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
    if (!empty($_SERVER['HTTP_FORWARDED_FOR']) && AM_validate_ip($_SERVER['HTTP_FORWARDED_FOR']))
        return $_SERVER['HTTP_FORWARDED_FOR'];
    if (!empty($_SERVER['HTTP_FORWARDED']) && AM_validate_ip($_SERVER['HTTP_FORWARDED']))
        return $_SERVER['HTTP_FORWARDED'];
    // return unreliable ip since all else failed
    return $_SERVER['REMOTE_ADDR'];
}


function Send_Elastic_Email($recipients, $subject, $from, $fromName, $text, $html) {	
       
	    require_once 'ElasticEmailClient.php';
		
		$elastick_email_apikey = get_option( 'elastic_email_subaccount_apikey' );
		//$elastick_email_apikey = get_option( 'elastick_email_apikey' );
		
		ElasticEmailClient\ApiClient::SetApiKey($elastick_email_apikey);
	   
	    $EEemail = new ElasticEmailClient\Email();
        
        try
        {
            $response = $EEemail->Send($subject, $from, $fromName, null, null, null, null, null, null, $recipients, array(), array(), array(), array(), array(), null, null, stripslashes($html), $text);		
        }
        catch (Exception $e)
        {
            $response->error = $e->getMessage();
            
            return $response;
        }
		
		return $response;
}


if(isset($_GET['action']) && $_GET['action'] == 'get_newsletter_schedules')
{

	global $wpdb;
	$now_date= date('Y-m-d G:i');
	
	//echo $now_date; 
	
	$all_newsletter_schedules = $wpdb->get_results("SELECT ".$wpdb->prefix."am_newsletter_schedules.*, ".$wpdb->prefix."am_newsletter.from_name, ".$wpdb->prefix."am_newsletter.from_email, ".$wpdb->prefix."am_newsletter.subject, ".$wpdb->prefix."am_newsletter.company_name, ".$wpdb->prefix."am_newsletter.address, ".$wpdb->prefix."am_newsletter.mail_content, ".$wpdb->prefix."am_contacts.name, ".$wpdb->prefix."am_contacts.email_address FROM `".$wpdb->prefix."am_newsletter_schedules` JOIN ".$wpdb->prefix."am_newsletter ON ".$wpdb->prefix."am_newsletter.id=".$wpdb->prefix."am_newsletter_schedules.newsletter_id JOIN ".$wpdb->prefix."am_contacts ON ".$wpdb->prefix."am_contacts.id=".$wpdb->prefix."am_newsletter_schedules.contact_id WHERE ".$wpdb->prefix."am_newsletter_schedules.schedule_date <='".$now_date."' AND ".$wpdb->prefix."am_newsletter_schedules.status=0 ");
	
/*	echo "<pre>";
	print_r($all_newsletter_schedules);
	exit;
	*/

	if(count($all_newsletter_schedules)>0){
		
		foreach($all_newsletter_schedules as $newsletter){
		
			$newsletter_id = $newsletter->newsletter_id;
			$fromName = $newsletter->from_name;
			$fromEmail = $newsletter->from_email;
			$subject = $newsletter->subject;
			$company_name = $newsletter->company_name;
			$address = $newsletter->address;
			$bodyHtml = $newsletter->mail_content;
			
			$schedule_id = $newsletter->id;
			$contact_id = $newsletter->contact_id;
			$to_email = $newsletter->email_address;
			$contact_name = $newsletter->name;
			
			$recipients = array($to_email);
			$bodyText = "";
					
			if (strpos($bodyHtml,'[NAME]') !== false)
			{
				$bodyHtml=str_replace('[NAME]', $contact_name ,$bodyHtml);
			}
			if (strpos($bodyHtml,'[EMAIL]') !== false)
			{
				$bodyHtml=str_replace('[EMAIL]', $to_email ,$bodyHtml);
			}
			if (strpos($bodyHtml,'[LINK]') !== false)
			{
				$bodyHtml=str_replace('[LINK]', $subcribelink ,$bodyHtml);
			}
			if($company_name != '')
			{
				if (strpos($bodyHtml,'[COMPANY]') !== false)
				{
					$bodyHtml=str_replace('[COMPANY]', $company_name ,$bodyHtml);
				}
			}
			if($address != '')
			{
				if (strpos($bodyHtml,'[ADDRESS]') !== false)
				{
					$bodyHtml=str_replace('[ADDRESS]', $address ,$bodyHtml);
				}
			}
			
			$Email_contents = $bodyHtml.'<p>Impressum:<br>{accountaddress}</p>';		
					
			$response = Send_Elastic_Email($recipients, $subject, $fromEmail, $fromName, $bodyText, $Email_contents);
			
			if($response->transactionid !="" && $response->messageid !=""){
			
			$transactionid = $response->transactionid;
			$messageid = $response->messageid;
			
			//Update Filtered Contacts Record
			$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET transactionid='".$transactionid."', messageid='".$messageid."', status = 1 WHERE schedule_id = '".$schedule_id."' ");
					
			
			//Update Newsletter Record
			$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_schedules` SET status = 1 WHERE id = '".$schedule_id."' ");
			
			}//End if message send
			
		}
		
	}
	
	echo "<pre>";
	print_r($response);
	exit;
	
}


if(isset($_GET['action']) && $_GET['action'] == 'export_csv')
{
		include_once ABSPATH."wp-includes/pluggable.php";
	
	
	if(is_user_logged_in())
	{
		header("Content-type: text/csv");
		header("Content-Disposition: attachment; filename=contacts.csv");
		header("Pragma: no-cache");
		header("Expires: 0");
		
		$sql    = "SELECT * FROM `".$wpdb->prefix."am_contacts` where status='0'";
		$contactsData=$wpdb->get_results( $sql );
		
	
		
		$tsql="select * from `".$wpdb->prefix."am_tags`";
		$tagsData=$wpdb->get_results( $tsql );
		
		$total_tags=count($tagsData);
		echo "Name;Email";
		
		foreach($tagsData as $tagData)
		{
			echo ';"'.$tagData->tag_name.'"';
		}
		
		
		echo "\n";
		
		foreach($contactsData as $contactData)
		{
			echo $contactData->name.";".$contactData->email_address;
			$tags_string="";
			$tagsArr=explode(",",$contactData->tags);
			$contactTags=0;
			foreach($tagsData as $tagData)
			{
				if(in_array($tagData->id,$tagsArr))
				{
					echo ';"'.$tagData->tag_name.'"';
					
				}
				else
				{
					echo ";";
				}
			}
			
			
			echo "\n";
			
			
			
		}
		
		die;
	}
}







if(isset($_GET['action']) && $_GET['action'] == 'get_email_response')
{

	$post_data = $_REQUEST;	
	file_put_contents(dirname(__FILE__)."/req.log",print_r($_REQUEST,true),FILE_APPEND);

	$to_email_address = $post_data['to'];
	$transactionid = $post_data['transaction'];
	$messageid = $post_data['messageid'];
	$status = $post_data['status'];
	
	$query="SELECT * from `".$wpdb->prefix."am_contacts` where email_address='$to_email_address' and status!='2'";
	$contactData=$wpdb->get_results($query);
		$contact_id=$contactData[0]->id;
	
	$query1="UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET sent_status = 1 WHERE transactionid = '".$transactionid."' and contact_id='".$contact_id."'";
	
	file_put_contents(dirname(__FILE__)."/req.log",$query1."\n".$query."\n".print_r($contactData,true)."\n",FILE_APPEND);
	

	
	if($status == "Sent"){
		//Update Newsletter Record
		$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET sent_status = 1 WHERE transactionid = '".$transactionid."' and contact_id='".$contact_id."'");
	}
	
	if($status == "Opened"){
		//Update Newsletter Record
		$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET opened = 1 WHERE transactionid = '".$transactionid."' and contact_id='".$contact_id."'");
	}
	
	if($status == "Clicked"){
		//Update Newsletter Record
		$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET clicked = 1 WHERE transactionid = '".$transactionid."' and contact_id='".$contact_id."'");
	}
	
	if($status == "Unsubscribed" or $status == "AbuseReport" or $status == "Error"){
		//Update Contacts Record
		$wpdb->query("UPDATE `".$wpdb->prefix."am_contacts` SET status = 2 WHERE email_address = '".$to_email_address."' ");
	}
	
	
	
	///////////////////////////////////////////////////////////////////////
	////////////////******* Email Temaplates Trigger ******////////////////
	$am->am_check_email_series();
	////////////////******* End Email Temaplates Trigger ******////////////
	///////////////////////////////////////////////////////////////////////
	
	
	$postdata = print_r($_REQUEST, true);
	$data = $postdata;
	$fp = fopen('text.txt', 'a') or exit("Unable to open file!");;
	fwrite($fp, $data);
	fclose($fp);
	
	exit;
}


/**********************************************************************/
/////////////////// Remove Extra Email Admin Menus /////////////////////
/**********************************************************************/
function remove_menus(){
  
   global $submenu;
   $elastic_subAccount=get_option('elastic_subAccount');
  
   foreach($submenu['am'] as $key => $value )
    {
        if( 'am_email_series' == $value[2] ){
            $submenu['am'][$key][4] .= "am_subcustom_class";
		}
		if( 'am_tags' == $value[2] ){
            $submenu['am'][$key][4] .= "am_subcustom_class";
		}
		if( 'am_contacts' == $value[2] ){
            $submenu['am'][$key][4] .= "am_subcustom_class";
		}
		if( 'am_optin_frm' == $value[2] ){
            $submenu['am'][$key][4] .= "am_subcustom_class";
		}
		
	if($elastic_subAccount=="yes")
	{
		if( 'am_email_setting' == $value[2] ){
            $submenu['am'][$key][4] .= "am_subcustom_class";
		}
	}
		if( 'am_emails_categories' == $value[2] ){
            $submenu['am'][$key][4] .= "am_subcustom_class";
		}
    }
	
}
add_action( 'admin_menu', 'remove_menus' );
/**********************************************************************/
/////////////////// End Remove Extra Email Admin Menus /////////////////
/**********************************************************************/



function create_sub_account(){
	
$elastick_email_apikey = '8535ff91-62a5-48dd-af75-92e04c77af41';

$url = 'https://api.elasticemail.com/v2/account/addsubaccount';

//Generate Password
$password='';
$length = 8;
$possible = "123467890abcdfghjkmnpqrtvwxyzABCDFGHJKLMNPQRTVWXYZ";
$maxlength = strlen($possible);
if ($length > $maxlength) {
	  $length = $maxlength;
	}
$i = 0; 
while ($i < $length) { 
$char = substr($possible, mt_rand(0, $maxlength-1), 1);
if (!strstr($password, $char)) { 
$password .= $char;
$i++;
}
}

$admin_email = get_option('admin_email');

$data = array(
			'apikey' => $elastick_email_apikey,
			'email' => $admin_email,
			'password' => $password,
			'confirmPassword' => $password,
			'requiresEmailCredits' => 'False',
			'enableLitmusTest' => 'False',
			'requiresLitmusCredits' => 'False',
			'maxContacts' => '20000'
		);

//use key 'http' even if you send the request to https://...
$options = array(
    'http' => array(
        'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
        'method'  => 'POST',
        'content' => http_build_query($data)
    )
);

$context  = stream_context_create($options);
$result = file_get_contents($url, false, $context);
$result_arr = json_decode($result);
$sub_account_api_key = $result_arr->data;

if($result_arr->success ==1){

update_option('elastic_email_subaccount_apikey', $sub_account_api_key);


//Send Email to Plugin Owner

/*
$mail_content = 'Super,<br> bitte logge Dich jetzt bei unserem E-Mail Versand-Dienstleister und erstelle für einen DSGVO konformen Versand Deine "Auftragsdatenberarbeitungsvereinbarung". Du findest sie NACH Deinem Login unter folgenedem Link: https://elasticemail.com/account/#/account/legal/dpa --> einfach auf den grünen Download-Knopf drücken. Hier Deine Zugangsdaten:<br><br>';
$mail_content .= 'E-Mail / Benutzername: '.$admin_email."<br>";
$mail_content .= 'Passwort: '.$password."<br><br>";
$mail_content .= 'Schritt 1: Login: <a href="https://elasticemail.com/account/#/account/legal/dpa">Login</a> <br>';
$mail_content .= 'Schritt 2: Download: <a href="https://elasticemail.com/account/#/account/legal/dpa">dann hier auf den grünen Download Link klicken</a>';
$mail_content .= 'Das wars schon,<br>Dein AccessMember Team';

	
$body = nl2br($mail_content);
$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
$headers .= 'From: AccessMember <'.$admin_email. "\r\n";

$subject = "DSGVO Vereinbarung abschließen";

mail($admin_email,$subject,$body,$headers);

}else{
			
//Send Email to Plugin Owner
$mail_content = 'Hallo,<br> der folgende Fehler kommt vom Elastic Email System: <br><br>';
$mail_content .= $result_arr->error;

$body = nl2br($mail_content);
$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
$headers .= 'From: AccessMember <'.$admin_email. "\r\n";

$subject = "Elastic Email Fehler";

mail($admin_email,$subject,$body,$headers);
	
*/	
}//end if account created


}


//--------------------css for post page lesson-----------//
// resize columns in post listing screen
function wptutsplus_post_listing_column_resize() { ?>
        <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN" crossorigin="anonymous">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
        <style type="text/css">
            /**.post-type-lessons **/
            
            .post-type-lessons .page-title-action {
                background: #e91e63 none repeat scroll 0 0 !important;
                border: medium none #e91e63 !important;
                border-radius: 2px 4px 4px 2px !important;
                color: #fff !important;
                cursor: pointer !important;
                font-size: 14px !important;
                font-weight: bold !important;
                padding: 7px 21px !important;
                text-decoration: none !important;
                text-transform: capitalize !important;
            }
            
            .post-type-lessons .page-title-action:hover {
                box-shadow: 0 6px 10px rgba(0, 0, 0, 0.23), 0 10px 30px rgba(0, 0, 0, 0.19) !important;
            }
            
            .post-type-lessons .page-title-action:active {
                transform: translateY(2px) !important;
            }
            
            .post-type-lessons .wp-heading-inline {
                display: block !important;
                margin-bottom: 14px !important;
            }
            
            .post-type-lessons .subsubsub li a {
                font-weight: bold;
            }
            
            .post-type-lessons .subsubsub .count {
                font-weight: Bold !important;
            }
            
            .post-type-lessons .subsubsub {
                margin-top: 52px;
                margin-bottom: 5px;
            }
            
            .post-type-lessons #doaction {
                background: #fff none repeat scroll 0 0 !important;
                border: 1px solid #dfe8f1 !important;
                box-shadow: none !important;
                font-weight: bold !important;
                height: 37px;
                padding: 0 17px !important;
            }
            
            .post-type-lessons #post-query-submit {
                background: #fff none repeat scroll 0 0 !important;
                border: 1px solid #dfe8f1 !important;
                box-shadow: none !important;
                font-weight: bold !important;
                height: 37px;
                padding: 0 17px !important;
            }
            
            .post-type-lessons #bulk-action-selector-top,
            {
                background: #fff none repeat scroll 0 0;
                border: 1px solid #dfe8f1 !important;
                height: 37px !important;
            }
            
            .post-type-lessons .actions select {
                background: #fff none repeat scroll 0 0;
                border: 1px solid #dfe8f1 !important;
                height: 37px !important;
            }
            
            .post-type-lessons .tablenav {
                margin-bottom: 33px !important;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts thead tr th {
                font-weight: bold;
            }
            
            .post-type-lessons.alternate,
            .striped > tbody > *:nth-child(2n+1),
            ul.striped > *:nth-child(2n+1) {
                background: #fefeff !important;
            }
            
            .post-type-lessons .column-comments .comment-count-approved,
            .column-comments .comment-count-no-comments,
            .column-response .comment-count-approved,
            .column-response .comment-count-no-comments {
                background-color: #52c306;
            }
            
            .post-type-lessons .column-comments .post-com-count-approved::after,
            .column-comments .post-com-count-no-comments::after,
            .column-response .post-com-count-approved::after,
            .column-response .post-com-count-no-comments::after {
                border-top: 5px solid #52c306 !important;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts td:not(:first-child):not(:nth-child(2)) {
                text-align: center;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts thead tr th {
                text-align: center;
            }
            
            .post-type-lessons .type-lessons td {
                border: 1px solid #f0f2f6;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts tfoot th {
                text-align: center;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts tbody tr td:nth-child(2) {
                text-transform: capitalize;
            }
            
            .post-type-lessons #post-search-input {
                background: #fff none repeat scroll 0 0 !important;
                border: 1px solid #dfe8f1 !important;
                border-radius: 3px !important;
                box-shadow: 1px 1px 3px #f6f6f6 inset !important;
                font-size: 13px;
                height: 38px;
                padding: 6px 12px;
                transition: all 0.3s ease 0s !important;
            }
            
            .post-type-lessons #post-search-inputfocus {
                border-color: #3da6ff !important;
                box-shadow: none !important;
            }
            
            .post-type-lessons #search-submit {
                background: #fff none repeat scroll 0 0 !important;
                border: 1px solid #dfe8f1 !important;
                box-shadow: none !important;
                font-weight: bold !important;
                height: 37px;
                padding: 0 17px !important;
            }
            
            .post-type-lessons #title {
                border: none !important;
            }
            
            .post-type-lessons .wrap {
                background: #fff none repeat scroll 0 0;
                padding: 25px;
                margin: 6px 20px 0 2px;
            }
            
            .post-type-lessons #doaction2 {
                background: #fff none repeat scroll 0 0 !important;
                border: 1px solid #dfe8f1 !important;
                box-shadow: none !important;
                font-weight: bold !important;
                height: 37px;
                padding: 0 17px !important;
            }
            
            .post-type-lessons .tablenav-pages.one-page {
                font-weight: bold;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts tbody tr td {
                color: #918d99;
            }
            
            .post-type-lessons .wp-list-table.widefat.fixed.striped.posts tfoot tr {
                background: #f9fafe none repeat scroll 0 0 !important;
            }
            
            .post-type-lessons .manage-column.column-modules.sortable.desc {
                padding-left: 33px
            }
            
            .post-type-lessons .manage-column.column-date.sortable.asc {
                padding-left: 16px
            }
            
            .post-type-lessons .manage-column.column-comments.num.sortable.desc {
                padding-left: 27px;
            }
            
            .post-type-lessons .row-title {
                font-weight: bold;
            }
            
            .post-type-lessons .checkspan input[type="checkbox"] {
                height: 100%;
                left: 0;
                margin: 0;
                opacity: 0;
                position: absolute;
                top: 0;
                width: 100%;
                z-index: 999;
            }
            
            .post-type-lessons .checkspan {
                float: left;
                height: 26px;
                position: relative;
                width: 24px;
            }
            
            .post-type-lessons .checklabspan {
                background-image: url('<?php echo site_url(); ?>/wp-content/plugins/access_members/images/chex.png');
                background-position: 0 0;
                background-repeat: no-repeat;
                float: left;
                height: 26px;
                width: 24px;
            }
            
            .post-type-lessons .checkspan input[type='checkbox']:checked + .checklabspan {
                background-position: 0 -26px;
            }
            
            .post-type-lessons .meta-options .selectit .checkspan {
                margin-right: 9px;
                position: relative;
                top: -10px;
            }
            
            .post-type-lessons #post-body-content #titlediv #titlewrap #title-prompt-text {
                color: #a5a5a5;
                font-size: 13px;
                font-weight: normal;
                padding: 11px 10px;
                position: absolute;
            }
            
            .post-type-lessons #post-body-content #titlediv #titlewrap #title {
                border: 1px solid #dfe8f1 !important;
            }
            
            .post-type-lessons .tablenav-pages-navspan {
                background: #ffffff none repeat scroll 0 0 !important;
                border-color: #ddd !important;
                color: #499D9E !important;
                height: 29px !important;
            }  
            .post-type-lessons .tablenav-pages .current-page {
               font-size: 10px !important;
            }  
            
            
            
            
            .post-type-lessons .media-upload-form .notice, .media-upload-form div.error, .wrap .notice, .wrap div.error, .wrap div.updated {
                 border: 1px solid #dfe8f1;
                margin: 20px 0 15px !important;
            }
            
            .post-type-lessons .tablenav .tablenav-pages a,
            .tablenav-pages-navspan {
                min-width: 27px !important;
                background: #EA1E63;
                border: medium none;
                height: 28px;
                color: #fff;
                padding: 4px 5px 7px!important;
            }
        </style>
        <?php }
add_action( 'admin_enqueue_scripts', 'wptutsplus_post_listing_column_resize' );


function wptutsplus_post_listing_column() { ?>
            <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
            <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
            <script>
                jQuery(document).ready(function () {
                    jQuery(".post-type-lessons input[type='checkbox']").each(function () {
                        jQuery(this).wrap('<span class="checkspan"></span>');
                        jQuery(this).after('<span class="checklabspan"></span>');
                    });
                });
                jQuery(document).ready(function () {
                    var place_holder = "Suche...";
                    jQuery(".post-type-lessons").find("#post-search-input").attr("placeholder", place_holder);
                    jQuery(".post-type-lessons").find("#search-submit").attr("value", "suchen");
                    jQuery(".post-type-lessons").find("select").css({
                        'appearance': 'none'
                        , 'background': 'url("<?php echo site_url(); ?>/wp-content/plugins/access_members/images/chevron-arrow-down.png") no-repeat right'
                        , 'width': '150px'
                        , 'background-position': '95% 60% '
                        , 'background-size': '10px 10px'
                    });
                });
                jQuery(document).ready(function () {
                    jQuery(".post-type-lessons").find("#title").addClass("element-form");
                });
            </script>
            <?php }
add_action( 'admin_enqueue_scripts', 'wptutsplus_post_listing_column' );
//--------------------------------------------------------------------------------------





///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
add_action( 'isa_add_every_three_minutes', 'every_three_minutes_event_func' );

add_filter( 'cron_schedules', 'isa_add_every_three_minutes' );
function isa_add_every_three_minutes( $schedules ) {
    $schedules['every_three_minutes'] = array(
            'interval'  => 60,
            'display'   => __( 'Every 1 Minutes', 'textdomain' )
    );
    return $schedules;
}

// Schedule an action if it's not already scheduled
if ( ! wp_next_scheduled( 'isa_add_every_three_minutes' ) ) {
    wp_schedule_event( time(), 'every_three_minutes', 'isa_add_every_three_minutes' );
}

// Hook into that action that'll fire every three minutes
add_action( 'isa_add_every_three_minutes', 'every_three_minutes_event_func' );
 //add_action( 'wp_footer', 'your_function' );
function every_three_minutes_event_func() {
    
	global $wpdb;
	file_put_contents(dirname(__file__)."/testing.log","balwinder");
	//Check Key
	$options = get_option( 'am_settings', array() );
	$options['am_license_key'];
	$siteurl = site_url();
	
	if($options['am_license_key'] !=""){
	
		$license_key = $options['am_license_key'];
		$postData = array(
			'license_key' => $license_key,
			'AuthKey' => 'vizz789',
			'site_url' => $siteurl,
		
		);
		
		$url = AM_LICENSE_KEY_PARENT_URL."?action=check_license_key&license_key=".$license_key."&site_url=".$siteurl;
		
		// Setup cURL
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // On dev server only!
		$result = curl_exec($ch);
		if (curl_error($ch)) {
			$error_msg = curl_error($ch);
		}
		curl_close ($ch); // close curl handle
		$post_data = json_decode($result);
	//	print_r($result);
		
		if($post_data->error ==""){
			
			global $wpdb;
			$created_date = date('Y-m-d G:i:s');
			
		//	global $wpdb;
		//	$created_date = date('Y-m-d G:i:s');
			if(isset($post_data->license_type)){
				$options = get_option( 'am_settings' );
				$options['days_left'] = $post_data->days_left;
				update_option( 'am_settings', $options );
				$post_data = $post_data->data;
			}
			if($post_data->status ==1){
				
				$sql = "TRUNCATE TABLE `".$wpdb->prefix."am_license_keys` ";
				$wpdb->query($sql);
				
				//Update no of contacts
				update_option('no_of_contacts_allowed',0);
				
			}else{
			
			
				//Check Key
				echo $sql = "SELECT * FROM `".$wpdb->prefix."am_license_keys` WHERE license_key='".$license_key."' ";
				$license_arr = $wpdb->get_row( $sql );
				
				if(count($license_arr)>0){
					
					$sql_update = "UPDATE `".$wpdb->prefix."am_license_keys` SET license_key = '".$post_data->license_key."', no_of_contacts = '".$post_data->no_of_contacts."', lessons = '".$post_data->lessons."', products = '".$post_data->products."', orders = '".$post_data->orders."', email_series = '".$post_data->email_series."', newsletter = '".$post_data->newsletter."', optin_forms = '".$post_data->optin_forms."', survey = '".$post_data->survey."', status = '".$post_data->status."' WHERE license_key = '".$license_key."'";
					
					$wpdb->query($sql_update);
					
					
				}else{
				
					$sql = "INSERT INTO `".$wpdb->prefix."am_license_keys` (`license_key`, `no_of_contacts`, `lessons`, `products`, `orders`, `email_series`, `newsletter`, `optin_forms`, `survey`, `status`, `created_date` ) VALUES ('".$post_data->license_key."', '".$post_data->no_of_contacts."', '".$post_data->lessons."', '".$post_data->products."', '".$post_data->orders."', '".$post_data->email_series."', '".$post_data->newsletter."', '".$post_data->optin_forms."', '".$post_data->survey."', '0',  '".$created_date."')";
				
					$wpdb->query($sql);
				
				}
				
				//Update no of contacts
				update_option('no_of_contacts_allowed',$post_data->no_of_contacts);
			
			}//End if license is active
			
		}else{
			$options = get_option( 'am_settings' );
				$options['days_left'] = 0;
				update_option( 'am_settings', $options );
		}
		
	}//end if license key 
	execute_schduler();
	
	
}



function execute_schduler(){
	global $wpdb;
	$cron_status = array();
	//Email CronJob Function
	$is_progress = get_option( 'elastic_mails_in_progress');
	$cron_status['status'] = "Already a cron running please wait ! and try again after some time!";
	file_put_contents(dirname(__file__)."/tttt.log","progress status $is_progress");
	if($is_progress == 0){
		$cron_status['status'] = "completed successfully!";
		update_option( 'elastic_mails_in_progress' , 1);
		date_default_timezone_set('Europe/Berlin');
		$now_date= date('Y-m-d G:i');
		$all_newsletter_schedules = $wpdb->get_results("SELECT ".$wpdb->prefix."am_newsletter_schedules.*, ".$wpdb->prefix."am_newsletter.from_name, ".$wpdb->prefix."am_newsletter.from_email, ".$wpdb->prefix."am_newsletter.subject, ".$wpdb->prefix."am_newsletter.company_name, ".$wpdb->prefix."am_newsletter.address, ".$wpdb->prefix."am_newsletter.mail_content, ".$wpdb->prefix."am_contacts.name, ".$wpdb->prefix."am_contacts.email_address FROM `".$wpdb->prefix."am_newsletter_schedules` JOIN ".$wpdb->prefix."am_newsletter ON ".$wpdb->prefix."am_newsletter.id=".$wpdb->prefix."am_newsletter_schedules.newsletter_id JOIN ".$wpdb->prefix."am_contacts ON ".$wpdb->prefix."am_contacts.id=".$wpdb->prefix."am_newsletter_schedules.contact_id WHERE ".$wpdb->prefix."am_newsletter_schedules.schedule_date <='".$now_date."' AND ".$wpdb->prefix."am_newsletter_schedules.status=0 ");
		// file_put_contents(dirname(__FILE__)."/all_newsletter_schedules.txt" , print_r($all_newsletter_schedules , true) , FILE_APPEND);
		$email_records = array();
		if(count($all_newsletter_schedules)>0){
			foreach($all_newsletter_schedules as $newsletter){
				$newsletter_id = $newsletter->newsletter_id;
				$fromName = $newsletter->from_name;
				$fromEmail = $newsletter->from_email;
				$subject = $newsletter->subject;
				$company_name = $newsletter->company_name;
				$address = $newsletter->address;
				$bodyHtml = $newsletter->mail_content;
				$schedule_id = $newsletter->id;
				$contact_id = $newsletter->contact_id;
				$to_email = $newsletter->email_address;
				$contact_name = $newsletter->name;
				$recipients = array($to_email);
				$bodyText = "";
						
				if (strpos($bodyHtml,'[NAME]') !== false)
				{
					$bodyHtml=str_replace('[NAME]', '{NAME}' ,$bodyHtml);
				}
				if (strpos($bodyHtml,'[EMAIL]') !== false)
				{
					$bodyHtml=str_replace('[EMAIL]', '{EMAIL}' ,$bodyHtml);
				}
				if (strpos($bodyHtml,'[LINK]') !== false)
				{
					$bodyHtml=str_replace('[LINK]', '{LINK}' ,$bodyHtml);
				}
				if($company_name != '')
				{
					if (strpos($bodyHtml,'[COMPANY]') !== false)
					{
						$bodyHtml=str_replace('[COMPANY]', '{COMPANY}' ,$bodyHtml);
					}
				}
				if($address != '')
				{
					if (strpos($bodyHtml,'[ADDRESS]') !== false)
					{
						$bodyHtml=str_replace('[ADDRESS]', '{ADDRESS}' ,$bodyHtml);
					}
				}  
				$Email_contents = $bodyHtml.'<p>Impressum:<br>{accountaddress}</p>';
				file_put_contents(dirname(__FILE__).'/email_content.txt' , $Email_contents , FILE_APPEND);
				$email_records[$newsletter_id]['from'] = $fromEmail;
				$email_records[$newsletter_id]['fromName'] = $fromName;
				$email_records[$newsletter_id]['subject'] = $subject;
				$email_records[$newsletter_id]['bodyHtml'] = $Email_contents;
				$email_records[$newsletter_id]['bodyText'] = $bodyText;
				$email_records[$newsletter_id]['contacts'][] = array("to" => $to_email , 'name' => $contact_name , 'address' => $address  , 'company_name' => $company_name);
				$email_records[$newsletter_id]['schedule_id'][] = $schedule_id;
			}
			$cron_status['records'] = $email_records;
			$am_lincense_key=constant('AM_LICENSE_KEY'); 
			foreach($email_records as $id => $record){
				$list = array();
				$list[] = "ToEmail,NAME,EMAIL,ADDRESS,COMPANY";
				foreach($record['contacts'] as $single_contact){
					$list[] = $single_contact['to'].",".$single_contact['name'].",".$single_contact['to'].",".$single_contact['address'].",".$single_contact['company_name'];
				}
				$filedata = fopen(dirname(__FILE__)."/contacts_".$id.".csv","w");
				$only_filename = "contacts_".$id.".csv";
				foreach($list as $line){
					fputcsv($filedata,explode(',',$line));
				}
				fclose($filedata);
				$file_name_with_full_path = dirname(__FILE__).'/'.$only_filename;
				$url = 'https://api.elasticemail.com/v2/email/send';
				$elastick_email_apikey = get_option( 'elastic_email_subaccount_apikey' );
				
				if(empty($am_lincense_key))
				{
					$record['bodyHtml']=$record['bodyHtml'].'<p style="font-size:12px;">gesendet mit <a href="https://www.accessmember.de">AccessMember</a></p>';
				}
				$post = array(
					'from' => $record['from'],
					'fromName' => $record['fromName'],
					'apikey' => $elastick_email_apikey,
					'subject' => $record['subject'],
					'bodyHtml' => $record['bodyHtml'],
					'bodyText' => $record['bodyText'],
					'isTransactional' => false,
					'file_contacts' => new CurlFile($file_name_with_full_path, 'text/csv', $only_filename),
					'mergesourcefilename' => $only_filename
				);
				$ch = curl_init();
				curl_setopt_array($ch, array(
					CURLOPT_URL => $url,
					CURLOPT_POST => true,
					CURLOPT_POSTFIELDS => $post,
					CURLOPT_RETURNTRANSFER => true,
					CURLOPT_HEADER => false,
					CURLOPT_SSL_VERIFYPEER => false
				));
				$response=curl_exec ($ch); 
				if ($response === FALSE){ echo curl_error($ch); }
				else{ 
					$response = json_decode($response);
					file_put_contents(dirname(__FILE__)."/query.txt",print_r($response, true),FILE_APPEND);
					if($response->data->transactionid !="" ){
						foreach($record['schedule_id'] as $schedule_id){
							$transactionid = $response->data->transactionid;
							$messageid = $response->data->messageid;
							//Update Filtered Contacts Record
							$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET transactionid='".$transactionid."', messageid='".$messageid."', status = 1 WHERE schedule_id = ".$schedule_id);
							 file_put_contents(dirname(__FILE__)."/query.txt","UPDATE `".$wpdb->prefix."am_newsletter_filtered_contacts` SET transactionid='".$transactionid."', messageid='".$messageid."', status = 1 WHERE schedule_id IN ('".$schedule_id."' )" ,FILE_APPEND);
							//Update Newsletter Record
							$wpdb->query("UPDATE `".$wpdb->prefix."am_newsletter_schedules` SET status = 1 WHERE id = '".$schedule_id."'");
							 file_put_contents(dirname(__FILE__)."/query.txt","UPDATE `".$wpdb->prefix."am_newsletter_schedules` SET status = 1 WHERE id = '".$schedule_id."'",FILE_APPEND);
						}//End if message send 
					}
				}
				curl_close ($ch);
			}
			
	
		}
		update_option( 'elastic_mails_in_progress' , 0);
	}
	return $cron_status;
}
require_once AM_PLUGIN_PATH.'includes/am_cron_jobs.php';
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////


