<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Class that will hold functionality for front side
 *
 * PHP version 5
 *
 * @category   Front Side Code
 * @package    Access Members
 * @author     Erfolgs-Faktor
 * @version    1.0.0
 * @since      File available since Release 1.0.0
*/


class AM_Front extends AM 
{
    //Front side starting point. Will call appropriate front side hooks
    public function __construct() {
        
        do_action('am_before_front', $this );
        //All front side code will go here
        add_action( 'template_redirect', array( $this, 'am_template_redirect' ), 2 );
        add_action( 'wp', array( $this, 'am_wp_action' ) );
        //add_action( 'widgets_init', array( $this, 'am_widget_init' ) );
        add_action( 'wp_enqueue_scripts', array( $this, 'am_load_scripts' ), 25 );
        add_action( 'am_verify_plugin_license', array( $this, 'am_verify_plugin_license' ), 10 );
        add_action( 'wp_ajax_am_load_lesson_contents', array( $this, 'am_load_lesson_contents' ) );
        add_action( 'wp_ajax_nopriv_am_load_lesson_contents', array( $this, 'am_load_lesson_contents' ) );
        add_action( 'wp_ajax_am_purchase_coins', array( $this, 'am_purchase_coins' ) );
        add_action( 'wp_ajax_nopriv_am_purchase_coins', array( $this, 'am_purchase_coins' ) );
        
        add_action( 'after_switch_theme', array( $this, 'am_after_switch_theme' ) );
        
        add_action( 'wp_footer', array( $this, 'am_footer' ) );
        add_action( 'wp_footer', array( $this, 'am_footer_powered' ) );
		
		
        add_action( 'wp_ajax_am_get_lesson_comments', array( $this, 'am_get_lesson_comments' ) );
        add_action( 'wp_ajax_nopriv_am_get_lesson_comments', array( $this, 'am_get_lesson_comments' ) );
        
        add_shortcode( 'am_product', array( $this, 'am_product' ) );
        add_shortcode( 'am_bonus_button', array( $this, 'am_bonus_button' ) );
        
        add_shortcode( 'am_offer', array( $this, 'am_offer' ) );
        add_shortcode( 'am_coins_purchased_button', array( $this, 'am_coins_purchased_button' ) );
        add_shortcode( 'am_available_coins', array( $this, 'am_available_coins' ) );
		
		add_shortcode( 'am_survey', array( $this, 'am_survey_shortcode' ) );
		add_shortcode( 'am_quiz_progressbar', array( $this, 'am_quiz_progressbar_shortcode' ) );
		add_shortcode( 'am_customer_order_form', array( $this, 'am_customer_order_form_shortcode' ) );
        
        add_filter( 'login_redirect', array( $this, 'am_login_redirect' ), 10, 3 );
        
        do_action('am_after_front', $this );
    }
    
	public function am_survey_shortcode($atts = array(), $content = null) {
      
		 
		 if(is_user_logged_in()) {
		 
			 global $wpdb;
			 
			 $survey_id = $atts['id'];
			 $user_id = get_current_user_id(); 
			 $survey_arr = $this->am_get_survey_font($survey_id);
			 
			 $survey_report = $this->am_get_survey_report($survey_id, $user_id);
			 
			 if(!empty($survey_report)){
				$checked_survey = 'checked'; 
			 }else{
				$checked_survey = ''; 
			 }
			  
			 $html =  '<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">';
			 $html .= '<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>';
		
			 $html .= '<div class="row">
							 <div class="col-md-4">
							 <img src="'.$survey_arr->survey_image.'">
							 </div>
							 <div class="col-md-6">
							 <h4>'.$survey_arr->survey_title.'</h4>
							 <p>'.$survey_arr->survey_description.'</p>
							 </div>
							 <div class="col-md-2">
							 <div class="survey-checkbox survey-checkbox-success">
								<input type="checkbox" class="am_user_survey" id="inlineCheckbox'.$survey_id.'" value="'.$survey_id.'" '.$checked_survey .'>
								<label for="inlineCheckbox'.$survey_id.'"></label>
							 </div>
							 </div>
						</div>';
			 
			 return $html;
		
		}
		
    }
	
	
	public function am_quiz_progressbar_shortcode() {
      
	  	 global $glob_lesson_id,$glob_product_id,$glob_main_count,$glob_count;
	
		 $total_questions = $this->am_count_lesson_quiz($glob_lesson_id,$glob_product_id);
		 $quiz_percent = $glob_count/$total_questions*100;
		 
		 $html = '<div class="response_progress_bar">
				  <h3>Questions '.$glob_main_count.'/'.$total_questions.'</h3>
				  <div class="progress" style="width: 50%;">
				  <div class="progress-bar progress-bar-success" role="progressbar" aria-valuenow="40"
				  aria-valuemin="0" aria-valuemax="100" style="width:'.$quiz_percent.'%">
					'.$quiz_percent.'% '.__( 'Complete', 'am' ).'
				  </div>
				  </div>
				  </div>';
		
		 return $html;
		
    }		
	
	public function am_customer_order_form_shortcode($attr){		
		
        ob_start();
		$html = '';
		$product_id = $attr['product_id'];
		global $wpdb;
		$sql2 = "SELECT * FROM `".$wpdb->prefix."am_products` where id=".$product_id;
		$product = $wpdb->get_row( $sql2 );
		$message = $this->am_save_customer_form();
        require_once AM_PLUGIN_PATH.'templates/front/am_customer_order_form.php';
		$html = ob_get_contents();
        ob_end_clean();
        echo $html;
	}
	
	public function am_footer_powered()
	{
		$am_lincense_key=constant('AM_LICENSE_KEY'); 
		if(empty($am_lincense_key)):
		?>
		<p style="text-align:center;font-size:11px;font-weight:700;font-family:Tahoma;">interner Bereich mit <?php echo $am_lincense_key;?> <a href="https://www.accessmember.de">AccessMember</a></p>
		
		<?php endif;?>
		
	<?php
	}
	
    public function am_footer() {
        
        $html = '';
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/front/am_footer.php';
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
    
    public function am_get_lesson_comments() {
        
        ob_start();
        query_posts( 'post_type=lessons&p='.$_POST['lesson_id'] ); 
        if( have_posts() ) : while( have_posts() ) : the_post();
        endwhile; endif; 
        $withcomments = 1;
        comments_template();
        wp_reset_query();
        
        $html = ob_get_contents();
        ob_end_clean();
        
        $return = array( 'error'=> false, 'content' => $html );

        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
    
    public function am_login_redirect( $redirect_to, $request, $user ) {
        
        $product_members = $this->am_get_products_members( "user_id = '".$user->ID."'" );
        if( sizeof($product_members) > 0 ) {
            $product_member = array_shift( $product_members );
            $product = array_shift($this->am_get_products( "id = '".$product_member->product_id."'" ));
            
            $redirect_to = get_permalink($product->login_redirect);
        }
        return $redirect_to;
    }

    public function am_bonus_button( $atts ) {
        
        $html = '';
        $button_id = $atts['id'];
        
        $bonus_button = array_shift($this->am_get_bonus_buttons( "id = '".$button_id."'" ));
        if( !$this->am_user_have_access_to_bonus_content($bonus_button) ) {
            return $html;
        }
        
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/front/am_get_bonus_button.php';
        $html = ob_get_contents();
        ob_end_clean();
        
        return $html;
    }
    
    public function am_user_have_access_to_bonus_content( $bonus_button ) {
        
        if( empty($bonus_button) ) {
            return false;
        }
        $product_id = get_post_meta( get_the_ID(), '_am_product_id', true );
        
        if( $bonus_button->for_customers == 'yes' ) {
            $current_user = wp_get_current_user();
            if( $current_user->ID == 0 ) {
                return false;
            }
            
            return $this->am_user_have_access( $current_user->ID, $bonus_button->product );
        }else if(  $product_id == $bonus_button->product ){
            return true;
        }elseif (empty ($bonus_button->for_customers) && empty ($bonus_button->product) ) {
            return true;
        }
        return false;
    }
    
    public function am_load_scripts() {
        
        wp_localize_script( 'am_js', 'am_js_values', array( 
            'ajax_url' => AM_SITE_BASE_URL.'/?call=ajax'//admin_url('admin-ajax.php')
            ) );
    }
    
    public function am_load_lesson_contents() {
        
        if( !empty($_POST['lesson']) ) {
            
			
			$args = explode("&",$_POST['lesson']);
            $lesson_product_query = explode("@",$args[0]);
            $lesson_id = $this->am_number_decrypt($lesson_product_query[0]);
            $product_id = $this->am_number_decrypt($lesson_product_query[1]);
            $module_id = $this->am_number_decrypt($lesson_product_query[2]);
            $evergreen_email = $offer_id = '';
            $extra_param = explode("=",$args[1]);
			
			if( $extra_param[0] == 'eid' ) {
                $evergreen_email = trim($extra_param[1]);
            }
            if( $extra_param[0] == 'offer_id' ) {
                $offer_id = trim($extra_param[1]);
            }
			
			
            //echo $evergreen_email;
            $data = $this->am_get_lesson_content( $lesson_id, $product_id, $module_id, $evergreen_email, $offer_id );  
			
			//Lesson Finish Track Record
			$this->am_finished_lesson_record($lesson_id);    
            
            $html = $data['html'];
            $instructor = $data['instructor'];
            $duration = $data['duration'];
            $title      = $data['title'];
			
        }
        
        $return = array( 'error'=> false, 'content' => $html, 'duration'=> $duration, 'instructor' => $instructor, 'title' => $title );

        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
	
	
	public function am_load_lesson_contents_quiz_done() {
		
        if( !empty($_POST['lesson']) ) {
			
			$args = explode("&",$_POST['lesson']);
            $lesson_product_query = explode("@",$args[0]);
            $lesson_id = $this->am_number_decrypt($lesson_product_query[0]);
            $product_id = $this->am_number_decrypt($lesson_product_query[1]);
            $module_id = $this->am_number_decrypt($lesson_product_query[2]);
            $evergreen_email = $offer_id = '';
            $extra_param = explode("=",$args[1]);
			
			if( $extra_param[0] == 'eid' ) {
                $evergreen_email = trim($extra_param[1]);
            }
            if( $extra_param[0] == 'offer_id' ) {
                $offer_id = trim($extra_param[1]);
            }
			         
            
            //echo $evergreen_email;
            $data = $this->am_get_lesson_content( $lesson_id, $product_id, $module_id, $evergreen_email, $offer_id );
			
			//Lesson Finish Track Record
			$this->am_finished_lesson_record($lesson_id);   
            
            $html = $data['html'];
            $instructor = $data['instructor'];
            $duration = $data['duration'];
            $title      = $data['title'];
			
        }
        
        $return = array( 'error'=> false, 'content' => $html, 'duration'=> $duration, 'instructor' => $instructor, 'title' => $title );

        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
	
    
    public function am_get_lesson_content( $lesson_id, $product_id, $module_id, $evergreen_email = '', $offer_id = '' ) {
        
        if( !is_numeric( $lesson_id ) || !is_numeric($product_id) || empty($module_id) ) {
            return '';
        }
        
        $current_user = wp_get_current_user();
        
        $product = array_shift($this->am_get_products( "id = '".$product_id."'" ));
        
        $lesson = get_post( $lesson_id );
        $lesson_data = get_post_meta( $lesson_id, '_am_lesson_data', true );
        
        $lessons = $this->am_get_user_lessons( $product, $evergreen_email );
        
        $product_member = array_shift($this->am_get_products_members( "user_id = '".$current_user->ID."' AND product_id = '".$product->id."'" ));
        
        $active_lessons = array();
		$active_modules= array();
        $lesson_sumit_access = array();
        $required_coins = array();
        $now_date = strtotime('now');
        if( !empty($evergreen_email) ) {
            if( $product->enable_evergreen == 'yes' && !filter_var($evergreen_email, FILTER_VALIDATE_EMAIL) === false ) {
                $evergreen_row = $this->am_get_evergreen_user( $evergreen_email, $product );
            }
        }
        
        foreach( $lessons as $single_lesson ) { 
            //if( get_post_status($single_lesson->lesson_id) == 'publish' ) {
               $active_lessons[] = $single_lesson->lesson_id;
			   $active_modules[] = $single_lesson->module_id;
            //}
            if($product->enable_coins == 'yes'){
                $required_coins[$single_lesson->module_id][$single_lesson->lesson_id] = false;
                $coins = $this->am_get_post_coins($single_lesson->lesson_id);
                $user_purchased_posts = get_user_meta( $current_user->ID, 'user_purchased_posts', true );
                if(empty($user_purchased_posts)) {
                    $user_purchased_posts = array();
                }
                if( $coins > 0 && !in_array($single_lesson->lesson_id, $user_purchased_posts) ) {
                    $required_coins[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                }else{
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                }
            }elseif(is_numeric($offer_id)){
                unset($offers_structure);
                $offers_structure = $this->am_get_offers_structure( "offer_id = '".$offer_id."' AND lesson_id = '".$single_lesson->lesson_id."' ORDER BY id ASC" );
                if( $offers_structure ) {
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                }else{
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = false;
                }
            }elseif( $product->enable_sumit == 'yes' &&  0 == $current_user->ID ) {
                if( $single_lesson->free_access_start <= $now_date && $single_lesson->free_access_end >= $now_date ) {
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                }else{
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = false;
                }
            }elseif( $product->enable_evergreen == 'yes' && !filter_var($evergreen_email, FILTER_VALIDATE_EMAIL) === false ) {
                if( $this->am_is_lesson_evergreen( $single_lesson, $evergreen_row ) ) {
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                }else{
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = false;
                }
            }elseif( $product->enable_delay_access == 'yes' &&  0 != $current_user->ID && $single_lesson->days_delay > 0 ) {
                $days_delay = strtotime( "+".$single_lesson->days_delay." days", $product_member->member_timestamp );
                if( $days_delay <= $now_date ) {
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
                }else{
                    $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = false;
                }
            }else{
                $lesson_sumit_access[$single_lesson->module_id][$single_lesson->lesson_id] = true;
            }
        }
		
		
        foreach ( $active_lessons as $index => $active_lesson ) {
            if( $active_lesson == $lesson_id) {
                if( ($index+1) == sizeof($active_lessons) ) {
                    $next_lesson = $active_lessons[0];
                }else{
                    $next_lesson = $active_lessons[$index+1];
                }
                break;
            }
        }
		
        
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/front/am_get_lesson_content.php';
        $html = ob_get_contents();
        ob_end_clean();
        
        $instructor_text = $js = $duration = '';
        
        if( $lesson_data['duration'] < 10 && !empty( $lesson_data['duration'] ) ) {
            $duration.= '0';            
        }
        
        if( !empty( $lesson_data['duration'] ) ) {
            $duration.=$lesson_data['duration'];
            $duration_text = '<div class="am_lesson_time" style="color:'.$product->post_duriation_text_color.'; font-size:'.$product->post_duriation_text_size.'; font-family:'.$product->post_duriation_text_font.'"><i class="fa fa-clock-o" aria-hidden="true"></i> '.$duration." ".__( "Minutes", "am" ).'</div>';
        }
        
        if( !empty( $lesson_data['instructor_name'] ) || !empty( $lesson_data['instructor_image'] ) ) {
            $instructor_text.='<div class="am_lesson_instructor">';
            if( !empty( $lesson_data['instructor_image'] ) ) {
                $instructor_text.= '<img src="'.$lesson_data['instructor_image'].'" width="50" />';
            }
            if( !empty( $lesson_data['instructor_name'] ) ) {
                $instructor_text.='<span style="color: '.$product->instructor_text_color.'; font-size:'.$product->instructor_text_size.'; font-family:'.$product->instructor_text_font.';">'.__( 'INSTRUCTOR', 'am' ).'<br>'.$lesson_data['instructor_name'].'</span>';
            }
            $instructor_text.='</div>';
        }
        
        $data = array( 'html' => $html, 'duration' => $duration_text, 'instructor' => $instructor_text, 'title' => $lesson->post_title );
        
        return $data;
    }
    
    public function am_is_lesson_evergreen( $single_lesson, $evergreen_row ) {
        
        $start_day = $single_lesson->evergreen_start_day;
        $start_hour = $single_lesson->evergreen_start_hour;
        $end_day = $single_lesson->evergreen_end_day;
        $end_hour = $single_lesson->evergreen_end_hour;
        $time_string = '';
        $start_date = '';
        $end_date = '';
        if( $start_day > 0 ) {
            if( $start_day > 1 ) {
               $time_string = '+'.$start_day.' days'; 
            }else{
               $time_string = '+'.$start_day.' day'; 
            }                    
            $start_date = strtotime(date( 'Y-m-d', strtotime( $time_string, $evergreen_row->access_timestamp )).' '.$start_hour.':00:00');
        }
        if( $end_day > 0 ) {
            if( $start_day > 1 ) {
               $time_string = '+'.$end_day.' days'; 
            }else{
               $time_string = '+'.$end_day.' day'; 
            }                    
            $end_date = strtotime(date( 'Y-m-d', strtotime( $time_string, $evergreen_row->access_timestamp )).' '.$end_hour.':00:00');
        }
        $now_date = strtotime('now');
        if( $now_date >= $start_date  && $now_date <= $end_date ) {
            return true;
        }
        return false;
    }
    
    public function am_product( $atts ) {
		
        $html = '';
        if( is_admin() ) {
            return $html;
        }
        $product_id = $atts['id'];
		
        $current_user = wp_get_current_user();
        
	    $evergreen_email = trim($_GET['eid']);
        $offer_id = base64_decode($_GET['oid']);
            
        if( !empty($_GET['lesson']) ) {
            $lesson_product_query = explode("@",$_GET['lesson']);
            $load_lesson = $this->am_number_decrypt($lesson_product_query[0]);
            $load_product_id = $this->am_number_decrypt($lesson_product_query[1]);
            $load_module_id = $this->am_number_decrypt($lesson_product_query[2]);
            if( $load_product_id != $product_id ) {
                return $html;
            }
            if( !empty($load_product_id) ) {
                $product_id = $load_product_id;
            }
        }
        
	   
	    if( !is_numeric($product_id) ) {
            return $html;
        }
        
		
        $product = array_shift($this->am_get_products( "id = '".$product_id."'" ));
		
        if( empty($product) ) {
            return $html;
        }
        //print_r($product);exit();
		
	   $lessons = $this->am_get_user_lessons( $product, $evergreen_email );
        
        $error_text = '';
        if( sizeof($lessons) == 0 ) {
            if( $product->enable_sumit == 'yes' ) {
                $error_text = $product->error_text;
            }else{
                $this->redirect(get_permalink($product->error_redirect));
            }
        }else{
            $modules = $this->am_get_modules();
            $lesson_ids = array();
            $lesson_sumit_access = array();
            $required_coins = array();
            $now_date = strtotime('now');
            
            
            if( !empty($evergreen_email) ) {
                if( $product->enable_evergreen == 'yes' && !filter_var($evergreen_email, FILTER_VALIDATE_EMAIL) === false ) {
                    $evergreen_row = $this->am_get_evergreen_user( $evergreen_email, $product );
                }
            }
        
            foreach( $lessons as $lesson ) { 
                $lesson_ids[$lesson->module_id][] = $lesson->lesson_id;
                if($product->enable_coins == 'yes'){
                    $required_coins[$lesson->module_id][$lesson->lesson_id] = false;
                    $coins = $this->am_get_post_coins($lesson->lesson_id);
                    $user_purchased_posts = get_user_meta( $current_user->ID, 'user_purchased_posts', true );
                    if(empty($user_purchased_posts)) {
                        $user_purchased_posts = array();
                    }
                    if( $coins > 0 && !in_array($lesson->lesson_id, $user_purchased_posts) ) {
                        $required_coins[$lesson->module_id][$lesson->lesson_id] = true;
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;
                    }else{
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;
                    }
                }elseif(is_numeric($offer_id)){
                    $offers_structure = $this->am_get_offers_structure( "offer_id = '".$offer_id."' AND lesson_id = '".$lesson->lesson_id."' ORDER BY id ASC" );
                    if( $offers_structure ) {
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;
                    }else{
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = false;
                    }
                }elseif( $product->enable_sumit == 'yes' &&  0 == $current_user->ID ) {
                    if( $lesson->free_access_start <= $now_date && $lesson->free_access_end >= $now_date ) {
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;
                    }else{
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = false;
                    }
                }elseif( $product->enable_evergreen == 'yes' && !filter_var($evergreen_email, FILTER_VALIDATE_EMAIL) === false ) {
                    if( $this->am_is_lesson_evergreen( $lesson, $evergreen_row ) ) {
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;
                    }else{
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = false;
                    }
                }elseif( $product->enable_delay_access == 'yes' &&  0 != $current_user->ID && $lesson->days_delay > 0 ) {
                    $days_delay = strtotime( "+".$lesson->days_delay." days",$now_date);
                    if( $days_delay <= $now_date ) {
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;
                    }else{
                        $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = false;
                    }
                }else{
                    $lesson_sumit_access[$lesson->module_id][$lesson->lesson_id] = true;                   
                }
                
            }            
        }
        
        $options = get_option( 'am_settings' );
        
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/front/am_product.php';
        $html = ob_get_contents();
        ob_end_clean();
        
        return $html;
    }
    
    public function am_offer( $atts ) {
        
        $html = '';
        if( is_admin() ) {
            return $html;
        }
        $offer_id = $atts['id'];
        $current_user = wp_get_current_user();
        
        if( !is_numeric($offer_id) ) {
            return $html;
        }
        
        $offer = array_shift($this->am_get_offers( "id = '".$offer_id."'" ));
        if( empty($offer) ) {
            return $html;
        }
        
        $products = $this->am_get_user_offer_products($offer);
        
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/front/am_offer.php';
        $html = ob_get_contents();
        ob_end_clean();
        
        return $html;
    }
    
    public function am_get_user_offer_products( $offer ) {
        
        $offer_id = $offer->id;
        $current_user = wp_get_current_user();
        if ( 0 == $current_user->ID ) {
            $this->redirect(get_permalink($offer->error_redirect));
        }else{
            $user_locked = get_user_meta( $current_user->ID, 'am_account_locked', true );
            if( $user_locked == 'yes' ) {
                $this->redirect(get_permalink($product->lock_redirect));
            }
            if( $this->am_user_have_access( $current_user->ID, $offer_id, 'offer' ) ) {
                $offers_structure = $this->am_get_offers_structure( "offer_id = '".$offer_id."' ORDER BY id ASC" );
                $offer_products_ids = array();
                foreach( $offers_structure as $offer_structure ) {
                    $offer_products_ids[] = $offer_structure->product_id;
                }
                $offer_products_ids = array_unique($offer_products_ids);

                $products = $this->am_get_products( "id IN( '".  implode("', '", $offer_products_ids). "' )" );
            }else{
                $this->redirect(get_permalink($offer->error_redirect));
            }            
        }
        
        return $products;
    }

    public function am_get_user_lessons( $product, $evergreen_email = '' ) {
        
        $lessons = array();
        if( empty( $product ) ) {
            return $lessons;
        }
        if( empty($evergreen_email) ) {
            $evergreen_email = trim($_GET['eid']);
        }
        if (!filter_var($evergreen_email, FILTER_VALIDATE_EMAIL) === false) {
            if ( $product->enable_evergreen == 'yes' && $this->am_is_email_evergreen( $evergreen_email, $product ) ) {
                $lessons = $this->am_get_visitor_lessons( $product, $evergreen_email );
            }else{
                $this->redirect(get_permalink($product->error_redirect));
            }
        }else{
            $current_user = wp_get_current_user();
            if ( 0 == $current_user->ID ) {
                $lessons = $this->am_get_visitor_lessons( $product );
            }else{
                $user_locked = get_user_meta( $current_user->ID, 'am_account_locked', true );
                if( $user_locked == 'yes' ) {
                    $this->redirect(get_permalink($product->lock_redirect));
                }
                
				$lessons = $this->am_get_login_user_lessons( $current_user->ID, $product );
            }
        }
        
        return $lessons;
    }
    
    public function am_get_visitor_lessons( $product, $evergreen_email = '' ) {
        
        $lessons = array();
        
        if( empty( $product ) ) {
            return $lessons;
        }
        
        if (!filter_var($evergreen_email, FILTER_VALIDATE_EMAIL) === false && $product->enable_evergreen == 'yes' ) {
            $lessons = $this->am_get_course_structure( "product_id = '".$product->id."' ORDER BY id ASC" );
        }elseif( $product->enable_sumit == 'yes' ) {
            $lessons = $this->am_get_course_structure( "product_id = '".$product->id."' ORDER BY id ASC" );
        }
        
        return $lessons;
    }
    
    public function am_get_login_user_lessons( $user_id, $product ) {
        
        $lessons = array();
        if( empty($user_id) || empty( $product ) ) {
            return $lessons;
        }
		
		
		/* Changes by ilyaskhan for Admin access to All Products 
		 * on 27-02-2017
		 */
		
		//If User can not Admin then goes to If condition
		if (!current_user_can('administrator') && !is_admin()) {
			
			if( $this->am_user_have_access( $user_id, $product->id ) ) {
				$lessons = $this->am_get_course_structure( "product_id = '".$product->id."' ORDER BY id ASC" );
			}else{
				
				$this->redirect(get_permalink($product->error_redirect));
			}
		
		//If User is Admin then can access to All Lessons
		}else{
			
			$lessons = $this->am_get_course_structure( "product_id = '".$product->id."' ORDER BY id ASC" );	
			
		}
		/* End Changes here by ilyaskhan
		 * on 27-02-2017
		 */
		
        
        return $lessons;
    }
    
    public function am_user_have_access( $user_id, $product_id, $type = 'product' ) {
        
        if( empty($user_id) || empty($product_id) ) {
            return false;
        }
        if( $type == 'offer' ) {
            $product_members = $this->am_get_products_members( "offer_id = '".$product_id."' AND user_id = '".$user_id."'" );
        }else{
            $product_members = $this->am_get_products_members( "product_id = '".$product_id."' AND user_id = '".$user_id."'" );
        }
        if( sizeof($product_members) == 0 ) {
            return false;
        }
        $product_member  = array_shift( $product_members );
        if( !empty($product_member->order_id ) ) {
            $orders = $this->am_get_orders( "id = '".$product_member->order_id."'" );
            $order  = array_shift( $orders );
            if( $order->status == 'inactive' ) {
                return false;
            }
        }
        return true;
    }
    
    public function am_on_digistore24_payment( $data, $event ) {
        
        $products = $this->am_get_products();
        $this->am_log($products, 'Products');
        $found_product_id = 0;
		
		
		foreach( $products as $product ) {
		
		    $digi_products = $product->digi_products;
			
			$this->am_log($digi_products, 'DigiStore24 Products');
		
			$foundstringinarray = strstr($digi_products, $data['product_id']);

			if( $foundstringinarray != false ) {

					$this->am_log($product->id, 'Product matched');
                	$found_product_id = $product->id;
                	break;
			}
			
		
		}
        if( $found_product_id ) {
            $data['product_id']     = $found_product_id;
            $data['product_name']   = $product->product_name;
            $data['status']         = 'active';
            
            $this->am_log($found_product_id, 'Product found');
            $user_id = $this->am_register_new_user( $data );
            $this->am_log( $user_id, 'User created');
            if( $event == 'on_payment' ) {
                $order_id = $this->am_save_digistore24_order( $data );
                if( empty($order_id) ) {
                    $order_id = 0;
                }
            }
            if ( $user_id ) {
                if( $event == 'on_payment_missed' ) {
                    $this->am_log( 'Payment missed' );
                    if($product->lock_user_on_no_payment == 'yes' ) {
                        update_user_meta( $user_id, 'am_account_locked', 'yes' );
                        $this->am_log( 'After user locked due to Payment missed' );
                    }
                }  
                $this->am_log( 'Before Save member' );
                $this->am_save_product_member(array( 'product_id'=> $found_product_id, 'user_id' => $user_id, 'order_id' => $order_id ));
                $this->am_log( 'After Save member' );
                //return $user_id;
            }
        }else{
            $this->am_log( 'Product not found', 'Product not found');
            $offers = $this->am_get_offers();
            $found_offer_id = 0;
            foreach( $offers as $offer ) {
                $digi_products = maybe_unserialize($offer->digi_products);
                $this->am_log($digi_products, 'DigiStore24 Products');
                if( (is_array($digi_products) && in_array( $data['product_id'], $digi_products )) || ( !is_array($digi_products) && $digi_products == $data['product_id'] ) ) {
                    $this->am_log($offer->id, 'Offer matched');
                    $found_offer_id = $offer->id;
                    break;
                }
            }
            if( $found_offer_id ) {
                $data['offer_id']       = $found_offer_id;
                $data['product_name']   = $offer->offer_name;
                $data['status']         = 'active';

                $this->am_log($found_offer_id, 'Product found');
                $user_id = $this->am_register_new_user( $data );
                $this->am_log( $user_id, 'User created');
                if( $event == 'on_payment' ) {
                    $order_id = $this->am_save_digistore24_order( $data );
                    if( empty($order_id) ) {
                        $order_id = 0;
                    }
                }
                if ( $user_id ) {
                    if( $event == 'on_payment_missed' ) {
                        $this->am_log( 'Payment missed' );
                        if($offer->lock_user_on_no_payment == 'yes' ) {
                            update_user_meta( $user_id, 'am_account_locked', 'yes' );
                            $this->am_log( 'After user locked due to Payment missed' );
                        }
                    }  
                    $this->am_log( 'Before Save member' );
                    $this->am_save_product_member(array( 'offer_id'=> $found_offer_id, 'user_id' => $user_id, 'order_id' => $order_id));
                    $this->am_log( 'After Save member' );
                    //return $user_id;
                }                
            }else{
                $this->am_log( 'Offer not found', 'Offer not found');
            }
            
        }
        return true;
    }
    
    public function am_after_switch_theme() {
        
        copy( AM_PLUGIN_PATH."templates/front/am_products_template.php",get_template_directory()."/am_products_template.php" );
        copy( AM_PLUGIN_PATH."templates/front/am_offers_template.php",get_template_directory()."/am_offers_template.php" );
		//copy( AM_PLUGIN_PATH."templates/front/am_survey_template.php",get_template_directory()."/am_survey_template.php" );
    }
    
    public function am_template_redirect() {
		global $wpdb;
		ob_end_clean();
		
	
	
	
        if( $_REQUEST['am_digistore24_ipn'] == 'yes' ) {
			
			$sql    = "SELECT * FROM `".$wpdb->prefix."am_orders` ";
			$results=$wpdb->get_results($sql);
			$order_count=count($results);
			$am_lincense_key=constant('AM_LICENSE_KEY'); 
	
			if(empty($am_lincense_key) && $order_count>50){ 
				
				return;	
			
			
			}
		
			
			
            $this->am_log( 'Function call for IPN', 'Function call for IPN');
            $this->am_log( $_REQUEST, 'IPN Call Data');
            $event                  = $_REQUEST['event'];
            $data['api_mode']       = $_REQUEST['api_mode'];
            $data['order_id']       = $_REQUEST['order_id'];
            $data['product_id']     = $_REQUEST['product_id'];
            $data['product_name']   = $_REQUEST['product_name'];
            $data['billing_type']   = $_REQUEST['order_item_billing_type'];
            $data['email']          = $_REQUEST['email'];
            $data['first_name']     = $_REQUEST['address_first_name'];
            $data['last_name']      = $_REQUEST['address_last_name'];
			
			
			
			$checkemails = $wpdb->get_row("SELECT id,tags,optin_form_id FROM `".$wpdb->prefix."am_contacts` WHERE email_address = '".$_REQUEST['email']."'");
	
			if(count($checkemails) == 0){
				
				$created_date			=	date("Y-m-d H:i:s");

				$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` (`name`,`email_address`,`status`,`created_date`) VALUES ('".$_REQUEST['address_first_name']."', '".$_REQUEST['email']."','0', '".$created_date."')";
			
			}
			else
			{
				$sql = "UPDATE `".$wpdb->prefix."am_contacts` set name='".$_REQUEST['address_first_name']."' where email_address = '".$_REQUEST['email']."'";
				
			}
			
		
			
		
			$wpdb->query($sql);
			
			
            
            if($event == 'connection_test') {
                $this->am_log( 'Connection Test', 'Connection Test');
                die('OK');
            }elseif($event == 'on_payment') {
                $this->am_log( 'On Payment Start', 'On Payment Start');
                $this->am_on_digistore24_payment( $data, $event );
                die('OK');
            }elseif($event == 'on_payment_missed') {
                $this->am_log( 'On Payment Missed', 'On Payment Missed');
                $this->am_on_digistore24_payment( $data, $event  );
                die('OK');
            }elseif($event == 'on_refund') {
                $this->am_log( 'On Payment Refund', 'On Payment Refund');
                die('OK');
            }elseif($event == 'on_chargeback') {
                $this->am_log( 'On Payment Chargeback', 'On Payment Chargeback');
                die('OK');
            }else{
                $this->am_log( 'Unknow event '.$event, 'On Payment Start');
                die('OK');
            }
            exit();
        }
        if( $_REQUEST['call'] == 'ajax' ) {
            if( !empty( $_REQUEST['action']) ) {
                call_user_func(array($this, $_REQUEST['action'] ));
            }
            exit();
        }
    }
    
    public function am_verify_plugin_license() {
        
        if(!$this->am_process_license()) {
            update_option( 'am_plugin_valid', 'false' );
        }else{
            update_option( 'am_plugin_valid', 'true' );
        }
    }
    
    public function am_available_coins() {
        
        $current_user = wp_get_current_user();
        $available_coins = $this->am_get_user_available_coins($current_user->ID);
        return $available_coins;
    }
    
    public function am_purchase_coins() {
        
        global $am_remaining_coins;
        $post_id            = $_POST['post_id'];
        $coins              = $_POST['coins'];
        $should_redirect    = $_POST['should_redirect'];
        
        $error = false;
        
        if( !$error && !is_numeric($post_id) ) {
            $error = true;
            $message = __( 'There is some error to purchase coins. Some wrong data has provided.', 'am' );
        }
        
        if( !$error && $post_id <= 0 ) {
            $error = true;
            $message = __( 'There is some error to purchase coins. Some wrong data has provided.', 'am' );
        }
        
        $post_coins = $this->am_get_post_coins($post_id);
        if( !$error && $post_coins != $coins ) {
            $error = true;
            $message = __( 'There is some error to purchase coins. Some wrong data has provided.', 'am' );
        }
        
        $current_user = wp_get_current_user();
        if( !$error && $current_user->ID == 0 ) {
            $error = true;
            $message = __( 'You are not authorize to purchase coins. Please login to buy coins.', 'am' );
        }
        
        if( !$error && !$this->am_set_user_used_coins( $current_user->ID, $coins ) ) {
            $error = true;
            $message = __( 'You have insufficient coins. You should buy some more coins.', 'am' );
        }
        
        $return_url = '';
        if( !$error ) {
            if( $should_redirect == 'yes' ) {
                $return_url = get_permalink($post_id);
            }            
            $user_purchased_posts = get_user_meta( $current_user->ID, 'user_purchased_posts', true );
            if( !in_array($post_id, $user_purchased_posts)) {
                $user_purchased_posts[] = $post_id;
                update_user_meta( $current_user->ID, 'user_purchased_posts', $user_purchased_posts );            
            }
            $lesson = get_post($post_id);
            $message = '<div class="am_lesson_thumb">'.get_the_post_thumbnail( $lesson->ID, 'full' ).'</div>';
            $message.= '<div class="am_lesson_content_">'.do_shortcode($lesson->post_content).'</div>';            
        }
        
        $return = array( 'error'=> $error, 'message' => $message, 'return_url' => $return_url );

        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
    
    public function am_coins_purchased_button() {
        $post_to_purchase = $_GET['amreturnid'];
        if( !is_numeric($post_to_purchase) ) {
            return '';
        }
        if( $post_to_purchase <= 0 ) {
            return '';
        }
        $coins = $this->am_get_post_coins($post_to_purchase);
        if( $coins == 0 ) {
            return '';
        }
        $should_redirect = 'yes';
        if( $_GET['should_redirect'] == 'false' ) {
            $should_redirect = 'no';
        }
        $html = '';
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/front/am_coins_purchased_button.php';
        $html = ob_get_contents();
        ob_end_clean();
        return $html;
    }
    
    public function am_wp_action() {
        
		$current_user = wp_get_current_user();
		
		/////////// Code for Page and Post Restrictions By Ilyaskhan on 20-07-2017 /////////////
		if(!is_page_template('am_products_template.php') &&  !is_admin() && !$_GET['call']=='ajax' && !$_GET['action']=='check_license_key'){
		
		global $post;
		
		$now_date = strtotime('now');
		$evergreen_email = trim($_GET['eid']);
		$allowed_products_ids = array();
		
        if( $current_user->ID != 0 ) {
			
			$product_members = $this->am_get_products_members( "user_id = '".$current_user->ID."'" );
			foreach( $product_members as $member ) {
                $allowed_products_ids[] = $member->product_id;
            }
            $allowed_products_ids = array_unique($allowed_products_ids);
			
			//Check Page Structure
			$check_page = $this->am_check_page_restrictions($post->ID);
			
			if(count($check_page)>0){
				
				foreach($check_page as $restrict){
					
					$product_id = $restrict->product_id;
					if(in_array($product_id,$allowed_products_ids)){
						
						$allowed_page = "yes";
						break;
						
					}else{
						
						if($restrict->free_access_start <= $now_date && $restrict->free_access_end >= $now_date){
							$allowed_page = "yes";
							break;
						}else{
							$allowed_page = "no";
						}
					}
				}
				
				if($allowed_page =="no"){
					
					global $wp_query;
					$wp_query->set_404();
					$wp_query->is_404 = true;
					status_header(404);
					nocache_headers();
					include( get_query_template( '404' ) );
					die();	
					
				}//end if
				
			}//end if pages found
			
        }else{
			
			//Check Page Structure
			$check_page = $this->am_check_page_restrictions($post->ID);
			 
			if(count($check_page)>0){
				
				foreach($check_page as $restrict) {
				
					if($restrict->free_access_start <= $now_date && $restrict->free_access_end >= $now_date){
						$allowed_page = "yes";
						break;
					}else{
						$allowed_page = "no";
					}
				
				}//end for
				
				if($allowed_page =="no"){
					
				global $wp_query;
				$wp_query->set_404();
				$wp_query->is_404 = true;
				status_header(404);
				nocache_headers();
				include( get_query_template( '404' ) );
				die();	
					
			 }//end if 	
			 
			}//end if pages found
			 
		}//End if
		}//End if Page is Not Product Page
		/////////////////////////// End Code for Page and Post Restrictions  ///////////////////
		
        $allowed_products_ids = array();
        if( $current_user->ID != 0 ) {
            $product_members = $this->am_get_products_members( "user_id = '".$current_user->ID."'" );
            foreach( $product_members as $member ) {
                $allowed_products_ids[] = $member->product_id;
            }
            $allowed_products_ids = array_unique($allowed_products_ids);
        }
        $products = $this->am_get_products();
        $user_restricted_posts = array();
        $am_products = array();
        foreach( $products as $product ) {
            if( !in_array($product->id, $allowed_products_ids ) ) {
                $secure_pages = maybe_unserialize($product->product_secure_pages);
                $secure_posts = maybe_unserialize($product->product_secure_posts);
                foreach( $secure_pages as $page ) {
                    $user_restricted_posts[$product->id][] = $page;
                    $am_products[$product->id] = $product;
                }
                foreach( $secure_posts as $post222 ) {
                    $user_restricted_posts[$product->id][] = $post222;
                    $am_products[$product->id] = $product;
                }
            }
        }
        
        $user_restricted_posts = array_unique($user_restricted_posts);
        $user_purchased_posts = get_user_meta( $current_user->ID, 'user_purchased_posts', true );
        if(empty($user_purchased_posts)) {
            $user_purchased_posts = array();
        }
        
        global $post;
        foreach( $user_restricted_posts as $pro_id=>$res_posts ) {
            if(in_array($post->ID, $res_posts)) {
                $coins = $this->am_get_post_coins($post->ID);
                if( $coins > 0 && !in_array($post->ID, $user_purchased_posts) ) {
                    if( empty($am_products[$pro_id]->error_redirect) ) {
                        global $wp_query;
                        $wp_query->set_404();
                        $wp_query->is_404 = true;
                        status_header(404);
                        nocache_headers();
                        include( get_query_template( '404' ) );
                        die();
                    }else{
                        $url = get_permalink($am_products[$pro_id]->error_redirect);
                        if(strpos("?", $url) === False ) {
                            $url.="?amreturnid=".$post->ID;
                        }else{
                            $url.="&amreturnid=".$post->ID;
                        }
                        $this->redirect($url);
                    }
                }
            }
        }
    }
    
    public function am_get_post_coins( $post_id='' ) {
        if( !is_numeric($post_id) ) {
            return "0";
        }
        global $current_user;
        get_currentuserinfo();
        if( $current_user->ID == 0 ) {
            return 0;
        }
        
        $post_type = get_post_type( $post_id );
        $order = array_shift($this->am_get_orders( "buyer_email = '".$current_user->user_email."'" ));
        if( !empty($order)) {
            $product_id = $order->product_id;
            $product = array_shift($this->am_get_products( "id = '".$product_id."'" ));
            if($product->enable_coins != 'yes'){
                return 0;
            }
            if( $post_type == 'lessons' ) {
                $user_coins = array_shift($this->am_get_course_structure("product_id = '".$product_id."' AND lesson_id = '".$post_id."'"));
                if( !empty($user_coins)) {
                    $am_coins = $user_coins->coins;
                }else{
                    $am_coins = 0;
                }                
            }elseif( $post_type == 'post' || $post_type == 'page' ){
                $secure_pages = maybe_unserialize($product->product_secure_pages);
                $counter = 0;
                $post_found = false;
                foreach( $secure_pages as $page_id ) {
                    if( $page_id == $post_id ) {
                        $post_found = true;
                        break;
                    }
                    $counter++;
                }
                if(!$post_found) {
                    $secure_posts = maybe_unserialize($product->product_secure_posts);
                    $counter = 0;
                    foreach( $secure_posts as $page_id ) {
                        if( $page_id == $post_id ) {
                            $post_found = true;
                            break;
                        }
                        $counter++;
                    }
                }else{
                    $pages_price = maybe_unserialize($product->pages_price);
                    $am_coins = $pages_price[$counter];
                }
                if(!$post_found) {
                    $am_coins = 0;
                }else{
                    $posts_price = maybe_unserialize($product->posts_price);
                    $am_coins = $posts_price[$counter];
                }
            }            
        }else{
            return 0;
        }
        
        $options = get_option( 'am_settings', array() );
        //$am_coins = get_post_meta( $post_id, '_am_coins', true );
        if(!empty($am_coins)){
            return $am_coins;            
        }elseif(!empty($options['default_coins'])){
            return $options['default_coins'];            
        }else{
            return "0";            
        }
        /*
        if( !is_numeric($post_id) ) {
            return "0";
        }
        $options = get_option( 'am_settings', array() );
        $am_coins = get_post_meta( $post_id, '_am_coins', true );
        if(!empty($am_coins)){
            return $am_coins;            
        }elseif(!empty($options['default_coins'])){
            return $options['default_coins'];            
        }else{
            return "0";            
        }*/
    }
    
    private function make_safe( $variable ) {

        $variable = $this->strip_html_tags($variable);
        $bad = array("=","<", ">", "/","\"","`","~","'","$","%","#");
        $variable = str_replace($bad, "", $variable);
        $variable = mysql_real_escape_string(trim($variable));

        return $variable;
    }

    private function strip_html_tags( $text ) {
        $text = preg_replace(
                array(
                  // Remove invisible content
                        '@<head[^>]*?>.*?</head>@siu',
                        '@<style[^>]*?>.*?</style>@siu',
                        '@<script[^>]*?.*?</script>@siu',
                        '@<object[^>]*?.*?</object>@siu',
                        '@<embed[^>]*?.*?</embed>@siu',
                        '@<applet[^>]*?.*?</applet>@siu',
                        '@<noframes[^>]*?.*?</noframes>@siu',
                        '@<noscript[^>]*?.*?</noscript>@siu',
                        '@<noembed[^>]*?.*?</noembed>@siu'
                ),
                array(
                        '', '', '', '', '', '', '', '', ''), $text );

        return strip_tags( $text);
    }

    // Function to safe redirect the page without warnings
    private function redirect( $url ) {
        echo '<script language="javascript">window.location.href="'.$url.'";</script>';
        exit();
    }
	
	
	public function am_get_survey_report($survey_id, $user_id){
		
		global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_survey_report` WHERE survey_id=".$survey_id." AND user_id =".$user_id;
        $survey_report = $wpdb->get_row( $sql );
        
        return $survey_report;
		
	}
	
	
	public function am_submit_survey_report(){
		 
		 $user_id = get_current_user_id(); 
		 $survey_id = $_POST['survey_id'];
		 $user_action = $_POST['user_action'];
		 
		 global $wpdb;
		 
		 if($user_action =='add'){
				
		 $created_date = date('Y-m-d G:i:s');
		
		 $sql = "INSERT INTO `".$wpdb->prefix."am_survey_report` (`user_id`,`survey_id`,`created_date`) VALUES ('".$user_id."','".$survey_id."','".$created_date."')";
		 $wpdb->query($sql);
		 
		 }else{
			 
		 $sql_delete = "DELETE FROM`".$wpdb->prefix."am_survey_report` WHERE survey_id = ".$survey_id." AND user_id = ".$user_id;
		 $wpdb->query($sql_delete);
		
		 }
		 
		 ///////////////////////////////////////////////////////////////////////
		 ////////////////******* Email Temaplates Trigger ******////////////////
		 $this->am_check_email_series();
		 ////////////////******* End Email Temaplates Trigger ******////////////
		 ///////////////////////////////////////////////////////////////////////
		 
		 echo "1";
		 exit();
		 
	}
	
	
	public function am_load_lesson_quiz_questions() {
		 
		 $product_id = $_POST['product_id'];
		 $lesson_id = $_POST['lesson_id'];
		 $module_id = $_POST['module_id'];
		 $count=1;
		 
		 //Get Quiz lesson questions
		 $lesson_first_question = $this->am_get_lesson_first_question($product_id,$lesson_id);
		 
		 //Get Quiz Question Options
		 $quiz_question_options = $this->am_get_quiz_question_options($lesson_first_question->id);
		 
		 
		 //Define Global Variables
		 global $glob_lesson_id,$glob_product_id,$glob_main_count,$glob_count;
		 
		 $glob_lesson_id  = $lesson_id;
		 $glob_product_id = $product_id;
		 $glob_main_count = $count;
		 $glob_count      = $count -1;
		 
		 $response ='<div class="am_lesson_content_container">
						<i class="fa fa-spinner fa-pulse fa-3x fa-fw am_lesson_ajax_loader"></i>
						<div class="quiz_cls">
							'.do_shortcode('[am_quiz_progressbar]').'
						</div>
						<div class="question_ans_reponse"></div>
						<div class="quiz_cls">
							<h4>'.$lesson_first_question->question.'?</h4>
						</div>';
						
						$i=0;
						foreach($quiz_question_options as $option_val){
						$i++;
							
							if($i==1){
								$sr="<b>A</b>";	
							}elseif($i==2){
								$sr="<b>B</b>";	
							}elseif($i==3){
								$sr="<b>C</b>";	
							}else{
								$sr="<b>D</b>";	
							}
							
						    $response .='<div class="quiz_cls">'.$sr.'. <span class="myrad"><input type="radio" name="quiz_answer" id="d1'.$i.'" class="quiz_answer" value="'.$option_val->id.'"> <label for="d1'.$i.'"> '.$option_val->options.'</label></span></div>';
							
						}
							
		 $response .='<div class="quiz_cls">
						<button type="button" product_id="'.$product_id.'" question_id="'.$lesson_first_question->id.'" module_id="'.$module_id.'" count="'.$count.'" class="btn btn-success sbt_quiz_answer">'.__( 'Submit Answer', 'am' ).'</button>	
					  </div>';
					  
		 $response .='</div>';
		 
        
		$progress_bar_response = do_shortcode('[am_quiz_progressbar]');
		echo $response."|".$progress_bar_response;
        exit();
		 
	}
	
	
	public function am_check_question_ans() {
		 
		 $option_id = $_POST['option_id'];
		 $question_id = $_POST['question_id'];
		 $module_id = $_POST['module_id'];
		 $product_id = $_POST['product_id'];
		 $count = $_POST['count'];
		 
		 //Check Question option answer
		 $check_question_option_ans = $this->am_check_question_option_ans($question_id,$option_id);
		 
		 //Get Question
		 $question_arr = $this->am_get_quiz_question($question_id);
		 $lesson_id = $question_arr->lesson_id;
		
		 //Get Quiz Question Options
		 $quiz_question_options = $this->am_get_quiz_question_options($question_id);
		 
		 
		 //Define Global Variables
		 global $glob_lesson_id,$glob_product_id,$glob_main_count,$glob_count;
		 
		 $glob_lesson_id  = $lesson_id;
		 $glob_product_id = $product_id;
		 $glob_main_count      = $count;
		 $glob_count      = $count;
		 
		 if($check_question_option_ans){
			 
			$response ='<div class="am_lesson_content_container">
						<i class="fa fa-spinner fa-pulse fa-3x fa-fw am_lesson_ajax_loader"></i>
						<div class="quiz_cls">
							'.do_shortcode('[am_quiz_progressbar]').'
						</div>
						<div class="quiz_cls">
							<h2>'.__( 'Your Answer', 'am' ).': <span style="color:green;">'.__( 'Correct', 'am' ).'</span></h2>
						</div>
						<div class="question_ans_reponse"></div>
						<div class="quiz_cls">
							<h4>'.$question_arr->question.'?</h4>
						</div>';
			
						$i=0;
						$count++;
						foreach($quiz_question_options as $option_val){
						$i++;	
				
							if($i==1){
								$sr="<b>A</b>";	
							}elseif($i==2){
								$sr="<b>B</b>";	
							}elseif($i==3){
								$sr="<b>C</b>";	
							}else{
								$sr="<b>D</b>";	
							}
							
							if($option_val->id == $option_id){
								$response .='<div class="quiz_cls">'.$sr.'. '.$option_val->options.'<span style="color:green;">  <i class="fa fa-check" aria-hidden="true"></i>   ('.__( 'Your Answer', 'am' ).')</span></div>';
							}else{
								$response .='<div class="quiz_cls">'.$sr.'. '.$option_val->options.'</div>';
							}
							
						}//End foreach
						
			if($quiz_percent=='100'){
				
				$button_label= __( 'Finish', 'am' );
				$finished_class ="lesson_finished_record";
				
			}else{
				
				$button_label= __( 'Next Question', 'am' );
				$finished_class ="";
				
			}
			
			$response .='<div class="quiz_cls">
							<button type="button" question_id="'.$question_id.'" module_id="'.$module_id.'" count="'.$count.'" product_id="'.$product_id.'" lesson_id="'.$lesson_id.'" class="btn btn-success quiz_next_question '.$finished_class.'">'.$button_label.' >></button>	
						 </div>';			
			$response .='</div>';
			
			 
		 }else{
			 
			 
			$response ='<div class="am_lesson_content_container">
						<i class="fa fa-spinner fa-pulse fa-3x fa-fw am_lesson_ajax_loader"></i>
						<div class="quiz_cls">
							'.do_shortcode('[am_quiz_progressbar]').'
						</div>
						<div class="quiz_cls">
							<h2>'.__( 'Your Answer', 'am' ).': <span style="color:red;">'.__( 'Incorrect', 'am' ).'</span></h2>
						</div>
						<div class="question_ans_reponse"></div>
						<div class="quiz_cls">
							<h4>'.$question_arr->question.'?</h4>
						</div>';
			
						$i=0;
						$count++;
						foreach($quiz_question_options as $option_val){
						$i++;
							
							if($i==1){
								$sr="<b>A</b>";	
							}elseif($i==2){
								$sr="<b>B</b>";	
							}elseif($i==3){
								$sr="<b>C</b>";	
							}else{
								$sr="<b>D</b>";	
							}
				
							if($option_val->id == $option_id){
								$response .='<div class="quiz_cls">'.$sr.'. '.$option_val->options.'  <span style="color:red;"> <i class="fa fa-times" aria-hidden="true"></i>    ('.__( 'Your Answer', 'am' ).')</span></div>';
							}elseif($option_val->answer =='1'){
								$response .='<div class="quiz_cls">'.$sr.'. '.$option_val->options.'  <span style="color:green;"><i class="fa fa-check" aria-hidden="true"></i>   ('.__( 'Correct Answer', 'am' ).')</span></div>';
							}else{
								$response .='<div class="quiz_cls">'.$sr.'. '.$option_val->options.'</div>';
							}
							
						}//End foreach
						
						
			if($quiz_percent=='100'){
				
				$button_label = __( 'Finish', 'am' );
				$finished_class ="lesson_finished_record";
				
			}else{
				
				$button_label = __( 'Next Question', 'am' );
				$finished_class ="";
				
			}
						
						
			$response .='<div class="quiz_cls">
							<button type="button" question_id="'.$question_id.'" module_id="'.$module_id.'" count="'.$count.'" product_id="'.$product_id.'" lesson_id="'.$lesson_id.'" class="btn btn-success quiz_next_question '.$finished_class.'">'.$button_label.' >></button>	
						 </div>';			
			$response .='</div>';
		} 
		
	 
		$progress_bar_response = do_shortcode('[am_quiz_progressbar]');
		echo $response."|".$progress_bar_response;
		exit(); 
	}
	
	
	public function am_quiz_next_question() {
		
			$question_id = $_POST['question_id'];
			$module_id = $_POST['module_id'];
			$product_id = $_POST['product_id'];
			$count = $_POST['count'];
			 
			//Get Question
			$question_arr = $this->am_get_quiz_question($question_id);
			$lesson_id = $question_arr->lesson_id;
				
			//Get Quiz Next Question
			$quiz_next_question = $this->am_get_quiz_next_question($question_id,$product_id,$lesson_id);
			
			
			//Define Global Variables
			global $glob_lesson_id,$glob_product_id,$glob_main_count,$glob_count;
			 
			$glob_lesson_id  = $lesson_id;
			$glob_product_id = $product_id;
			$glob_main_count = $count;
			$glob_count      = $count -1;
			
			
			if(count($quiz_next_question)>0){ 
		
			//Get Quiz Question Options
			$quiz_question_options = $this->am_get_quiz_question_options($quiz_next_question->id);
		 
			$response ='<div class="am_lesson_content_container">
						<i class="fa fa-spinner fa-pulse fa-3x fa-fw am_lesson_ajax_loader"></i>
						<div class="quiz_cls">
							'.do_shortcode('[am_quiz_progressbar]').'
						</div>
						<div class="question_ans_reponse"></div>
						<div class="quiz_cls">
							<h4>'.$quiz_next_question->question.'?</h4>
						</div>';
						
						$i=0;
						foreach($quiz_question_options as $option_val){
						$i++;
							
							if($i==1){
								$sr="<b>A</b>";	
							}elseif($i==2){
								$sr="<b>B</b>";	
							}elseif($i==3){
								$sr="<b>C</b>";	
							}else{
								$sr="<b>D</b>";	
							}
							
							$response .='<div class="quiz_cls">'.$sr.'. <span class="myrad"><input type="radio" name="quiz_answer" id="d1'.$i.'" class="quiz_answer" value="'.$option_val->id.'"> <label for="d1'.$i.'"> '.$option_val->options.'</label></span></div>';
							
						}
							
			
			$response .='<div class="quiz_cls">
							<button type="button" product_id="'.$product_id.'" question_id="'.$quiz_next_question->id.'" module_id="'.$module_id.'" count="'.$count.'" class="btn btn-success sbt_quiz_answer">'.__( 'Submit Answer', 'am' ).'</button>
						 </div>';
						  
			$response .='</div>';
		
		
			}else{
					
			$response ='<div class="am_lesson_content_container">
							<i class="fa fa-spinner fa-pulse fa-3x fa-fw am_lesson_ajax_loader"></i>
							<div class="quiz_cls">
								<h2>'.__( 'Thank you for finishing this lesson', 'am' ).'</h2>
							</div>
							<div class="quiz_cls">
								<button type="button" class="btn btn-warning repeat_quiz" product_id="'.$product_id.'" lesson_id="'.$lesson_id.'" module_id="'.$module_id.'">'.__( 'Repeat Quiz', 'am' ).'</button>
							</div>
						</div>';
							
			}
			
		$progress_bar_response = do_shortcode('[am_quiz_progressbar]');
		echo $response."|".$progress_bar_response;
		exit(); 
		
	}//End am_quiz_next_question
	
	
	public function am_finished_lesson_record($lesson_id) {
		
			
		 global $current_user,$wpdb;
		 
		 $user_id =  $current_user->ID;
		 $created_date = date('Y-m-d G:i:s');
		 
		  //Check Already Inserted contacts
		  $check_contacts = $wpdb->get_row("SELECT COUNT(id) as total_found FROM `".$wpdb->prefix."am_lesson_finished` WHERE user_id=".$user_id." AND lesson_id=".$lesson_id." ");
			 
		  if($check_contacts->total_found ==0){
		 
		  $wpdb->query("INSERT INTO `".$wpdb->prefix."am_lesson_finished` (`user_id`,`lesson_id`,`created_date`) VALUES ('".$user_id."','".$lesson_id."','".$created_date."')");
		  
		  
		  ///////////////////////////////////////////////////////////////////////
		  ////////////////******* Email Temaplates Trigger ******////////////////
		  $this->am_check_email_series();
		  ////////////////******* End Email Temaplates Trigger ******////////////
		  ///////////////////////////////////////////////////////////////////////
		 
		  }//End if record not inserted 
		  
		  
		 
		 return true;
       
	}//End am_finished_lesson_record
	
	public function am_save_customer_form(){
		
        $action = $_REQUEST['action'];
        if( $action == 'add_customer_order' ) {
            if( isset($_POST['btnsave']) ) {
				$order_id = 'by admin';
                if( !empty($_REQUEST['order_id']) ) {
                    $order_id = $_REQUEST['order_id'];
                }
                if( !empty($_POST['product']) ) {
                    $db_product             = explode( "@@", $_POST['product'] );
                    $product_id             = $db_product[0];
                    $product_name           = $db_product[1];
                    $data['product_id']     = $product_id;
                    $data['product_name']   = $product_name;
                }
                if( !empty($_POST['offer']) ) {
                    $db_product             = explode( "@@", $_POST['offer'] );
                    $product_id             = $db_product[0];
                    $product_name           = $db_product[1];
                    $data['offer_id']       = $product_id;
                    $data['product_name']   = $product_name;
                }
                $data['order_id']       = $order_id;
                $data['email']          = $_REQUEST['email'];
                $data['first_name']     = $_REQUEST['first_name'];
                $data['last_name']      = $_REQUEST['last_name'];
                $data['status']         = $_REQUEST['status'];
                $order_id = $this->am_save_digistore24_order( $data );
				
				$user_id = $this->am_register_new_user( $data );
                    if ( $user_id ) {
                        if( !empty($_POST['offer']) ) {
                            $this->am_save_product_member(array( 'offer_id'=> $data['offer_id'], 'user_id' => $user_id, 'order_id' => $order_id ));
                        }else{
                            $this->am_save_product_member(array( 'product_id'=> $data['product_id'], 'user_id' => $user_id, 'order_id' => $order_id ));
                        }
                        
                    }else{
                        echo $user_id->get_error_message();
                    }
				global $wpdb;
				$contact_name = $_REQUEST['first_name']." ".$_REQUEST['last_name'];
				$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` (`user_id`, `name`, `email_address`, `tags` , `status`, `created_date`) VALUES ('".$user_id."','".$contact_name."', '".$_REQUEST['email']."' , '', 0, '".$created_date."')";
				$wpdb->query($sql);
				
                $message = "Order added successfully!";
				return $message;
			}
		}
	}
	
}

$am_front = new AM_Front();