<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Plugin main class that will control the whole skeleton and common functions
 *
 * PHP version 5
 *
 * @category   Main
 * @package    Access Members
 * @author     Erfolgs-Faktor
 * @version    1.0.0
 * @since      File available since Release 1.0.0
*/

class AM
{
     
    //Plugin starting point. Will call appropriate actions
    public function __construct() {
		
        $options = get_option( 'am_settings' );
		
        define( 'AM_DIGISTORE24_API_KEY', $options['digistore24_api_key'] );
        define( 'AM_LICENSE_KEY', $options['am_license_key'] );
        add_action( 'plugins_loaded', array( $this, 'am_init' ) );
		
		
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
		if( !constant('AM_LICENSE_KEY') ) {
            $am_plugin_license_key_enabled = 'no';
        }else{
			$am_plugin_license_key_enabled = 'yes';
		}
		
		
		//if($am_plugin_license_key_enabled =='yes' && $license_settings->lessons ==1){
        add_action( 'init', array( $this, 'am_create_custom_post_types' ), 10 );
		//}//lessons
		
        add_action( 'wp_enqueue_scripts', array( $this, 'am_enqueue_scripts' ), 20 );
        add_action( 'admin_enqueue_scripts', array( $this, 'am_enqueue_scripts' ), 20 );
    }

    //Plugin initialization
    public function am_init() {

        do_action('am_before_init');
        
        load_plugin_textdomain( 'am', FALSE, AM_LANG_DIR );
        
        if(is_admin()){
            
            require_once AM_PLUGIN_PATH.'am_admin.php';            
        }

        require_once AM_PLUGIN_PATH.'am_front.php';
        
        do_action('am_after_init');
    }
    
    //Function will add CSS and JS files
    public function am_enqueue_scripts() {
        
        do_action('am_before_enqueue_scripts');
        
        wp_enqueue_script( 'jquery' );
        wp_enqueue_script( 'am_js', AM_PLUGIN_URL.'js/am.js', array( 'jquery' ), time() );
        
        if( is_admin() ) {
            wp_enqueue_script( 'am_jtable_js', AM_PLUGIN_URL.'js/jtable/jquery.jtable.js', array( 'am_js', 'jquery-ui-widget', 'jquery-ui-dialog' ), time() );
            //wp_enqueue_style( 'am_admin_ui_css','http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.0/themes/base/jquery-ui.css', array(), time() );
            wp_enqueue_style( 'am_jtable_css', AM_PLUGIN_URL.'js/jtable/themes/lightcolor/gray/jtable.css', array(), time() );
        }
        
        wp_enqueue_style( 'am_css', AM_PLUGIN_URL.'css/am.css', array(), time() );
        wp_enqueue_style( 'am_font_awasome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css' );
        
        $google_fonts = '';
        $options = get_option( 'am_settings', array() );
        if( !empty($options['google_fonts']) ) {
            $trimmed_array=array_map( 'trim',explode( "\n", $options['google_fonts'] ) );
            $google_fonts = str_replace( " ", "+", implode( "|", $trimmed_array ));
            wp_enqueue_style( 'am_googe_fonts', 'https://fonts.googleapis.com/css?family='.$google_fonts );
        }
        
        do_action('am_after_enqueue_scripts');
    }
    
    public function am_number_encrypt($data, $key = '&/SAIMASD%g/....&FWSF2csvsq2we!%%', $base64_safe=true, $shrink=true) {
        return $data;
        if ($shrink) $data = base_convert($data, 10, 36);
        $data = @mcrypt_encrypt(MCRYPT_ARCFOUR, $key, $data, MCRYPT_MODE_STREAM);
        if ($base64_safe) $data = str_replace('=', '', base64_encode($data));
        return $data;
    }

    public function am_number_decrypt($data, $key = '&/SAIMASD%g/....&FWSF2csvsq2we!%%', $base64_safe=true, $expand=true) {
        return $data;
        if ($base64_safe) $data = base64_decode($data.'==');
        $data = @mcrypt_encrypt(MCRYPT_ARCFOUR, $key, $data, MCRYPT_MODE_STREAM);
        if ($expand) $data = base_convert($data, 36, 10);
        return $data;
    }
    
    public function am_get_post_coins( $post_id='' ) {
        if( !is_numeric($post_id) ) {
            return "0";
        }
        global $current_user;
        get_currentuserinfo();
        if( $current_user->ID == 0 ) {
            return "999999999";
        }
        
        $post_type = get_post_type( $post_id );
        $order = array_shift($this->am_get_orders( "buyer_email = '".$current_user->user_email."'" ));
        if( !empty($order)) {
            $product_id = $order->product_id;
            if( $post_type == 'lessons' ) {
                $user_coins = array_shift($this->am_get_course_structure("product_id = '".$product_id."' AND lesson_id = '".$post_id."'"));
                if( !empty($user_coins)) {
                    $am_coins = $user_coins->coins;
                }else{
                    $am_coins = 0;
                }                
            }elseif( $post_type == 'post' || $post_type == 'page' ){
                $product = array_shift($this->am_get_products( "product_id = '".$product_id."'" ));
                $secure_pages = maybe_unserialize($product->product_secure_pages);
                $counter = 0;
                $post_found = false;
                foreach( $secure_pages as $page_id ) {
                    if( $page_id == $post_id ) {
                        $post_found = true;
                        break;
                    }
                    $counter++;
                }
                if(!$post_found) {
                    $secure_posts = maybe_unserialize($product->product_secure_posts);
                    $counter = 0;
                    foreach( $secure_posts as $page_id ) {
                        if( $page_id == $post_id ) {
                            $post_found = true;
                            break;
                        }
                        $counter++;
                    }
                }else{
                    $pages_price = maybe_unserialize($product->pages_price);
                    $am_coins = $pages_price[$counter];
                }
                if(!$post_found) {
                    $am_coins = 0;
                }else{
                    $posts_price = maybe_unserialize($product->posts_price);
                    $am_coins = $posts_price[$counter];
                }
            }            
        }else{
            return "999999999";
        }
        
        $options = get_option( 'am_settings', array() );
        //$am_coins = get_post_meta( $post_id, '_am_coins', true );
        if(!empty($am_coins)){
            return $am_coins;            
        }elseif(!empty($options['default_coins'])){
            return $options['default_coins'];            
        }else{
            return "0";            
        }
    }
    
    public function am_set_user_used_coins( $user_id = '', $coins_used = 0 ) {
        global $am_remaining_coins;
        if( empty($user_id) ) {
            return false;
        }
        $available_coins = $this->am_get_user_available_coins( $user_id );
        $remaining_coins = $available_coins - $coins_used;
        $am_remaining_coins = $remaining_coins;
        if( $remaining_coins >= 0 ) {
            update_user_meta( $user_id, 'user_available_coins', $remaining_coins );
        }else{
            return false;
        }
        return true;
    }
    
    public function am_get_user_available_coins( $user_id = '' ) {
        
        if( empty($user_id) ) {
            return false;
        }
        
        $user_available_coins = get_user_meta( $user_id, 'user_available_coins', true );
        if( !empty($user_available_coins) ) {
            return $user_available_coins;
        }
        $current_timestamp = strtotime("now");
        
        $current_user_coins = 0;
        $current_user = get_user_by( "ID", $user_id );
        $order = array_shift($this->am_get_orders( "buyer_email = '".$current_user->user_email."'" ));
        if( !empty($order)) {
            $product_id = $order->product_id;
            $product = array_shift($this->am_get_products( "product_id = '".$product_id."'" ));
            $after_order_month = strtotime( "+1 month", $order->order_timestamp );
            if( $after_order_month >= $current_timestamp ) {
                $current_user_coins = $product->initial_coins;                                             
            }else{
                $initial_coins_expired = true;
                $current_user_coins = $product->month_coins;
            }
        }
        /*
        $coins_data_rows = $this->am_get_all_coins_management_entries();
        $initial_coins_expired = false;
        foreach( $coins_data_rows as $row ) {
            $user_ids = maybe_unserialize($row->user_ids);
            $current_user_coins = 0;
            foreach( $user_ids as $row_user_id ) {
                if( $row_user_id == $user_id ) {
                    $after_order_month = strtotime( "+1 month", $row->record_timestamp );
                    if( $after_order_month >= $current_timestamp ) {
                        $current_user_coins = $row->initital_coins;                                             
                    }else{
                        $initial_coins_expired = true;
                        $current_user_coins = $row->per_month_coins;
                    }                    
                    break;
                }
            }
            if( $current_user_coins > 0 ) {
                break;
            }
        }
        */
        if( $initial_coins_expired ) {
            $initial_coins_expired_timestamp = get_user_meta( $user_id, 'initial_coins_expired_timestamp', true );
            if( empty($initial_coins_expired_timestamp) ) {
                update_user_meta( $user_id, 'initial_coins_expired_timestamp', $current_timestamp );
                update_user_meta( $user_id, 'user_available_coins', $current_user_coins );
            }elseif( $current_timestamp > $initial_coins_expired_timestamp ) {
                update_user_meta( $user_id, 'user_available_coins', $current_user_coins );
            }
        }
        return $current_user_coins;
    }
    
    public function am_get_all_coins_management_entries( $where = "1" ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_user_coins` WHERE ".$where;
        $records = $wpdb->get_results( $sql );
        
        return $records;
    }
    
    public function am_get_offers( $where = "1" ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_offers` WHERE ".$where;
        $offers = $wpdb->get_results( $sql );
        
        return $offers;
    }
    
    public function am_get_offers_structure( $where = "1" ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_offer_structure` WHERE ".$where;
        $offers_structure = $wpdb->get_results( $sql );
        
        return $offers_structure;
    }
    
    public function am_is_email_evergreen( $email = '', $product = '' ) {
        
        if( empty($email) || empty($product) ) {
            return false;
        }
        global $wpdb;
        if (!filter_var($email, FILTER_VALIDATE_EMAIL) === false) {
            $emails = $this->am_get_evergreen_emails();
            if(in_array($email, $emails)) {                
                $evergreen_row = $this->am_get_evergreen_user( $email, $product );
                if( empty($evergreen_row) ) {
                    if ( $product->enable_evergreen == 'yes' ) {
                        $sql = "INSERT INTO `".$wpdb->prefix."am_evergreen_users` ( `id`, `product_id`, `user_email`, `access_timestamp` ) VALUES ( '', '".$product->id."', '".$email."', '".strtotime('-2 minutes')."' );";
                        $wpdb->query($sql);
                    }
                }                                
            }else{
                $this->am_add_evergreen_email( $email );
                $evergreen_row = $this->am_get_evergreen_user( $email, $product );
                if( empty($evergreen_row) ) {
                    if ( $product->enable_evergreen == 'yes' ) {
                        $sql = "INSERT INTO `".$wpdb->prefix."am_evergreen_users` ( `id`, `product_id`, `user_email`, `access_timestamp` ) VALUES ( '', '".$product->id."', '".$email."', '".strtotime('-2 minutes')."' );";
                        $wpdb->query($sql);
                    }
                }
            }
            return true;
        }
        
        return false;
    }
    
    public function am_get_evergreen_user( $email, $product ) {
        
        global $wpdb;
        
        $access_timestamp = strtotime( 'now' );
        $sql = "SELECT * FROM `".$wpdb->prefix."am_evergreen_users` WHERE user_email = '".$email."' AND access_timestamp <= '".$access_timestamp."' AND product_id = '".$product->id."'";
        $evergreen_row = $wpdb->get_row( $sql );
        if( empty($evergreen_row) ) {
            if ( $product->enable_evergreen == 'yes' ) {
                $sql = "INSERT INTO `".$wpdb->prefix."am_evergreen_users` ( `id`, `product_id`, `user_email`, `access_timestamp` ) VALUES ( '', '".$product->id."', '".$email."', '".strtotime('-2 minutes')."' );";
                $wpdb->query($sql);
            }
            $sql = "SELECT * FROM `".$wpdb->prefix."am_evergreen_users` WHERE user_email = '".$email."' AND access_timestamp <= '".$access_timestamp."' AND product_id = '".$product->id."'";
            $evergreen_row = $wpdb->get_row( $sql );
        }
        if( empty( $evergreen_row->access_timestamp ) ) {
            $sql = "UPDATE `".$wpdb->prefix."am_evergreen_users` SET access_timestamp = '".strtotime('-2 minutes')."' WHERE id = '".$evergreen_row->id."'";
            $wpdb->query($sql);
        }
        return $evergreen_row;
    }
    
    public function am_add_evergreen_email( $email = '' ) {
        
        if( empty( $email )) {
            return false;
        }
        $options = get_option( 'am_settings', array() );
        $emails = explode( PHP_EOL, $options['evergreen_emails'] );
        $emails[] = $email;
        $options['evergreen_emails'] = implode( PHP_EOL, $emails );
        update_option( 'am_settings', $options );
        return true;
    }
    
    public function am_get_evergreen_emails() {
        
        $options = get_option( 'am_settings', array() );
        $emails = explode( PHP_EOL, $options['evergreen_emails'] );
        if( is_array($emails) && sizeof($emails) > 0 ) {
            return $emails;
        }
        return array();
    }
    
    //Function will add CSS and JS files
    public function am_create_custom_post_types() {
        
        $labels = array(
		'name'               => __( 'Lessons', 'am' ),
		'singular_name'      => __( 'Lesson', 'am' ),
		'menu_name'          => __( 'Lessons', 'am' ),
		'name_admin_bar'     => __( 'Lesson', 'am' ),
		'add_new'            => __( 'Add New Lesson', 'am' ),
		'add_new_item'       => __( 'Add New Lesson', 'oc' ),
		'new_item'           => __( 'New Lesson', 'am' ),
		'edit_item'          => __( 'Edit Lesson', 'am' ),
		'view_item'          => __( 'View Lesson', 'am' ),
		'all_items'          => __( 'Lessons', 'am' ),
		'search_items'       => __( 'Search Lessons', 'am' ),
		'parent_item_colon'  => __( 'Parent Lessons:', 'am' ),
		'not_found'          => __( 'No lessons found.', 'am' ),
		'not_found_in_trash' => __( 'No lessons found in Trash.', 'am' )
	);
        
        $args = array(
                    'public'        => true,
                    'labels'        => $labels,
                    'show_ui'       => true,
                    'show_in_menu'  => 'am',
                    'menu_position' => 20,
                    'supports'      => array( 'title', 'editor', 'thumbnail', 'comments' )
                    );
        register_post_type( 'lessons', $args );
    }
    
    public function am_log( $data = '', $desc = '' ) {
        
        if( empty($data) ) {
            return false;
        }
        
        $text = maybe_serialize($data);
        global $wpdb;
        $sql = "INSERT INTO `".$wpdb->prefix."am_log` ( `id`, `text`, `desc` ) VALUES ( '', '".$text."', '".$desc."' );";
        $wpdb->query($sql);
    }
    
    public function am_get_modules( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_modules` WHERE ".$where;
        $modules = $wpdb->get_results( $sql );
        
        return $modules;
    }
    
    public function am_get_digimember_products( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."digimember_product` WHERE ".$where;
        $products = $wpdb->get_results( $sql );
        
        return $products;
    }
    
    public function am_get_digimember_product_contents( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."digimember_page_product` WHERE ".$where;
        $products_content = $wpdb->get_results( $sql );
        
        return $products_content;
    }
    
    public function am_get_products( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_products` WHERE ".$where;
        $products = $wpdb->get_results( $sql );
        
        return $products;
    }
	
	
	public function am_get_product_name($product_id) {
        
        global $wpdb;
        $sql = "SELECT product_name FROM `".$wpdb->prefix."am_products` WHERE  id=".$product_id;
        $products = $wpdb->get_row( $sql);
		
		$product_name = $products->product_name;
		
        return $product_name;
    }
	
	
	public function am_get_all_quiz( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_quiz_questions` WHERE ".$where." ORDER BY id DESC";
        $quiz_questions = $wpdb->get_results( $sql );
        
        return $quiz_questions;
    }
	
	
	public function am_delete_all_lesson_quiz($lesson_id) {
        
        global $wpdb;
        $sql_delete = "DELETE FROM`".$wpdb->prefix."am_quiz_questions` WHERE lesson_id = '".$lesson_id."'";
		$wpdb->query($sql_delete);
		  
		$sql_delete_options = "DELETE FROM`".$wpdb->prefix."am_quiz_question_options` WHERE lesson_id = '".$lesson_id."'";
		$wpdb->query($sql_delete_options);
        
        return true;
    }
	
	
	public function am_delete_quiz_question($question_id) {
        
        global $wpdb;
        $sql_delete = "DELETE FROM`".$wpdb->prefix."am_quiz_questions` WHERE id = '".$question_id."'";
		$wpdb->query($sql_delete);
		  
		$sql_delete_options = "DELETE FROM`".$wpdb->prefix."am_quiz_question_options` WHERE quiz_question_id = '".$question_id."'";
		$wpdb->query($sql_delete_options);
        
        return true;
    }
	
	
	public function am_get_all_lesson_quiz($lesson_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_quiz_questions` WHERE lesson_id=".$lesson_id." ORDER BY id ASC";
        $all_lesson_quiz = $wpdb->get_results( $sql );
		
		if(count($all_lesson_quiz)>0){
			
			foreach($all_lesson_quiz as $key=>$quiz){
				
				$question_id = 	$quiz->id;
				$quiz_question_options = $this->am_get_quiz_question_options($question_id);
				
				$all_lesson_quiz[$key]->question_options = $quiz_question_options;
			}	
		}
        
        return $all_lesson_quiz;
    }
	
	
	public function am_get_quiz_question($question_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_quiz_questions` WHERE id=".$question_id;
        $quiz_question = $wpdb->get_row( $sql );
        
        return $quiz_question;
    }
	
	
	public function am_get_quiz_question_options($question_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_quiz_question_options` WHERE quiz_question_id=".$question_id;
        $quiz_question_options = $wpdb->get_results( $sql );
        
        return $quiz_question_options;
    }
	
	
	public function am_check_lesson_quiz($lesson_id, $product_id) {
        
        global $wpdb;
        $sql = "SELECT COUNT(id) as total_record FROM `".$wpdb->prefix."am_quiz_questions` WHERE lesson_id=".$lesson_id;
        $quiz_question = $wpdb->get_row( $sql );
		
		if($quiz_question->total_record >0){
			
			return true;
		
		}else{
			
			return false;
		}
		
    }
	
	
	public function am_count_lesson_quiz($lesson_id, $product_id) {
        
        global $wpdb;
        $sql = "SELECT COUNT(id) as total_record FROM `".$wpdb->prefix."am_quiz_questions` WHERE lesson_id=".$lesson_id;
        $quiz_question = $wpdb->get_row( $sql );
		
		return $quiz_question->total_record;
		
    }
	
	
	public function am_check_question_option_ans($question_id,$option_id) {
        
        global $wpdb;
        $sql = "SELECT answer FROM `".$wpdb->prefix."am_quiz_question_options` WHERE quiz_question_id=".$question_id." AND id=".$option_id;
        $question_options = $wpdb->get_row( $sql );
		
		if($question_options->answer ==1){
			
			return true;
		
		}else{
			
			return false;
		}
		
    }
	
	
	public function am_get_lesson_first_question($product_id,$lesson_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_quiz_questions` WHERE lesson_id=".$lesson_id." ORDER BY id ASC LIMIT 1";
        $quiz_questions = $wpdb->get_row( $sql );
        
        return $quiz_questions;
    }
	
	
	public function am_get_quiz_next_question($question_id,$product_id,$lesson_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_quiz_questions` WHERE lesson_id=".$lesson_id." AND id >".$question_id." ORDER BY id ASC LIMIT 1";
        $next_question = $wpdb->get_row( $sql );
		
        return $next_question;
    }
	
	
	public function am_get_all_survey( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_survey` WHERE ".$where." ORDER BY id DESC";
        $all_survey = $wpdb->get_results( $sql );
        
        return $all_survey;
    }
	
	
	public function am_get_survey_font($survey_id){
        
        global $wpdb;
		
        $sql = "SELECT * FROM `".$wpdb->prefix."am_survey` WHERE id=".$survey_id;
        $survey = $wpdb->get_row( $sql );
        
        return $survey;
    }
	
	
	public function am_get_license_settings($license_id){
        
        global $wpdb;
		
        $sql = "SELECT * FROM `".$wpdb->prefix."am_license_keys` WHERE id=".$license_id;
        $license_keys = $wpdb->get_row( $sql );
        
        return $license_keys;
    }
	
	
	public function am_get_survey($survey_id){
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_survey` WHERE id=".$survey_id;
        $survey = $wpdb->get_row( $sql );
        
        return $survey;
    }
	
	
	public function am_get_all_contacts( $tag, $where = '1' ) {
        
        global $wpdb; 
        $sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE ".$where."  AND  tags like '%".$tag."%' ORDER BY id DESC";
        $contacts = $wpdb->get_results( $sql );
        
        return $contacts;
    }
	
	
	public function am_get_contact($contact_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE id=".$contact_id;
        $contact = $wpdb->get_row( $sql );
        
        return $contact;
    }
	
	
	public function am_get_all_emails_categories( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_emails_categories` WHERE ".$where." ORDER BY id DESC";
        $emails_categories = $wpdb->get_results( $sql );
        
        return $emails_categories;
    }
	
	
	public function am_get_emails_category($id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_emails_categories` WHERE id=".$id;
        $emails_category = $wpdb->get_row( $sql );
        
        return $emails_category;
    }
	
	
	
	public function am_get_all_tags( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_tags` WHERE ".$where." ORDER BY id DESC";
        $tags = $wpdb->get_results( $sql );
        
        return $tags;
    }
	
	
	public function am_get_tag($tag_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_tags` WHERE id=".$tag_id;
        $tag = $wpdb->get_row( $sql );
        
        return $tag;
    }
	
	
	public function am_get_optin_forms( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_optin_forms` WHERE ".$where." ORDER BY id DESC";
        $optin_forms = $wpdb->get_results( $sql );
        
        return $optin_forms;
    }
	
	
	public function am_get_optin_form($optin_form_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_optin_forms` WHERE id=".$optin_form_id;
        $optin_form = $wpdb->get_row( $sql );
        
        return $optin_form;
    }
	
	
	public function am_get_optin_users($optin_form_id) {
        
        global $wpdb;
        $sql = "SELECT optin_form_id FROM `".$wpdb->prefix."am_contacts`";
		$optin_contacts = $wpdb->get_results( $sql ,'ARRAY_A');
		
		$total_contacts=0;
		foreach($optin_contacts as $optin_contact)
		{
			$optionContacts=explode(",",$optin_contact['optin_form_id']);
			if(in_array($optin_form_id,$optionContacts))
			{
				$total_contacts++;
			}
		}
		
        
        
        return $total_contacts;
    }
	
	
	public function am_get_optin_confirm_users($optin_form_id) {
        
        global $wpdb;
        $sql = "SELECT optin_form_id FROM `".$wpdb->prefix."am_contacts` WHERE  status=0";
		$optin_contacts = $wpdb->get_results( $sql ,'ARRAY_A');
		
		$total_contacts=0;
		foreach($optin_contacts as $optin_contact)
		{
			$optionContacts=explode(",",$optin_contact['optin_form_id']);
			if(in_array($optin_form_id,$optionContacts))
			{
				$total_contacts++;
			}
		}
        //$optin_form = $wpdb->get_row( $sql );
        
        return $total_contacts;
    }
	
	
	public function am_get_all_emails( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE ".$where." ORDER BY id DESC";
        $emails = $wpdb->get_results( $sql );
        
        return $emails;
    }
	
	public function get_newsletter_assigned_contacts($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id=".$newsletter_id;
        $assigned_contacts = $wpdb->get_row( $sql );
		
		$sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id=".$newsletter_id." AND sent_status=1";
        $sent_contacts = $wpdb->get_row( $sql );
		
		$sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id=".$newsletter_id." AND opened=1";
        $opened_contacts = $wpdb->get_row( $sql );
		
		$sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id=".$newsletter_id." AND clicked=1";
        $clicked_contacts = $wpdb->get_row( $sql );
		
		$data['assigned_contacts'] = $assigned_contacts->total_contacts;
		$data['sent_contacts'] = $sent_contacts->total_contacts;
		$data['opened_contacts'] = $opened_contacts->total_contacts;
		$data['clicked_contacts'] = $clicked_contacts->total_contacts;
        
        return $data;
    }
	
	
	public function am_delete_newsletter($newsletter_id) {
        
        global $wpdb;
		
        $sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter` WHERE id = '".$newsletter_id."'";
		$wpdb->query($sql_delete);
		  
		//Delete Contact Tags Record
		$sql_delete11 = "DELETE FROM`".$wpdb->prefix."am_newsletter_tags` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete11);
		  
		//Delete Newsletter Tags Record
		$sql_delete22 = "DELETE FROM`".$wpdb->prefix."am_newsletter_emails_tags` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete22);
		  
		//Delete Lesson Tags Record
		$sql_delete33 = "DELETE FROM`".$wpdb->prefix."am_newsletter_lesson_tags` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete33);
		  
		//Delete Product Tags Record
		$sql_delete44 = "DELETE FROM`".$wpdb->prefix."am_newsletter_product_tags` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete44);
		  
		//Delete Opted form Tags Record
		$sql_delete55 = "DELETE FROM`".$wpdb->prefix."am_newsletter_optedfrom_tags` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete55);
		
		//Delete Survey Tags Record
		$sql_delete55 = "DELETE FROM`".$wpdb->prefix."am_newsletter_survey_tags` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete55);
		
		//Delete Filter Contacts Record
		$sql_delete66 = "DELETE FROM`".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete66);
		
		//Delete Newsletter Schedules
		$sql_delete77 = "DELETE FROM`".$wpdb->prefix."am_newsletter_schedules` WHERE newsletter_id = '".$newsletter_id."'";
		$wpdb->query($sql_delete77);
        
        return true;
    }
	
	
	public function am_get_all_newsletters( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE ".$where." AND type='newsletter' ORDER BY id DESC";
        $newsletter = $wpdb->get_results( $sql );
        
        return $newsletter;
    }
	
	
	public function am_get_newsletter($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE id=".$newsletter_id;
        $newsletter = $wpdb->get_row( $sql );
        
        return $newsletter;
    }
	
	public function am_get_newsletter_tags($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_tags` WHERE newsletter_id=".$newsletter_id;
        $newsletter_tags = $wpdb->get_results( $sql );
        
        return $newsletter_tags;
    }
	
	public function am_get_newsletter_email_tags($newsletter_id,$type) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_emails_tags` WHERE newsletter_id=".$newsletter_id." AND email_type='".$type."'";
        $newsletter_email_tags = $wpdb->get_results( $sql );
        
        return $newsletter_email_tags;
    }
	
	public function am_get_newsletter_lesson_tags($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_lesson_tags` WHERE newsletter_id=".$newsletter_id;
        $newsletter_lesson_tags = $wpdb->get_results( $sql );
        
        return $newsletter_lesson_tags;
    }
	
	public function am_get_newsletter_product_tags($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_product_tags` WHERE newsletter_id=".$newsletter_id;
        $newsletter_product_tags = $wpdb->get_results( $sql );
        
        return $newsletter_product_tags;
    }
	
	public function am_get_filtered_contacts($post_data,$status="") {
		
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Tags Filter *****//////////////////////////
		////////////////////////////////////////////////////////////////////
		$tags_id = $post_data['tags_id'];
		foreach($tags_id as $key=>$tag){
					
			$tag_id = $key;
			$tag_value = $tag;
			
			if($tag_value =='yes'){
				$query_string1 .= " tags LIKE '%,".$tag_id."%' OR " ;	
			}else{
				$query_string2 .= " tags NOT LIKE '%,".$tag_id."%' AND " ;	
			}
		}
		
		$query_string1 = rtrim($query_string1,'OR ');
		$query_string2 = rtrim($query_string2,'AND ');
		
		$search = "AND ";
		if($query_string1 !=""){
		  $search .= $query_string1." AND ";
		}
		if($query_string2 !=""){
		  $search .= $query_string2." AND ";
		}
		
		$search = rtrim($search,'AND ');
        
        global $wpdb;		
		$sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE 1=1 ".$search." AND status=0";	//echo $sql =  "SELECT * FROM `wp_am_contacts` WHERE 1=1 AND tags LIKE '%,4%' OR tags LIKE '%,3%' OR tags LIKE '%,2%' AND status=0";
		
		if($post_data['include_users']=="all")
		{
			$sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE 1=1 ".$search;
		}
		else if($post_data['include_users']=="unconfirmed")
		{
			$sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE 1=1 ".$search." AND status=1";
		}

        $contacts_arr  = $wpdb->get_results($sql);
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Tags Filter *****///////////////////////
		///////////////////////////////////////////////////////////////////
		//
		//
		//
		//
		//
		
		
		
		
		
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Opened Email Filter *****///////////////////
		////////////////////////////////////////////////////////////////////
		
		$opened_emails = $post_data['opened_emails'];
		file_put_contents(dirname(__file__)."/openedemails.log",print_r($opened_emails,true),FILE_APPEND);
		
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			
			$opened_emails = $post_data['opened_emails'];
			
			if(count($opened_emails)){
			foreach($opened_emails as $key=>$email){
						
				$email_id = $key;
				$email_value = $email;
				
				if($email_value =='yes'){
					$search22 = "opened ='1' " ;	
				}else{
					$search22 = "opened ='0' " ;	
				}
				
				$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE contact_id=".$contact_id." AND newsletter_id=".$email_id." AND ".$search22." ";
				if($email_value=="no")
				{
					$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE contact_id=".$contact_id."  AND ".$search22." ";
					
				}
				
				
        		$newsletter  = $wpdb->get_row($sql);
				
				if(empty($newsletter)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				}
				
			}//End if
			}//End if
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Opened Email Filter *****///////////////
		////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Clicked Email Filter *****//////////////////
		////////////////////////////////////////////////////////////////////
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			
			$clicked_emails = $post_data['clicked_emails'];
			if(count($clicked_emails)){
			foreach($clicked_emails as $key=>$email){
						
				$email_id = $key;
				$email_value = $email;
				
				if($email_value =='yes'){
					$search33 = "clicked ='1' " ;	
				}else{
					$search33 = "clicked ='0' " ;	
				}
				
				$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE contact_id=".$contact_id." AND newsletter_id=".$email_id." AND ".$search33." ";
        		$newsletter  = $wpdb->get_row($sql);
				
				if(empty($newsletter)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				}
				
			}//End if
			}//End if
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Clicked Email Filter *****//////////////
		/////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Sent Email Filter *****/////////////////////
		/////////////////////////////////////////////////////////////////////
		
		
		/*
		
		$sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id=".$newsletter_id;
        $assigned_contacts = $wpdb->get_row( $sql );
		
		*/
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			
			$sent_emails = $post_data['sent_emails'];
			if(count($sent_emails)){
			foreach($sent_emails as $key=>$email){
						
				$email_id = $key;
				$email_value = $email;
				

				if($email_value =='yes'){	
					$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE contact_id=".$contact_id." AND newsletter_id=".$email_id;
        		$newsletter  = $wpdb->get_row($sql);
				
				if(empty($newsletter)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				}
					
				}else{
					$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE contact_id=".$contact_id." AND newsletter_id=".$email_id;
        		$newsletter  = $wpdb->get_row($sql);
				
				if(!empty($newsletter)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				}
				}
				
				
				
			}//End if
			}//End if
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Sent Email Filter *****/////////////////
		/////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Sent Opted From Filter *****////////////////
		/////////////////////////////////////////////////////////////////////
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			
			$opted_in = $post_data['opted_in'];
			if(count($opted_in)){
			foreach($opted_in as $key=>$optedform){
						
				$optedform_id = $key;
				$optedform_value = $optedform;
				
				if($optedform_value =='yes'){
					$search55 = " AND optin_form_id =".$optedform_id." " ;	
				}else{
					$search55 = " AND optin_form_id !=".$optedform_id." " ;	
				}
				
				$sql = "SELECT * FROM `".$wpdb->prefix."am_contacts` WHERE id=".$contact_id." ".$search55." ";
        		$opted_contacts  = $wpdb->get_row($sql);
				
				if(empty($opted_contacts)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				}
				
			}//End if
			}//End if
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Opted From  Filter *****////////////////
		/////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Lesson Finished Filter *****////////////////
		/////////////////////////////////////////////////////////////////////
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			$user_id = $contact->user_id;
			
			if($user_id !=""){
			$lesson_finished = $post_data['lesson_finished'];
			if(count($lesson_finished)){
			foreach($lesson_finished as $key=>$lesson){
						
				$lesson_id = $key;
				$lesson_value = $lesson;
				
			 	$sql = "SELECT * FROM `".$wpdb->prefix."am_lesson_finished` WHERE user_id=".$user_id." AND lesson_id =".$lesson_id." ";
        		$lesson_finished_arr  = $wpdb->get_row($sql);
				
				if($lesson_value =='yes' && !empty($lesson_finished_arr)){
					
				
				}elseif($lesson_value =='yes' && empty($lesson_finished_arr)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				
				}elseif($lesson_value =='no' && !empty($lesson_finished_arr)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
					
				}else{
					
					
				}
				
				
			}//End if
			}//End if
			}//End if User not empty
			
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Lesson Finished Filter *****////////////
		/////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Purchased Producuts Filter *****////////////
		/////////////////////////////////////////////////////////////////////
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			$user_id = $contact->user_id;
			
			if($user_id !=""){
			$purchased_product = $post_data['purchased_product'];
			if(count($purchased_product)){
			foreach($purchased_product as $key=>$product){
						
				$product_id = $key;
				$product_value = $product;
				
				$sql = "SELECT * FROM `".$wpdb->prefix."am_product_members` WHERE user_id=".$user_id." AND product_id =".$product_id."  ";
        		$product_members  = $wpdb->get_row($sql);
				
				if($product_value =='yes' && !empty($product_members)){
					
				
				}elseif($product_value =='yes' && empty($product_members)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				
				}elseif($product_value =='no' && !empty($product_members)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
					
				}else{
					
					
				}
				
				
			}//End if
			}//End if
			}//End if User not empty
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Purchased Producuts Filter *****////////
		/////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Survey Filter *****/////////////////////////
		/////////////////////////////////////////////////////////////////////
		foreach($contacts_arr as $mainkey => $contact){
		
			$contact_id = $contact->id;
			$user_id = $contact->user_id;
			
			$survey_filter = $post_data['survey_filter'];
			if(count($survey_filter)){
			foreach($survey_filter as $key=>$survey){
						
				$survey_id = $key;
				$survey_value = $survey;
				
			 	$sql = "SELECT * FROM `".$wpdb->prefix."am_survey_report` WHERE user_id=".$user_id." AND survey_id =".$survey_id." ";
        		$survey_arr  = $wpdb->get_row($sql);
				
				if($survey_value =='yes' && !empty($survey_arr)){
					
				
				}elseif($survey_value =='yes' && empty($survey_arr)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
				
				}elseif($survey_value =='no' && !empty($survey_arr)){
					
					if((array_search($contact_id, $contact)) !== false) {
						
						unset($contacts_arr[$mainkey]);
					}
					
				}else{
					
					
				}
				
				
			}//End if
			}//End if
			
		
		}//End Contacts_arr
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Survey Filter *****/////////////////////
		/////////////////////////////////////////////////////////////////////
		
		
		$contacts__final_arr = array_values($contacts_arr);
        
        return $contacts__final_arr;
    }
	
	
	public function am_get_newsletter_survey_tags($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_survey_tags` WHERE newsletter_id=".$newsletter_id;
        $newsletter_survey_tags = $wpdb->get_results( $sql );
        
        return $newsletter_survey_tags;
    }
	
	
	public function am_get_newsletter_optedform_tags($newsletter_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_optedfrom_tags` WHERE newsletter_id=".$newsletter_id;
        $newsletter_optedfrom_tags = $wpdb->get_results( $sql );
        
        return $newsletter_optedfrom_tags;
    }
	
	
	public function am_get_all_email_series( $where = '1' ) {
        
		global $wpdb;
		global $wp_rewrite;
		$rows_per_page = 2;
		$current = isset($_GET['paged']) ? $_GET['paged'] : 1;
		
		$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE ".$where." AND type='email_series'  ORDER BY id DESC";
		$email_series = $wpdb->get_results( $sql );
		
		
		$pagination_args = array(
		'base' => @add_query_arg('paged','%#%'),
		'format' => '',
		'total' => ceil(sizeof($email_series)/$rows_per_page),
		'current' => $current,
		'show_all' => false,
		'type' => 'plain'
		);
		
		if( !empty($wp_query->query_vars['s']) )
		$pagination_args['add_args'] = array('s'=>get_query_var('s'));
		
		echo '<strong>Pages</strong>'.paginate_links($pagination_args);
$start = ($current - 1) * $rows_per_page;
$end = $start + $rows_per_page;
$end = (sizeof($email_series) < $end) ? sizeof($email_series) : $end;


$sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE ".$where." AND type='email_series'  ORDER BY id DESC LIMIT $start,$rows_per_page";
		$email_series = $wpdb->get_results( $sql );
		
        return $email_series;
    }
	
	
	public function am_get_emailseries($emailseries_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE id=".$emailseries_id;
        $emailseries = $wpdb->get_row( $sql );
        
        return $emailseries;
    }
	
	
	public function get_tagged_survey_users($survey_id){
		
		global $wpdb;
        $sql = "SELECT COUNT(id) as total_record FROM `".$wpdb->prefix."am_survey_report` WHERE survey_id=".$survey_id;
        $survey_report = $wpdb->get_row( $sql );
        
        return $survey_report->total_record;
		
	}
	
	
	public function count_tag_contacts($tag_id,$status="") {
        
        global $wpdb;
		
        $sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_contacts` WHERE tags LIKE ('%,".$tag_id."%')";
        
		if($status=="active")
		{
			$sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_contacts` WHERE tags LIKE ('%,".$tag_id."%') and status=0";
		}
		
		
		
		$tag_contacts = $wpdb->get_row( $sql );
		
        return $tag_contacts->total_contacts;
    }
	
    
    public function am_get_product_page( $product_id = '' ) {
        
        if(empty($product_id)) {
            return false;
        }
        
        global $wpdb;
        $sql = "SELECT product_page FROM `".$wpdb->prefix."am_products` WHERE id = '".$product_id."'";
        $product_page = $wpdb->get_var($sql);
        return $product_page;
    }
    
    public function am_product_have_free_lessons( $product_id = '' ) {
        
        if(empty($product_id)) {
            return false;
        }
        
        global $wpdb;
        $sql = "SELECT enable_sumit FROM `".$wpdb->prefix."am_products` WHERE id = '".$product_id."'";
        $enable_sumit = $wpdb->get_var($sql);
        if( $enable_sumit == 'yes' ) {
            return true;
        }
        return false;
    }
    
    public function am_get_course_structure( $where = '1' ) {
        
        global $wpdb;
        //echo date( "d/m/Y", strtotime('05.06.2016 01:00'));
        $sql = "SELECT * FROM `".$wpdb->prefix."am_product_course_structure` WHERE ".$where;
        $products = $wpdb->get_results( $sql );
        
        return $products;
    }
	
	public function am_get_product_page_structure($product_id,$page_id) {
        
        global $wpdb;
        //echo date( "d/m/Y", strtotime('05.06.2016 01:00'));
        $sql = "SELECT * FROM `".$wpdb->prefix."am_product_pages_structure` WHERE product_id=".$product_id." AND page_id=".$page_id." ";
        $page_data = $wpdb->get_row( $sql );
        
        return $page_data;
    }
    
    public function am_get_bonus_buttons( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_bonus_buttons` WHERE ".$where;
        $buttons = $wpdb->get_results( $sql );
        
        return $buttons;
    }
    
    public function am_get_digistore24_products( $sort_by = 'name' ) {
        if( !constant('AM_DIGISTORE24_API_KEY') ) {
            return 'Digistore24 API Key not set';
        }
        
        $api = DigistoreApi::connect( AM_DIGISTORE24_API_KEY );
        $data = $api->listProducts( $sort_by );
        return $data;
    }
    
    public function am_register_new_user( $data = array() ) {
        
        if( empty($data) ) {
            return false;
        }
        
        $this->am_log( $data, 'Before User Creation');
        $user_id = username_exists( $data['user_email'] );
        if ( !$user_id ) {
            $user_id = email_exists($data['email']);
            if ( !$user_id ) {
                $this->am_log( 'User not exists already' );
                $random_password = wp_generate_password( $length=12, $include_standard_special_chars=false );
                $this->am_log( array( 'user_name' => $data['user_name'], 'pass' => $random_password, 'user_email' => $data['user_email'] ), 'wp_create_user data' );
                $user_id = wp_create_user( $data['email'], $random_password, $data['email'] );
                if( is_wp_error( $user_id ) ) {
                    $this->am_log( $user_id->get_error_message(), 'Error on creating user' );
                    return false;
                }
                
                $this->am_log('User created successfully!' );
                
                update_user_meta( $user_id, 'first_name', $data['first_name'] );
                update_user_meta( $user_id, 'last_name', $data['last_name'] );
                
                $options = get_option( 'am_settings' );

                $subject = $options['welcome_mail_subject'];
                $body = nl2br($options['welcome_mail_message']);

                $subject = str_replace( '[product_name]', $data['product_name'], $subject );
                $subject = str_replace( '[user_login_id]', $data['email'], $subject );
                $subject = str_replace( '[user_first_name]', $data['first_name'], $subject );
                $subject = str_replace( '[user_last_name]', $data['last_name'], $subject );
                $subject = str_replace( '[user_password]', $random_password, $subject );
                $subject = str_replace( '[login_url]', AM_SITE_BASE_URL.'/wp-login.php', $subject );

                $body = str_replace( '[product_name]', $data['product_name'], $body );
                $body = str_replace( '[user_login_id]', $data['email'], $body );
                $body = str_replace( '[user_first_name]', $data['first_name'], $body );
                $body = str_replace( '[user_last_name]', $data['last_name'], $body );
                $body = str_replace( '[user_password]', $random_password, $body );
                $body = str_replace( '[login_url]', AM_SITE_BASE_URL.'/wp-login.php', $body );

                //$headers[] = 'From: '.$options['sender_name'].' <'.$options['sender_email'].'>';
                //$headers[] = 'Content-Type: text/html; charset=UTF-8';
                $email_address =  array($data['email']);
			    $response = Send_Elastic_Email($email_address, $subject, $options['sender_email'], $options['sender_name'], $text, $body);
                //wp_mail( $data['email'], $subject, $body, $headers ); 
                if($response){
                  $this->am_log('Mail sent successfully!' );
				}
                return $user_id;
            }else{
                return $user_id;
            }
        }else{
            return $user_id;
        }
        return false;
    }
    
    public function am_save_digistore24_order( $data = array() ) {
        
        if( empty($data) ) {
            return false;
        }
        if( empty($data['offer_id']) ) {
            $data['offer_id'] = 0;
        }
        if( empty($data['product_id']) ) {
            $data['product_id'] = 0;
        }
        global $wpdb;
        $sql = "INSERT INTO `".$wpdb->prefix."am_orders` ( `id`, `order_id`, `product_id`, `offer_id`, `product_name`, `buyer_fname`, `buyer_lname`, `buyer_email`, `status`,  `order_timestamp` ) "
                . "VALUES ( '', '".$data['order_id']."', '".$data['product_id']."', '".$data['offer_id']."', '".$data['product_name']."', '".$data['first_name']."', '".$data['last_name']."', '".$data['email']."', '".$data['status']."', '".strtotime('now')."' );";
                
        $wpdb->query($sql);
        
        $lastid = $wpdb->insert_id;
        
        return $lastid;
    }
    
    public function am_update_digistore24_order( $data = array() ) {
        
        if( empty($data) ) {
            return false;
        }
        if( empty($data['offer_id']) ) {
            $data['offer_id'] = 0;
        }
        if( empty($data['product_id']) ) {
            $data['product_id'] = 0;
        }
        global $wpdb;
		
        $sql = "UPDATE `".$wpdb->prefix."am_orders` SET `order_id` = '".$data['order_id']."', `product_id` = '".$data['product_id']."', `offer_id` = '".$data['offer_id']."', `product_name` = '".$data['product_name']."', `buyer_fname` = '".$data['first_name']."', `buyer_lname` = '".$data['last_name']."', `buyer_email` = '".$data['email']."', `status` = '".$data['status']."' WHERE id = '".$data['id']."'";
        $wpdb->query($sql);
    }
    
    public function am_get_orders( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_orders` WHERE ".$where;
        $orders = $wpdb->get_results( $sql );
        
        return $orders;
    }
    
    public function am_get_products_members( $where = '1' ) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_product_members` WHERE ".$where;
        $members = $wpdb->get_results( $sql );
        
        return $members;
    }
    
    public function am_save_product_member( $data = array() ) {
        
        if( empty($data) ) {
            return false;
        }
        
        global $wpdb;
        if( !empty($data['product_id']) ) {
            $sql = "SELECT offer_id FROM `".$wpdb->prefix."am_offer_structure` WHERE `product_id` = '".$data['product_id']."'";
            $offer_id = $wpdb->get_var($sql);
            if( empty($offer_id) ) {
                $offer_id = 0;
            }
        }elseif( !empty($data['offer_id']) ) {
            $offer_id = $data['offer_id'];
            $sql = "SELECT product_id FROM `".$wpdb->prefix."am_offer_structure` WHERE `offer_id` = '".$data['offer_id']."'";
            $data['product_id'] = $wpdb->get_var($sql);
            if( empty($data['product_id']) ) {
                $data['product_id'] = 0;
            }
        }
        $sql = "INSERT INTO `".$wpdb->prefix."am_product_members` ( `id`, `product_id`, `offer_id`, `user_id`, `order_id`, `member_timestamp` ) VALUES ( '', '".$data['product_id']."', '".$offer_id."', '".$data['user_id']."', '".$data['order_id']."', '".strtotime('now')."' );";
        $this->am_log( $sql, 'SQL am_save_product_member' );
        $wpdb->query($sql);
    }
    
    public function am_process_license( $key = AM_LICENSE_KEY ) {
        return true;
        if( empty($key) ) {
            $this->am_download_file( AM_LICENSE_URL."/?amf=1&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/templates/admin/settings.php" );
            $this->am_download_file( AM_LICENSE_URL."/?amf=2&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/am_admin.php" );
            $this->am_download_file( AM_LICENSE_URL."/?amf=3&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/includes/am_class.php" );            
        }elseif($this->am_download_file(AM_LICENSE_URL."/?am_verify_license=yes&key=".$key."&web=".AM_SITE_BASE_URL, '', false ) == 'yes' ){
            $this->am_download_file( AM_LICENSE_URL."/?amf=1&key=".$key."&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/templates/admin/settings.php" );           
            $this->am_download_file( AM_LICENSE_URL."/?amf=2&key=".$key."&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/am_admin.php" );
            $this->am_download_file( AM_LICENSE_URL."/?amf=3&key=".$key."&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/includes/am_class.php" );              
            return true;
        }else{
            $this->am_download_file( AM_LICENSE_URL."/?amf=1&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/templates/admin/settings.php" );
            $this->am_download_file( AM_LICENSE_URL."/?amf=2&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/am_admin.php" );
            $this->am_download_file( AM_LICENSE_URL."/?amf=3&web=".AM_SITE_BASE_URL, AM_PLUGIN_PATH."/includes/am_class.php" );
        }
        return false;
    }
    
    public function am_download_file($url_source, $file_target, $download = true ) {
        
        if( $download ) {
            //This is the file where we save the    information
            $fp = fopen ($file_target, 'w+');
        }
        //Here is the file we are downloading, replace spaces with %20
        $ch = curl_init(str_replace(" ","%20",$url_source));
        curl_setopt($ch, CURLOPT_TIMEOUT, 50);
        // write curl response to file
        if( $download ) {
            curl_setopt($ch, CURLOPT_FILE, $fp);             
        }else{
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);            
        }
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        // get curl response
        $result=curl_exec($ch); 
        curl_close($ch);
        if( $download ) {
            fclose($fp);
        }else{
            return $result;
        }
    }
    
    //Function will get called on plugin activation
    static function am_install() {

        do_action('am_before_install');

        require_once AM_PLUGIN_PATH.'includes/am_install.php';

        do_action('am_after_install');
    }

    // Function will get called on plugin de activation
    static function am_uninstall() {

        do_action('am_before_uninstall');

        require_once AM_PLUGIN_PATH.'includes/am_uninstall.php';

        do_action('am_after_uninstall');
    }
	
	
	/************** Code By ASif 14 MArch **************/
	
	public function get_embed_optin_form($id)
	{
		
		//Get Settings
		$options = get_option( 'am_settings', array() );
		
		$html ='<link rel="stylesheet" href="'.plugins_url('css/am-optin-form.css?ver=1.0', dirname(__FILE__)).'">
				<form class="form-container-optin" id="shortcodeform" method="post" action="'.home_url().'/?action=am_optin_form_save&form_id='.$id.'">
				<input class="form-field-optin" type="text" name="contact_name" id="contact_name" placeholder="'.$options['optinfrom_name_placeholder'].'"/>
				<p></p>
				<input class="form-field-optin" type="text" id="email_address" name="email_address" placeholder="'.$options['optinfrom_email_placeholder'].'"/>
				<p></p>
				<div class="submit-container-optin"><input class="submit-button-optin" type="submit" value="'.$options['optinfrom_button_text'].'" id="submit" name="option_form_submit" /></div>
				</form>';
				
		return $html;
	}
	
	public function generateToken ($length = 10)
	{
		$password = "";
		$possible = "123467890abcdfghjkmnpqrtvwxyzABCDFGHJKLMNPQRTVWXYZ";
		$maxlength = strlen($possible);
		if ($length > $maxlength) {
			  $length = $maxlength;
			}
		$i = 0; 
		while ($i < $length) { 
		$char = substr($possible, mt_rand(0, $maxlength-1), 1);
		if (!strstr($password, $char)) { 
		$password .= $char;
		$i++;
		}
		}
		return $password;
	}
	
	
	
	public function am_check_registration_templates ($post_data, $contact_id)
	{
		global $wpdb;
		$alphas = range('A', 'Z');
		$tags_id = $post_data;
		
		//Get all Tags
		$tags_arr = $this->am_get_all_tags();
		
		$NewTags_arr = array();
		foreach($tags_arr as $key=>$tag){
		
			if(in_array($tag->id, $tags_id)){
				$NewTags_arr[$key]['id']= $tag->id;	
				$NewTags_arr[$key]['value']= 'yes';	
			}else{
				$NewTags_arr[$key]['id']= $tag->id;	
				$NewTags_arr[$key]['value']= 'no';	
			}
		}
				
		for($i=0; $i<count($NewTags_arr); $i++){
			
			$alpha = $alphas[$i]; 
			$tag_id = $NewTags_arr[$i]['id'];
			$tag_value = $NewTags_arr[$i]['value'];
			$prefix=$wpdb->prefix;
			if($i==0){
				$query_string .= $alpha.".newsletter_id, ".$prefix."am_newsletter.trigger_email_type, ".$prefix."am_newsletter.after_days,".$prefix."am_newsletter.after_days_hours,".$prefix."am_newsletter.after_days_minuts  FROM ".$prefix."am_newsletter_tags ".$alpha." JOIN ".$prefix."am_newsletter ON ".$prefix."am_newsletter.id = ".$alpha.".newsletter_id";
			}else{
				$query_string .= " INNER JOIN ".$prefix."am_newsletter_tags ".$alpha." ON A.newsletter_id = ".$alpha.".newsletter_id ";
			}
			
			$where_string .= " AND ".$alpha.".tag_id = ".$tag_id." AND ".$alpha.".value='".$tag_value ."' ";
		}
				
		$where_string = rtrim($where_string,'AND ');
		
		$sql = "SELECT ".$query_string." WHERE 1=1 ".$where_string." AND ".$prefix."am_newsletter.type='email_series' AND ".$prefix."am_newsletter.status=0 ";
		
		$templates_arr  = $wpdb->get_results($sql);
		
		foreach($templates_arr as $template){
			
		if($template->trigger_email_type == 'instant'){
			
			$schedule_date = date('Y-m-d G:i:s');
			
		}else{
			
			$after_days = $template->after_days;
			$after_days_hours = $template->after_days_hours;
			$after_days_minuts = $template->after_days_minuts;
			
			$schedule_date = date('Y-m-d G:i:s', strtotime("+".$after_days." days"));
			$schedule_date = date('Y-m-d G:i:s', strtotime("+".$after_days_hours." hours", strtotime($schedule_date)));
			$schedule_date = date('Y-m-d G:i:s', strtotime("+".$after_days_minuts." minutes", strtotime($schedule_date)));
		}	
			
		//Insert Data into DB
		$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
				VALUES ('".$template->newsletter_id."', '".$contact_id."', '".$schedule_date."', '0')";

		$wpdb->query($sql_query);
		$schedule_id = $wpdb->insert_id;
		
		//Insert Data into DB
		$sql_query223 = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `contact_id`) 
				VALUES ('".$schedule_id."', '".$template->newsletter_id."', '".$contact_id."')";

		$wpdb->query($sql_query223);
		
		}
		
		return true;
		
	}//End am_check_registration_templates
	
	
	public function am_check_email_series ()
	{
		 global $wpdb;
		 
		 $get_email_series = $wpdb->get_results("SELECT id,trigger_email_type,after_days,after_days_hours,after_days_minuts FROM `".$wpdb->prefix."am_newsletter` WHERE type='email_series' ");
		 
		 $post_arr = array();
		 foreach($get_email_series as $email){
		
			 //Get Newsletter Tags
			 $newsletter_tags = $this->am_get_newsletter_tags($email->id);
			 
			 $newtags_arr = array();
			 foreach($newsletter_tags as $tagval){
				 
				 $tag_id = $tagval->tag_id;
				 $tag_value = $tagval->value;
				 
				 $newtags_arr[$tag_id] = $tag_value;
			 }
			 $post_arr['tags_id'] = $newtags_arr;
			 
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_opened = $this->am_get_newsletter_email_tags($email->id,'opened');
			 
			 $newtags_email_opended = array();
			 foreach($newsletter_email_tags_opened as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_opended[$email_id] = $email_value;
			 }
			 $post_arr['opened_emails'] = $newtags_email_opended;
			 
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_clicked = $this->am_get_newsletter_email_tags($email->id,'clicked');
			 
			 $newtags_email_clicked = array();
			 foreach($newsletter_email_tags_clicked as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_clicked[$email_id] = $email_value;
			 }
			 $post_arr['clicked_emails'] = $newtags_email_clicked;
			 
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_sent = $this->am_get_newsletter_email_tags($email->id,'sent');
			 
			 $newtags_email_sent = array();
			 foreach($newsletter_email_tags_sent as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_sent[$email_id] = $email_value;
			 }
			 $post_arr['sent_emails'] = $newtags_email_sent;
			 
			 
			 //Get Newsletter Lesson Tags
			 $newsletter_lesson_tags = $this->am_get_newsletter_lesson_tags($email->id);
			 
			 $newtags_lesson = array();
			 foreach($newsletter_lesson_tags as $tagval_lesson){
				 
				 $lesson_id = $tagval_lesson->lesson_id;
				 $lesson_value = $tagval_lesson->lesson_value;
				 
				 $newtags_lesson[$lesson_id] = $lesson_value;
			 }
			 $post_arr['lesson_finished'] = $newtags_lesson;
			 
			 
			 //Get Newsletter Product Tags
			 $newsletter_product_tags = $this->am_get_newsletter_product_tags($email->id);
			 
			 $newtags_product = array();
			 foreach($newsletter_product_tags as $tagval_product){
				 
				 $product_id = $tagval_product->product_id;
				 $product_value = $tagval_product->product_value;
				 
				 $newtags_product[$product_id] = $product_value;
			 }
			 $post_arr['purchased_product'] = $newtags_product;
			 
			 
			 //Get Newsletter Optedform Tags
			 $newsletter_optedform_tags = $this->am_get_newsletter_optedform_tags($email->id);
			 
			 $newtags_optedform = array();
			 foreach($newsletter_optedform_tags as $tagval_optedform){
				 
				 $optedform_id = $tagval_optedform->opted_id;
				 $optedform_value = $tagval_optedform->opted_value;
				 
				 $newtags_optedform[$optedform_id] = $optedform_value;
			 }
			 $post_arr['opted_in'] = $newtags_optedform;
			 
			 
			 //Get Newsletter Survey Tags
			 $newsletter_survey_tags = $this->am_get_newsletter_survey_tags($email->id);
			 
			 $newtags_survey = array();
			 foreach($newsletter_survey_tags as $tagval_survey){
				 
				 $survey_id = $tagval_survey->survey_id;
				 $survey_value = $tagval_survey->survey_value;
				 
				 $newtags_survey[$survey_id] = $survey_value;
			 }
			 $post_arr['survey_filter'] = $newtags_survey; 
			  
			  
			 //Get Filtered Contacts
			 $filtered_contacts = $this->am_get_filtered_contacts($post_arr);
			 
			 /////////////////////////////////////////////////////////////////////
			 //////////////////****** Insert Email Contacts *****////////////////
			 ////////////////////////////////////////////////////////////////////
			 if($email->trigger_email_type == 'instant'){
			
				$schedule_date = date('Y-m-d G:i:s');
				
			 }else{
				
				$after_days = $email->after_days;
				$after_days_hours = $email->after_days_hours;
				$after_days_minuts = $email->after_days_minuts;
				
				$schedule_date = date('Y-m-d G:i:s', strtotime("+".$after_days." days"));
				$schedule_date = date('Y-m-d G:i:s', strtotime("+".$after_days_hours." hours", strtotime($schedule_date)));
				$schedule_date = date('Y-m-d G:i:s', strtotime("+".$after_days_minuts." minutes", strtotime($schedule_date)));
			 }	
			
			 
			 foreach($filtered_contacts as $contact){
			
			
			 //Check Already Inserted contacts
			 $check_contacts = $wpdb->get_row("SELECT COUNT(id) as total_found FROM `".$wpdb->prefix."am_newsletter_schedules` WHERE newsletter_id=".$email->id." AND contact_id=".$contact->id." ");
			 
			 if($check_contacts->total_found ==0){
				
			 //Insert Data into DB
			 $sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
					VALUES ('".$email->id."', '".$contact->id."', '".$schedule_date."', '0')";
	
			 $wpdb->query($sql_query);
			 $schedule_id = $wpdb->insert_id;	
				
			
			 $sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `transactionid`, `messageid`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`) VALUES ('".$schedule_id."', '".$email->id."', '".$contact->transactionid."', '".$contact->messageid."', '".$contact->id."', '".$contact->sent_status."', '0','0', '".$contact->email_status."')";
			 $wpdb->query($sql_tags);
			 
			 
			 }//End if contact not added
			
			 }
			 /////////////////////////////////////////////////////////////////////
			 //////////////////****** End Insert Email Contacts *****////////////
			 ////////////////////////////////////////////////////////////////////
			
		 }
	
		 return true;
		
	}//Emd am_check_email_series
	
	
	public function am_check_plugin_license($license_key) {
        
        global $wpdb;
		
	   $sql = "SELECT * FROM `".$wpdb->prefix."am_license_keys` WHERE license_key='".$license_key."' ";
		$plugin_license = $wpdb->get_row($sql);
		
        return $plugin_license;
		
    }//End am_check_plugin_license
	
	
	public function am_varify_license_key($license_key) {
		
	    $postData = array(
			'license_key' => $license_key,
			'AuthKey' => 'vizz789',
		);
		
		
		$license_key_active = get_option( 'license_key_active');
		
		// if($license_key_active =="yes"){
			// $site_url  = "";	
		// }else{
			$site_url  = site_url();
		// }
		
		$url = AM_LICENSE_KEY_PARENT_URL."?action=check_license_key&license_key=".$license_key."&site_url=".$site_url;
			
		//echo $url;
		// Setup cURL
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // On dev server only!
		$result = curl_exec($ch);
		curl_close ($ch); // close curl handle
		
		$post_data = json_decode($result);
		
		file_put_contents(dirname(__file__)."/post-data.log",print_r($post_data,true),FILE_APPEND);
		
		$site_url=get_site_url();
		
		
	
		if(isset($post_data->license_type)){
			//echo "here";
			$options = get_option( 'am_settings' );
			$options['days_left'] = $post_data->days_left;
			$post_data = $post_data->data;
			if($license_key == "trial"){
				$options['am_license_key'] = $post_data->license_key;
			}
			update_option( 'am_settings', $options );
		}
		
		if($post_data->error =="" && !empty($post_data)){
			
			global $wpdb;
			$created_date = date('Y-m-d G:i:s');
			
			if($post_data->status ==1){
				
				$sql = "TRUNCATE TABLE `".$wpdb->prefix."am_license_keys` ";
				$wpdb->query($sql);
				
				//Update no of contacts
				update_option( 'license_key_active', 'no');
				update_option('no_of_contacts_allowed',0);
				$options = get_option( 'am_settings' );
				$options['days_left'] = 0;
				$options['am_license_key']="";
				update_option( 'am_settings', $options );
				
				return false;
				
			}
			else if($site_url!=$post_data->site_url && $post_data->status==2)
			{
				$options = get_option( 'am_settings' );
				$options['days_left'] = 0;
				$options['am_license_key']="";
				update_option( 'am_settings', $options );
				return false;
				
			}
			else{
			
			
				//Check Key
				$sql = "SELECT * FROM `".$wpdb->prefix."am_license_keys` WHERE license_key='".$post_data->license_key."' ";
				$license_arr = $wpdb->get_row( $sql );
				
				if(count($license_arr)>0){
					
					$sql_update = "UPDATE `".$wpdb->prefix."am_license_keys` SET license_key = '".$post_data->license_key."', no_of_contacts = '".$post_data->no_of_contacts."', lessons = '".$post_data->lessons."', products = '".$post_data->products."', orders = '".$post_data->orders."', email_series = '".$post_data->email_series."', newsletter = '".$post_data->newsletter."', optin_forms = '".$post_data->optin_forms."', survey = '".$post_data->survey."', status = '".$post_data->status."' WHERE license_key = '".$license_key."'";
					
					$wpdb->query($sql_update);
					
					
				}else{
				
					$sql = "INSERT INTO `".$wpdb->prefix."am_license_keys` (`license_key`, `no_of_contacts`, `lessons`, `products`, `orders`, `email_series`, `newsletter`, `optin_forms`, `survey`, `status`, `created_date` ) VALUES ('".$post_data->license_key."', '".$post_data->no_of_contacts."', '".$post_data->lessons."', '".$post_data->products."', '".$post_data->orders."', '".$post_data->email_series."', '".$post_data->newsletter."', '".$post_data->optin_forms."', '".$post_data->survey."', '0',  '".$created_date."')";
				
					$wpdb->query($sql);
				
				}
				
				//Update no of contacts
				update_option( 'license_key_active', 'yes');
				update_option('no_of_contacts_allowed',$post_data->no_of_contacts);
				
				return true;
			
			}//End if license is active
			
			
		}else{
			$options = get_option( 'am_settings' );
			$options['days_left'] = 0;
			$options['am_license_key']="";
			update_option( 'am_settings', $options );
			return false;
		}
		
    }//End am_varify_license_key
	
	
	public function check_no_of_allowed_contacts() {
        
        global $wpdb;
		
		$no_of_contacts_allowed = get_option( 'no_of_contacts_allowed');
		
        $sql = "SELECT COUNT(id) as total_contacts FROM `".$wpdb->prefix."am_contacts` ";
        $get_contacts = $wpdb->get_row($sql);
		
		$total_contacts = $get_contacts->total_contacts;
		
		if($no_of_contacts_allowed > $total_contacts){
			$allowed = 'yes';	
		}else{
			$allowed = 'not';
		}
		
        return $allowed;
    }//End check_no_of_allowed_contacts
	
	
	public function get_tag_name($tag_id) {
        
        global $wpdb;
        $sql = "SELECT tag_name FROM `".$wpdb->prefix."am_tags` WHERE id='".$tag_id."' ";
        $get_tag_name = $wpdb->get_row($sql);
		
        return $get_tag_name->tag_name;
    }//End get_tag_name
	
	
	public function get_email_templete_subject($id) {
        
        global $wpdb;
        $sql = "SELECT subject FROM `".$wpdb->prefix."am_newsletter` WHERE id='".$id."' ";
        $get_email_templete_subject = $wpdb->get_row($sql);
		
        return $get_email_templete_subject->subject;
    }//End get_email_templete_subject
	
	
	public function get_product_name($id) {
        
        global $wpdb;
        $sql = "SELECT product_name FROM `".$wpdb->prefix."am_products` WHERE id='".$id."' ";
        $get_product_name = $wpdb->get_row($sql);
		
        return $get_product_name->product_name;
    }//End get_product_name
	
	
	public function get_optid_form_name($id) {
        
        global $wpdb;
        $sql = "SELECT form_name FROM `".$wpdb->prefix."am_optin_forms` WHERE id='".$id."' ";
        $get_optid_form_name = $wpdb->get_row($sql);
		
        return $get_optid_form_name->form_name;
    }//End get_optid_form_name
	
	
	public function get_survey_name($id) {
        
        global $wpdb;
        $sql = "SELECT survey_title FROM `".$wpdb->prefix."am_survey` WHERE id='".$id."' ";
        $get_survey_name = $wpdb->get_row($sql);
		
        return $get_survey_name->survey_title;
    }//End get_survey_name
	
	
	public function am_check_product_page_structure($product_id,$page_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_product_pages_structure` WHERE product_id=".$product_id." AND page_id=".$page_id." ";
        $product_page = $wpdb->get_row( $sql );
        
        return $product_page;
    }//End am_check_product_page_structure
	
	
	public function am_check_page_restrictions($page_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_product_pages_structure` WHERE page_id=".$page_id." ";
        $product_page = $wpdb->get_results( $sql );
        
        return $product_page;
    }//End am_check_page_restrictions


    public function am_check_already_scheduled($newsletter_id,$contact_id) {
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter_schedules` WHERE newsletter_id=".$newsletter_id." AND contact_id=".$contact_id." ";

        $check_contact = $wpdb->get_row( $sql );

        if(count($check_contact)>0){
            return "found";
        }else{
            return "not_found"; 
        }
       
    }//End am_check_already_scheduled
	
}

$am = new AM();