<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */



/**

 * Class that will hold functionality for plugin activation

 *

 * PHP version 5

 *

 * @category   Install

 * @package    Access Members

 * @author     Erfolgs-Faktor

 * @version    1.0.0

 * @since      File available since Release 1.0.0

*/



class AM_Install extends AM

{

    public function __construct() {

        

        do_action('am_before_install', $this );

        

        global $wpdb;

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_orders`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_orders`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_orders` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `order_id` varchar(255) DEFAULT NULL,

                          `product_id` varchar(255) DEFAULT '',

                          `offer_id` varchar(255) DEFAULT '',

                          `product_name` varchar(255) DEFAULT '0',

                          `buyer_fname` varchar(255) DEFAULT '0',

                          `buyer_lname` varchar(255) DEFAULT '0',

                          `buyer_email` varchar(255) DEFAULT '0',

                          `status` varchar(255) DEFAULT '0',

                          `order_timestamp` varchar(255) DEFAULT '0',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_orders` ( `id`, "

                . "`order_id`, `product_id`, `offer_id`, "

                . "`product_name`, `buyer_fname`, `buyer_lname`, "

                . "`buyer_email`, `status`, `order_timestamp`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', "

                    . "'".$row->order_id."', "

                    . "'".$row->product_id."', "

                    . "'".$row->offer_id."', "

                    . "'".$row->product_name."', "

                    . "'".$row->buyer_fname."', "

                    . "'".$row->buyer_lname."', "

                    . "'".$row->buyer_email."', "

                    . "'".$row->status."', "

                    . "'".$row->order_timestamp."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_modules`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_modules`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_modules` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `name` varchar(255) DEFAULT NULL,

                          `module_timestamp` varchar(255) DEFAULT '0',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        

        $sql = "INSERT INTO `".$wpdb->prefix."am_modules` ("

                . "`id`, `name`, `module_timestamp`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->name."', "

                    . "'".$row->module_timestamp."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_user_coins`");

		

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_user_coins`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_user_coins` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `title` varchar(255) DEFAULT '',

                          `user_ids` text DEFAULT '',

                          `initital_coins` bigint(20) NULL,

                          `per_month_coins` bigint(20) NULL,

                          `record_timestamp` varchar(255) DEFAULT '0', 

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        

		$sql = "INSERT INTO `".$wpdb->prefix."am_user_coins` ( `id`,"

                . "`title`, `user_ids`, `initital_coins`, "

                . "`per_month_coins`, `record_timestamp`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->title."', "

                    . "'".$row->user_ids."', "

                    . "'".$row->initital_coins."', "

                    . "'".$row->per_month_coins."', "

                    . "'".$row->record_timestamp."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

        

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_log`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_log` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `text` text DEFAULT NULL,

                          `desc` text DEFAULT NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_offers`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_offers`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_offers` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `offer_name` varchar(255) DEFAULT NULL,

                          `digi_products` varchar(255) DEFAULT '',

                          `login_redirect` varchar(255) DEFAULT '',

                          `error_redirect` varchar(255) DEFAULT '',

                          `error_text` text DEFAULT '',

                          `lock_user_on_no_payment` varchar(255) DEFAULT '',

                          `lock_redirect` varchar(255) DEFAULT '',

                          `bg_image` varchar(255) DEFAULT '',

                          `logo` varchar(255) DEFAULT '',

                          `top_header_gradient_color1` varchar(255) DEFAULT '',

                          `top_header_gradient_color2` varchar(255) DEFAULT '',

                          `content_gradient_color1` varchar(255) DEFAULT '',

                          `content_gradient_color2` varchar(255) DEFAULT '',                          

                          `above_button_text` varchar(255) DEFAULT '',

                          `text_color` varchar(255) DEFAULT '',

                          `text_size` varchar(255) DEFAULT '',

                          `text_font` varchar(255) DEFAULT '',

                          `button_text` varchar(255) DEFAULT '',

                          `button_bg_color` varchar(255) DEFAULT '',

                          `button_text_color` varchar(255) DEFAULT '',

                          `button_text_font` varchar(255) DEFAULT '',

                          `button_text_size` varchar(255) DEFAULT '',

                          `offer_page` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_offers` ( `id`, "

                . "`offer_name`, `digi_products`, `login_redirect`, "

                . "`error_redirect`, `error_text`, `lock_user_on_no_payment`, "

                . "`lock_redirect`, `bg_image`, `logo`, "

                . "`top_header_gradient_color1`, `top_header_gradient_color2`, `content_gradient_color1`, "

                . "`content_gradient_color2`, `above_button_text`, `text_color`, "

                . "`text_size`, `text_font`, `button_text`, "

                . "`button_bg_color`, `button_text_color`, `button_text_font`, "

                . "`button_text_size`, `offer_page`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->offer_name."', '".$row->digi_products."', '".$row->login_redirect."', "

                    . "'".$row->error_redirect."', '".$row->error_text."', '".$row->lock_user_on_no_payment."', "

                    . "'".$row->lock_redirect."', '".$row->bg_image."', '".$row->logo."', "

                    . "'".$row->top_header_gradient_color1."', '".$row->top_header_gradient_color2."', '".$row->content_gradient_color1."', "

                    . "'".$row->content_gradient_color2."', '".$row->above_button_text."', '".$row->text_color."', "

                    . "'".$row->text_size."', '".$row->text_font."', '".$row->button_text."', "

                    . "'".$row->button_bg_color."', '".$row->button_text_color."', '".$row->button_text_font."', "

                    . "'".$row->button_text_size."', '".$row->offer_page."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_offer_structure`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_offer_structure`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_offer_structure` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `offer_id` bigint(20) NULL,

                          `product_id` bigint(20) NULL,

                          `module_id` bigint(20) NULL,

                          `lesson_id` bigint(20) NULL,                          

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_offer_structure` ( `id`, "

                . "`offer_id`, `product_id`, `module_id`, "

                . "`lesson_id`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->offer_id."', '".$row->product_id."', '".$row->module_id."', "

                    . "'".$row->lesson_id."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_products`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_products`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_products` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `product_name` varchar(255) DEFAULT NULL,

                          `product_image` varchar(255) DEFAULT NULL,

                          `enable_sumit` varchar(255) DEFAULT '',

                          `enable_delay_access` varchar(255) DEFAULT '',

                          `enable_evergreen` varchar(255) DEFAULT '',

                          `enable_coins` varchar(255) DEFAULT '',

                          `digi_products` varchar(255) DEFAULT '',

                          `product_secure_posts` varchar(255) DEFAULT '',

                          `product_secure_pages` varchar(255) DEFAULT '',                          

                          `pages_price` varchar(255) DEFAULT '',

                          `posts_price` varchar(255) DEFAULT '',                          

                          `login_redirect` varchar(255) DEFAULT '',

                          `error_redirect` varchar(255) DEFAULT '',

                          `error_text` text DEFAULT '',

                          `lock_user_on_no_payment` varchar(255) DEFAULT '',

                          `lock_redirect` varchar(255) DEFAULT '',

                          `enable_adv` varchar(255) DEFAULT '',

                          `adv_image` varchar(255) DEFAULT '',

                          `adv_url` varchar(255) DEFAULT '',                          

                          `bg_image` varchar(255) DEFAULT '',

                          `logo` varchar(255) DEFAULT '',

                          `top_header_gradient_color1` varchar(255) DEFAULT '',

                          `top_header_gradient_color2` varchar(255) DEFAULT '',

                          `top_header_content` text DEFAULT '',

                          `content_top_gradient_color1` varchar(255) DEFAULT '',

                          `content_top_gradient_color2` varchar(255) DEFAULT '',     

                          `menu_position` varchar(255) DEFAULT '',

                          `module_bg_color` varchar(255) DEFAULT '',

                          `module_text_color` varchar(255) DEFAULT '',

                          `module_text_size` varchar(255) DEFAULT '',

                          `module_text_font` varchar(255) DEFAULT '',

                          `lesson_bg_color` varchar(255) DEFAULT '',

                          `lesson_text_color` varchar(255) DEFAULT '',

                          `lesson_text_size` varchar(255) DEFAULT '',

                          `lesson_text_font` varchar(255) DEFAULT '',

                          `access_symbol_active_color` varchar(255) DEFAULT '',

                          `access_symbol_inactive_color` varchar(255) DEFAULT '',

                          `access_active_color` varchar(255) DEFAULT '',

                          `access_inactive_color` varchar(255) DEFAULT '',

                          `module_tab` varchar(255) DEFAULT '',

                          `sticky_menu` varchar(255) DEFAULT '',

                          `scrollbar` varchar(255) DEFAULT '',

                          `auto_scroll` varchar(255) DEFAULT '',

                          `post_duriation_text_color` varchar(255) DEFAULT '',

                          `post_duriation_text_size` varchar(255) DEFAULT '',

                          `post_duriation_text_font` varchar(255) DEFAULT '',

                          `instructor_text_color` varchar(255) DEFAULT '',

                          `instructor_text_size` varchar(255) DEFAULT '',

                          `instructor_text_font` varchar(255) DEFAULT '',

                          `product_page` varchar(255) DEFAULT '',

                          `initial_coins` varchar(255) DEFAULT '',

                          `month_coins` varchar(255) DEFAULT '',
						  
						  `selected_product` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_products` ( `id`, "

                . "`product_name`, `product_image`, `enable_sumit`, "

                . "`enable_delay_access`, `enable_evergreen`, `enable_coins`, "

                . "`digi_products`, `product_secure_posts`, `product_secure_pages`, "

                . "`pages_price`, `posts_price`, `login_redirect`, "

                . "`error_redirect`, `error_text`, `lock_user_on_no_payment`, "

                . "`lock_redirect`, `enable_adv`, `adv_image`, "

                . "`adv_url`, `bg_image`, `logo`, "

                . "`top_header_gradient_color1`, `top_header_gradient_color2`, `top_header_content`, "

                . "`content_top_gradient_color1`, `content_top_gradient_color2`, `menu_position`, "

                . "`module_bg_color`, `module_text_color`, `module_text_size`, "

                . "`module_text_font`, `lesson_bg_color`, `lesson_text_color`, "

                . "`lesson_text_size`, `access_symbol_active_color`, `access_symbol_inactive_color`, "

                . "`access_active_color`, `access_inactive_color`, `module_tab`, "

                . "`sticky_menu`, `scrollbar`, `auto_scroll`, "

                . "`post_duriation_text_color`, `post_duriation_text_size`, `post_duriation_text_font`, "

                . "`instructor_text_color`, `instructor_text_size`, `instructor_text_font`, "

                . "`product_page`, `initial_coins`, `month_coins` ) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->product_name."', '".$row->product_image."', '".$row->enable_sumit."', "

                    . "'".$row->enable_delay_access."', '".$row->enable_evergreen."', '".$row->enable_coins."', "

                    . "'".$row->digi_products."', '".$row->product_secure_posts."', '".$row->product_secure_pages."', "

                    . "'".$row->pages_price."', '".$row->posts_price."', '".$row->login_redirect."', "

                    . "'".$row->error_redirect."', '".$row->error_text."', '".$row->lock_user_on_no_payment."', "

                    . "'".$row->lock_redirect."', '".$row->enable_adv."', '".$row->adv_image."', "

                    . "'".$row->adv_url."', '".$row->bg_image."', '".$row->logo."', "

                    . "'".$row->top_header_gradient_color1."', '".$row->top_header_gradient_color2."', '".$row->top_header_content."', "

                    . "'".$row->content_top_gradient_color1."', '".$row->content_top_gradient_color2."', '".$row->menu_position."', "

                    . "'".$row->module_bg_color."', '".$row->module_text_color."', '".$row->module_text_size."', "

                    . "'".$row->module_text_font."', '".$row->lesson_bg_color."', '".$row->lesson_text_color."', "

                    . "'".$row->lesson_text_size."', '".$row->access_symbol_active_color."', '".$row->access_symbol_inactive_color."', "

                    . "'".$row->access_active_color."', '".$row->access_inactive_color."', '".$row->module_tab."', "

                    . "'".$row->sticky_menu."', '".$row->scrollbar."', '".$row->auto_scroll."', "

                    . "'".$row->post_duriation_text_color."', '".$row->post_duriation_text_size."', '".$row->post_duriation_text_font."', "

                    . "'".$row->instructor_text_color."', '".$row->instructor_text_size."', '".$row->instructor_text_font."', "

                    . "'".$row->product_page."', '".$row->initial_coins."', '".$row->month_coins."' ),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_product_course_structure`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_product_course_structure`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_product_course_structure` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `product_id` bigint(20) NULL,

                          `module_id` bigint(20) NULL,

                          `lesson_id` bigint(20) NULL,

                          `free_access_start` varchar(255) DEFAULT '',

                          `free_access_end` varchar(255) DEFAULT '',

                          `evergreen_start_day` varchar(255) DEFAULT '',

                          `evergreen_start_hour` varchar(255) DEFAULT '',

                          `evergreen_end_day` varchar(255) DEFAULT '',

                          `evergreen_end_hour` varchar(255) DEFAULT '',

                          `days_delay` varchar(255) DEFAULT '',

                          `coins` varchar(255) DEFAULT '',

                          `module_position` bigint(20) NULL,

                          `lesson_position` bigint(20) NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_product_course_structure` ( `id`, "

                . "`product_id`, `module_id`, `lesson_id`, "

                . "`free_access_start`, `free_access_end`, `evergreen_start_day`, "

                . "`evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, "

                . "`days_delay`, `coins`, `module_position`, "

                . "`lesson_position`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->product_id."', '".$row->module_id."', '".$row->lesson_id."', "

                    . "'".$row->free_access_start."', '".$row->free_access_end."', '".$row->evergreen_start_day."', "

                    . "'".$row->evergreen_start_hour."', '".$row->evergreen_end_day."', '".$row->evergreen_end_hour."', "

                    . "'".$row->days_delay."', '".$row->coins."', '".$row->module_position."', "

                    . "'".$row->lesson_position."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_product_members`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_product_members`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_product_members` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `product_id` bigint(20) NULL,

                          `offer_id` bigint(20) NULL,

                          `user_id` bigint(20) NULL,

                          `order_id` bigint(20) NULL,

                          `member_timestamp` varchar(255) DEFAULT '0',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_product_members` ( `id`, "

                . "`product_id`, `offer_id`, `user_id`, "

                . "`order_id`, `member_timestamp`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->product_id."', '".$row->offer_id."', '".$row->user_id."', "

                    . "'".$row->order_id."', '".$row->member_timestamp."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_bonus_buttons`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_bonus_buttons`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_bonus_buttons` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `title` varchar(255) DEFAULT '',

                          `desc` varchar(255) DEFAULT '',

                          `symbol` varchar(255) DEFAULT '',

                          `button_text` varchar(255) DEFAULT '',

                          `url` varchar(255) DEFAULT '',

                          `for_customers` varchar(255) DEFAULT '',

                          `product` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_bonus_buttons` ( `id`, "

                . "`title`, `desc`, `symbol`, "

                . "`button_text`, `url`, `for_customers`, "

                . "`product`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->title."', '".$row->desc."', '".$row->symbol."', "

                    . "'".$row->button_text."', '".$row->url."', '".$row->for_customers."', "

                    . "'".$row->product."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

        

        $data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_evergreen_users`");

        $wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_evergreen_users`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_evergreen_users` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `product_id` bigint(20) NULL,

                          `user_email` varchar(255) DEFAULT '',

                          `access_timestamp` varchar(255) DEFAULT '0',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

        $sql = "INSERT INTO `".$wpdb->prefix."am_evergreen_users` ( `id`, "

                . "`product_id`, `user_email`, `access_timestamp`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->product_id."', '".$row->user_email."', '".$row->access_timestamp."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		///////////////////////////////////////////////////////////////////////////////////

		/////////////////********** New Tables by ilyaskhan *****//////////////////////////

		///////////////////////////////////////////////////////////////////////////////////

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_contacts`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_contacts`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_contacts` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `user_id` bigint(20) NULL,

						  `token` varchar(255) DEFAULT '',

						  `name` varchar(255) DEFAULT '',

                          `email_address` text DEFAULT '',

						  `tags` varchar(255) DEFAULT '',

						  `optin_form_id` varchar(255) DEFAULT '',

                          `status` bigint(20) NULL,

						  `confirmed_date` datetime NULL,

						  `created_date` datetime NULL,

						  `created_by_ip` varchar(255) DEFAULT '',

                          `refferal_url` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` ( `id`, `user_id`, `token`, `name`,`email_address`,`tags`,`optin_form_id`,`status`,`confirmed_date`,`created_date`,`created_by_ip`,`refferal_url`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->user_id."', '".$row->token."', '".$row->name."', '".$row->email_address."', '".$row->tags."', '".$row->optin_form_id."', '".$row->status."', '".$row->confirmed_date."', '".$row->created_date."', '".$row->created_by_ip."', '".$row->refferal_url."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_emails_categories`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_emails_categories`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_emails_categories` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `category_name` varchar(255) DEFAULT '',

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_emails_categories` ( `id`, `category_name`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->category_name."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_lesson_finished`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_lesson_finished`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_lesson_finished` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `user_id` bigint(20) NULL,

						  `lesson_id` bigint(20) NULL,

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_lesson_finished` ( `id`, `user_id`, `lesson_id`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->user_id."', '".$row->lesson_id."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_license_keys`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_license_keys`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_license_keys` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `license_key` varchar(255) DEFAULT '',

						  `no_of_contacts` bigint(20) NULL,

						  `lessons` bigint(20) NULL,

						  `products` bigint(20) NULL,

						  `orders` bigint(20) NULL,

						  `email_series` bigint(20) NULL,

						  `newsletter` bigint(20) NULL,

						  `optin_forms` bigint(20) NULL,

						  `survey` bigint(20) NULL,
						  
						  `status` bigint(20) NULL,

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_license_keys` ( `id`, `license_key`, `no_of_contacts`, `lessons`, `products`, `orders`, `email_series`, `newsletter`, `optin_forms`, `survey`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->license_key."', '".$row->no_of_contacts."', '".$row->lessons."', '".$row->products."', '".$row->orders."', '".$row->email_series."', '".$row->newsletter."', '".$row->optin_forms."', '".$row->survey."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `category_id` bigint(20) NULL,

						  `template_name` varchar(255) DEFAULT '',

						  `from_name` varchar(255) DEFAULT '',

						  `from_email` varchar(255) DEFAULT '',

						  `subject` varchar(255) DEFAULT '',

                          `mail_content` text DEFAULT '',

						  `company_name` varchar(255) DEFAULT '',

						  `address` varchar(255) DEFAULT '',

                          `link_tracking` bigint(20) NULL,

						  `send_preview_email` varchar(255) DEFAULT '',

						  `type` varchar(255) DEFAULT '',

						  `trigger_email_type` varchar(255) DEFAULT '',

                          `trigger_date_time` datetime NULL,

                          `after_days` varchar(255) DEFAULT '',

						  `after_days_hours` varchar(255) DEFAULT '',

						  `after_days_minuts` varchar(255) DEFAULT '',

						  `status` 	int(11) NULL,

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter` ( `id`, `category_id`, `template_name`, `from_name`, `from_email`, `subject`,`mail_content`,`company_name`,`address`,`link_tracking`,`send_preview_email`,`type`,`trigger_email_type`,`trigger_date_time`,`after_days`,`after_days_hours`, `after_days_minuts`,`status`,`created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->category_id."', '".$row->template_name."', '".$row->from_name."', '".$row->from_email."', '".$row->subject."', '".$row->mail_content."', '".$row->company_name."', '".$row->address."', '".$row->link_tracking."', '".$row->send_preview_email."', '".$row->type."', '".$row->trigger_email_type."', '".$row->trigger_date_time."', '".$row->after_days."', '".$row->after_days_hours."', '".$row->after_days_minuts."', '".$row->status."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_emails_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_emails_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_emails_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `email_id` bigint(20) NULL,

						  `email_value` varchar(255) DEFAULT '',

                          `email_type` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` ( `id`, `newsletter_id`, `email_id`, `email_value`,`email_type`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->email_id."', '".$row->email_value."', '".$row->email_type."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_filtered_contacts`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_filtered_contacts`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_filtered_contacts` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

						  `schedule_id` bigint(20) NULL,

                          `newsletter_id` bigint(20) NULL,

						  `transactionid` varchar(255) DEFAULT '',

						  `messageid` varchar(255) DEFAULT '',

                          `contact_id` bigint(20) NULL,

						  `sent_status` bigint(20) NULL,

						  `opened` bigint(20) NULL,

						  `clicked` bigint(20) NULL,

						  `status` bigint(20) NULL,

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` ( `id`, `schedule_id`, `newsletter_id`, `transactionid`, `messageid`,`contact_id`,`sent_status`,`opened`,`clicked`,`status`,`created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->schedule_id."', '".$row->newsletter_id."', '".$row->transactionid."', '".$row->messageid."', '".$row->contact_id."', '".$row->sent_status."', '".$row->opened."', '".$row->clicked."', '".$row->status."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_lesson_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_lesson_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_lesson_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `lesson_id` bigint(20) NULL,

						  `lesson_value` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` ( `id`, `newsletter_id`, `lesson_id`, `lesson_value`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->lesson_id."', '".$row->lesson_value."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_optedfrom_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_optedfrom_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_optedfrom_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `opted_id` bigint(20) NULL,

						  `opted_value` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` ( `id`, `newsletter_id`, `opted_id`, `opted_value`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->opted_id."', '".$row->opted_value."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_product_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_product_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_product_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `product_id` bigint(20) NULL,

						  `product_value` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` ( `id`, `newsletter_id`, `product_id`, `product_value`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->product_id."', '".$row->product_value."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_schedules`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_schedules`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_schedules` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `contact_id` bigint(20) NULL,

						  `schedule_date` datetime NULL,

						  `status` bigint(20) NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` ( `id`, `newsletter_id`, `contact_id`, `schedule_date`, `status`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->contact_id."', '".$row->schedule_date."', '".$row->status."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_survey_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_survey_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_survey_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `survey_id` bigint(20) NULL,

						  `survey_value` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` ( `id`, `newsletter_id`, `survey_id`, `survey_value`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->survey_id."', '".$row->survey_value."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_newsletter_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_newsletter_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_newsletter_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `newsletter_id` bigint(20) NULL,

						  `tag_id` bigint(20) NULL,

						  `value` varchar(255) DEFAULT '',

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` ( `id`, `newsletter_id`, `tag_id`, `value`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->newsletter_id."', '".$row->tag_id."', '".$row->value."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_optin_forms`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_optin_forms`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_optin_forms` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

						  `subject` varchar(255) DEFAULT '',

                          `form_name` varchar(255) DEFAULT '',

						  `from_name` varchar(255) DEFAULT '',

						  `from_email` varchar(255) DEFAULT '',

						  `form_redirect_page_id` bigint(20) NULL,

						  `optin_confirmation` bigint(20) NULL,

						  `email_redirect_page_id` bigint(20) NULL,

						  `mail_content` text DEFAULT '',

						  `company_name` varchar(255) DEFAULT '',

						  `address` varchar(255) DEFAULT '',

						  `tags` varchar(255) DEFAULT '',

						  `form_shortcode` varchar(255) DEFAULT '',

						  `full_embed` varchar(255) DEFAULT '',

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_optin_forms` ( `id`, `subject`, `form_name`, `from_name`, `from_email`, `form_redirect_page_id`, `optin_confirmation`, `email_redirect_page_id`, `mail_content`, `company_name`, `address`, `tags`, `form_shortcode`, `full_embed`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->subject."', '".$row->form_name."', '".$row->from_name."', '".$row->from_email."', '".$row->form_redirect_page_id."', '".$row->optin_confirmation."', '".$row->email_redirect_page_id."', '".$row->mail_content."', '".$row->company_name."', '".$row->address."', '".$row->tags."', '".$row->form_shortcode."', '".$row->full_embed."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		
		
		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_product_pages_structure`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_product_pages_structure`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_product_pages_structure` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `product_id` bigint(20) NULL,

						  `page_id` bigint(20) NULL,

						  `free_access_start` varchar(255) DEFAULT '',
						  
						  `free_access_end` varchar(255) DEFAULT '',
						  
						  `evergreen_start_day` varchar(255) DEFAULT '',
						  
						  `evergreen_start_hour` varchar(255) DEFAULT '',
						  
						  `evergreen_end_day` varchar(255) DEFAULT '',
						  
						  `evergreen_end_hour` varchar(255) DEFAULT '',
						  
						  `days_delay` varchar(255) DEFAULT '',
						  
						  `coins` varchar(255) DEFAULT '',

                           PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);
		
		$sql = "INSERT INTO `".$wpdb->prefix."am_product_pages_structure` ( `id`, `product_id`, `page_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->product_id."', '".$row->page_id."', '".$row->free_access_start."', '".$row->free_access_end."', '".$row->evergreen_start_day."', '".$row->evergreen_start_hour."', '".$row->evergreen_end_day."', '".$row->evergreen_end_hour."', '".$row->days_delay."', '".$row->coins."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);
		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_quiz_questions`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_quiz_questions`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_quiz_questions` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `product_id` bigint(20) NULL,

						  `lesson_id` bigint(20) NULL,

						  `question` varchar(255) DEFAULT '',

						  `status` bigint(20) NULL,

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_quiz_questions` ( `id`, `product_id`, `lesson_id`, `question`, `status`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->product_id."', '".$row->lesson_id."', '".$row->question."', '".$row->status."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_quiz_question_options`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_quiz_question_options`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_quiz_question_options` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `lesson_id` bigint(20) NULL,

						  `quiz_question_id` bigint(20) NULL,

						  `options` varchar(255) DEFAULT '',

						  `answer` bigint(20) NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_quiz_question_options` ( `id`, `lesson_id`, `quiz_question_id`, `options`, `answer`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->lesson_id."', '".$row->quiz_question_id."', '".$row->options."', '".$row->answer."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_survey`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_survey`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_survey` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `survey_title` varchar(255) DEFAULT '',

						  `survey_image` varchar(255) DEFAULT '',

						  `survey_description` text DEFAULT '',

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_survey` ( `id`, `survey_title`, `survey_image`, `survey_description`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->survey_title."', '".$row->survey_image."', '".$row->survey_description."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_survey_report`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_survey_report`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_survey_report` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `user_id` bigint(20) NULL,

						  `survey_id` bigint(20) NULL,

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_survey_report` ( `id`, `user_id`, `survey_id`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->user_id."', '".$row->survey_id."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		

		

		

		$data = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."am_tags`");

		$wpdb->query("DROP TABLE IF EXISTS `".$wpdb->prefix."am_tags`");

        $sql="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."am_tags` (

                          `id` bigint(20) NOT NULL AUTO_INCREMENT,

                          `tag_name` varchar(255) DEFAULT '',

						  `created_date` datetime NULL,

                          PRIMARY KEY (`id`)

                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

        $wpdb->query($sql);

		

		$sql = "INSERT INTO `".$wpdb->prefix."am_tags` ( `id`, `tag_name`, `created_date`) VALUES ";

        foreach( $data as $row ) {

            $sql.= "( '".$row->id."', '".$row->tag_name."', '".$row->created_date."'),";

        }

        $sql = rtrim($sql, ",");

        $wpdb->query($sql);

		//////////////////////////////////////////////////////////////////////////////////

		/////////////////********** End New Tables by ilyaskhan *****/////////////////////

		//////////////////////////////////////////////////////////////////////////////////

		

        

        copy( AM_PLUGIN_PATH."templates/front/am_products_template.php",get_template_directory()."/am_products_template.php" );

        copy( AM_PLUGIN_PATH."templates/front/am_offers_template.php",get_template_directory()."/am_offers_template.php" );

		//copy( AM_PLUGIN_PATH."templates/front/am_survey_template.php",get_template_directory()."/am_survey_template.php" );

        

        if (! wp_next_scheduled ( 'am_verify_plugin_license' )) {

            wp_schedule_event(time(), 'daily', 'am_verify_plugin_license');

        }

        

        $options = get_option( 'am_settings', array() );

        if( empty($options['welcome_mail_message']) ) {

            $options['welcome_mail_subject']    = 'Deine Zugangsdaten';
            $options['sender_name']             = get_option('blogname');
            $options['sender_email']            = get_option('admin_email');

            $options['welcome_mail_message']    = 'Hallo [user_first_name],<br>&nbsp;<br>nochmal herzlichen Glückwunsch zu Deiner Entscheidung zum Produkt "[product_name]"!<br>&nbsp;<br>Hier Deine Zugangsdaten:<br>&nbsp;<br>Benutzername:<br>[user_login_id]<br><br>Passwort:<br>[user_password]<br><br>Login:<br>[login_url]<br>&nbsp;<br>... und jetzt viel Spaß!<br><br>:-)';

			$options['login_default_logo']      = plugins_url('access_members/images/accessmember-light.png');
            $options['login_default_bg_image']  = plugins_url('access_members/images/mountain-range-918595_1920.jpg');
			
			$options['optinfrom_name_placeholder']="Hier bitte Deinen Vornamen eintragen...";
			$options['optinfrom_email_placeholder']="Hier bitte Deine E-Mail eintragen...";
			$options['optinfrom_button_text']="Abschicken";



			
            update_option( 'am_settings', $options );
        }

        $this->am_process_license();

		
		update_option( 'no_of_contacts_allowed', '500');

        //For Elastic Email
		//disable it as its no need to set the values
		//update_option( 'elastic_subAccount', 'no');	
		
		
		//Update optin-form email contents
		$email_contents = '<p>Hallo [NAME],</p><p>bitte bestätige jetzt noch Deine E-Mail Adresse, indem Du auf den folgenden Link klickst:</p><p>[LINK]</p><p>Viele Grüße</p><p>AccessMember</p>';
		update_option( 'default_optin_email', $email_contents);	
		update_option( 'elastic_mails_in_progress', 0);	
		
		
		do_action('am_after_install', $this );

    }    

}



$am_install = new AM_Install();