<?php
require_once("pagination.class.php");
if ( $message!="") : ?>
<div id="message" class="updated">
	<p><strong><?php echo __($message, 'am'); ?></strong></p>
</div>
<?php endif; ?>

 <?php
 $am_lincense_key=constant('AM_LICENSE_KEY'); 

	?>
 
<section class="main_manage_wrap_product_page_design">
    <div class="container-fluid">
        <div class="row custom_secondary_wrap">
            <div class="col-lg-12 custom_manage_title_wrap">
                <h3><?php echo __( 'Manage Products', 'am' );?> </h3> 
            </div>
            <div class="col-lg-12 custom_manage_btn_wrap">
			<?php
			
				if(empty($am_lincense_key) && count($products)>=1){
					
					?>
			
				<div id="message" class="error">
					<p><strong><?php echo __("Please enter a licence key in order to add a new product.", 'am'); ?></strong></p>
				</div>
				<?php } else  { ?>
			
                <a href="?page=am_products&action=add" type="button" class="custom_add_lesson_wrap"><?php echo __( 'Add New', 'am' );?></a>
			<?php } ?>	
            </div>
        </div>
    </div>
    <div class="container-fluid custom_wrap_table">
        <div class="row table-responsive">
            <table class="table table-bordered custom_table_wrap_b">
                <thead>
                    <tr>
                        <th><?php echo __( 'Short-Code', 'am' );?></th>
                        <th><?php echo __( 'Product Image', 'am' );?></th>
                        <th><?php echo __( 'Product Name', 'am' );?></th>
                        <th><?php echo __( 'Members', 'am' );?></th>
                        <th><?php echo __( 'Modules', 'am' );?></th>
                        <th><?php echo __( 'Lessons', 'am' );?></th>
                        <th><?php echo __( 'Action', 'am' );?></th>
                    </tr>
                </thead>
                <tbody>
                <?php 
				
				global $wpdb;
				/* Show many results per page? */
				$sql    = "SELECT * FROM `".$wpdb->prefix."am_products`";
				$count  = $wpdb->get_results( $sql );
				$items  = count($count); 
				$limit  = 10; // If you want to exceed the limit No. 
				
			    if($items > 0) {
					
					$p = new pagination;
					$p->items($items);
					$p->limit($limit); // Limit entries per page
					$p->target("admin.php?page=am_products"); 
					$p->currentPage($_GET[$p->paging]); // Gets and validates the current page
					$p->calculate(); // Calculates what to show
					$p->parameterName('paging');
					$p->adjacents(1); //No. of page away from the current page
						 
					if(!isset($_GET['paging'])) {
						$p->page = 1;
						$i = 1;
					}else {
						$p->page = $_GET['paging'];
						$i = ($_GET['paging'] -1)* $limit;
					}
					//Query for limit paging
					$limit = "LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit;	 
					
					$sql2 = "SELECT * FROM `".$wpdb->prefix."am_products` $limit";
					$products = $wpdb->get_results( $sql2 );
				} 
 
				
					
				if( !empty($products) ) { 
				foreach( $products as $product ) { 
				$members_count = $modules = $lessons = 0;
				$module_ids = array();
				foreach( $course_structures as $lesson ) {
					if( $lesson->product_id == $product->id ) {
						$lessons++;
						$module_ids[] = $lesson->module_id;
					}
				}
				$modules = sizeof(array_unique($module_ids));
				foreach( $members as $member ) {
					if( $member->product_id == $product->id ) {
						$members_count++;
					}
				}
                ?>
                    <tr>
                        <td>[am_product id="<?php echo $product->id;?>"]</td>
                        <td>
						<?php if( $product->product_image != "" ) {?>
                        <img src="<?php echo $product->product_image;?>" width="50" />
						<?php }else{?>
                        <?php }?> 
                        </td>
                        <td><?php echo $product->product_name;?></td>
                        <td><?php echo $members_count;?></td>
                        <td><?php echo $modules;?></td>
                        <td><?php echo $lessons;?></td>
                        <td>
					<?php
						if(!empty($am_lincense_key)) { ?>
                        <span class="cutom_file custom_padding">
                        <a href="?page=am_products&action=clone&id=<?php echo $product->id;?>"><i class="fa fa-file" aria-hidden="true"></i></a>
                        </span> 
						
						<?php } ?>
                        
                        <span class="cutom_delete custom_padding">
                        <a href="?page=am_products&action=del&id=<?php echo $product->id;?>" onClick="javascript: return confirm('<?php echo __( 'Are you sure you want to delete that item?');?>');"><i class="fa fa-trash-o" aria-hidden="true"></i></a>
                        </span> 
                        
                        <span class="cutom_edit custom_padding">
                        <a href="?page=am_products&action=edit&id=<?php echo $product->id;?>"><i class="fa fa-pencil" aria-hidden="true"></i></a>
                        </span>
                        </td>
                    </tr>
                    <?php }?>
					<?php }else{?>
                    <tr class="alternate">
                        <td colspan="7">
                            <p><?php echo __( 'There is no product at the moment', 'am' );?></p>
                        </td>
                    </tr>
                    <?php }?>
                </tbody>
                <tfoot>
                    <tr>
                        <th><?php echo __( 'Short-Code', 'am' );?></th>
                        <th><?php echo __( 'Product Image', 'am' );?></th>
                        <th><?php echo __( 'Product Name', 'am' );?></th>
                        <th><?php echo __( 'Members', 'am' );?></th>
                        <th><?php echo __( 'Modules', 'am' );?></th>
                        <th><?php echo __( 'Lessons', 'am' );?></th>
                        <th><?php echo __( 'Action', 'am' );?></th>
                    </tr>
                </tfoot>
            </table>
        </div>
        <div class="custom_pagination_wrap">
        <ul class="pagination custom_pagination_ul">
        <?php
		 if(count($products)>0){
		 echo $p->show();  // Echo out the list of paging. 
		 }?>
    </ul>
</div>
    </div>
</section>