<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Class that will hold functionality for admin side
 *
 * PHP version 5
 *
 * @category   Admin Side Code
 * @package    Access Members
 * @author     Erfolgs-Faktor
 * @version    1.0.0
 * @since      File available since Release 1.0.0
*/

class AM_Admin extends AM
{
    //Admin side starting point. Will call appropriate admin side hooks
    public function __construct()
	{
        
        do_action('am_before_admin', $this );
        //All admin side code will go here
        
        add_action( 'admin_menu', array( $this, 'am_admin_menus' ), 9 );    
        add_action( 'wp_ajax_am_add_product_module', array( $this, 'am_add_product_module' ) );
        add_action( 'wp_ajax_nopriv_am_add_product_module', array( $this, 'am_add_product_module' ) );       
        add_action( 'wp_ajax_am_load_product_module', array( $this, 'am_load_product_module' ) );
        add_action( 'wp_ajax_nopriv_am_load_product_module', array( $this, 'am_load_product_module' ) );        
        add_action( 'wp_ajax_am_add_product_lesson', array( $this, 'am_add_product_lesson' ) );
        add_action( 'wp_ajax_nopriv_am_add_product_lesson', array( $this, 'am_add_product_lesson' ) );        
        add_action( 'wp_ajax_am_save_module_name', array( $this, 'am_save_module_name' ) );
        add_action( 'wp_ajax_nopriv_am_save_module_name', array( $this, 'am_save_module_name' ) );
        add_action( 'wp_ajax_am_load_product', array( $this, 'am_load_product' ) );
        add_action( 'wp_ajax_nopriv_am_load_product', array( $this, 'am_load_product' ) );
		
		add_action( 'wp_ajax_am_send_preview_email', array( $this, 'am_send_preview_email' ) );
        add_action( 'wp_ajax_nopriv_am_send_preview_email', array( $this, 'am_send_preview_email' ) );
		
		add_action( 'wp_ajax_am_auto_connect_elasticEmail', array( $this, 'am_auto_connect_elasticEmail' ) );
        add_action( 'wp_ajax_nopriv_am_auto_connect_elasticEmail', array( $this, 'am_auto_connect_elasticEmail' ) );
		
		add_action( 'wp_ajax_am_get_action_tag_filter_contacts', array( $this, 'am_get_action_tag_filter_contacts' ) );
        add_action( 'wp_ajax_nopriv_am_get_action_tag_filter_contacts', array( $this, 'am_get_action_tag_filter_contacts' ) );
		
		
		add_action( 'wp_ajax_am_generate_auto_key', array( $this, 'am_generate_auto_key' ) );
        add_action( 'wp_ajax_nopriv_am_generate_auto_key', array( $this, 'am_generate_auto_key' ) );
		
		
		// By ALi
		add_action( 'wp_ajax_GetEmailTemplate', array( $this, 'GetEmailTemplate' ) );
        add_action( 'wp_ajax_nopriv_GetEmailTemplate', array( $this, 'GetEmailTemplate' ) );
		
		add_action( 'wp_ajax_GetNewsletterTemplate', array( $this, 'GetNewsletterTemplate' ) );
        add_action( 'wp_ajax_nopriv_GetNewsletterTemplate', array( $this, 'GetNewsletterTemplate' ) );  
		
		add_action( 'wp_ajax_nooffcaontacts', array( $this, 'nooffcaontacts' ) );
        add_action( 'wp_ajax_nopriv_nooffcaontacts', array( $this, 'nooffcaontacts' ) );  
		
		add_action( 'wp_ajax_sendmail', array( $this, 'sendmail' ) );
        add_action( 'wp_ajax_nopriv_sendmail', array( $this, 'sendmail' ) );
		
		add_action( 'wp_ajax_send_user_credentails', array( $this, 'send_user_credentails' ) );
        add_action( 'wp_ajax_nopriv_send_user_credentails', array( $this, 'send_user_credentails' ) );
		
		add_action( 'wp_ajax_save_elastic_api', array( $this, 'am_save_elastic_api' ) );
		
		
        add_action( 'admin_notices', array( $this, 'am_admin_notice_error' ) );
		add_action( 'load-index.php', function()
		{
			add_action( 'admin_notices', array( $this, 'am_admin_notice_license_error'));
		});
		
        add_action( 'add_meta_boxes', array( $this, 'am_register_meta_boxes' ), 100, 1 );
        add_action( 'save_post',      array( $this, 'am_save_post' ), 20, 1 );
        add_filter( 'manage_lessons_posts_columns' , array( $this, 'am_add_lessons_columns' ), 10, 1 );
        add_action( 'manage_lessons_posts_custom_column' , array( $this, 'am_display_lessons_columns' ), 10, 2 );
        add_filter( 'manage_edit-lessons_sortable_columns', array( $this, 'am_lessons_sortable_columns' ), 20, 1 );
        
        add_action( 'wp_ajax_am_list_coins_management_entries', array( $this, 'am_list_coins_management_entries') );
        add_action( 'pre_get_posts', array( $this, 'am_filter_by_product' ) );
        add_action( 'admin_head', array( $this, 'am_admin_head' ) );
		
        
		add_shortcode( 'optinform', array( $this, 'custom_shortcode' ) );
		
        do_action('am_after_admin', $this );
		
    }
	
	
    
    public function am_admin_menus(){
        
        $options = get_option( 'am_settings', array() );
		
		$am_plugin_license_key_enabled = get_option('am_plugin_license_key_enabled');
		
		
		
		//file_put_contents(dirname(__file__)."/license.log",AM_LICENSE_KEY);
		
		
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
		if( !constant('AM_LICENSE_KEY') ) {
            $am_plugin_license_key_enabled = 'no';
        }else{
			$am_plugin_license_key_enabled = 'yes';
		}
		
		
        
        add_menu_page( AM_PLUGIN_NAME, __( AM_PLUGIN_NAME, 'am' ), 'manage_options', 'am', array( $this, 'am_settings' ), AM_PLUGIN_URL."images/icon.png" );
       
	    add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Settings', 'am'), __('Settings', 'am'), 'manage_options', 'am', array( $this, 'am_settings' ) );
       
	    
		//if($am_plugin_license_key_enabled =='yes' && $license_settings->products ==1){
		add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Products', 'am'), __('Products', 'am'), 'manage_options', 'am_products', array( $this, 'am_products' ) );
		//}//products
		
		
        if( $options['offers'] == 'yes' && $am_plugin_license_key_enabled =='yes') {
        add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Offers', 'am'), __('Offers', 'am'), 'manage_options', 'am_offers', array( $this, 'am_offers' ) );
        }
       
	  // if($am_plugin_license_key_enabled =='yes' && $license_settings->orders ==1){
		add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Orders', 'am'), __('Orders', 'am'), 'manage_options', 'am_orders', array( $this, 'am_orders' ) );
		//}//orders
	   
	    add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Mail Texts', 'am'), __('Mail Texts', 'am'), 'manage_options', 'am_mail_texts', array( $this, 'am_mail_texts' ) );
      
	  
	   
	  //  if($am_plugin_license_key_enabled =='yes' && $license_settings->newsletter ==1){
				$elastic_subAccount=get_option('elastic_subAccount');
				if($elastic_subAccount=="yes")
				{
					add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('E-Mail', 'am'), __('E-Mail', 'am'), 'manage_options', 'am_newsletter', array( $this, 'am_newsletter' ) );
					add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('E-Mail', 'am'), __('E-Mail', 'am'), 'manage_options', 'am_email_setting', array( $this, 'am_email_setting' ) );
				}
				else
				{
					
					add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('E-Mail', 'am'), __('E-Mail', 'am'), 'manage_options', 'am_email_setting', array( $this, 'am_email_setting' ) );
				}
		//}//newsletter
	   
	   
	   // if($am_plugin_license_key_enabled =='yes' && $license_settings->email_series ==1){
		add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Email Series', 'am'), __('Email Series', 'am'), 'manage_options', 'am_email_series', array( $this, 'am_email_series' ) );
		//}//email_series
		
		
		
		add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Categories', 'am'), __('Categories', 'am'), 'manage_options', 'am_emails_categories', array( $this, 'am_emails_categories' ) );
		
        
		add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Tags', 'am'), __('Tags', 'am'), 'manage_options', 'am_tags', array( $this, 'am_tags' ) );
        
        add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Contacts', 'am'), __('Contacts', 'am'), 'manage_options', 'am_contacts', array( $this, 'am_contacts' ) );
		
        
	//	if($am_plugin_license_key_enabled =='yes' && $license_settings->optin_forms ==1){   
        add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Opt-In Forms', 'am'), __('Opt-In Forms', 'am'), 'manage_options', 'am_optin_frm', array( $this, 'am_optin_frm' ) );
		//}//optin_forms
                    
      //  add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Email Settings', 'am'), __('Email Settings', 'am'), 'manage_options', 'am_email_setting', array( $this, 'am_email_setting' ) );
		
		if($am_plugin_license_key_enabled =='yes' && $license_settings->survey ==1){
		add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Survey', 'am'), __('Survey', 'am'), 'manage_options', 'am_survey', array( $this, 'am_survey' ) );
		}//survey
		
		if($am_plugin_license_key_enabled =='yes')
		{
			add_submenu_page( 'am', AM_PLUGIN_NAME.' :: '.__('Import', 'am'), __('Import', 'am'), 'manage_options', 'am_import', array( $this, 'am_import' ) );
		}
    }    
    
    
    public function am_coins_management()
	{
        
        $action = $_REQUEST['action'];
        $id = $_REQUEST['id'];
        if( !empty($action) && $action == 'edit' && is_numeric($id) ) {
            if( !empty($_POST['btnsave']) ) {
                if( $this->am_update_coins( $_POST ) ) {
                    $message = __( 'Coins updated successfully.', 'am' );
                }else{
                    $message = __( 'There is some error to update coins.', 'am' );
                }
            }
            $users = get_users( 'orderby=nicename' );
            $row = array_shift($this->am_get_all_coins_management_entries( "id = '".$id."'" ));
            require_once AM_PLUGIN_PATH.'templates/admin/am_edit_coins_management_entry.php';        
        }elseif( !empty($action) && $action == 'add' ){
            if( !empty($_POST['btnsave']) ) {
                if( $this->am_save_coins( $_POST ) ) {
                    $message = __( 'Coins saved successfully.', 'am' );
                }else{
                    $message = __( 'There is some error to save coins.', 'am' );
                }
            }
            $users = get_users( 'orderby=nicename' );
            require_once AM_PLUGIN_PATH.'templates/admin/am_add_coins_management_entry.php';
        }else{
            if( !empty($action) && $action == 'del' && is_numeric($id) ) {
                $this->am_del_coins_management_entry($id);
                $message = __( 'Record deleted successfully.', 'am' );
            }
            require_once AM_PLUGIN_PATH.'templates/admin/am_coins_management.php';        
        }
    }
    
    public function am_update_coins( $data=array() )
	{
        $id = $_POST['id'];
        if( !is_array($data) || empty($data) || empty($id) ) {
            return false;
        }
        global $wpdb;
        $exclude = array( 'btnsave', 'id' );        
        $attr = '';
        foreach ( $data as $k=>$val ) {
            if( !in_array($k, $exclude)) {
                if(is_array($val)) {
                    $value = maybe_serialize($val);
                }else{
                    $value = stripslashes($val);
                }
                if( $attr == "" ) {
                    $attr.="`".$k."` = '".$value."'";         
                }else{
                    $attr.=", `".$k."` = '".$value."'";                              
                }
            }
        }
        $sql = "UPDATE `".$wpdb->prefix."am_user_coins` SET ".$attr." WHERE id = '".$id."'";
        $result = $wpdb->query($sql);
        if( false === $result ) {
            return false;
        }
        return true;
    }
    
    public function am_save_coins( $data=array() ) {
        
        if( !is_array($data) || empty($data) ) {
            return false;
        }
        global $wpdb;
        $data['record_timestamp'] = strtotime('now');
        $exclude = array( 'btnsave' );
        $attr = $attr_val = '';
        foreach ( $data as $k=>$val ) {
            if( !in_array($k, $exclude)) {
                if(is_array($val)) {
                    $value = maybe_serialize($val);
                }else{
                    $value = stripslashes($val);
                }
                if( $attr == "" ) {
                    $attr.="`".$k."`";
                    $attr_val.="'".$value."'";                
                }else{
                    $attr.=", `".$k."`";
                    $attr_val.=", '".$value."'";                
                }
            }
        }
        $sql = "INSERT INTO `".$wpdb->prefix."am_user_coins` (".$attr.") VALUES (".$attr_val.")";
        $result = $wpdb->query($sql);
        if( false === $result ) {
            return false;
        }
        return true;
    }
    
    public function am_list_coins_management_entries() {
        
        $where = 1;
        $result = $this->am_get_all_coins_management_entries( $where );
        $recordCount = sizeof( $result );
        
        $orderby = " ORDER BY " . $_GET["jtSorting"];
        $limit = " LIMIT " . $_GET["jtStartIndex"] . "," . $_GET["jtPageSize"];
        $result = $this->am_get_all_coins_management_entries( $where, $orderby, $limit );
        
        $rows = array();
        foreach ( $result as $row ) {
            $user_ids = maybe_unserialize($row->user_ids);
            $users_data = array();
            foreach( $user_ids as $user_id ) {
                $user = get_userdata($user_id);
                $users_data[] = "<span class='am_coins_users'>(".$user->ID.")</span> ".$user->display_name;
            }
            
            $record = array();
            $record['ID'] = $row->id;
            $record['Title'] = $row->title;
            $record['Users'] = implode( "<br>", $users_data );
            $record['InitialCoins'] = $row->initital_coins;
            $record['MonthlyCoins'] = $row->per_month_coins;
            $record['Date'] = date( 'jS \of F Y', $row->record_timestamp );
            $record['View'] = '<a class="am_del_icon" title="Delete" href="admin.php?page=am_coins_management&action=del&id='.$row->id.'" onclick="javascript:return confirm(\'Are you sure you want to delete that item?\');"></a> <a class="am_edit_icon" title="Edit" href="admin.php?page=am_coins_management&action=edit&id='.$row->id.'"></a>';
            $rows[] = $record;
        }
        $jTableResult = array();
        $jTableResult['Result'] = "OK";
        $jTableResult['TotalRecordCount'] = $recordCount;
        $jTableResult['Records'] = $rows;
        print json_encode($jTableResult);
        exit();
    }
    
    public function am_del_coins_management_entry( $id = '' ) {
        
        if( empty($id) ) {
            return false;
        }
        global $wpdb;
        $sql = "DELETE FROM `".$wpdb->prefix."am_user_coins` WHERE id = '".$id."'";
        $wpdb->query($sql);
        
        return true;
    }
    
    public function am_import() {
        
        $html = '';
        ob_start();
        
        $action = $_REQUEST['action'];
        if( $action == 'import' ) {
            if( !empty($_POST['btnsave']) ) {
                if($this->am_save_product($_POST)) {
                    $message = "Product imported successfully!";
                }
            }
        }
        
        //$products = $this->am_get_digimember_products();
		
        $product_id = $_REQUEST['product_id'];
        if( empty($product_id)) {
            foreach( $products as $product ) {
                $selected_product = $product;                
            }
        }else{
            foreach( $products as $product ) {
                if( $product->id == $product_id ) {
                    $selected_product = $product;
                    break;
                }
            }
        }
        //$product_content = $this->am_get_digimember_product_contents( "product_id = '".$selected_product->id."'" );
      
	    wp_enqueue_script('wp-color-picker');
        wp_enqueue_script('media-upload');
        wp_enqueue_script('thickbox');
        wp_enqueue_style('thickbox');
        wp_enqueue_style( 'wp-color-picker' );
		
        $digi_products = $this->am_get_digistore24_products();
		
        $modules = $this->am_get_modules();
        $pages = get_pages(); 
        $fonts = $this->am_get_html_fonts();
        $options = get_option( 'am_settings', array() );
        
        $args = array( 'post_type' => 'post', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
        $posts = get_posts( $args );
        require_once AM_PLUGIN_PATH.'templates/admin/am_import.php';
        $this->load_javascript();
        
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
    
    public function am_admin_head() {
        if( $_REQUEST['post_type'] == 'lessons' ) {
            $products = $this->am_get_products();
            echo '<script>';
            echo 'var am_product_filter = \'<select name="am_filter_by_product"><option value="">'.__('Select Product', 'am').'</option>\';';
            foreach( $products as $product ) {
                if( $_REQUEST['am_filter_by_product'] == $product->id ) {
                    echo 'am_product_filter = am_product_filter+\'<option selected value="'.$product->id.'">'.$product->product_name.'</option>\';';
                }else{
                    echo 'am_product_filter = am_product_filter+\'<option value="'.$product->id.'">'.$product->product_name.'</option>\';';
                }
            }
            echo 'am_product_filter = am_product_filter+\'</select>\';';
            echo '</script>';
        }
    }
    
    public function am_filter_by_product( $query ) {
        
        if( ! is_admin() && $query->get( 'post_type') != 'lessons' )
            return;
        
        $orderby = $query->get( 'orderby');
        
        if( is_numeric($_REQUEST['am_filter_by_product']) ) {
            $course_structures = $this->am_get_course_structure( "product_id = '".$_REQUEST['am_filter_by_product']."'" );
            $product_lessons = array();
            $other_lessons = array();
            foreach( $course_structures as $course_structure ) {
                $product_lessons[] = $course_structure->lesson_id;
            }
            global $wpdb;
            $sql = "SELECT ID FROM `".$wpdb->prefix."posts` WHERE post_status = 'publish' AND post_type = 'lessons'";
            $lessons = $wpdb->get_results($sql);
            
            foreach( $lessons as $lesson ) {
                if( !in_array( $lesson->ID, $product_lessons ) ) {
                    $other_lessons[] = $lesson->ID;
                }
            }
            
            $query->query_vars['post__in'] = $product_lessons;
            $query->query_vars['post__not_in'] = $other_lessons;
            return $query;
        }
        
        if( $orderby == 'module' ) { 
            $query->set( 'meta_key', 'am_lesson_first_module' );
            $query->set( 'orderby', 'meta_value_num' );
        }
        return $query;
    }
    
    public function am_load_product() {
        
        $product_id = $_POST['id'];
        
        $error = false;
        $html = '';
        ob_start();
        if( !is_numeric($product_id)) {
            $error = true;
            $html  = __( 'Invalid product id', 'am' );
        }
        
        if( !$error ) {
            $modules = $this->am_get_modules();
            $products = $this->am_get_products( "id = '".$product_id."'" );
            $product = array_shift($products);
            $course_structures = $this->am_get_course_structure( "product_id = '".$product->id."' ORDER BY id ASC" );
            
            //echo '<pre>';
            //print_r($course_structures);
            //echo '</pre>';
            
            require_once AM_PLUGIN_PATH.'templates/admin/am_get_offer_arch.php';
            $html = ob_get_contents();
            $js = 'if(jQuery(".offer_product_all_lesons").length){jQuery(".offer_product_all_lesons").click(function(){var pro_id = jQuery(this).val();if(jQuery(this).is(":checked")){jQuery(".offer_product_"+pro_id+"_lesson").prop("checked",true);}else{jQuery(".offer_product_"+pro_id+"_lesson").prop("checked",false);}});}';
        }
        ob_end_clean();
        
        $return = array( 'error'=> $error, 'content' => $html, 'js' => $js );
        
        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
    
    public function am_offers() {
        
        $action = $_REQUEST['action'];
        $html = '';
        ob_start();
        if( $action == 'edit' ) {
            if( is_numeric($_REQUEST['id']) ) {
                if( isset($_POST['btnsave']) ) {
                    $_POST['id'] = $_REQUEST['id'];
                    if( $this->am_update_offer( $_POST ) ) {
                        $message = "Offer updated successfully!";
                    }
                }
                $offer_id = $_REQUEST['id'];
                wp_enqueue_script('wp-color-picker');
                wp_enqueue_script('media-upload');
                wp_enqueue_script('thickbox');
                wp_enqueue_style('thickbox');
                wp_enqueue_style( 'wp-color-picker' );
                $fonts = $this->am_get_html_fonts();
                $digi_products = $this->am_get_digistore24_products();
                $products = $this->am_get_products();
                
                $pages = get_pages(); 
                $offers = $this->am_get_offers("id = '".$offer_id."'");
                $offer = array_shift($offers);
                $offers_structure = $this->am_get_offers_structure( "offer_id = '".$offer_id."' ORDER BY id ASC" );
                $modules = $this->am_get_modules();
                
                $selected_lessons = array();
                $offer_products = array();
                $offer_products_ids = array();
                $course_structures = array();
                foreach( $offers_structure as $offer_structure ) {
                    foreach( $products as $product ) {
                        if( $offer_structure->product_id == $product->id && !in_array($product->id, $offer_products_ids) ) {
                            $offer_products[] = $product;
                            $offer_products_ids[] = $product->id;
                            $course_structures[$product->id] = $this->am_get_course_structure( "product_id = '".$product->id."' ORDER BY id ASC" );
                            break;
                        }
                    } 
                    $selected_lessons[] = $offer_structure->lesson_id;
                }
                                        
                require_once AM_PLUGIN_PATH.'templates/admin/am_edit_offer.php';
                $this->load_javascript();
            }
        }elseif( $action == 'add' ) {
            if( isset($_POST['btnsave']) ) {
                if( $this->am_save_offer( $_POST ) ) {
                    $message = "Offer added successfully!";
                }
            }
            wp_enqueue_script('wp-color-picker');
            wp_enqueue_script('media-upload');
            wp_enqueue_script('thickbox');
            wp_enqueue_style('thickbox');
            wp_enqueue_style( 'wp-color-picker' );
            $fonts = $this->am_get_html_fonts();
            $digi_products = $this->am_get_digistore24_products();
            $products = $this->am_get_products();
            $pages = get_pages(); 
            $options = get_option( 'am_settings', array() );
            require_once AM_PLUGIN_PATH.'templates/admin/am_add_offer.php';
            $this->load_javascript();
        }else{
            if( $action == 'del' ) {
                if( is_numeric($_REQUEST['id']) ) {
                    if( $this->am_del_offer($_REQUEST['id']) ) {
                        $message = "Offer deleted successfully!";
                    }
                }                
            }
            
            if( $action == 'clone' ) {        
                if( is_numeric($_REQUEST['id']) ) {
                    if( $this->am_clone_offer($_REQUEST['id']) ) {
                        $message = "Offer cloned successfully!";
                    }
                }
            }
            
            $offers = $this->am_get_offers();
            $offers_structure = $this->am_get_offers_structure();
            $members = $this->am_get_products_members( "offer_id != ''" );
            
            require_once AM_PLUGIN_PATH.'templates/admin/am_offers.php';
            $this->load_javascript();
        }
        
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
    
    public function am_del_offer( $id = '' ) {
        if( empty($id) ) {
            return false;
        }
        global $wpdb;
        $sql = "DELETE FROM `".$wpdb->prefix."am_offers` WHERE id = '".$id."'";
        $wpdb->query($sql);
        $sql = "DELETE FROM `".$wpdb->prefix."am_offer_structure` WHERE offer_id = '".$id."'";
        $wpdb->query($sql);
        
        return true;
    }
    
    public function am_clone_offer( $offer_id = '' ) {
        
        if( empty($offer_id) ) {
            return false;
        }
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_offer_structure` WHERE offer_id = '".$offer_id."' ORDER BY id ASC";
        $offers_structure = $wpdb->get_results($sql);
        
        $sql = "SELECT * FROM `".$wpdb->prefix."am_offers` WHERE id = '".$offer_id."'";
        $offer = $wpdb->get_row($sql);
        $attr = "";
        $attr_val = "";
        foreach ( $offer as $k=>$val ) {
            if( $attr == "" ) {
                $attr.="`".$k."`";
                $attr_val.="''";                
            }else{
                $attr.=", `".$k."`";
                $attr_val.=", '".stripslashes($val)."'";                
            }
        }
        $sql = "INSERT INTO `".$wpdb->prefix."am_offers` (".$attr.") VALUES (".$attr_val.")";
        $wpdb->query($sql);
        
        $offer_id = $wpdb->insert_id;
        
        foreach ($offers_structure as $offer_structure ) {
            $sql = "INSERT INTO `".$wpdb->prefix."am_offer_structure` ( `offer_id`, `product_id`, `module_id`, `lesson_id` ) VALUES ( '".$offer_id."', '".$offer_structure->product_id."', '".$offer_structure->module_id."', '".$offer_structure->lesson_id."' )";
            $wpdb->query($sql);
        }
        
        $data['offer_name'] = $offer->offer_name;
        
        $this->am_insert_offer_page( $data, $offer_id );
        
        return true;
    }
    
    public function am_update_offer( $data=array() ) {
        //echo '<pre>';
        //print_r($data);
        //echo '</pre>';
        if( !is_array($data) || sizeof($data) == 0 ) {
            return false;
        }
        global $wpdb;
        $id = $data['id'];
        $exclude = array( 'btnsave', 'am_offer_product', 'modules', 'lessons', 'offer_product_all_lesons', 'btnupload', 'lessons_product' );
        $attr = "";
        foreach( $data as $k=>$val ) {
            if(is_array($val)) {
                $val = maybe_serialize($val);
            }
            $should_insert = true;
            foreach( $exclude as $v ) {
                $pos = strpos($k, $v);
                if ($pos !== false) {
                    $should_insert = false;
                    break;
                }
            }
            if( $should_insert ) {
                if( $attr == "" ) {
                    $attr.="`".$k."` = '".$val."'";                    
                }else{
                    $attr.=", `".$k."` = '".$val."'";
                }                
            }
        }
        $arr_all_vals = array( 'offer_name', 'digi_products', 'login_redirect', 'error_redirect', 
            'error_redirect', 'error_text', 'lock_user_on_no_payment', 'lock_redirect', 
            'bg_image', 'logo', 'top_header_gradient_color1', 'top_header_gradient_color2', 'content_gradient_color1', 
            'content_gradient_color2', 'above_button_text', 'text_color', 'text_size', 'text_font', 'button_text' );
        
        $attr_default = "";
        foreach( $arr_all_vals as $val ) {            
            if( $attr_default == "" ) {
                $attr_default.="`".$val."` = ''";                    
            }else{
                $attr_default.=", `".$val."` = ''";
            }            
        }
        $sql = "UPDATE `".$wpdb->prefix."am_offers` SET ".$attr_default." WHERE id = '".$id."'";
        //exit();
        $wpdb->query($sql);
        
       echo  "Query===$attr".$sql = "UPDATE `".$wpdb->prefix."am_offers` SET ".$attr." WHERE id = '".$id."'";
        $wpdb->query($sql);
       
        $offer_id = $id;
        $sql = "DELETE FROM `".$wpdb->prefix."am_offer_structure` WHERE offer_id = '".$offer_id."'";
        $wpdb->query($sql);
        if( is_array($data['modules']) && sizeof($data['modules']) > 0 && $offer_id ) {
            $module_counter = 0;
            //echo '<pre>';
            //print_r($data['modules']);
            //echo '</pre>';
            foreach( $data['modules'] as $module_id ) {
                $module_counter++;
                
                if( is_array($data['lessons_'.$module_id]) && sizeof($data['lessons_'.$module_id]) > 0 ) {  
                    //echo '<pre>';
                    //print_r($data['lessons_'.$module_id]);
                    //echo '</pre>';
                    $lesson_counter = 0;
                    foreach( $data['lessons_'.$module_id] as $lesson_id ) {
                        $lesson_counter++;  
                        $product_id = $data['lessons_product_'.$module_id];
                        $sql = "INSERT INTO `".$wpdb->prefix."am_offer_structure` ( `offer_id`, `product_id`, `module_id`, `lesson_id` ) VALUES ( '".$offer_id."', '".$product_id."', '".$module_id."', '".$lesson_id."' )";
                        //echo '<br>';
                        $wpdb->query($sql);
                    }
                }
            }
        }
        
        return true;
    }

    public function am_save_offer( $data=array() ) {
        
        if( empty($data) || !is_array( $data ) ) {
            return false;
        }
        
        global $wpdb;
        $exclude = array( 'btnsave', 'am_offer_product', 'modules', 'lessons', 'offer_product_all_lesons', 'btnupload', 'lessons_product' );
        $attr = "";
        $attr_val = "";
        foreach( $data as $k=>$val ) {
            if(is_array($val)) {
                $val = maybe_serialize($val);
            }
            $should_insert = true;
            foreach( $exclude as $v ) {
                $pos = strpos($k, $v);
                if ($pos !== false) {
                    $should_insert = false;
                    break;
                }
            }
            if( $should_insert ) {
                if( $attr == "" ) {
                    $attr.="`".$k."`";
                    $attr_val.="'".$val."'";
                }else{
                    $attr.=", `".$k."`";
                    $attr_val.=", '".$val."'";
                }                
            }
        }
        
        $sql = "INSERT INTO `".$wpdb->prefix."am_offers` (".$attr.") VALUES (".$attr_val.")";
        $wpdb->query($sql);
        $offer_id = $wpdb->insert_id;
        if( is_array($data['modules']) && sizeof($data['modules']) > 0 && $offer_id ) {
            $module_counter = 0;
            foreach( $data['modules'] as $module_id ) {
                $module_counter++;
                
                if( is_array($data['lessons_'.$module_id]) && sizeof($data['lessons_'.$module_id]) > 0 ) {                    
                    $lesson_counter = 0;
                    foreach( $data['lessons_'.$module_id] as $lesson_id ) {
                        $lesson_counter++;  
                        $product_id = $data['lessons_product_'.$module_id];
                        $sql = "INSERT INTO `".$wpdb->prefix."am_offer_structure` ( `offer_id`, `product_id`, `module_id`, `lesson_id` ) VALUES ( '".$offer_id."', '".$product_id."', '".$module_id."', '".$lesson_id."' )";
                        $wpdb->query($sql);
                    }
                }
            }
        }
        
        $this->am_insert_offer_page( $data, $offer_id );
        
        return true;
    }
    
    public function am_insert_offer_page( $data = array(), $offer_id ) {
        
        if( !is_array($data) || sizeof($data) == 0 ) {
            return false;
        }
        
        global $user_ID, $wpdb;
        $page['post_type']    = 'page';
        $page['post_author']  = $user_ID;
        $page['post_status']  = 'publish';
        $page['comment_status'] = 'open';
        $page['post_title']   = $data['offer_name'];
        $page['post_content'] = '[am_offer id="'.$offer_id.'"]';

        $pageid = wp_insert_post( $page, true );

        if ($pageid != 0) {  
            $sql = "UPDATE `".$wpdb->prefix."am_offers` SET `offer_page` = '".$pageid."', `login_redirect` = '".$pageid."' WHERE id = '".$offer_id."'";
            $wpdb->query($sql);
            $options = get_option( 'am_settings', array() );
            
            if( !empty($options['wp_offer_page_template'])) {
                update_post_meta( $pageid, '_wp_page_template', $options['wp_offer_page_template'] );
                update_post_meta( $pageid, '_am_offer_id', $offer_id );
            }
        }
    }
    
    public function am_bonus_buttons() {
        
        $action = $_REQUEST['action'];
        $html = '';
        ob_start();
        if( $action == 'del' ) {
            if( is_numeric($_REQUEST['id']) ) {
                $this->am_delte_bonus_button($_REQUEST['id']);
            }
        }
        if( $action == 'edit' ) {
            if( is_numeric($_REQUEST['id']) ) {
                if( isset($_POST['btnsave']) ) {
                    if( $this->am_update_bonus_button( $_POST ) ) {
                        $message = "Bonus buttons updated successfully!";
                    }
                }
                wp_enqueue_script('wp-color-picker');
                wp_enqueue_script('media-upload');
                wp_enqueue_script('thickbox');
                wp_enqueue_style('thickbox');
                wp_enqueue_style( 'wp-color-picker' );
                $products = $this->am_get_products();
                $pages = get_pages(); 
                $buttons = $this->am_get_bonus_buttons( "id = '".$_REQUEST['id']."'" );
                $bonus_button = array_shift($buttons);
                require_once AM_PLUGIN_PATH.'templates/admin/am_edit_bonus_buttons.php';
                $this->load_javascript();
            }            
        }else if( $action == 'add' ) {
            if( isset($_POST['btnsave']) ) {
                if( $this->am_save_bonus_button( $_POST ) ) {
                    $message = "Bonus buttons added successfully!";
                }
            }
            wp_enqueue_script('wp-color-picker');
            wp_enqueue_script('media-upload');
            wp_enqueue_script('thickbox');
            wp_enqueue_style('thickbox');
            wp_enqueue_style( 'wp-color-picker' );
            $products = $this->am_get_products();
            $pages = get_pages(); 
            require_once AM_PLUGIN_PATH.'templates/admin/am_add_bonus_buttons.php';
            $this->load_javascript();
        }else{
            $buttons = $this->am_get_bonus_buttons();
            require_once AM_PLUGIN_PATH.'templates/admin/am_bonus_buttons.php';
        }
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
    
    public function am_update_bonus_button( $data = array() ) {
        if( !is_array($data) && sizeof($data) == 0 ) {
            return false;
        }
        global $wpdb;
        $id = $data['id'];
        $exclude = array( 'id','btnsave' );
        $attr = "";
        foreach( $data as $k=>$val ) {
            if(is_array($val)) {
                $val = maybe_serialize($val);
            }
            $should_insert = true;
            foreach( $exclude as $v ) {
                $pos = strpos($k, $v);
                if ($pos !== false) {
                    $should_insert = false;
                    break;
                }
            }
            if( $should_insert ) {
                if( $attr == "" ) {
                    $attr.="`".$k."` = '".$val."'";                    
                }else{
                    $attr.=", `".$k."` = '".$val."'";
                }                
            }
        }
        $sql = "UPDATE `".$wpdb->prefix."am_bonus_buttons` SET ".$attr." WHERE id = '".$id."'";
        $wpdb->query($sql);
        return true;
    }
    
    public function am_save_bonus_button( $data = array() ) {
        
        if( empty($data) || !is_array( $data ) ) {
            return false;
        }
        
        global $wpdb;
        $exclude = array( 'btnsave' );
        $attr = "";
        $attr_val = "";
        foreach( $data as $k=>$val ) {
            if(is_array($val)) {
                $val = maybe_serialize($val);
            }
            $should_insert = true;
            foreach( $exclude as $v ) {
                $pos = strpos($k, $v);
                if ($pos !== false) {
                    $should_insert = false;
                    break;
                }
            }
            if( $should_insert ) {
                if( $attr == "" ) {
                    $attr.="`".$k."`";
                    $attr_val.="'".$val."'";
                }else{
                    $attr.=", `".$k."`";
                    $attr_val.=", '".$val."'";
                }                
            }
        }
        $sql = "INSERT INTO `".$wpdb->prefix."am_bonus_buttons` (".$attr.") VALUES (".$attr_val.")";
        $wpdb->query($sql);
        
        return true;
    }
    
    public function am_delte_bonus_button( $id = '' ) {
        
        if( empty($id) || !is_numeric( $id ) ) {
            return false;
        }
        
        global $wpdb;
        $sql = "DELETE FROM `".$wpdb->prefix."am_bonus_buttons` WHERE id = '".$id."'";
        $wpdb->query($sql);
        return true;
    }
    
    public function am_mail_texts() {
        
		
        if( isset($_POST['btnsave']) && $_POST['btnsave'] != "" ) {
            
            $exclude = array('btnsave');
            $options = get_option( 'am_settings', array() );
            
            foreach( $_POST as $k => $v ) {
                if( !in_array( $k, $exclude )) {
                    $options[$k] = $v;
                }
            }
			
			//Update User Data
			wp_update_user( array(
				'ID' => $_POST[ 'user_id' ],
				'display_name' => $_POST[ 'sender_name' ],
				'user_email' => $_POST[ 'sender_email' ]
		    )); 
            
			
            update_option( 'am_settings', $options );
			
            $message = 'Mail Settings Saved Successfully!';
        }
		
		$current_user = wp_get_current_user();
		$current_user=get_userdata($current_user->ID);
        
        $options = get_option( 'am_settings', array() );
        
        $html = '';
		
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/admin/am_mail_texts.php';
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
	
	
	public function am_email_series() {
        
        $action = $_REQUEST['action'];
		 
		//Get Settings
		$options = get_option( 'am_settings', array() );
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
       
        if($action == 'view' ) {
			
			$sub_action = $_REQUEST['sub_action'];
			$category_id = $_REQUEST['cat_id'];
			
			if( $sub_action == 'add' ) {
            
			 if(!empty($_POST['btnsave_emailseries'])){
				
				global $wpdb;
				
				
				$created_date = date('Y-m-d G:i:s');
				
				$after_days = $_POST['after_days'];
				$after_days_hours = $_POST['after_days_hours'];
				$after_days_minuts = $_POST['after_days_minuts'];
				
				if($_POST['btnsave_emailseries'] =='draft'){
					$status = 2;	
				}else{
					$status = 0;	
				}
				
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter` (`category_id`, `template_name`, `from_name`, `from_email`, `subject`, `mail_content`, `company_name`, `address`, `link_tracking`, `send_preview_email`, `type`, `trigger_email_type`, `trigger_date_time`, `after_days`, `after_days_hours`,`after_days_minuts`,  `status`, `created_date` ) VALUES ('".$_POST['category_id']."', '".$_POST['template_name']."', '".$_POST['from_name']."', '".$_POST['from_email']."', '".$_POST['subject']."', '".nl2br($_POST['mail_content'])."', '".$_POST['company_name']."', '".$_POST['address']."', '".$_POST['link_tracking']."', '".$_POST['send_preview_email']."', 'email_series', '".$_POST['trigger_email_type']."', '', '".$after_days."', '".$after_days_hours."', '".$after_days_minuts."', '".$status."', '".$created_date."')";
                
				$wpdb->query($sql);
				$newsletter_id = $wpdb->insert_id;
				
				
				/////////////////////////////////////////////////////////////////////
				//////////////////******  Send Now check *****///////////////////////
				/////////////////////////////////////////////////////////////////////
				if($_POST['send_contacts_now'] == 1){
				
				//Get Filtered Contacts
			 	$filtered_contacts = $this->am_get_filtered_contacts($_POST);
				
				if($_POST['trigger_email_type'] =='instant'){
					$trigger_date_time = date("Y-m-d G:i:s");
				}else{
					$trigger_date_time = date('Y-m-d G:i:s', strtotime("+".$after_days." days"));
					$trigger_date_time = date('Y-m-d G:i:s', strtotime("+".$after_days_hours." hours", strtotime($trigger_date_time)));
					$trigger_date_time = date('Y-m-d G:i:s', strtotime("+".$after_days_minuts." minutes", strtotime($trigger_date_time)));
				}
				
				foreach($filtered_contacts as $contact){

                 //Check if Already Inserted 
                 $check_contact = $this->am_check_already_scheduled($newsletter_id,$contact->id);

                 if($check_contact =='not_found'){     
					
    				//Insert Data into DB
    				$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
    						VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '0')";
    		
    				$wpdb->query($sql_query);
    				$schedule_id = $wpdb->insert_id;	
					
				
    				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `transactionid`, `messageid`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->transactionid."', '".$contact->messageid."', '".$contact->id."', '".$contact->sent_status."', '0','0', '".$contact->email_status."', '".$created_date."')";
    				$wpdb->query($sql_tags);

                }//End if
				
				}//End foreach
				
				}//End if Send Now check
				/////////////////////////////////////////////////////////////////////
				/////////////////////****** End Send Now check *****/////////////////
				/////////////////////////////////////////////////////////////////////
				
				
				//Insert Tags
				$post_tags = $_POST['tags_id'];
				foreach($post_tags as $key=>$tag){
					
				$tag_id = $key;
				$tag_value = $tag;	
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
				$wpdb->query($sql_tags);
				
				}
				
				//Insert opended email
				$opened_emails = $_POST['opened_emails'];
				
				if(count($opened_emails)>0){
				foreach($opened_emails as $key=>$opened){
					
				$email_id = $key;
				$email_value = $opened;	
				
				$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
				$wpdb->query($sql_opened);
				
				}
				}
				
				//Insert clicked email
				$clicked_emails = $_POST['clicked_emails'];
				if(count($clicked_emails)>0){
				foreach($clicked_emails as $key=>$clicked){
					
				$email_id = $key;
				$email_value = $clicked;	
				
				$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";
				$wpdb->query($sql_clicked);
				
				}
				}
				
				//Insert sent email
				$sent_emails = $_POST['sent_emails'];
				if(count($sent_emails)>0){
				foreach($sent_emails as $key=>$sent){
					
				$email_id = $key;
				$email_value = $sent;	
				
				$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
				$wpdb->query($sql_sent);
				
				}
				}
				
				//Insert Lesson Finished
				$lesson_finished = $_POST['lesson_finished'];
				if(count($lesson_finished)>0){
				foreach($lesson_finished as $key=>$lesson){
					
				$lesson_id = $key;
				$lesson_value = $lesson;	
				
				$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
				$wpdb->query($sql_lesson);
				
				}
				}
				
				//Insert Purchased Products
				$purchased_product = $_POST['purchased_product'];
				if(count($purchased_product)>0){
				foreach($purchased_product as $key=>$product){
					
				$product_id = $key;
				$product_value = $product;	
				
				$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
				$wpdb->query($sql_product);
				
				}
				}
				
				//Insert Opted forms
				$opted_in = $_POST['opted_in'];
				if(count($opted_in)>0){
				foreach($opted_in as $key=>$opted){
					
				$opted_id = $key;
				$opted_value = $opted;	
				
				$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
				$wpdb->query($sql_opted);
				
				}
				}
				
				
				//Insert Survey
				$survey_filter = $_POST['survey_filter'];
				if(count($survey_filter)>0){
				foreach($survey_filter as $key=>$survey){
					
				$survey_id = $key;
				$survey_value = $survey;	
				
				$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
				$wpdb->query($sql_survey);
				
				}
				}
				
				// header("Location:?page=am_email_series&action=view&cat_id=".$category_id."");
				$redirecturl = admin_url('admin.php?page=am_email_series&action=view&cat_id='.$category_id);
			print('<script>window.location.href="'.$redirecturl.'"</script>');
			exit;
				//$message = "Email Series added successfully!";//header("Location:?page=am_email_series&action=view&sub_action=edit&cat_id=".$category_id."&id=".$newsletter_id."");
				
				$message = $newsletter_id;

             }
			 
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 //Get all Emails
			 $emails_arr = $this->am_get_all_emails();
			 
			 //Get all Lessons
			 $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
             $lessons = get_posts( $args );
			 
			 //Get all Products
			 $products = $this->am_get_products();
			 
			 //Get all Optin-forms
			 $optin_forms_arr = $this->am_get_optin_forms();
			 
			 //Get all Survey
			 $all_survey = $this->am_get_all_survey();
			 
			 //Get all Categories
			 $emails_categories_arr = $this->am_get_all_emails_categories();
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new-emailseries.php';
			 
            
        }elseif($sub_action == 'edit' && is_numeric($_REQUEST['id'])){
			
			 if(isset($_POST['btnsave_update'])) {
			
				global $wpdb;
				
				$newsletter_id = $_REQUEST['id'];
				
				$after_days = $_POST['after_days'];
				$after_days_hours = $_POST['after_days_hours'];
				$after_days_minuts = $_POST['after_days_minuts'];

				if($_POST['btnsave_update'] =='draft'){
					$status = 2;	
				}else{
					$status = 0;	
				}
				
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_newsletter` SET template_name = '".$_POST['template_name']."',  from_name = '".$_POST['from_name']."', from_email = '".$_POST['from_email']."', subject = '".$_POST['subject']."', mail_content = '".nl2br($_POST['mail_content'])."', company_name = '".$_POST['company_name']."', address = '".$_POST['address']."', link_tracking = '".$_POST['link_tracking']."', send_preview_email = '".$_POST['send_preview_email']."', trigger_email_type = '".$_POST['trigger_email_type']."', after_days='".$after_days."', after_days_hours='".$after_days_hours."',after_days_minuts='".$after_days_minuts."',status='".$status."' WHERE id = '".$newsletter_id."'";
            	$wpdb->query($sql_update);
				
				
				/////////////////////////////////////////////////////////////////////
				//////////////////******  Send Now check *****///////////////////////
				/////////////////////////////////////////////////////////////////////
				if($_POST['send_contacts_now'] == 1){
				
				//Get Filtered Contacts
			 	$filtered_contacts = $this->am_get_filtered_contacts($_POST);
				
				if($_POST['trigger_email_type'] =='instant'){
					$trigger_date_time = date("Y-m-d G:i:s");
				}else{
					$trigger_date_time = date('Y-m-d G:i:s', strtotime("+".$after_days." days"));
					$trigger_date_time = date('Y-m-d G:i:s', strtotime("+".$after_days_hours." hours", strtotime($trigger_date_time)));
					$trigger_date_time = date('Y-m-d G:i:s', strtotime("+".$after_days_minuts." minutes", strtotime($trigger_date_time)));
				}
				
				foreach($filtered_contacts as $contact){

                 //Check if Already Inserted 
                 $check_contact = $this->am_check_already_scheduled($newsletter_id,$contact->id);

                 if($check_contact =='not_found'){      
					
    				//Insert Data into DB
    				$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
    						VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '0')";
    		
    				$wpdb->query($sql_query);
    				$schedule_id = $wpdb->insert_id;	
					
				
    				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `transactionid`, `messageid`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->transactionid."', '".$contact->messageid."', '".$contact->id."', '".$contact->sent_status."', '0','0', '".$contact->email_status."', '".$created_date."')";
    				$wpdb->query($sql_tags);

                }//End if
				
				}//End foreach
				
				}//End if Send Now check
				/////////////////////////////////////////////////////////////////////
				/////////////////////****** End Send Now check *****/////////////////
				/////////////////////////////////////////////////////////////////////
				
				
				//Delete Old Tags
				$sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete);
				
				//Insert Tags
				$post_tags = $_POST['tags_id'];
				foreach($post_tags as $key=>$tag){
					
				$tag_id = $key;
				$tag_value = $tag;	
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
				$wpdb->query($sql_tags);
				
				}
				
				//Delete Old Email Tags
				$sql_delete2 = "DELETE FROM`".$wpdb->prefix."am_newsletter_emails_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete2);
				
				//Insert Tags
				$opened_emails_tags = $_POST['opened_emails'];
				foreach($opened_emails_tags as $key=>$opened_email){
					
				$email_id = $key;
				$email_value = $opened_email;	
				
				$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
				$wpdb->query($sql_opened);
				
				}
				
				//Insert Tags
				$clicked_emails_tags = $_POST['clicked_emails'];
				foreach($clicked_emails_tags as $key=>$clicked_email){
					
				$email_id = $key;
				$email_value = $clicked_email;	
				
				$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";
				$wpdb->query($sql_clicked);
				
				}
				
				//Insert Tags
				$sent_emails_tags = $_POST['sent_emails'];
				foreach($sent_emails_tags as $key=>$sent_email){
					
				$email_id = $key;
				$email_value = $sent_email;	
				
				$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
				$wpdb->query($sql_sent);
				
				}
				
				
				//Delete Old Lesson Tags
				$sql_delete3 = "DELETE FROM`".$wpdb->prefix."am_newsletter_lesson_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete3);
				
				//Insert Lesson Finished
				$lesson_finished = $_POST['lesson_finished'];
				foreach($lesson_finished as $key=>$lesson){
					
				$lesson_id = $key;
				$lesson_value = $lesson;	
				
				$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
				$wpdb->query($sql_lesson);
				
				}
				
				
				//Delete Old Product Tags
				$sql_delete4 = "DELETE FROM`".$wpdb->prefix."am_newsletter_product_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete4);
				
				//Insert Purchased Products
				$purchased_product = $_POST['purchased_product'];
				foreach($purchased_product as $key=>$product){
					
				$product_id = $key;
				$product_value = $product;	
				
				$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
				$wpdb->query($sql_product);
				
				}
				
				
				//Delete Old Opted Tags
				$sql_delete5 = "DELETE FROM`".$wpdb->prefix."am_newsletter_optedfrom_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete5);
				
				//Insert Opted forms
				$opted_in = $_POST['opted_in'];
				foreach($opted_in as $key=>$opted){
					
				$opted_id = $key;
				$opted_value = $opted;	
				
				$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
				$wpdb->query($sql_opted);
				
				}
				
				
				//Delete Old Survey Tags
				$sql_delete6 = "DELETE FROM`".$wpdb->prefix."am_newsletter_survey_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete6);
				
				//Insert Survey
				$survey_filter = $_POST['survey_filter'];
				foreach($survey_filter as $key=>$survey){
					
				$survey_id = $key;
				$survey_value = $survey;	
				
				$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
				$wpdb->query($sql_survey);
				
				}
				
				$message = "Record updated successfully!";
				$redirecturl = admin_url('admin.php?page=am_email_series&action=view&cat_id='.$category_id); 
				// header("Location: $redirecturl");
						print('<script>window.location.href="'.$redirecturl.'"</script>');
						exit;
            }
			
			
             //Get Email Series Data
			 $emailseries_arr = $this->am_get_emailseries($_REQUEST['id']);
			 
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 //Get all Emails
			 $emails_arr = $this->am_get_all_emails();
			 
			 //Get all Lessons
			 $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
             $lessons = get_posts( $args );
			 
			 //Get all Products
			 $products = $this->am_get_products();
			 
			 //Get all Optin-forms
			 $optin_forms_arr = $this->am_get_optin_forms();
			 
			 //Get all Survey
			 $all_survey = $this->am_get_all_survey();
			 
			 
			 //Get Newsletter Tags
			 $newsletter_tags = $this->am_get_newsletter_tags($_REQUEST['id']);
			 
			 $newtags_arr = array();
			 foreach($newsletter_tags as $tagval){
				 
				 $tag_id = $tagval->tag_id;
				 $tag_value = $tagval->value;
				 
				 $newtags_arr[$tag_id] = $tag_value;
			 }
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_opened = $this->am_get_newsletter_email_tags($_REQUEST['id'],'opened');
			 
			 $newtags_email_opended = array();
			 foreach($newsletter_email_tags_opened as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_opended[$email_id] = $email_value;
			 }
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_clicked = $this->am_get_newsletter_email_tags($_REQUEST['id'],'clicked');
			 
			 $newtags_email_clicked = array();
			 foreach($newsletter_email_tags_clicked as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_clicked[$email_id] = $email_value;
			 }
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_sent = $this->am_get_newsletter_email_tags($_REQUEST['id'],'sent');
			 
			 $newtags_email_sent = array();
			 foreach($newsletter_email_tags_sent as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_sent[$email_id] = $email_value;
			 }
			 
			 //Get Newsletter Lesson Tags
			 $newsletter_lesson_tags = $this->am_get_newsletter_lesson_tags($_REQUEST['id']);
			 
			 $newtags_lesson = array();
			 foreach($newsletter_lesson_tags as $tagval_lesson){
				 
				 $lesson_id = $tagval_lesson->lesson_id;
				 $lesson_value = $tagval_lesson->lesson_value;
				 
				 $newtags_lesson[$lesson_id] = $lesson_value;
			 }
			 
			 //Get Newsletter Product Tags
			 $newsletter_product_tags = $this->am_get_newsletter_product_tags($_REQUEST['id']);
			 
			 $newtags_product = array();
			 foreach($newsletter_product_tags as $tagval_product){
				 
				 $product_id = $tagval_product->product_id;
				 $product_value = $tagval_product->product_value;
				 
				 $newtags_product[$product_id] = $product_value;
			 }
			 
			 //Get Newsletter Optedform Tags
			 $newsletter_optedform_tags = $this->am_get_newsletter_optedform_tags($_REQUEST['id']);
			 
			 $newtags_optedform = array();
			 foreach($newsletter_optedform_tags as $tagval_optedform){
				 
				 $optedform_id = $tagval_optedform->opted_id;
				 $optedform_value = $tagval_optedform->opted_value;
				 
				 $newtags_optedform[$optedform_id] = $optedform_value;
			 }
			 
			 
			 //Get Newsletter Survey Tags
			 $newsletter_survey_tags = $this->am_get_newsletter_survey_tags($_REQUEST['id']);
			 
			 $newtags_survey = array();
			 foreach($newsletter_survey_tags as $tagval_survey){
				 
				 $survey_id = $tagval_survey->survey_id;
				 $survey_value = $tagval_survey->survey_value;
				 
				 $newtags_survey[$survey_id] = $survey_value;
			 }
			 
			 
             require_once AM_PLUGIN_PATH.'templates/admin/am_edit_emailseries.php';
			
			
        }else{
         
         	if($sub_action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  //Delete Newsletter Record
				  $this->am_delete_newsletter($_REQUEST['id']);
				  $message = "Record deleted successfully!";
			}
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_email_series.php';
        }
			
			
			
		
		}elseif($action == 'add' ) {
			$emails_categories_array = $this->am_get_all_emails_categories();
			 $am_lincense_key=constant('AM_LICENSE_KEY'); 
			 if(empty($am_lincense_key) && count($emails_categories_array)>=1){
				?>
			
				<div id="message" class="error">
					<p><strong><?php echo __("Please enter a licence key in order to add a new email series.", 'am'); ?></strong></p>
				</div>
				<?php } 	
				
            
             if(!empty($_POST['btnsave_tags'])){
				 
				
				global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_emails_categories` (`category_name`, `created_date` ) VALUES ('".$_POST['name']."', '".$created_date."')";
                $wpdb->query($sql);
				
				$category_id = $wpdb->insert_id;
				
				$message = "Category added successfully!";
				$redirecturl = admin_url('admin.php?page=am_email_series&action=view&cat_id='.$category_id); 
				// header("Location: $redirecturl");
			print('<script>window.location.href="'.$redirecturl.'"</script>');
			exit;
               
             }	
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new-emails_category.php';
			 
            
        }elseif($action == 'edit' && is_numeric($_REQUEST['id'])){
			
			
            if(isset($_POST['btnsave_update'])) {
                
				global $wpdb;
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_emails_categories` SET category_name = '".$_POST['name']."' WHERE id = '".$_REQUEST['id']."'";
            	$wpdb->query($sql_update);
				
				$message = "Record updated successfully!";
            }
			
             //Get Category Data
			 $emails_category_arr = $this->am_get_emails_category($_REQUEST['id']);
			 
             require_once AM_PLUGIN_PATH.'templates/admin/am_edit_emails_category.php';
			
			
        }else{
         
         	
			if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  global $wpdb;
				  
				   //Delete Email Categories
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_emails_categories` WHERE id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  
				  //Get All Newsletter
				  $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE category_id = '".$_REQUEST['id']."'";
				  $newsletter_arr = $wpdb->get_results( $sql );
				
				  foreach($newsletter_arr as $newsletter){
					
				    $newsletter_id = $newsletter->id;
				  
				    //Delete Newsletter Record
				    $this->am_delete_newsletter($newsletter_id);
					
				  }//End foreach
				  
				  
				  //Delete Email Templates
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter` WHERE category_id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $message = "Record deleted successfully!";
			}
			
			
			//Get all Categories
			$emails_categories_array = $this->am_get_all_emails_categories();
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_emails_categories.php';
        }
       
    }
    
    
    public function am_newsletter() {
        
        $action = $_REQUEST['action'];
		$elastic_subAccount=get_option('elastic_subAccount');
		//Get Settings
		$options = get_option( 'am_settings', array() );
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
       
        if( $action == 'add' ) {
			
			
             if(!empty($_POST['btnsave_newsletter'])){
				
				global $wpdb;
				
				//Get Filtered Contacts
			 	$filtered_contacts = $this->am_get_filtered_contacts($_POST);
				
				$created_date = date('Y-m-d G:i:s');
				
				$trigger_date_time = date("Y-m-d G:i:s", strtotime($_POST['trigger_date_time']));
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter` (`template_name`, `from_name`, `from_email`, `subject`, `mail_content`, `company_name`, `address`, `link_tracking`, `send_preview_email`, `type`, `trigger_email_type`, `trigger_date_time`, `status`, `created_date` ) VALUES ('".$_POST['template_name']."', '".$_POST['from_name']."', '".$_POST['from_email']."', '".$_POST['subject']."', '".nl2br($_POST['mail_content'])."', '".$_POST['company_name']."', '".$_POST['address']."', '".$_POST['link_tracking']."', '".$_POST['send_preview_email']."', 'newsletter', '".$_POST['trigger_email_type']."', '".$trigger_date_time."', '2', '".$created_date."')";
                
				$wpdb->query($sql);
				
				$newsletter_id = $wpdb->insert_id;
				
				/////////////////////////////////////////////////////////////////////
				//////////////////****** Insert Email Contacts *****////////////////
				////////////////////////////////////////////////////////////////////
				foreach($filtered_contacts as $contact){
					
				//Insert Data into DB
				$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
						VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '2')";
		
				$wpdb->query($sql_query);
				$schedule_id = $wpdb->insert_id;	
					
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `transactionid`, `messageid`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->transactionid."', '".$contact->messageid."', '".$contact->id."', '".$contact->sent_status."', '0','0', '".$contact->email_status."', '".$created_date."')";
				$wpdb->query($sql_tags);
				
				}
				/////////////////////////////////////////////////////////////////////
				//////////////////****** End Insert Email Contacts *****////////////
				////////////////////////////////////////////////////////////////////
				
				//Insert Tags
				$post_tags = $_POST['tags_id'];
				foreach($post_tags as $key=>$tag){
					
				$tag_id = $key;
				$tag_value = $tag;	
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
				$wpdb->query($sql_tags);
				
				}
				
				//Insert opended email
				$opened_emails = $_POST['opened_emails'];
				
				if(count($opened_emails)>0){
				foreach($opened_emails as $key=>$opened){
					
				$email_id = $key;
				$email_value = $opened;	
				
				$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
				$wpdb->query($sql_opened);
				
				}
				}
				
				//Insert clicked email
				$clicked_emails = $_POST['clicked_emails'];
				if(count($clicked_emails)>0){
				foreach($clicked_emails as $key=>$clicked){
					
				$email_id = $key;
				$email_value = $clicked;	
				
				$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";
				$wpdb->query($sql_clicked);
				
				}
				}
				
				//Insert sent email
				$sent_emails = $_POST['sent_emails'];
				if(count($sent_emails)>0){
				foreach($sent_emails as $key=>$sent){
					
				$email_id = $key;
				$email_value = $sent;	
				
				$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
				$wpdb->query($sql_sent);
				
				}
				}
				
				//Insert Lesson Finished
				$lesson_finished = $_POST['lesson_finished'];
				if(count($lesson_finished)>0){
				foreach($lesson_finished as $key=>$lesson){
					
				$lesson_id = $key;
				$lesson_value = $lesson;	
				
				$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
				$wpdb->query($sql_lesson);
				
				}
				}
				
				//Insert Purchased Products
				$purchased_product = $_POST['purchased_product'];
				if(count($purchased_product)>0){
				foreach($purchased_product as $key=>$product){
					
				$product_id = $key;
				$product_value = $product;	
				
				$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
				$wpdb->query($sql_product);
				
				}
				}
				
				//Insert Opted forms
				$opted_in = $_POST['opted_in'];
				if(count($opted_in)>0){
				foreach($opted_in as $key=>$opted){
					
				$opted_id = $key;
				$opted_value = $opted;	
				
				$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
				$wpdb->query($sql_opted);
				
				}
				}
				
				//Insert Survey
				$survey_filter = $_POST['survey_filter'];
				if(count($survey_filter)>0){
				foreach($survey_filter as $key=>$survey){
					
				$survey_id = $key;
				$survey_value = $survey;	
				
				$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
				$wpdb->query($sql_survey);
				
				}
				}
				
				
				$message = "Newsletter added successfully!";
				$redirecturl = admin_url('admin.php?page=am_newsletter'); 
				// header("Location: $redirecturl");
			print('<script>window.location.href="'.$redirecturl.'"</script>');
			exit;
				
               
             }
			 if($_POST['btnsave_newsletter_send']=='yes'){
				
				global $wpdb;
				
				//Get Filtered Contacts
			 	$filtered_contacts = $this->am_get_filtered_contacts($_POST);
				
				$created_date = date('Y-m-d G:i:s');
				
				$trigger_date_time = date("Y-m-d G:i:s", strtotime($_POST['trigger_date_time']));
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter` (`template_name`, `from_name`, `from_email`, `subject`, `mail_content`, `company_name`, `address`, `link_tracking`, `send_preview_email`, `type`, `trigger_email_type`, `trigger_date_time`, `status`, `created_date` ) VALUES ('".$_POST['template_name']."', '".$_POST['from_name']."', '".$_POST['from_email']."', '".$_POST['subject']."', '".$_POST['mail_content']."', '".$_POST['company_name']."', '".$_POST['address']."', '".$_POST['link_tracking']."', '".$_POST['send_preview_email']."', 'newsletter', '".$_POST['trigger_email_type']."', '".$trigger_date_time."', '0', '".$created_date."')";
                
				$wpdb->query($sql);
				
				$newsletter_id = $wpdb->insert_id;
				
				/////////////////////////////////////////////////////////////////////
				//////////////////****** Insert Email Contacts *****////////////////
				////////////////////////////////////////////////////////////////////
				foreach($filtered_contacts as $contact){
					
				//Insert Data into DB
				$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
						VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '0')";
		
				$wpdb->query($sql_query);
				$schedule_id = $wpdb->insert_id;	
					
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `transactionid`, `messageid`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->transactionid."', '".$contact->messageid."', '".$contact->id."', '".$contact->sent_status."', '0','0', '".$contact->email_status."', '".$created_date."')";
				$wpdb->query($sql_tags);
				
				}
				/////////////////////////////////////////////////////////////////////
				//////////////////****** End Insert Email Contacts *****////////////
				////////////////////////////////////////////////////////////////////
				
				//Insert Tags
				$post_tags = $_POST['tags_id'];
				foreach($post_tags as $key=>$tag){
					
				$tag_id = $key;
				$tag_value = $tag;	
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
				$wpdb->query($sql_tags);
				
				}
				
				//Insert opended email
				$opened_emails = $_POST['opened_emails'];
				
				if(count($opened_emails)>0){
				foreach($opened_emails as $key=>$opened){
					
				$email_id = $key;
				$email_value = $opened;	
				
				$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
				$wpdb->query($sql_opened);
				
				}
				}
				
				//Insert clicked email
				$clicked_emails = $_POST['clicked_emails'];
				if(count($clicked_emails)>0){
				foreach($clicked_emails as $key=>$clicked){
					
				$email_id = $key;
				$email_value = $clicked;	
				
				$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";
				$wpdb->query($sql_clicked);
				
				}
				}
				
				//Insert sent email
				$sent_emails = $_POST['sent_emails'];
				if(count($sent_emails)>0){
				foreach($sent_emails as $key=>$sent){
					
				$email_id = $key;
				$email_value = $sent;	
				
				$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
				$wpdb->query($sql_sent);
				
				}
				}
				
				//Insert Lesson Finished
				$lesson_finished = $_POST['lesson_finished'];
				if(count($lesson_finished)>0){
				foreach($lesson_finished as $key=>$lesson){
					
				$lesson_id = $key;
				$lesson_value = $lesson;	
				
				$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
				$wpdb->query($sql_lesson);
				
				}
				}
				
				//Insert Purchased Products
				$purchased_product = $_POST['purchased_product'];
				if(count($purchased_product)>0){
				foreach($purchased_product as $key=>$product){
					
				$product_id = $key;
				$product_value = $product;	
				
				$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
				$wpdb->query($sql_product);
				
				}
				}
				
				//Insert Opted forms
				$opted_in = $_POST['opted_in'];
				if(count($opted_in)>0){
				foreach($opted_in as $key=>$opted){
					
				$opted_id = $key;
				$opted_value = $opted;	
				
				$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
				$wpdb->query($sql_opted);
				
				}
				}
				
				//Insert Survey
				$survey_filter = $_POST['survey_filter'];
				if(count($survey_filter)>0){
				foreach($survey_filter as $key=>$survey){
					
				$survey_id = $key;
				$survey_value = $survey;	
				
				$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
				$wpdb->query($sql_survey);
				
				}
				}
				
				
				$message = "Newsletter added successfully!";
                $redirecturl = admin_url('admin.php?page=am_newsletter'); 
                // header("Location: $redirecturl");
			print('<script>window.location.href="'.$redirecturl.'"</script>');
			exit;

					 
			 }	
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 //Get all Emails
			 $emails_arr = $this->am_get_all_emails();
			 
			 //Get all Lessons
			 $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
             $lessons = get_posts( $args );
			 
			 //Get all Products
			 $products = $this->am_get_products();
			 
			 //Get all Optin-forms
			 $optin_forms_arr = $this->am_get_optin_forms();
			 
			 //Get all Survey
			 $all_survey = $this->am_get_all_survey();
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new-newsletter.php';
            
        }elseif(($action == 'edit' or $action == 'view') && is_numeric($_REQUEST['id'])){
			
			
            if(isset($_POST['btnsave_update'])){
				
				//Get Filtered Contacts
			 	$filtered_contacts = $this->am_get_filtered_contacts($_POST);
				
				global $wpdb;
				
				$newsletter_id = $_REQUEST['id'];
				
				$trigger_date_time = date("Y-m-d G:i:s", strtotime($_POST['trigger_date_time']));
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_newsletter` SET template_name = '".$_POST['template_name']."', from_name = '".$_POST['from_name']."', from_email = '".$_POST['from_email']."', subject = '".$_POST['subject']."', mail_content = '".nl2br($_POST['mail_content'])."', company_name = '".$_POST['company_name']."', address = '".$_POST['address']."', link_tracking = '".$_POST['link_tracking']."', send_preview_email = '".$_POST['send_preview_email']."', trigger_email_type = '".$_POST['trigger_email_type']."', trigger_date_time='".$trigger_date_time."', status='2' WHERE id = '".$newsletter_id."'";
            	$wpdb->query($sql_update);
				
				
				/////////////////////////////////////////////////////////////////////
				//////////////////****** Insert Email Contacts *****////////////////
				////////////////////////////////////////////////////////////////////
				//Delete Old Tags
				$sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete);
				
				$sql_delete22 = "DELETE FROM`".$wpdb->prefix."am_newsletter_schedules` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete22);
				
				foreach($filtered_contacts as $contact){
				
				//Insert Data into DB
				$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
						VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '2')";
		
				$wpdb->query($sql_query);
				$schedule_id = $wpdb->insert_id;
				
				//Insert Data into DB
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->id."', '0', '0','0', '0', '".$created_date."')";
				$wpdb->query($sql_tags);
				
				}
				/////////////////////////////////////////////////////////////////////
				//////////////////****** End Insert Email Contacts *****////////////
				////////////////////////////////////////////////////////////////////
				
				//Delete Old Tags
				$sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete);
				
				//Insert Tags
				$post_tags = $_POST['tags_id'];
				foreach($post_tags as $key=>$tag){
					
				$tag_id = $key;
				$tag_value = $tag;	
				
				$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
				$wpdb->query($sql_tags);
				
				}
				
				//Delete Old Email Tags
				$sql_delete2 = "DELETE FROM`".$wpdb->prefix."am_newsletter_emails_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete2);
				
				//Insert Tags
				$opened_emails_tags = $_POST['opened_emails'];
				foreach($opened_emails_tags as $key=>$opened_email){
					
				$email_id = $key;
				$email_value = $opened_email;	
				
				$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
				$wpdb->query($sql_opened);
				
				}
				
				//Insert Tags
				$clicked_emails_tags = $_POST['clicked_emails'];
				foreach($clicked_emails_tags as $key=>$clicked_email){
					
				$email_id = $key;
				$email_value = $clicked_email;	
				
				$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";
				$wpdb->query($sql_clicked);
				
				}
				
				//Insert Tags
				$sent_emails_tags = $_POST['sent_emails'];
				foreach($sent_emails_tags as $key=>$sent_email){
					
				$email_id = $key;
				$email_value = $sent_email;	
				
				$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
				$wpdb->query($sql_sent);
				
				}
				
				
				//Delete Old Lesson Tags
				$sql_delete3 = "DELETE FROM`".$wpdb->prefix."am_newsletter_lesson_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete3);
				
				//Insert Lesson Finished
				$lesson_finished = $_POST['lesson_finished'];
				foreach($lesson_finished as $key=>$lesson){
					
				$lesson_id = $key;
				$lesson_value = $lesson;	
				
				$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
				$wpdb->query($sql_lesson);
				
				}
				
				
				//Delete Old Product Tags
				$sql_delete4 = "DELETE FROM`".$wpdb->prefix."am_newsletter_product_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete4);
				
				//Insert Purchased Products
				$purchased_product = $_POST['purchased_product'];
				foreach($purchased_product as $key=>$product){
						
				$product_id = $key;
				$product_value = $product;	
				
				$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
				$wpdb->query($sql_product);
				
				}
				
				
				//Delete Old Opted Tags
				$sql_delete5 = "DELETE FROM`".$wpdb->prefix."am_newsletter_optedfrom_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete5);
				
				//Insert Opted forms
				$opted_in = $_POST['opted_in'];
				foreach($opted_in as $key=>$opted){
					
				$opted_id = $key;
				$opted_value = $opted;	
				
				$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
				$wpdb->query($sql_opted);
				
				}
				
				
				//Delete Old Survey Tags
				$sql_delete6 = "DELETE FROM`".$wpdb->prefix."am_newsletter_survey_tags` WHERE newsletter_id = '".$newsletter_id."'";
				$wpdb->query($sql_delete6);
				
				//Insert Survey
				$survey_filter = $_POST['survey_filter'];
				foreach($survey_filter as $key=>$survey){
					
				$survey_id = $key;
				$survey_value = $survey;	
				
				$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
				$wpdb->query($sql_survey);
				
				}
				
				$message = "Record updated successfully!";
				
            }
			if($_POST['btnsave_newsletter_send']=='yes'){
				$newsletter_id = $_REQUEST['id'];
				//Get Filtered Contacts
				$check_result = $this->IsNewsletter_exist($newsletter_id);
				if($check_result){
					$filtered_contacts = $this->am_get_filtered_contacts($_POST);
					global $wpdb;
					
					
					
					$trigger_date_time = date("Y-m-d G:i:s", strtotime($_POST['trigger_date_time']));
					
					$sql_update = "UPDATE `".$wpdb->prefix."am_newsletter` SET template_name = '".$_POST['template_name']."', from_name = '".$_POST['from_name']."', from_email = '".$_POST['from_email']."', subject = '".$_POST['subject']."', mail_content = '".$_POST['mail_content']."', company_name = '".$_POST['company_name']."', address = '".$_POST['address']."', link_tracking = '".$_POST['link_tracking']."', send_preview_email = '".$_POST['send_preview_email']."', trigger_email_type = '".$_POST['trigger_email_type']."', trigger_date_time='".$trigger_date_time."', status='0' WHERE id = '".$newsletter_id."'";
					$wpdb->query($sql_update);
					
					
					/////////////////////////////////////////////////////////////////////
					//////////////////****** Insert Email Contacts *****////////////////
					////////////////////////////////////////////////////////////////////
					//Delete Old Tags
					$sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete);
					
					$sql_delete22 = "DELETE FROM`".$wpdb->prefix."am_newsletter_schedules` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete22);
					
					foreach($filtered_contacts as $contact){
					
					//Insert Data into DB
					$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
							VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '0')";
			
					$wpdb->query($sql_query);
					$schedule_id = $wpdb->insert_id;
					
					//Insert Data into DB
					$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->id."', '0', '0','0', '0', '".$created_date."')";
					$wpdb->query($sql_tags);
					
					}
					/////////////////////////////////////////////////////////////////////
					//////////////////****** End Insert Email Contacts *****////////////
					////////////////////////////////////////////////////////////////////
					
					//Delete Old Tags
					$sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_tags` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete);
					
					//Insert Tags
					$post_tags = $_POST['tags_id'];
					foreach($post_tags as $key=>$tag){
						
					$tag_id = $key;
					$tag_value = $tag;	
					
					$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
					$wpdb->query($sql_tags);
					
					}
					
					//Delete Old Email Tags
					$sql_delete2 = "DELETE FROM`".$wpdb->prefix."am_newsletter_emails_tags` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete2);
					
					//Insert Tags
					$opened_emails_tags = $_POST['opened_emails'];
					foreach($opened_emails_tags as $key=>$opened_email){
						
					$email_id = $key;
					$email_value = $opened_email;	
					
					$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
					$wpdb->query($sql_opened);
					
					}
					
					//Insert Tags
					$clicked_emails_tags = $_POST['clicked_emails'];
					foreach($clicked_emails_tags as $key=>$clicked_email){
						
					$email_id = $key;
					$email_value = $clicked_email;	
					
					$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";

					$wpdb->query($sql_clicked);
					
					}
					
					//Insert Tags
					$sent_emails_tags = $_POST['sent_emails'];
					foreach($sent_emails_tags as $key=>$sent_email){
						
					$email_id = $key;
					$email_value = $sent_email;	
					
					$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
					$wpdb->query($sql_sent);
					
					}
					
					
					//Delete Old Lesson Tags
					$sql_delete3 = "DELETE FROM`".$wpdb->prefix."am_newsletter_lesson_tags` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete3);
					
					//Insert Lesson Finished
					$lesson_finished = $_POST['lesson_finished'];
					foreach($lesson_finished as $key=>$lesson){
						
					$lesson_id = $key;
					$lesson_value = $lesson;	
					
					$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
					$wpdb->query($sql_lesson);
					
					}
					
					
					//Delete Old Product Tags
					$sql_delete4 = "DELETE FROM`".$wpdb->prefix."am_newsletter_product_tags` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete4);
					
					//Insert Purchased Products
					$purchased_product = $_POST['purchased_product'];
					foreach($purchased_product as $key=>$product){
						
					$product_id = $key;
					$product_value = $product;	
					
					$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
					$wpdb->query($sql_product);
					
					}
					
					
					//Delete Old Opted Tags
					$sql_delete5 = "DELETE FROM`".$wpdb->prefix."am_newsletter_optedfrom_tags` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete5);
					
					//Insert Opted forms
					$opted_in = $_POST['opted_in'];
					foreach($opted_in as $key=>$opted){
						
					$opted_id = $key;
					$opted_value = $opted;	
					
					$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
					$wpdb->query($sql_opted);
					
					}
					
					
					//Delete Old Survey Tags
					$sql_delete6 = "DELETE FROM`".$wpdb->prefix."am_newsletter_survey_tags` WHERE newsletter_id = '".$newsletter_id."'";
					$wpdb->query($sql_delete6);
					
					//Insert Survey
					$survey_filter = $_POST['survey_filter'];
					foreach($survey_filter as $key=>$survey){
						
					$survey_id = $key;
					$survey_value = $survey;	
					
					$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
					$wpdb->query($sql_survey);
					
					}
					
					$message = "Record updated successfully!";
				}else {
					$message = "Record is already executed, you cannot update this record";
				}
				
			}
			
             //Get Newsletter Data
			 $newsletter_arr = $this->am_get_newsletter($_REQUEST['id']);
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 //Get all Emails
			 $emails_arr = $this->am_get_all_emails();
			 
			 //Get all Lessons
			 $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
             $lessons = get_posts( $args );
			 
			 //Get all Products
			 $products = $this->am_get_products();
			 
			 //Get all Optin-forms
			 $optin_forms_arr = $this->am_get_optin_forms();
			 
			 //Get all Survey
			 $all_survey = $this->am_get_all_survey();
			 
			 
			 //Get Newsletter Tags
			 $newsletter_tags = $this->am_get_newsletter_tags($_REQUEST['id']);
			 
			 $newtags_arr = array();
			 foreach($newsletter_tags as $tagval){
				 
				 $tag_id = $tagval->tag_id;
				 $tag_value = $tagval->value;
				 
				 $newtags_arr[$tag_id] = $tag_value;
			 }
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_opened = $this->am_get_newsletter_email_tags($_REQUEST['id'],'opened');
			 
			 $newtags_email_opended = array();
			 foreach($newsletter_email_tags_opened as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_opended[$email_id] = $email_value;
			 }
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_clicked = $this->am_get_newsletter_email_tags($_REQUEST['id'],'clicked');
			 
			 $newtags_email_clicked = array();
			 foreach($newsletter_email_tags_clicked as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_clicked[$email_id] = $email_value;
			 }
			 
			 //Get Newsletter Email Tags
			 $newsletter_email_tags_sent = $this->am_get_newsletter_email_tags($_REQUEST['id'],'sent');
			 
			 $newtags_email_sent = array();
			 foreach($newsletter_email_tags_sent as $tagval_email){
				 
				 $email_id = $tagval_email->email_id;
				 $email_value = $tagval_email->email_value;
				 
				 $newtags_email_sent[$email_id] = $email_value;
			 }
			 
			 //Get Newsletter Lesson Tags
			 $newsletter_lesson_tags = $this->am_get_newsletter_lesson_tags($_REQUEST['id']);
			 
			 $newtags_lesson = array();
			 foreach($newsletter_lesson_tags as $tagval_lesson){
				 
				 $lesson_id = $tagval_lesson->lesson_id;
				 $lesson_value = $tagval_lesson->lesson_value;
				 
				 $newtags_lesson[$lesson_id] = $lesson_value;
			 }
			 
			 //Get Newsletter Product Tags
			 $newsletter_product_tags = $this->am_get_newsletter_product_tags($_REQUEST['id']);
			 
			 $newtags_product = array();
			 foreach($newsletter_product_tags as $tagval_product){
				 
				 $product_id = $tagval_product->product_id;
				 $product_value = $tagval_product->product_value;
				 
				 $newtags_product[$product_id] = $product_value;
			 }
			 
			 //Get Newsletter Optedform Tags
			 $newsletter_optedform_tags = $this->am_get_newsletter_optedform_tags($_REQUEST['id']);
			 
			 $newtags_optedform = array();
			 foreach($newsletter_optedform_tags as $tagval_optedform){
				 
				 $optedform_id = $tagval_optedform->opted_id;
				 $optedform_value = $tagval_optedform->opted_value;
				 
				 $newtags_optedform[$optedform_id] = $optedform_value;
			 }
			 
			 
			 //Get Newsletter Survey Tags
			 $newsletter_survey_tags = $this->am_get_newsletter_survey_tags($_REQUEST['id']);
			 
			 $newtags_survey = array();
			 foreach($newsletter_survey_tags as $tagval_survey){
				 
				 $survey_id = $tagval_survey->survey_id;
				 $survey_value = $tagval_survey->survey_value;
				 
				 $newtags_survey[$survey_id] = $survey_value;
			 }
			 
			 
             require_once AM_PLUGIN_PATH.'templates/admin/am_edit_newsletter.php';
			
			
        }else{
         
         	if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  //Delete Newsletter Record
				  $this->am_delete_newsletter($_REQUEST['id']);
				  $message = "Record deleted successfully!";
			}
			
			
			//Get all Newsletters
			//$newsletters_arr = $this->am_get_all_newsletters();
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_newsletter.php';
        }
       
    }
	
	
	public function am_survey() {
		
		$html = '';
        $action = $_REQUEST['action'];
        
        ob_start();
        if( $action == 'add' ) {
			
            if( !empty($_POST['btnsave']) ) {
                
                global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_survey` (`survey_title`, `survey_image`, `survey_description`, `created_date` ) VALUES ('".$_POST['survey_title']."', '".$_POST['survey_image']."', '".$_POST['survey_description']."', '".$created_date."')";
                $wpdb->query($sql);
				
				$message = "Survey added successfully!";
               
            }
			
            wp_enqueue_script('wp-color-picker');
            wp_enqueue_script('media-upload');
            wp_enqueue_script('thickbox');
            wp_enqueue_style('thickbox');
            
            require_once AM_PLUGIN_PATH.'templates/admin/new_survey.php';
            $this->load_javascript();
			
			
        }elseif( $action == 'edit'){
			
            if( is_numeric($_REQUEST['id']) ) {
				
                if(!empty($_POST['btnsave']) ) {
                    
					global $wpdb;
				
					$sql_update = "UPDATE `".$wpdb->prefix."am_survey` SET survey_title = '".$_POST['survey_title']."', survey_image = '".$_POST['survey_image']."', survey_description = '".$_POST['survey_description']."' WHERE id = '".$_REQUEST['id']."'";
					$wpdb->query($sql_update);
					
                    $message = "Survey updated successfully!";
                }
				
                wp_enqueue_script('wp-color-picker');
                wp_enqueue_script('media-upload');
                wp_enqueue_script('thickbox');
                wp_enqueue_style('thickbox');
               
                $survey_arr = $this->am_get_survey($_REQUEST['id']);
				
                require_once AM_PLUGIN_PATH.'templates/admin/am_edit_survey.php';
                $this->load_javascript();
            }
        }else{
           
            
			if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  global $wpdb;
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_survey` WHERE id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $message = "Record deleted successfully!";
			}
		
		   
		    //Get all Survey
			$all_survey = $this->am_get_all_survey();
            
            require_once AM_PLUGIN_PATH.'templates/admin/am_survey.php';
			
        }
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
		
	}
	
	
    public function am_emails_categories() {
        
        $action = $_REQUEST['action'];
		
		//Get Settings
		$options = get_option( 'am_settings', array() );
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
       
        if( $action == 'add' ) {
            
             if(!empty($_POST['btnsave_tags'])){
				
				global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_emails_categories` (`category_name`, `created_date` ) VALUES ('".$_POST['name']."', '".$created_date."')";
                $wpdb->query($sql);
				
				$message = "Category added successfully!";
               
             }	
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new-emails_category.php';
            
        }elseif($action == 'edit' && is_numeric($_REQUEST['id'])){
			
			
            if(isset($_POST['btnsave_update'])) {
                
				global $wpdb;
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_emails_categories` SET category_name = '".$_POST['name']."' WHERE id = '".$_REQUEST['id']."'";
            	$wpdb->query($sql_update);
				
				$message = "Record updated successfully!";
            }
			
             //Get Category Data
			 $emails_category_arr = $this->am_get_emails_category($_REQUEST['id']);
			 
             require_once AM_PLUGIN_PATH.'templates/admin/am_edit_emails_category.php';
			
			
        }else{
         
         	
			if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  global $wpdb;
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_emails_categories` WHERE id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $message = "Record deleted successfully!";
			}
			
			
			//Get all Categories
			//$emails_categories_arr = $this->am_get_all_emails_categories();
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_emails_categories.php';
        }
       
    }
	
	
    public function am_tags() {
        
        $action = $_REQUEST['action'];
		
		//Get Settings
		$options = get_option( 'am_settings', array() );
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
       
        if( $action == 'add' ) {
            
             if(!empty($_POST['btnsave_tags'])){
				
				global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_tags` (`tag_name`, `created_date` ) VALUES ('".$_POST['tag_name']."', '".$created_date."')";
                $wpdb->query($sql);
				
				$tag_id = $wpdb->insert_id;
				
				$message = "Tag added successfully!";
				
				//print('<script>window.location.href="admin.php?page=am_tags&action=edit&id='.$tag_id.'"</script>');
				print('<script>window.location.href="admin.php?page=am_tags"</script>');
			    exit;
               
             }	
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new-tag.php';
            
        }elseif($action == 'edit' && is_numeric($_REQUEST['id'])){
			
			
            if(isset($_POST['btnsave_update'])) {
                
				global $wpdb;
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_tags` SET tag_name = '".$_POST['tag_name']."' WHERE id = '".$_REQUEST['id']."'";
            	$wpdb->query($sql_update);
				
				$message = "Record updated successfully!";
								print('<script>window.location.href="admin.php?page=am_tags"</script>');

            }
			
             //Get Tag Data
			 $tag_arr = $this->am_get_tag($_REQUEST['id']);
			 
             require_once AM_PLUGIN_PATH.'templates/admin/am_edit_tag.php';
			
			
        }else{
         
         	
			if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  global $wpdb;
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_tags` WHERE id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $message = "Record deleted successfully!";
			}
			
			
			//Get all Tags
			//$tags_arr = $this->am_get_all_tags();
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_tags.php';
        }
       
    }
        
    
	public function am_contacts() {
        global $wpdb;
        $action = $_REQUEST['action'];
		
		//Get Settings
		$options = get_option( 'am_settings', array() );
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
       
        if( $action == 'add' ) {
			$sql    = "SELECT * FROM `".$wpdb->prefix."am_contacts`";
			$results=$wpdb->get_results($sql);
			$contact_count=count($results);
			$am_lincense_key=constant('AM_LICENSE_KEY'); 
			
			
			
			if(empty($am_lincense_key) && $contact_count>=500)
			{
			?>
				<div id="message" class="error">
					<p><strong><?php echo __("Please enter a licence key in order to add a new contact.", 'am'); ?></strong></p>
				</div>
			<?php
				exit;
			}
            
             if(!empty($_POST['btnsave_contacts'])){
				 
				global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				$contact_tags = implode(',',$_POST['tag_id']);
				$contact_tags = ",".$contact_tags;
				$ip_address = get_ip_address();
				$ip_data=explode(".",$ip_address);

				$ip_data[count($ip_data)-1]="00";

				$ip_address="";

				foreach($ip_data as $ipdata)
				{
					$ip_address.=$ipdata.".";

				}

				$ip_address=rtrim($ip_address,".");
				
				 
				if($_FILES['csv_upload']['name']){

					$filename = str_replace(" ","-",$_FILES['csv_upload']['name']);
					$path= AM_PLUGIN_PATH.'assets/csv';
				 	$file_path =  $path."/".$filename;
					
					if(move_uploaded_file($_FILES['csv_upload']['tmp_name'], $file_path)) {
							
							include AM_PLUGIN_PATH.'assets/Classes/PHPExcel/IOFactory.php';
							$inputFileName = $file_path; 

							$lineData=explode("\n",file_get_contents($inputFileName))[0];
							$lineArr=explode(";",$lineData);
							$tagsCount=0;
							$tagsIndexes=array();
							
							foreach($lineArr as $key=>$val)
							{
								if(strstr($val,'"'))
								{
									$tagsCount++;
									$tagsIndexes[]=$key;
								}
							}
						
						
							$objPHPExcel = PHPExcel_IOFactory::load($inputFileName);
							$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
							$arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet
							$csv_fields = array_values($allDataInSheet[1]);
							
							if (strpos($csv_fields[0], ';') !== false) {
								
								$objReader = PHPExcel_IOFactory::createReader('CSV'); 
								$objReader->setDelimiter(";"); 
								$objPHPExcel = $objReader->load($inputFileName);
								
								$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
								$arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet
								$csv_fields = array_values($allDataInSheet[1]);
							}
							
						
							file_put_contents(dirname(__file__)."/csvData.log",print_r($lineData,true)."\n".print_r($csv_fields,true)."\n".print_r($allDataInSheet,true));
						
						
							require_once AM_PLUGIN_PATH.'templates/admin/new_contacts_csv_mapping.php';
							exit;
							
					}else{
					
						echo "Error in uploading";
					}
					
						
				}else{
				
				
				//Check No-Of Allowed Contacts
				$allowed_contacts = $this->check_no_of_allowed_contacts();
				
				if($allowed_contacts =='yes'){
					
				$checkemails = $wpdb->get_row("SELECT id,tags,optin_form_id FROM `".$wpdb->prefix."am_contacts` WHERE email_address = '".$_POST['email_address']."'");
				
				file_put_contents(dirname(__file__)."/contactsql.log",print_r($checkemails,true)."\n",FILE_APPEND);
			
				if(count($checkemails) == 0){
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` (`name`, `email_address`, `tags`, `status`, `created_date`, `created_by_ip`) VALUES ('".$_POST['contact_name']."', '".$_POST['email_address']."', '".$contact_tags."', '0' , '".$created_date."', '".$ip_address."')";
				
				
				
                $wpdb->query($sql);
				$contact_id = $wpdb->insert_id;
				
				}
				else
				{
					$upTags=explode(",",$checkemails->tags);
					$contact_tags=str_replace(",","",$contact_tags);
					
					if(!in_array($contact_tags,$upTags))
					{
						$upTags[]=$contact_tags;
					}
					
				
					
					$contact_tags=implode(",",$upTags);
					
					$sql = "UPDATE `".$wpdb->prefix."am_contacts` set name='".$_POST['contact_name']."',tags='$contact_tags' where email_address = '".$_POST['email_address']."'";
					$wpdb->query($sql);
					$contact_id = $checkemails->id;
				}
				
				file_put_contents(dirname(__file__)."/contactsql.log",$sql."\n",FILE_APPEND);
				
				
				
				///////////////////////////////////////////////////////////////////////
				////////////////******* Email Temaplates Trigger ******////////////////
				$this->am_check_registration_templates($_POST['tag_id'], $contact_id);
				////////////////******* End Email Temaplates Trigger ******////////////
				///////////////////////////////////////////////////////////////////////
				
				$message = "Contact added successfully!";
				$redirecturl = admin_url('admin.php?page=am_contacts'); 
				// header("Location: $redirecturl");
						print('<script>window.location.href="'.$redirecturl.'"</script>');
						exit;
				
				}else{
					
				$message = "No of allowed Contacts exceeded, please purchase license for more Contacts";
				
				}
				
				}
				
             }	
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new_contacts.php';
			 
            
        }elseif( $action == 'csv_mapped' ) {
            
             if(!empty($_POST['btnsave_contacts'])){
				 
				global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				$tag_id = $_POST['tag_id'];
				$contact_tags = $_POST['contact_tags'];
				$ip_address = get_ip_address();
				
				$ip_data=explode(".",$ip_address);

				$ip_data[count($ip_data)-1]="00";

				$ip_address="";

				foreach($ip_data as $ipdata)
				{
					$ip_address.=$ipdata.".";

				}

				$ip_address=rtrim($ip_address,".");
				
				
				
				include AM_PLUGIN_PATH.'assets/Classes/PHPExcel/IOFactory.php';
				
				$path= AM_PLUGIN_PATH.'assets/csv';
				$file_path =  $path."/".$_POST['filename'];
				
				$inputFileName = $file_path; 
				
				$objPHPExcel = PHPExcel_IOFactory::load($inputFileName);
				$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
				$arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet
				$check_csv_fields = array_values($allDataInSheet[1]);
				
				if (strpos($check_csv_fields[0], ';') !== false) {
								
					$objReader = PHPExcel_IOFactory::createReader('CSV'); 
					$objReader->setDelimiter(";"); 
					$objPHPExcel = $objReader->load($inputFileName);
					
					$allDataInSheet = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
					$arrayCount = count($allDataInSheet);  // Here get total count of row in that Excel sheet
				}
				
				$contact_tags_arr=explode(",",$contact_tags);
				$contact_indexes=explode(",",$_POST['tags_indexes']);
				for($i=1; $i<=$arrayCount; $i++){
						
						if($i != 1){ 
							
							$DataInSheet_arr = array_values($allDataInSheet[$i]);
							$tag_column=-1;
							$contactTags=$contact_tags_arr;
							for($z=0; $z<count($DataInSheet_arr); $z++){
								
								if($_POST['name_map_field'] == $z){
									$name = $DataInSheet_arr[$z];
								}
								else if($_POST['email_map_field'] == $z){
									$email = $DataInSheet_arr[$z];
								}
								else
								{
									if(in_array($z,$contact_indexes))
									{
										$tag_column++;
										if(!empty($DataInSheet_arr[$z]))
										{
											
											$contactTags[]=$_POST['tag_map_field'][$tag_column];
										}
									
									}
									
								
								}
							}
							
							
							//Check No-Of Allowed Contacts
							$allowed_contacts = $this->check_no_of_allowed_contacts();
						
							if($allowed_contacts =='yes'){
							
							if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
								continue;
							}
							//Insert Data into DB
							$email=trim($email);
							$checkemails = $wpdb->get_row("SELECT id,tags,optin_form_id FROM `".$wpdb->prefix."am_contacts` WHERE email_address = '".$email."'");
							
							$contactTags=array_unique($contactTags);
							
							$contact_tags_string=implode(",",$contactTags);	
								
								
							if(count($checkemails) == 0){
								
								$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` (`name`, `email_address`, `tags`, `status`, `created_date`, `created_by_ip` ) 
										VALUES ('".$name."', '".$email."', '".$contact_tags_string."', '0' ,'".$created_date."', '".$ip_address."')";
					
								$wpdb->query($sql);
								$contact_id = $wpdb->insert_id;
								
							}
							else
							{
								
								$upTags=explode(",",$checkemails->tags);
								$contact_tagss=str_replace(",","",$contact_tags);
								
								if(!in_array($contact_tagss,$upTags))
								{
									$upTags[]=$contact_tagss;
								}
								
								$cTags=array_merge($contactTags,$upTags);
								$cTags=array_unique($cTags);
								$contact_tagss=implode(",",$cTags);
								
								$sql = "UPDATE `".$wpdb->prefix."am_contacts` set name='".$name."',tags='$contact_tagss' where email_address = '".$email."'";
								$wpdb->query($sql);
								$contact_id = $checkemails->id;
								
							}
							
							file_put_contents(dirname(__file__)."/testingsql.log",$sql."\n",FILE_APPEND);
							
							///////////////////////////////////////////////////////////////////////
							////////////////******* Email Temaplates Trigger ******////////////////
							$this->am_check_registration_templates($tag_id, $contact_id);
							////////////////******* End Email Temaplates Trigger ******////////////
							///////////////////////////////////////////////////////////////////////
						
							$message = "Contact added successfully!";
							
							}else{
					
							$message = "No of allowed Contacts exceeded, please purchase license for more Contacts";
							
							}
							
						}
						
				}
				
             }	
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/new_contacts.php';
			 
            
        }elseif($action == 'edit' && is_numeric($_REQUEST['id'])){
			
			
            if(isset($_POST['btnsave_update'])) {
                
				global $wpdb;
				
				$contact_tags = implode(',',$_POST['tag_id']);
				$contact_tags = ",".$contact_tags;
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_contacts` SET name = '".$_POST['contact_name']."', email_address = '".$_POST['email_address']."', tags = '".$contact_tags."' WHERE id = '".$_REQUEST['id']."'";
				
            	$wpdb->query($sql_update);
				
				$message = "Record updated successfully!";
            }
			
             //Get Contact Data
			 $contact_arr = $this->am_get_contact($_REQUEST['id']);
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 
			 $contact_tags = explode(',',$contact_arr->tags);
             
			 require_once AM_PLUGIN_PATH.'templates/admin/am_edit_contact.php';
			
			
        }else{
         	
			
			if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  global $wpdb;
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_contacts` WHERE id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_filtered_contacts` WHERE contact_id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_newsletter_schedules` WHERE contact_id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $message = "Record deleted successfully2829!";
			}
			
			   if($action == 'tag') { $tag = $_POST['tag']; }
         	
			//Get all Contacts
			//$contacts_arr = $this->am_get_all_contacts($tag);
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_contacts.php';
        }
		
    }
    
    
     public function am_email_setting() {
        
        $action = $_REQUEST['action'];
		
		$current_user = wp_get_current_user();
		
		//Get Settings
		$options = get_option( 'am_settings', array() );
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
		
		if( $action == 'add' ) {
			// echo "<pre>";
			// print_r($_POST);
             if(!empty($_POST['btnsave_elasticEmail'])){
				 
				 
				 
				global $wpdb;
				
				$elastick_email_apikey = '8535ff91-62a5-48dd-af75-92e04c77af41';
			//	$admin_email = $current_user->user_email;
				$admin_email =$_POST['email_address'];
				//Generate Password
				
				$password='';
				$length = 8;
				$possible = "123467890abcdfghjkmnpqrtvwxyzABCDFGHJKLMNPQRTVWXYZ";
				$maxlength = strlen($possible);
				if ($length > $maxlength) {
					$length = $maxlength;
				}
		
				$i = 0; 
				while ($i < $length) { 
				$char = substr($possible, mt_rand(0, $maxlength-1), 1);
				if (!strstr($password, $char)) { 
				$password .= $char;
				$i++;
				}
				}
		
				$url = 'https://api.elasticemail.com/v2/account/addsubaccount';
				$data = array(
							'apikey' => $elastick_email_apikey,
							'email' => $admin_email,
							'password' => $password,
							'confirmPassword' => $password,
							'requiresEmailCredits' => 'False',
							'enableLitmusTest' => 'False',
							'requiresLitmusCredits' => 'False',
							'maxContacts' => '20000',
							'dailySendLimit' => '41000'
						);
		
				//use key 'http' even if you send the request to https://...
				$options = array(
							'http' => array(
							'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
							'method'  => 'POST',
							'content' => http_build_query($data)
						   ));
		
				$context  = stream_context_create($options);
				$result = file_get_contents($url, false, $context);
				$result_arr = json_decode($result);
				// print_r($result_arr);
				$sub_account_api_key = $result_arr->data;
				
				//file_put_contents(dirname(__file__)."/elemailresult.log",print_r($result_arr,true),FILE_APPEND);
				
				if($result_arr->success ==1){
					
				update_option('elastic_email_subaccount_apikey', $sub_account_api_key);
				update_option('elastic_email_subaccount_email', $admin_email);
				update_option('elastic_email_subaccount_password', $password);
				update_option( 'elastic_subAccount', 'yes');
				
				///////////////////////////////////////////////////////////////
				///////////////////Update User Information/////////////////////
				///////////////////////////////////////////////////////////////
				$url = 'https://api.elasticemail.com/v2/account/updateprofile';
				$upd_data = array(
							'apikey' => $sub_account_api_key,
							'firstName' => $_POST['first_name'],
							'lastName' => $_POST['last_name'],
							'phone' => $_POST['phone_number'],
							'address1' => $_POST['address'],
							'city' => $_POST['city'],
							'state' => $_POST['state'],
							'zip' => $_POST['zipcode'],
							'countryID' => $_POST['country']
							);
		// print_r($upd_data);
				//use key 'http' even if you send the request to https://...
				$options = array(
							'http' => array(
							'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
							'method'  => 'POST',
							'content' => http_build_query($upd_data)
						   ));
		
				$context  = stream_context_create($options);
				$upd_result = file_get_contents($url, false, $context);
				$upd_result_arr = json_decode($upd_result);
				
				$url="https://wiki.accessmember.de/pdf/pdf.php";
				 
				 $response = wp_remote_post( $url, array(
				'method'      => 'POST',
				'body'        => array(
					'elastic_user' => $admin_email,
					'first_name' => $_POST['first_name'],
					'last_name' => $_POST['last_name'],
					'zip' => $_POST['zipcode'],
					'city' => $_POST['city'],
					'address' => $_POST['address'],
					'country' => $_POST['country']
				
				)
				));


				if ( is_wp_error( $response ) ) {
					$error_message = $response->get_error_message();
					echo "Something went wrong: $error_message";
				} else {
					update_option("access_memeber_elastic_pdf",$response['body']);
					
				 
				}
				
				// echo "update profile";
				// print_r($upd_result_arr);
				/////////////////////////////////////////////////////////////
				/////////////////End Update User Information/////////////////
				/////////////////////////////////////////////////////////////
				
				
				/////////////////////////////////////////////////////////////
				/////////////////Update Notification URL ///////////////////
				/////////////////////////////////////////////////////////////
				$url = 'https://api.elasticemail.com/v2/account/addwebhook';
				$upd_data2 = array(
							'apikey' => $sub_account_api_key,
							'name'=>'email_response',
							'webNotificationUrl' => site_url().'/?action=get_email_response',
							'notificationForClicked'=>"true",
							'notificationForOpened'=>"true",
							'notificationForUnsubscribed'=>"true",
							'notificationForAbuseReport'=>"true",
							'notificationForError'=>"true"
							);
		
				//use key 'http' even if you send the request to https://...
				$options2 = array(
							'http' => array(
							'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
							'method'  => 'POST',
							'content' => http_build_query($upd_data2)
						   ));
		
				$context2  = stream_context_create($options2);
				$upd_result2 = file_get_contents($url, false, $context2);
				$upd_result_arr2 = json_decode($upd_result2);
				
				//file_put_contents(dirname(__file__)."/upd_result_arr2.log",print_r($upd_result_arr2,true),FILE_APPEND);
				/////////////////////////////////////////////////////////////
				/////////////////End Update Notification URL ////////////////
				/////////////////////////////////////////////////////////////
					
				$cron_url=home_url()."/am_emails_cronjob_schedule";
				$url='https://www.easycron.com/rest/add?token=2585051ab46d6d8dfcfbf7a972105671&cron_expression=*/20 * * * *&url='.urlencode($cron_url);
				$cronRetData = file_get_contents($url);
						

/*		
				//Send Email to Plugin Owner
				$mail_content = 'Hallo,<br> Dein Konto wurde erstellt:<br><br>';
				$mail_content .= 'Email Addresse / Nutzername: '.$admin_email."<br>";
				$mail_content .= 'Passwort : '.$password."<br><br>";
				$mail_content .= 'Login Link: <a href="https://elasticemail.com">https://elasticemail.com</a>';
		
				$body = nl2br($mail_content);
				$headers  = 'MIME-Version: 1.0' . "\r\n";
				$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
				$headers .= 'From: Access Member <'.$admin_email. "\r\n";
				
				$subject = "Elastic Email Account Details";
				mail($admin_email,$subject,$body,$headers);
	*/			
				$message = "Email System erfolgreich erstellt";
				
				}else{
		
				$message = $result_arr->error;
				$error = 1;
		
				}//end if account created
				
			 }
			 
		}
		
		
       
        if( $action == 'update' ) {
			
			if(!empty($_POST['update_ses_credentails'])){	
				
				update_option( 'elastick_email_apikey', $_POST['elastick_email_apikey'] );
				
				$message = "Record updated successfully!";	
			}
		}
        //update_option( 'elastic_subAccount', 'yes');
	    $elastic_email_subaccount_apikey = get_option( 'elastic_email_subaccount_apikey' );
		//update_option('elastic_subAccount','');
		$elastic_subAccount = get_option( 'elastic_subAccount' );
		
		require_once AM_PLUGIN_PATH.'templates/admin/am_email_setting.php';
    }
	
	
	/********** start of Added By Asif 13 March 2017 ********/
	public function custom_shortcode($atts)
	{
		global $wpdb;
		$optin_id = $atts['id'];
		if(is_numeric($optin_id))
		{
           $optin_form_html	=	$this->get_embed_optin_form($optin_id);
		   return $optin_form_html;
       	}
	}
	/********** end of Added By Asif 13 March 2017 ********/
	
	public function am_optin_frm() {
        
        $action = $_REQUEST['action'];
		
		if( isset($_POST['btnsave']) && $_POST['btnsave'] != "" ) {
            
            $exclude = array('btnsave');
            $options = get_option( 'am_settings', array() );
            
            foreach( $_POST as $k => $v ) {
                if( !in_array( $k, $exclude )) {
                    $options[$k] = $v;
                }
            }
			
		
            
			
            update_option( 'am_settings', $options );
			
            $message = 'OptinForm Settings Saved Successfully!';
        }
		
		//Get Settings
		$options = get_option( 'am_settings', array() );
		
		
		$license_settings = $this->am_check_plugin_license(AM_LICENSE_KEY);
       
        if( $action == 'add' ) {
            
			 if(!empty($_POST['btnsave_optinform']))
			 {
				
				global $wpdb;
				
				$created_date = date('Y-m-d G:i:s');
				$optin_tags	 = implode(',',$_POST['tag_id']);
				$optin_tags 	= ",".$optin_tags;
				
				$sql = "INSERT INTO `".$wpdb->prefix."am_optin_forms` (`subject`,`form_name`,`from_name`,`from_email`, `form_redirect_page_id`, `optin_confirmation`, `email_redirect_page_id`, `mail_content`, `company_name`, `address`,`tags`, `created_date`) VALUES ('".$_POST['subject']."','".$_POST['form_name']."','".$_POST['from_name']."','".$_POST['from_email']."', '".$_POST['form_redirect_page_id']."' , '".$_POST['optin_confirmation']."', '".$_POST['email_redirect_page_id']."', '".$_POST['mail_content']."', '".$_POST['company_name']."', '".$_POST['address']."','".$optin_tags."', '".$created_date."')";
				$wpdb->query($sql);
				$lastid = $wpdb->insert_id;
				$message = "Optin-form added successfully!";
				
				print('<script>window.location.href="admin.php?page=am_optin_frm&action=edit&id='.$lastid.'"</script>');
				exit;
				
            }
			 
			 
			 //Get All pages
			 $args = array(
							'sort_order' => 'asc',
							'sort_column' => 'post_title',
							'hierarchical' => 1,
							'post_type' => 'page',
							'post_status' => 'publish'
						);
						 
			 $pages = get_pages($args); 
			 
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 require_once AM_PLUGIN_PATH.'templates/admin/new_optin_frm.php';
             //require_once AM_PLUGIN_PATH.'templates/admin/am_edit_optin_form.php';
			
        }elseif($action == 'edit' && is_numeric($_REQUEST['id'])){
			
			
            if(isset($_POST['btnsave_update'])) {
                
				global $wpdb;
				
				$optin_tags	 = implode(',',$_POST['tag_id']);
				$optin_tags 	= ",".$optin_tags;
				
				$sql_update = "UPDATE `".$wpdb->prefix."am_optin_forms` SET subject = '".$_POST['subject']."',form_name = '".$_POST['form_name']."',from_name = '".$_POST['from_name']."',from_email = '".$_POST['from_email']."', form_redirect_page_id = '".$_POST['form_redirect_page_id']."', optin_confirmation = '".$_POST['optin_confirmation']."', email_redirect_page_id='".$_POST['email_redirect_page_id']."' , mail_content = '".$_POST['mail_content']."', company_name = '".$_POST['company_name']."', address = '".$_POST['address']."', tags = '".$optin_tags."', full_embed = '".$_POST['full_embed']."' WHERE id = '".$_REQUEST['id']."'";
				
            	$wpdb->query($sql_update);
				
				$message = "Record updated successfully!";
            }
			
             //Get Optin-Form Data
			 $optin_form_arr = $this->am_get_optin_form($_REQUEST['id']);
			 
			 //Get All pages
			 $args = array(
							'sort_order' => 'asc',
							'sort_column' => 'post_title',
							'hierarchical' => 1,
							'post_type' => 'page',
							'post_status' => 'publish'
						);
						 
			 $pages = get_pages($args);
			 
             
			 //Get all Tags
			 $tags_arr = $this->am_get_all_tags();
			 $optin_tags = explode(',',$optin_form_arr->tags);
			 
			 
			 
			 require_once AM_PLUGIN_PATH.'templates/admin/am_edit_optin_form.php';
			
			
        }else{
         
		 	
			if($action == 'del' && is_numeric($_REQUEST['id'])) {
			
				  global $wpdb;
				  
				  $sql_delete = "DELETE FROM`".$wpdb->prefix."am_optin_forms` WHERE id = '".$_REQUEST['id']."'";
				  $wpdb->query($sql_delete);
				  
				  $message = "Record deleted successfully!";
			}
			
			//Get all Optin-forms
			//$optin_forms_arr = $this->am_get_optin_forms();
			
            require_once AM_PLUGIN_PATH.'templates/admin/am_optin_frm.php';
        }
       
    }
    
    
    
    public function am_orders() {
        
        $action = $_REQUEST['action'];
        $html = '';
      
        if( $action == 'add' ) {
			$orders = $this->am_get_orders();
			
			$order_count=count($orders);
			$am_lincense_key=constant('AM_LICENSE_KEY'); 
			
			
			
			if(empty($am_lincense_key) && $order_count>=50)
			{
			?>
				<div id="message" class="error">
					<p><strong><?php echo __("Please enter a licence key in order to add a new order.", 'am'); ?></strong></p>
				</div>
			<?php
				exit;
			}
			
			
            if( isset($_POST['btnsave']) ) {
                //$order_id = uniqid();
				$order_id = 'by admin';
                if( !empty($_REQUEST['order_id']) ) {
                    $order_id = $_REQUEST['order_id'];
                }
                //$digi_product           = explode( "@@", $_POST['digi_product'] );
                //$product_id             = $digi_product[0];
                //$product_name           = $digi_product[1];
                if( !empty($_POST['product']) ) {
                    $db_product             = explode( "@@", $_POST['product'] );
                    $product_id             = $db_product[0];
                    $product_name           = $db_product[1];
                    $data['product_id']     = $product_id;
                    $data['product_name']   = $product_name;
                }
                if( !empty($_POST['offer']) ) {
                    $db_product             = explode( "@@", $_POST['offer'] );
                    $product_id             = $db_product[0];
                    $product_name           = $db_product[1];
                    $data['offer_id']       = $product_id;
                    $data['product_name']   = $product_name;
                }
                $data['order_id']       = $order_id;
                $data['email']          = $_REQUEST['email'];
                $data['first_name']     = $_REQUEST['first_name'];
                $data['last_name']      = $_REQUEST['last_name'];
                $data['status']         = $_REQUEST['status'];
                /*
                $products = $this->am_get_products();
                $found_product_id = 0;
                foreach( $products as $product ) {
                    $digi_products = maybe_unserialize($product->digi_products);
                    if( (is_array($digi_products) && in_array( $data['product_id'], $digi_products )) || ( !is_array($digi_products) && $digi_products == $data['product_id'] ) ) {
                        $found_product_id = $product->id;
                        $found_product_name = $product->product_name;
                        break;
                    }
                }
                
                if( $found_product_id ) {
                    $data['product_id']     = $found_product_id;
                    $data['product_name']   = $found_product_name;
                }
                */
                $order_id = $this->am_save_digistore24_order( $data );
                
                //if( $found_product_id ) {
                    $user_id = $this->am_register_new_user( $data );
                    if ( $user_id ) {
                        if( !empty($_POST['offer']) ) {
                            $this->am_save_product_member(array( 'offer_id'=> $data['offer_id'], 'user_id' => $user_id, 'order_id' => $order_id ));
                        }else{
                            $this->am_save_product_member(array( 'product_id'=> $data['product_id'], 'user_id' => $user_id, 'order_id' => $order_id ));
                        }
                        
                    }else{
                        echo $user_id->get_error_message();
                    }
                //}
				
				
				//Insert Record IN Contacts Table
				global $wpdb;
				$contact_name = $_REQUEST['first_name']." ".$_REQUEST['last_name'];
				$sql = "INSERT INTO `".$wpdb->prefix."am_contacts` (`user_id`, `name`, `email_address`, `tags` , `status`, `created_date`) VALUES ('".$user_id."','".$contact_name."', '".$_REQUEST['email']."' , '', 0, '".$created_date."')";
				$wpdb->query($sql);
				
                $message = "Order added successfully!";
            }
			
            $products = $this->am_get_products();
            $offers   = $this->am_get_offers();
            //$digi_products = $this->am_get_digistore24_products();
            require_once AM_PLUGIN_PATH.'templates/admin/am_add_order.php';
        }elseif( $action == 'edit' && is_numeric($_REQUEST['id']) ){
            if( isset($_POST['btnsave']) ) {
                //$order_id = uniqid();
				$order_id = 'by admin';
                if( !empty($_REQUEST['order_id']) ) {
                    $order_id = $_REQUEST['order_id'];
                }
                if( !empty($_POST['product']) ) {
                    $db_product             = explode( "@@", $_POST['product'] );
                    $product_id             = $db_product[0];
                    $product_name           = $db_product[1];
                    $data['product_id']     = $product_id;
                    $data['product_name']   = $product_name;
                }
                if( !empty($_POST['offer']) ) {
                    $db_product             = explode( "@@", $_POST['offer'] );
                    $product_id             = $db_product[0];
                    $product_name           = $db_product[1];
                    $data['offer_id']       = $product_id;
                    $data['product_name']   = $product_name;
                }
                $data['order_id']       = $order_id;                
                $data['email']          = $_REQUEST['email'];
                $data['first_name']     = $_REQUEST['first_name'];
                $data['last_name']      = $_REQUEST['last_name'];
                $data['status']         = $_REQUEST['status'];
                $data['id']             = $_REQUEST['id'];
                
                $this->am_update_digistore24_order( $data );
				
				$message = "Order updated successfully!";
				
            }
            $products = $this->am_get_products();
            $offers   = $this->am_get_offers();
            $orders = $this->am_get_orders( "id = '".$_REQUEST['id']."'" );
            $order  = array_shift( $orders );
            require_once AM_PLUGIN_PATH.'templates/admin/am_edit_order.php';
        }else{
            if( $action == 'del' && is_numeric($_REQUEST['id']) ) {
                if($this->am_del_order( $_REQUEST['id'] )){
                    $message = "Order deleted successfully!";
                }
            }
           // $orders = $this->am_get_orders( "1 ORDER BY id DESC" );
            require_once AM_PLUGIN_PATH.'templates/admin/am_orders.php';
        }
		
    
    }
    
    public function am_del_order( $id = '' ) {
        
        if( !is_numeric($id)) {
            return false;
        }
        
        global $wpdb;
        
        
        $sql = "DELETE FROM `".$wpdb->prefix."am_product_members` WHERE order_id = '".$id."'";
        $wpdb->query($sql);
        
        $sql = "DELETE FROM `".$wpdb->prefix."am_orders` WHERE id = '".$id."'";
        $wpdb->query($sql);
        return true;
    }
    
    public function am_save_module_name() {
        
        if( is_numeric( $_POST['module_id'] ) && isset( $_POST['module_name'] ) ) {
            $id = $_POST['module_id'];
            $name = $_POST['module_name'];
            global $wpdb;
            $sql = "UPDATE `".$wpdb->prefix."am_modules` SET name = '".$name."' WHERE id = '".$id."'";
            $wpdb->query($sql);
        }
    }
    
    public function am_save_post( $post_id ) {
        
		if( isset( $_POST['am_lesson_data'] ) 
                && is_array( $_POST['am_lesson_data'] ) 
                && sizeof( $_POST['am_lesson_data'] ) > 0 ) {
            update_post_meta( $post_id, '_am_lesson_data', $_POST['am_lesson_data'] );
        }
        
        if( isset( $_POST['am_coins'] ) ) {
            update_post_meta( $post_id, '_am_coins', $_POST['am_coins'] );
        }
		
		
		if(isset($_POST['question']) && is_array($_POST['question']) && sizeof($_POST['question']) > 0){
			
			$questions_arr = array();
			for($i=0; $i<count($_POST['question']); $i++){
				
				if($_POST['question'][$i] !=""){
				
				$questions_arr[$i]['qestion'] = $_POST['question'][$i];
				
				$ansname = 'answer_question'.$i;
				
				if($_POST[$ansname]=='question_option1'){
					
					$questions_arr[$i]['options'][] = $_POST['question_option1'][$i].'@@@answer';
					$questions_arr[$i]['options'][] = $_POST['question_option2'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option3'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option4'][$i];
					
				}
				if($_POST[$ansname]=='question_option2'){
					
					$questions_arr[$i]['options'][] = $_POST['question_option1'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option2'][$i].'@@@answer';
					$questions_arr[$i]['options'][] = $_POST['question_option3'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option4'][$i];
					
				}
				if($_POST[$ansname]=='question_option3'){
					
					$questions_arr[$i]['options'][] = $_POST['question_option1'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option2'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option3'][$i].'@@@answer';
					$questions_arr[$i]['options'][] = $_POST['question_option4'][$i];
					
				}
				if($_POST[$ansname]=='question_option4'){
					
					$questions_arr[$i]['options'][] = $_POST['question_option1'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option2'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option3'][$i];
					$questions_arr[$i]['options'][] = $_POST['question_option4'][$i].'@@@answer';
				}
				
				}//end if not empty
				
			}
			
			if(count($questions_arr)>0){
				
			//Delete Old Data
			$this->am_delete_all_lesson_quiz($post_id);
				
			for($c=0; $c<count($questions_arr); $c++){
					
				$created_date = date('Y-m-d G:i:s');
				
				$product_id = "";
				$lesson_id = $post_id;
				
				$qestion = $questions_arr[$c]['qestion'];	
				
				global $wpdb;
			 	
				$sql = "INSERT INTO `".$wpdb->prefix."am_quiz_questions` (`product_id`, `lesson_id`, `question`, `status`, `created_date` ) VALUES ('".$product_id."', '".$lesson_id."' , '".$qestion."' , '0' , '".$created_date."')";
				
                $wpdb->query($sql);
				
                $question_lastid = $wpdb->insert_id;
				
				for($d=0; $d<count($questions_arr[$c]['options']); $d++){
					
					$question_option = $questions_arr[$c]['options'][$d];
					$option_split = explode('@@@',$question_option);
					
					if($option_split[1]=="answer"){
						$option_asnwer = 1;
					}else{
						$option_asnwer = 0;
					}
					
					$sql222 = "INSERT INTO `".$wpdb->prefix."am_quiz_question_options` (`lesson_id`,`quiz_question_id`, `options`, `answer`) VALUES ('".$lesson_id."', '".$question_lastid."', '".$option_split[0]."' , '".$option_asnwer."')";
					
					 $wpdb->query($sql222);
					
				}//end for
			}//end for
			}//end if
			
		}//end if
		
		
    }
    
    public function am_lessons_sortable_columns( $columns ) {
        
        $columns['modules'] = 'module';
        return $columns;
    }
    
    public function am_display_lessons_columns( $column, $post_id ) {
        $data = get_post_meta( $post_id, '_am_lesson_data', true );
        if( $column == 'instructor' ) {
            echo $data['instructor_name'];
        }
        if( $column == 'duration' ) {
            if( !empty($data['duration'])) {
                echo $data['duration']." ".__( "minutes", "am" );
            }
        }
        if( $column == 'products' ) {
            $am_course_struc = $this->am_get_course_structure( "lesson_id = '".$post_id."'" );
            $product_ids = array();
            foreach( $am_course_struc as $lesson ) {
                $product_ids[] = $lesson->product_id;
            }
            $product_ids = array_unique($product_ids);
            $products = $this->am_get_products( "id IN( ".implode(",",$product_ids)." )" );
            foreach( $products as $product ) {
                $products_names[] = $product->product_name;
            }
            echo implode(", ",$products_names);
        }
        if( $column == 'modules' ) {
            $am_course_struc = $this->am_get_course_structure( "lesson_id = '".$post_id."'" );
            $module_ids = array();
            foreach( $am_course_struc as $lesson ) {
                $module_ids[] = $lesson->module_id;
            }
            $module_ids = array_unique($module_ids);
            update_post_meta( $post_id, 'am_lesson_first_module', $module_ids[0] );
            $modules = $this->am_get_modules( "id IN( ".implode(",",$module_ids)." )" );
            foreach( $modules as $module ) {
                $modules_names[] = $module->name;
            }
            echo implode(", ",$modules_names);
        }
    }
    
    public function am_add_lessons_columns( $columns ) {
        unset($columns['date']);
        return array_merge($columns, 
              array('instructor' => __('Instructor', 'am' ),
                    'duration' =>__( 'Duration', 'am' ),
                    'products' =>__( 'Product(s)', 'am' ),
                    'modules' =>__( 'Module(s)', 'am' ),
                    'date' =>__( 'Date', 'am' ),
                  ));
    }

    public function am_register_meta_boxes( $post_type ) {
        
        if ( $post_type == 'lessons' ) {
            /*add_meta_box(
                'am_lessons',
                __( 'Lesson Settings', 'am' ),
                array( $this, 'am_lessons_metabox' ),
                array($post_type),
                'advanced',
                'high'
            );*/
			
			add_meta_box(
                'am_lessons_quiz',
                __( 'Lesson Quiz', 'am' ),
                array( $this, 'am_lessons_quiz_metabox' ),
                array($post_type),
                'advanced',
                'high'
            );
			
        }
		
		
        /*
        $include = array( 'lessons', 'post', 'page' );
        if( in_array( $post_type, $include ) ) {
            add_meta_box(
                'am_coins',
                __( 'Coins Management', 'am' ),
                array( $this, 'am_coins_metabox' ),
                array($post_type),
                'side',
                'high'
            );
        }*/
    }
    
    public function am_coins_metabox( $post ) {
        
        $coins = $this->am_get_post_coins($post->ID);
        // Display the form, using the current value.
        $html = '';
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/admin/am_coins_metabox.php';
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
    
    public function am_lessons_metabox( $post ) {
        
        // Use get_post_meta to retrieve an existing value from the database.
        $data = get_post_meta( $post->ID, '_am_lesson_data', true );
        
        $pages = get_pages(); 
        
        // Display the form, using the current value.
        $html = '';
        ob_start();
        require_once AM_PLUGIN_PATH.'templates/admin/am_lessons_metabox.php';
        $this->load_javascript();
        $html = ob_get_contents();
        ob_end_clean();
        echo $html;
    }
	
	
	public function am_lessons_quiz_metabox( $post ) {
		
		
		if(isset($_GET['qzaction']) && $_GET['qzaction']=='deletequiz'){
		
			$question_id = $_GET['question_id'];
			
			//Delete Quiz Question
			$this->am_delete_quiz_question($question_id);
		}
		
		 $post_id = $post->ID;
		 
		 //Get all Lesson Quiz Questions
		 $all_lesson_quiz = $this->am_get_all_lesson_quiz($post_id);
		 
         // Display the form, using the current value.
         $html = '';
         ob_start();
		 require_once AM_PLUGIN_PATH.'templates/admin/am_lesson_quiz_metabox.php';
		 $this->load_javascript();
         $html = ob_get_contents();
         ob_end_clean();
         echo $html;
        
    }
	
    
    public function am_add_product_lesson() {
        
        $module_id = $_REQUEST['module_id'];
        $html = '';
        $js = '';
        $error = false;
        if( !empty($module_id) ) {
            $modules = $this->am_get_modules( "id = '".$module_id."'" );
            if( !empty($modules) ) {
                $module = array_shift($modules);
                $lesson_id = uniqid();
                $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'any' ); 
                $lessons = get_posts( $args );
                ob_start();
                require_once AM_PLUGIN_PATH.'templates/admin/am_get_course_lesson.php';
                $html = ob_get_contents();
                ob_end_clean();
                $js = '$( ".am_datepicker" ).datetimepicker( "destroy" );$( ".am_datepicker" ).datetimepicker({format:"d.m.Y H:i"});';
            }else{
                $error = true;
                $html = __( 'You should select some module!', 'am' );
            }            
        }else{
            $error = true;
            $html = __( 'You should select some module!', 'am' );
        }
        $return = array( 'error'=> $error, 'content' => $html, 'js' => $js );
        
        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
    
    public function am_load_product_module() {
        
        $module_id = $_REQUEST['id'];
        $html = '';
        $js = '';
        $error = false;
        if( !empty($module_id) ) {
            $modules = $this->am_get_modules( "id = '".$module_id."'" );
            if( !empty($modules) ) {
                $module = array_shift($modules);
                ob_start();
                require_once AM_PLUGIN_PATH.'templates/admin/am_get_course_arch.php';
                $html = ob_get_contents();
                ob_end_clean();
                $js = 'Sortable.create(am_product_lessons_list'.$module_id.', {animation: 150});';
            }else{
                $error = true;
                $html = __( 'You should select some module!', 'am' );
            }            
        }else{
            $error = true;
            $html = __( 'You should select some module!', 'am' );
        }
        $return = array( 'error'=> $error, 'content' => $html, 'js' => $js );
        
        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
    
    public function am_add_product_module() {
        global $wpdb;
        $module_name = $_REQUEST['name'];
        $html = '';
        $error = false;
        if( !empty($module_name) ) {
            //$modules = $this->am_get_modules( "name = '".$module_name."'" );
            //if( empty($modules) ) {
                $sql = "INSERT INTO `".$wpdb->prefix."am_modules` ( `id`, `name`, `module_timestamp` ) VALUES ( '', '".$module_name."', '".strtotime('now')."' )";
                $wpdb->query($sql);
                $lastid = $wpdb->insert_id;
                $html = '<option value="'.$lastid.'">'.$module_name.'</option>';
            //}else{
            //    $error = true;
            //    $html = 'Same module has added already!';
            //}
        }else{
            $error = true;
            $html = __( 'You should provide some module name!', 'am' );
        }        
        $return = array( 'error'=> $error, 'content' => $html, 'id' => $lastid );
        
        header('Content-Type: application/json');
        echo json_encode($return);
        exit();
    }
    
    public function am_products() {
	
        
        $html = '';
        $action = $_REQUEST['action'];
        
        ob_start();
        if( $action == 'add' ) {
			$products = $this->am_get_products();
			
			$product_count=count($products);
			$am_lincense_key=constant('AM_LICENSE_KEY'); 
			
			
			
			if(empty($am_lincense_key) && $product_count>=1)
			{
			?>
				<div id="message" class="error">
					<p><strong><?php echo __("Please enter a licence key in order to add a new product.", 'am'); ?></strong></p>
				</div>
			<?php
				exit;
			}
			
            if( !empty($_POST['btnsave']) ) {
				
                if($_POST){
					//echo "<pre>";
						//print_r($_POST);
					$ProductId  =  $this->am_save_product($_POST);
					
				//	echo $ProductId;
					$course_structures = $this->am_get_course_structure( "product_id = '".$ProductId."' ORDER BY id ASC" );
                    $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'any' ); 
                    $lessons = get_posts( $args );
					$message = "Product added successfully!";
                }
            }
            wp_enqueue_script('wp-color-picker');
            wp_enqueue_script('media-upload');
            wp_enqueue_script('thickbox');
            wp_enqueue_style('thickbox');
            wp_enqueue_style( 'wp-color-picker' );
            $digi_products = $this->am_get_digistore24_products();
            $modules = $this->am_get_modules();
            $pages = get_pages(); 
            $args = array( 'post_type' => 'post', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
            $posts = get_posts( $args );
            $fonts = $this->am_get_html_fonts();
            $options = get_option( 'am_settings', array() );
			
			require_once AM_PLUGIN_PATH.'templates/admin/am_add_product.php';
            $this->load_javascript();
        }elseif( $action == 'clone' ){
            if( is_numeric($_REQUEST['id']) ) {
                $this->am_clone_product($_REQUEST['id']);
            }
            $products = $this->am_get_products();
            $course_structures = $this->am_get_course_structure();
            $members = $this->am_get_products_members();
            require_once AM_PLUGIN_PATH.'templates/admin/am_products.php';
        }elseif( $action == 'del' ) {
            if( is_numeric($_REQUEST['id']) ) {
                $this->am_del_product($_REQUEST['id']);
                $products = $this->am_get_products();
                $course_structures = $this->am_get_course_structure();
                $members = $this->am_get_products_members();
                require_once AM_PLUGIN_PATH.'templates/admin/am_products.php';
            }
        }elseif( $action == 'edit' ) {
            if( is_numeric($_REQUEST['id']) ) {
                if( !empty($_POST['btnsave']) ) {
                    if($this->am_update_product($_POST)) {
                        $message = "Product updated successfully!";
                    }
                }
                wp_enqueue_script('wp-color-picker');
                wp_enqueue_script('media-upload');
                wp_enqueue_script('thickbox');
                wp_enqueue_style('thickbox');
                wp_enqueue_style( 'wp-color-picker' );
                $products = $this->am_get_products( "id = '".$_REQUEST['id']."'" );
                $product  = array_shift( $products );
                $course_structures = $this->am_get_course_structure( "product_id = '".$_REQUEST['id']."' ORDER BY id ASC" );
                $digi_products = $this->am_get_digistore24_products();
                $modules = $this->am_get_modules();
                $args = array( 'post_type' => 'lessons', 'posts_per_page' => -1, 'post_status' => 'any' ); 
                $lessons = get_posts( $args );
                $pages = get_pages();
                $args = array( 'post_type' => 'post', 'posts_per_page' => -1, 'post_status' => 'publish' ); 
                $posts = get_posts( $args );
                $fonts = $this->am_get_html_fonts();
			
                require_once AM_PLUGIN_PATH.'templates/admin/am_edit_product.php';
                $this->load_javascript();
            }
        }else{
            $products = $this->am_get_products();
            $course_structures = $this->am_get_course_structure();
            $members = $this->am_get_products_members( "product_id != ''" );
            require_once AM_PLUGIN_PATH.'templates/admin/am_products.php';
        }
        $html = ob_get_contents();
        ob_end_clean();
		
        echo $html;
    }
    
    private function am_get_html_fonts() {
        
        $fonts = array();
        
        $options = get_option( 'am_settings', array() );
        $google_fonts = array_map( 'trim',explode( "\n", $options['google_fonts'] ) );
        $other_fonts = array( 'Georgia, serif', 'Times, serif', 'Arial, Helvetica, sans-serif', 'Gadget, sans-serif', 'cursive, sans-serif', 'Impact, Charcoal, sans-serif', 'sans-serif', 'Tahoma, Geneva, sans-serif', 'Helvetica, sans-serif', 'Verdana, Geneva, sans-serif', 'Courier, monospace', 'Monaco, monospace' );
        
        $fonts = array_merge($other_fonts, $google_fonts);
        asort($fonts);
        return $fonts;
    }
    
    public function am_clone_product( $product_id = '' ) {
        
        if( empty($product_id) ) {
            return false;
        }
        
        global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_product_course_structure` WHERE product_id = '".$product_id."' ORDER BY id ASC";
        $product_structure = $wpdb->get_results($sql);
        
        $sql = "SELECT * FROM `".$wpdb->prefix."am_products` WHERE id = '".$product_id."'";
        $product = $wpdb->get_row($sql);
        $attr = "";
        $attr_val = "";
        foreach ( $product as $k=>$val ) {
            if( $attr == "" ) {
                $attr.="`".$k."`";
                $attr_val.="''";                
            }else{
                $attr.=", `".$k."`";
                $attr_val.=", '".stripslashes($val)."'";                
            }
        }
        $sql = "INSERT INTO `".$wpdb->prefix."am_products` (".$attr.") VALUES (".$attr_val.")";
        $wpdb->query($sql);
        
        $product_id = $wpdb->insert_id;
        
        foreach ($product_structure as $product_structure_row ) {
            $sql = "INSERT INTO `".$wpdb->prefix."am_product_course_structure` ( `product_id`, `module_id`, `lesson_id`, `free_access_start`, `free_access_end`, `days_delay`, `module_position`, `lesson_position` ) "
                    . "VALUES ( '".$product_id."', '".$product_structure_row->module_id."', '".$product_structure_row->lesson_id."', '".$product_structure_row->free_access_start."', '".$product_structure_row->free_access_end."', '".$product_structure_row->days_delay."', '".$product_structure_row->module_position."', '".$product_structure_row->lesson_position."' )";
            $wpdb->query($sql);
        }
        
        $data['product_name'] = $product->product_name;
        
        $this->am_insert_product_page( $data, $product_id );
        
        return true;
    }
    
    public function am_del_product( $product_id = '' ) {
        if( empty($product_id) ) {
            return false;
        }
        
        global $wpdb;
        
        $sql = "DELETE FROM `".$wpdb->prefix."am_products` WHERE id = '".$product_id."'";
        $wpdb->query($sql);
        $sql = "DELETE FROM `".$wpdb->prefix."am_product_course_structure` WHERE product_id = '".$product_id."'";
        $wpdb->query($sql);
        $sql = "DELETE FROM `".$wpdb->prefix."am_product_members` WHERE product_id = '".$product_id."'";
        $wpdb->query($sql);
        $sql = "DELETE FROM `".$wpdb->prefix."am_offer_structure` WHERE product_id = '".$product_id."'";
        $wpdb->query($sql);
		
		//Delete Old Data
		$sql11 = "DELETE FROM `".$wpdb->prefix."am_product_pages_structure` WHERE product_id = '".$product_id."'";
		$wpdb->query($sql11);
        
        $product_page = $this->am_get_product_page($product_id);
        wp_delete_post( $product_page, true );
        
        return true;
    }
    
    public function am_update_product( $data = array() ) {
		
        if( !is_array($data) || sizeof($data) == 0 ) {
            return false;
        }
        global $wpdb;
        $id = $data['id'];
        $exclude = array( 'id','btnsave', 'am_product_modules', 'am_product_add_module', 'modules', 'lessons', 'free_access_start', 'free_access_end', 'evergreen_start_day', 'evergreen_start_hour', 'evergreen_end_day', 'evergreen_end_hour', 'days_delay', 'tokens', 'module_names', 'evergreen_start_day', 'evergreen_start_hour', 'evergreen_end_day', 'evergreen_end_hour', 'page_free_access_start', 'page_days_delay', 'page_evergreen_start_day', 'page_evergreen_start_hour', 'page_evergreen_end_day', 'page_evergreen_end_hour', 'page_coins', 'post_free_access_start', 'post_free_access_end', 'post_days_delay', 'post_evergreen_start_day', 'post_evergreen_start_hour', 'post_evergreen_end_day', 'post_evergreen_end_hour', 'post_coins' );
        $attr = "";
        foreach( $data as $k=>$val ) {
            if(is_array($val)) {
                $val = maybe_serialize($val);
            }
            $should_insert = true;
            foreach( $exclude as $v ) {
                $pos = strpos($k, $v);
                if ($pos !== false) {
                    $should_insert = false;
                    break;
                }
            }
            if( $should_insert ) {
                if( $attr == "" ) {
                    $attr.="`".$k."` = '".$val."'";                    
                }else{
					
						if($k == "digi_products"){
						$digivalue = $data['selected_product'];
						
						$attr.=", `".$k."` = '".$digivalue."'";
	
					}else{
						$attr.=", `".$k."` = '".$val."'";
					}
                }                
            }
        }
        $arr_all_vals = array( 'product_name', 'enable_sumit', 'enable_delay_access', 'enable_evergreen', 'enable_coins', 'digi_products', 'product_secure_posts', 'product_secure_pages',
            'login_redirect', 'error_redirect', 'error_text', 'lock_user_on_no_payment', 'lock_redirect', 
            'enable_adv', 'adv_image', 'adv_url', 'module_bg_color', 'module_text_color', 'module_text_size', 'module_text_font', 
            'lesson_bg_color', 'lesson_text_color', 'lesson_text_size', 'lesson_text_font', 'access_symbol_active_color', 
            'access_symbol_inactive_color', 'module_tab', 'sticky_menu', 'scrollbar', 'auto_scroll', 'post_duriation_text_color', 'post_duriation_text_size', 
            'post_duriation_text_font', 'instructor_text_color', 'instructor_text_size', 'instructor_text_font' );
        
        $attr_default = "";
        foreach( $arr_all_vals as $val ) {            
            if( $attr_default == "" ) {
                $attr_default.="` ".$val."` = ''";                    
            }else{
                $attr_default.=", `".$val."` = ''";
            }            
        }
        $sql = "UPDATE `".$wpdb->prefix."am_products` SET ".$attr_default." WHERE id = '".$id."'";
		$wpdb->query($sql);
        
        $sql = "UPDATE `".$wpdb->prefix."am_products` SET ".$attr." WHERE id = '".$id."'";
        $wpdb->query($sql);
      
	  
	   //$sql = "UPDATE `".$wpdb->prefix."am_products` SET ".$attr." WHERE id = '".$id."'";
        //$wpdb->query($sql);
        $product_id = $id;
        $sql = "DELETE FROM `".$wpdb->prefix."am_product_course_structure` WHERE product_id = '".$product_id."'";
        $wpdb->query($sql);
        if( is_array($data['modules']) && sizeof($data['modules']) > 0 && $product_id ) {
            $module_counter = 0;
            foreach( $data['modules'] as $module_id ) {
                $module_counter++;
                if( is_array($data['lessons_'.$module_id]) && sizeof($data['lessons_'.$module_id]) > 0 ) {
                    $lesson_counter = 0;
                    foreach( $data['lessons_'.$module_id] as $lesson_id ) {
                        $lesson_counter++;
                        $sql = "INSERT INTO `".$wpdb->prefix."am_product_course_structure` ( `product_id`, `module_id`, `lesson_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`, `module_position`, `lesson_position` ) VALUES ( '".$product_id."', '".$module_id."', '".$lesson_id."', '".strtotime($data['free_access_start_'.$module_id.'_'.$lesson_id])."', '".strtotime($data['free_access_end_'.$module_id.'_'.$lesson_id])."', '".$data['evergreen_start_day_'.$module_id.'_'.$lesson_id]."', '".$data['evergreen_start_hour_'.$module_id.'_'.$lesson_id]."', '".$data['evergreen_end_day_'.$module_id.'_'.$lesson_id]."', '".$data['evergreen_end_hour_'.$module_id.'_'.$lesson_id]."', '".$data['days_delay_'.$module_id.'_'.$lesson_id]."', '".$data['tokens_'.$module_id.'_'.$lesson_id]."', '".$module_counter."', '".$lesson_counter."' )";
                        $wpdb->query($sql);
                    }
                }
            }
        }
        
        $product_page = $this->am_get_product_page($product_id);
        if ( 'publish' != get_post_status ( $product_page ) ) {
            $this->am_insert_product_page( $data, $product_id );
        } 
		
		
		//Delete Old Data
		$sql11 = "DELETE FROM `".$wpdb->prefix."am_product_pages_structure` WHERE product_id = '".$product_id."'";
		$wpdb->query($sql11);
		
		//Insert Product Pages Structure
		if(count($data['product_secure_pages'])>0){
			for($i=0; $i<count($data['product_secure_pages']); $i++){
			
				$page_id = $data['product_secure_pages'][$i];
				
				if(count($data['page_free_access_start'][$page_id])>0){
					$structure_arr = $data['page_free_access_start'][$page_id];	
				}elseif(count($data['page_free_access_end'][$page_id])>0){
					$structure_arr = $data['page_free_access_end'][$page_id];	
				}elseif(count($data['page_days_delay'][$page_id])>0){
					$structure_arr = $data['page_days_delay'][$page_id];	
				}elseif(count($data['page_evergreen_start_day'][$page_id])>0){
					$structure_arr = $data['page_evergreen_start_day'][$page_id];	
				}elseif(count($data['page_evergreen_start_hour'][$page_id])>0){
					$structure_arr = $data['page_evergreen_start_hour'][$page_id];	
				}elseif(count($data['page_evergreen_end_day'][$page_id])>0){
					$structure_arr = $data['page_evergreen_end_day'][$page_id];	
				}elseif(count($data['page_evergreen_end_hour'][$page_id])>0){
					$structure_arr = $data['page_evergreen_end_hour'][$page_id];	
				}elseif(count($data['page_coins'][$page_id])>0){
					$structure_arr = $data['page_coins'][$page_id];	
				}	
					
				if(count($structure_arr)>0){	
					for($j=0; $j<count($structure_arr); $j++){
						
						if($data['enable_sumit']=='yes'){
						$page_free_access_start = $data['page_free_access_start'][$page_id][$j];
						$page_free_access_end = $data['page_free_access_end'][$page_id][$j];
						}else{
						$page_free_access_start = "";
						$page_free_access_end = "";	
						}
						
						if($data['enable_evergreen']=='yes'){
						$page_evergreen_start_day = $data['page_evergreen_start_day'][$page_id][$j];
						$page_evergreen_start_hour = $data['page_evergreen_start_hour'][$page_id][$j];
						$page_evergreen_end_day = $data['page_evergreen_end_day'][$page_id][$j];
						$page_evergreen_end_hour = $data['page_evergreen_end_hour'][$page_id][$j];
						}else{
						$page_evergreen_start_day = "";
						$page_evergreen_start_hour = "";
						$page_evergreen_end_day = "";
						$page_evergreen_end_hour = "";	
						}
						
						if($data['enable_delay_access']=='yes'){
						$page_days_delay = $data['page_days_delay'][$page_id][$j];
						}else{
						$page_days_delay = "";
						}
						
						if($data['enable_coins']=='yes'){
						$page_coins = $data['page_coins'][$page_id][$j];
						}else{
						$page_coins = "";
						}
						
						$sql2222 = "INSERT INTO `".$wpdb->prefix."am_product_pages_structure` ( `product_id`, `page_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`) VALUES ( '".$product_id."', '".$page_id."', '".strtotime($page_free_access_start)."', '".strtotime($page_free_access_end)."', '".$page_evergreen_start_day."', '".$page_evergreen_start_hour."', '".$page_evergreen_end_day."', '".$page_evergreen_end_hour."', '".$page_days_delay."', '".$page_coins."')";
                        $wpdb->query($sql2222);
					}
				}
					
			}//end for
		}//end if
		
		//Insert Product Posts Structure
		if(count($data['product_secure_posts'])>0){
			for($k=0; $k<count($data['product_secure_posts']); $k++){
			
				$post_id = $data['product_secure_posts'][$k];
				
				if(count($data['post_free_access_start'][$post_id])>0){
					$structure_arr2 = $data['post_free_access_start'][$post_id];	
				}elseif(count($data['post_free_access_end'][$post_id])>0){
					$structure_arr2 = $data['post_free_access_end'][$post_id];	
				}elseif(count($data['post_days_delay'][$post_id])>0){
					$structure_arr2 = $data['post_days_delay'][$post_id];	
				}elseif(count($data['post_evergreen_start_day'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_start_day'][$post_id];	
				}elseif(count($data['post_evergreen_start_hour'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_start_hour'][$post_id];	
				}elseif(count($data['post_evergreen_end_day'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_end_day'][$post_id];	
				}elseif(count($data['post_evergreen_end_hour'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_end_hour'][$post_id];	
				}elseif(count($data['post_coins'][$post_id])>0){
					$structure_arr2 = $data['post_coins'][$post_id];	
				}	
					
				if(count($structure_arr2)>0){	
					for($l=0; $l<count($structure_arr2); $l++){
						
						if($data['enable_sumit']=='yes'){
						$post_free_access_start = $data['post_free_access_start'][$post_id][$l];
						$post_free_access_end = $data['post_free_access_end'][$post_id][$l];
						}else{
						$post_free_access_start = "";
						$post_free_access_end = "";	
						}
						
						if($data['enable_evergreen']=='yes'){
						$post_evergreen_start_day = $data['post_evergreen_start_day'][$post_id][$l];
						$post_evergreen_start_hour = $data['post_evergreen_start_hour'][$post_id][$l];
						$post_evergreen_end_day = $data['post_evergreen_end_day'][$post_id][$l];
						$post_evergreen_end_hour = $data['post_evergreen_end_hour'][$post_id][$l];
						}else{
						$post_evergreen_start_day = "";
						$post_evergreen_start_hour = "";
						$post_evergreen_end_day = "";
						$post_evergreen_end_hour = "";	
						}
						
						if($data['enable_delay_access']=='yes'){
						$post_days_delay = $data['post_days_delay'][$post_id][$l];
						}else{
						$post_days_delay = "";
						}
						
						if($data['enable_coins']=='yes'){
						$post_coins = $data['post_coins'][$post_id][$l];
						}else{
						$post_coins = "";
						}
						
						
						$sql3333 = "INSERT INTO `".$wpdb->prefix."am_product_pages_structure` ( `product_id`, `page_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`) VALUES ( '".$product_id."', '".$post_id."', '".strtotime($post_free_access_start)."', '".strtotime($post_free_access_end)."', '".$post_evergreen_start_day."', '".$post_evergreen_start_hour."', '".$post_evergreen_end_day."', '".$post_evergreen_end_hour."', '".$post_days_delay."', '".$post_coins."')";
                        $wpdb->query($sql3333);
					}
				}
					
			}//end for
		}//end if
		
		       
        return true;
    }
    
    public function am_insert_product_page( $data = array(), $product_id ) {
        
        if( !is_array($data) || sizeof($data) == 0 ) {
            return false;
        }
        
        global $user_ID, $wpdb;
        $page['post_type']    = 'page';
        $page['post_author']  = $user_ID;
        $page['post_status']  = 'publish';
        $page['comment_status'] = 'open';
        $page['post_title']   = $data['product_name'];
        $page['post_content'] = '[am_product id="'.$product_id.'"]';

        $pageid = wp_insert_post( $page, true );

        if ($pageid != 0) {  
            $sql = "UPDATE `".$wpdb->prefix."am_products` SET `product_page` = '".$pageid."', `login_redirect` = '".$pageid."' WHERE id = '".$product_id."'";
            $wpdb->query($sql);
            $options = get_option( 'am_settings', array() );
            if( !empty($options['wp_page_template'])) {
                update_post_meta( $pageid, '_wp_page_template', $options['wp_page_template'] );
                update_post_meta( $pageid, '_am_product_id', $product_id );
            }
        }
    }
    
    public function am_save_product( $data = array() ) {
        
        if( !is_array($data) || sizeof($data) == 0 ) {
            return false;
        }
        global $wpdb;
		
		/*echo "<pre>";
		print_r($data);
		exit;*/
        
        $exclude = array( 'btnsave', 'am_product_modules', 'am_product_add_module', 'modules', 'lessons', 'free_access_start', 'free_access_end', 'days_delay', 'tokens', 'module_names', 'digimember_product', 'import_engine', 'evergreen_start_day', 'evergreen_start_hour', 'evergreen_end_day', 'evergreen_end_hour', 'page_free_access_start', 'page_days_delay', 'page_evergreen_start_day', 'page_evergreen_start_hour', 'page_evergreen_end_day', 'page_evergreen_end_hour', 'page_coins', 'post_free_access_start', 'post_free_access_end', 'post_days_delay', 'post_evergreen_start_day', 'post_evergreen_start_hour', 'post_evergreen_end_day', 'post_evergreen_end_hour', 'post_coins' );
        $attr = "";
        $attr_val = "";
        foreach( $data as $k=>$val ) {
            if(is_array($val)) {
                $val = maybe_serialize($val);
            }
            $should_insert = true;
            foreach( $exclude as $v ) {
                $pos = strpos($k, $v);
                if ($pos !== false) {
                    $should_insert = false;
                    break;
                }
            }
            if( $should_insert ) {
                if( $attr == "" ) {
                    $attr.="`".$k."`";
                    $attr_val.="'".$val."'";
                }else{
                    $attr.=", `".$k."`";
                    $attr_val.=", '".$val."'";
                }                
            }
        }
        $sql = "INSERT INTO `".$wpdb->prefix."am_products` (".$attr.") VALUES (".$attr_val.")";
        $wpdb->query($sql);
        $product_id = $wpdb->insert_id;
        if( is_array($data['modules']) && sizeof($data['modules']) > 0 && $product_id ) {
            $module_counter = 0;
            foreach( $data['modules'] as $module_id ) {
                $module_counter++;
                if( is_array($data['lessons_'.$module_id]) && sizeof($data['lessons_'.$module_id]) > 0 ) {
                    $lesson_counter = 0;
                    foreach( $data['lessons_'.$module_id] as $lesson_id ) {
                        $lesson_counter++;
                        $sql = "INSERT INTO `".$wpdb->prefix."am_product_course_structure` ( `product_id`, `module_id`, `lesson_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`, `module_position`, `lesson_position` ) VALUES ( '".$product_id."', '".$module_id."', '".$lesson_id."', '".strtotime($data['free_access_start_'.$module_id.'_'.$lesson_id])."', '".strtotime($data['free_access_end_'.$module_id.'_'.$lesson_id])."', '".$data['evergreen_start_day_'.$module_id.'_'.$lesson_id]."', '".$data['evergreen_start_hour_'.$module_id.'_'.$lesson_id]."', '".$data['evergreen_end_day_'.$module_id.'_'.$lesson_id]."', '".$data['evergreen_end_hour_'.$module_id.'_'.$lesson_id]."', '".$data['days_delay_'.$module_id.'_'.$lesson_id]."', '".$data['tokens_'.$module_id.'_'.$lesson_id]."', '".$module_counter."', '".$lesson_counter."' )";
                        $wpdb->query($sql);
						$lastid = $wpdb->insert_id;
                    }
                }
            }
        }
        
        $this->am_insert_product_page( $data, $product_id );
		
		
		//Insert Product Pages Structure
		if(count($data['product_secure_pages'])>0){
			for($i=0; $i<count($data['product_secure_pages']); $i++){
			
				$page_id = $data['product_secure_pages'][$i];
				
				if(count($data['page_free_access_start'][$page_id])>0){
					$structure_arr = $data['page_free_access_start'][$page_id];	
				}elseif(count($data['page_free_access_end'][$page_id])>0){
					$structure_arr = $data['page_free_access_end'][$page_id];	
				}elseif(count($data['page_days_delay'][$page_id])>0){
					$structure_arr = $data['page_days_delay'][$page_id];	
				}elseif(count($data['page_evergreen_start_day'][$page_id])>0){
					$structure_arr = $data['page_evergreen_start_day'][$page_id];	
				}elseif(count($data['page_evergreen_start_hour'][$page_id])>0){
					$structure_arr = $data['page_evergreen_start_hour'][$page_id];	
				}elseif(count($data['page_evergreen_end_day'][$page_id])>0){
					$structure_arr = $data['page_evergreen_end_day'][$page_id];	
				}elseif(count($data['page_evergreen_end_hour'][$page_id])>0){
					$structure_arr = $data['page_evergreen_end_hour'][$page_id];	
				}elseif(count($data['page_coins'][$page_id])>0){
					$structure_arr = $data['page_coins'][$page_id];	
				}	
					
				if(count($structure_arr)>0){	
					for($j=0; $j<count($structure_arr); $j++){
						
						if($data['enable_sumit']=='yes'){
						$page_free_access_start = $data['page_free_access_start'][$page_id][$j];
						$page_free_access_end = $data['page_free_access_end'][$page_id][$j];
						}else{
						$page_free_access_start = "";
						$page_free_access_end = "";	
						}
						
						if($data['enable_evergreen']=='yes'){
						$page_evergreen_start_day = $data['page_evergreen_start_day'][$page_id][$j];
						$page_evergreen_start_hour = $data['page_evergreen_start_hour'][$page_id][$j];
						$page_evergreen_end_day = $data['page_evergreen_end_day'][$page_id][$j];
						$page_evergreen_end_hour = $data['page_evergreen_end_hour'][$page_id][$j];
						}else{
						$page_evergreen_start_day = "";
						$page_evergreen_start_hour = "";
						$page_evergreen_end_day = "";
						$page_evergreen_end_hour = "";	
						}
						
						if($data['enable_delay_access']=='yes'){
						$page_days_delay = $data['page_days_delay'][$page_id][$j];
						}else{
						$page_days_delay = "";
						}
						
						if($data['enable_coins']=='yes'){
						$page_coins = $data['page_coins'][$page_id][$j];
						}else{
						$page_coins = "";
						}
						
						
						$sql2222 = "INSERT INTO `".$wpdb->prefix."am_product_pages_structure` ( `product_id`, `page_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`) VALUES ( '".$product_id."', '".$page_id."', '".strtotime($page_free_access_start)."', '".strtotime($page_free_access_end)."', '".$page_evergreen_start_day."', '".$page_evergreen_start_hour."', '".$page_evergreen_end_day."', '".$page_evergreen_end_hour."', '".$page_days_delay."', '".$page_coins."')";
                        $wpdb->query($sql2222);
					}
				}
					
			}//end for
		}//end if
		
		//Insert Product Posts Structure
		if(count($data['product_secure_posts'])>0){
			for($k=0; $k<count($data['product_secure_posts']); $k++){
			
				$post_id = $data['product_secure_posts'][$k];
				
				if(count($data['post_free_access_start'][$post_id])>0){
					$structure_arr2 = $data['post_free_access_start'][$post_id];	
				}elseif(count($data['post_free_access_end'][$post_id])>0){
					$structure_arr2 = $data['post_free_access_end'][$post_id];	
				}elseif(count($data['post_days_delay'][$post_id])>0){
					$structure_arr2 = $data['post_days_delay'][$post_id];	
				}elseif(count($data['post_evergreen_start_day'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_start_day'][$post_id];	
				}elseif(count($data['post_evergreen_start_hour'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_start_hour'][$post_id];	
				}elseif(count($data['post_evergreen_end_day'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_end_day'][$post_id];	
				}elseif(count($data['post_evergreen_end_hour'][$post_id])>0){
					$structure_arr2 = $data['post_evergreen_end_hour'][$post_id];	
				}elseif(count($data['post_coins'][$post_id])>0){
					$structure_arr2 = $data['post_coins'][$post_id];	
				}	
					
				if(count($structure_arr2)>0){	
					for($l=0; $l<count($structure_arr2); $l++){
						
						if($data['enable_sumit']=='yes'){
						$post_free_access_start = $data['post_free_access_start'][$post_id][$l];
						$post_free_access_end = $data['post_free_access_end'][$post_id][$l];
						}else{
						$post_free_access_start = "";
						$post_free_access_end = "";	
						}
						
						if($data['enable_evergreen']=='yes'){
						$post_evergreen_start_day = $data['post_evergreen_start_day'][$post_id][$l];
						$post_evergreen_start_hour = $data['post_evergreen_start_hour'][$post_id][$l];
						$post_evergreen_end_day = $data['post_evergreen_end_day'][$post_id][$l];
						$post_evergreen_end_hour = $data['post_evergreen_end_hour'][$post_id][$l];
						}else{
						$post_evergreen_start_day = "";
						$post_evergreen_start_hour = "";
						$post_evergreen_end_day = "";
						$post_evergreen_end_hour = "";	
						}
						
						if($data['enable_delay_access']=='yes'){
						$post_days_delay = $data['post_days_delay'][$post_id][$l];
						}else{
						$post_days_delay = "";
						}
						
						if($data['enable_coins']=='yes'){
						$post_coins = $data['post_coins'][$post_id][$l];
						}else{
						$post_coins = "";
						}
						
						
						$sql3333 = "INSERT INTO `".$wpdb->prefix."am_product_pages_structure` ( `product_id`, `page_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`) VALUES ( '".$product_id."', '".$post_id."', '".strtotime($post_free_access_start)."', '".strtotime($post_free_access_end)."', '".$post_evergreen_start_day."', '".$post_evergreen_start_hour."', '".$post_evergreen_end_day."', '".$post_evergreen_end_hour."', '".$post_days_delay."', '".$post_coins."')";
                        $wpdb->query($sql3333);
					}
				}
					
			}//end for
		}//end if
		
        
        return $product_id;
    }
    
	public function am_admin_notice_license_error() {
		global $wpdb;
		$sql    = "SELECT * FROM `".$wpdb->prefix."am_orders` ";
		$results=$wpdb->get_results($sql);
		$order_count=50-count($results);
		$order_count=max($order_count,0);
			
			
		$sql    = "SELECT * FROM `".$wpdb->prefix."am_contacts`";
		$results=$wpdb->get_results($sql);
		$contact_count=500-count($results);
		$contact_count=max($contact_count,0);
			
		$sql    = "SELECT * FROM `".$wpdb->prefix."am_products`";
		$results  = $wpdb->get_results( $sql );	
		$product_count=1-count($results);
		$product_count=max($product_count,0);
			
		$am_lincense_key=constant('AM_LICENSE_KEY'); 
		
		if(empty($am_lincense_key))
		{
			$class = 'notice notice-error';
            $message = __( '<div>
<div style="width: 200px;margin-right: 5px; float: left;"><a href="https://accessmember.de/neukunden-upgrade" target="_blank" rel="noopener"><img class="aligncenter wp-image-1809 " src="https://accessmember.de/wp-content/uploads/2018/07/accessmember-400.png" alt="" width="166" height="173"></a></div>

<div style="width: 600px;margin-right: 20px; float: left;"><h2><span style="color: #556e8c;">NEUKUNDEN-AKTION! Aktion!</span></h2>
<strong>AccessMember PRO jetzt mit <span style="color: #ff7800;">100,- € Rabatt!</span>&nbsp;+ inkl. 10.000 E-Mail Kontakte</strong>
<div><a href="https://accessmember.de/neukunden-upgrade" target="_blank" rel="noopener" class="btcta" id="btcta" style="
    display: inline-block;
    text-align: center;
    vertical-align: middle;
    padding: 10px 12px;
    border: 1px solid #b37a00;
    border-radius: 8px;
    background: #ffdd03;
    background: -webkit-gradient(linear, left top, left bottom, from(#ffdd03), to(#e3a300));
    background: -moz-linear-gradient(top, #ffdd03, #e3a300);
    background: linear-gradient(to bottom, #ffdd03, #e3a300);
    text-shadow: #805700 1px 1px 1px;
    font: normal normal bold 15px arial;
    color: #ffffff;
	margin-top:5px;
	margin-bottom:5px;
    text-decoration: none;">HIER KLICKEN & mehr erfahren</a><br>
   			Du kannst noch '.$product_count.' weitere Produkte, '.$order_count.' weitere Kunden, und '.$contact_count.' weitere E-Mail Kontakte hinzufügen. Schalte <a href="https://accessmember.de/neukunden-upgrade">hier</a> die Pro-Version frei.</div>
<div></div>
&nbsp;</div>

<div style="width: 200px;margin-right: 0px; float: left;"></div>

<div style="clear: both;"></div>
</div>', 'am' );

           printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
			
		}
		
		
	}
	 
    public function am_admin_notice_error() {
        global $wpdb;
        $am_plugin_valid = get_option( 'am_plugin_valid' );
        if( $am_plugin_valid != 'true' ) {
            $class = 'notice notice-error';
            $message = __( 'Irks! An error has occurred. Your license key for the Access Member plugin is not valid.', 'am' );

            printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
        }
		

	
	
	}
    
    public function am_settings() {
		
		$is_requesting = !empty( $_GET[ 'ds24_do_connect' ] );
		$is_returning  = !empty( $_GET[ 'ds24_connected' ] ) && $_GET[ 'ds24_connected' ] == 'Y';
		$is_aborting   = !empty( $_GET[ 'ds24_connected' ] ) && $_GET[ 'ds24_connected' ] != 'Y';
		$current_url = (empty( $_SERVER['HTTPS'] ) ? 'http://' : 'https://' )
             . $_SERVER['HTTP_HOST']
             . $_SERVER['SCRIPT_NAME'];
			 
			 
		$return_url = "$current_url?page=am&ds24_connected=Y";
        $cancel_url = "$current_url?page=am&ds24_connected=N";
		define( 'YOUR_DEVELOPER_API_KEY', '417625-IdtRt7oXO9v64eiCNUhYemmnvGGIlEowH5NYXlUW' ); // replace by your api key (permission: "developer") - see https://www.digistore24.com/vendor/settings/account_access/api

		require dirname(__file__).'/ds24_api.php';
		
		$permissions = DS_API_WRITABLE;    // Permission of the new api key: DS_API_READONLY or DS_API_WRITABLE
		if($is_requesting)
		{
			try
			{
				

				

				$developer_api = DigistoreApi::connect( YOUR_DEVELOPER_API_KEY );
				$data = $developer_api->requestApiKey( $permissions, $return_url, $cancel_url );
				$developer_api->disconnect();
	
				$request_url   = trim($data->request_url);
				
				file_put_contents(dirname(__file__)."/req.log",$request_url."\n",FILE_APPEND);
				$request_token = $data->request_token;

					
				// Store the request token for step 3.
				update_option('DS24_TOKEN',$request_token);
				//$wp_session['DS24_TOKEN'] = $request_token;
				
				$headers_sent = headers_sent();
				if ($headers_sent)
				{
					
					file_put_contents(dirname(__file__)."/req.log","working1"."\n",FILE_APPEND);
					echo "
					<script type='text/javascript'>
					location.href=\"$request_url\";
					</script>
					";
					
				}
				else
				{
					file_put_contents(dirname(__file__)."/req.log","working2"."\n",FILE_APPEND);
					wp_redirect($request_url);
				}
				exit;
			
			}
			catch (DigistoreApiException $e)
			{
				$error_message = $e->getMessage();

				
			}
			
		}
	    elseif ($is_returning)
		{		
	
			try
			{
				
				$request_token = get_option('DS24_TOKEN');
				
				

				$developer_api = DigistoreApi::connect( YOUR_DEVELOPER_API_KEY );
				$data = $developer_api->retrieveApiKey( $request_token );
				$developer_api->disconnect();

				if (empty($data->api_key))
				{
					throw new Exception( "The api key already has been retrieved. Maybe you reloaded the page." );
				}

				$api_key = $data->api_key;
				
				$api = DigistoreApi::connect( $api_key );
				$notification_url=site_url().'/?am_digistore24_ipn=yes';
				$domain=site_url();
				$domain_id=str_replace(array("http://","https://","www."),"",$domain);
				
				$data = $api->ipnSetup($notification_url,'AccessMember at '.$domain_id,'all',$domain_id,'orders','all','delayed');
				
				
				$options = get_option( 'am_settings', array() );
				$options['digistore24_api_key'] = html_entity_decode(stripslashes($api_key));
				
            
				update_option( 'am_settings', $options );
				
				$headers_sent = headers_sent();
				$setting_url='admin.php?page=am';
			
				if ($headers_sent)
				{
					
					echo "
					<script type='text/javascript'>
					location.href=\"$setting_url\";
					</script>
					";
					
				}
				else
				{
				
					wp_redirect( "Location: $setting_url" );
				}
				
				
				
		}

		
		
		 catch (DigistoreApiException $e)
		{
			$error_message = $e->getMessage();

		}

		}	
		if(isset($_REQUEST['action']) && $_REQUEST['action']=='load_demo_contents'){
			
			global $wpdb;
			
			$created_date = date('Y-m-d G:i:s');
			
			 //Insert Demo Lessons one
			 $post_contents = '<iframe src="https://www.youtube.com/embed/2MpUj-Aua48" width="560" height="315" frameborder="0" allowfullscreen="allowfullscreen"></iframe>';
			 $my_post = array(
			  'post_title'    => 'Demo Lesson One',
			  'post_content'  => $post_contents,
			  'post_status'   => 'publish',
			  'post_type'   => 'lessons',
			  'post_author'   => 1
			 );
			 //Insert the post into the database
			 $lesson_id_one = wp_insert_post($my_post);
			 
			 
			 //Insert Demo Lessons one
			 $post_contents2 = '<iframe width="560" height="315" src="https://www.youtube.com/embed/6jiNS_4CEug" frameborder="0" allowfullscreen></iframe>';
			 $my_post = array(
			  'post_title'    => 'Demo Lesson Two',
			  'post_content'  => $post_contents2,
			  'post_status'   => 'publish',
			  'post_type'   => 'lessons',
			  'post_author'   => 1
			 );
			 //Insert the post into the database
			 $lesson_id_two = wp_insert_post($my_post);
			
			
			 //Insert Product
			 $sql = "INSERT INTO `".$wpdb->prefix."am_products` (`product_name`,`product_image`,`enable_sumit`,`enable_delay_access`,`enable_evergreen`,`enable_coins`,`logo`,`top_header_gradient_color1`,`top_header_gradient_color2`,`top_header_content`,`content_top_gradient_color1`,`content_top_gradient_color2`,`menu_position`,`module_bg_color`,`module_text_color`,`module_text_size`,`module_text_font`,`lesson_bg_color`,`lesson_text_color`,`lesson_text_size`,`lesson_text_font`,`access_symbol_active_color`,`access_symbol_inactive_color`,`access_active_color`,`access_inactive_color`,`module_tab`,`sticky_menu`,`scrollbar`,`auto_scroll`,`post_duriation_text_color`,`post_duriation_text_size`,`post_duriation_text_font`,`instructor_text_color`,`instructor_text_size`,`instructor_text_font`,`product_page`) 
			VALUES ('Demo Product','http://vizzwebsolutions.com/projects/accessmember/wp-content/uploads/2017/06/empty-img-300x300.png','yes','','','','http://accessmember.de/wp-content/uploads/2016/08/accessmember.png','#e8e8e8','#cccccc','','#dddddd','#bababa','left','#232b2d','#ffffff','14','Arial, Helvetica, sans-serif','#333f3c','#a3a3a3','12','','#78c8ce','#3f4c4f','#78c8ce','#b3cece','all_active','','','','#313b3d','10','Arial, Helvetica, sans-serif','#bbbbbb','12','Arial, Helvetica, sans-serif','7')";
			
			 $wpdb->query($sql);
			 $product_id = $wpdb->insert_id;
			 
			 //Insert Modules
			 $sql1 = "INSERT INTO `".$wpdb->prefix."am_modules` ( `id`, `name`, `module_timestamp` ) VALUES ( '', 'Module one', '".strtotime('now')."' )";
             $wpdb->query($sql1);
			 $module_id_one = $wpdb->insert_id;
			 
			 $sql2 = "INSERT INTO `".$wpdb->prefix."am_modules` ( `id`, `name`, `module_timestamp` ) VALUES ( '', 'Module two', '".strtotime('now')."' )";
             $wpdb->query($sql2);
			 $module_id_two = $wpdb->insert_id;
			 
			 //Insert Modules Lesson
			 $sql1 = "INSERT INTO `".$wpdb->prefix."am_product_course_structure` ( `product_id`, `module_id`, `lesson_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`, `module_position`, `lesson_position` ) 
			 VALUES (".$product_id.", ".$module_id_one.", ".$lesson_id_one .", '1483272360', '1514721960', '0', '00', '0', '00', '0', '', '2', '1')";
			 $wpdb->query($sql1);
			 
			 
			 $sql2 = "INSERT INTO `".$wpdb->prefix."am_product_course_structure` ( `product_id`, `module_id`, `lesson_id`, `free_access_start`, `free_access_end`, `evergreen_start_day`, `evergreen_start_hour`, `evergreen_end_day`, `evergreen_end_hour`, `days_delay`, `coins`, `module_position`, `lesson_position` ) 
			 VALUES (".$product_id.", ".$module_id_two.", ".$lesson_id_two .", '1483272360', '1514721960', '0', '00', '0', '00', '0', '', '1', '1')";
			 $wpdb->query($sql2);
			 
			 
			 //Insert Product Page
			 global $user_ID, $wpdb;
			 $page['post_type']    = 'page';
			 $page['post_author']  = $user_ID;
			 $page['post_status']  = 'publish';
			 $page['comment_status'] = 'open';
			 $page['post_title']   = 'Demo Product';
			 $page['post_content'] = '[am_product id="'.$product_id.'"]';
	
			 $pageid = wp_insert_post( $page, true );
	
			 if($pageid != 0){  
				$sql = "UPDATE `".$wpdb->prefix."am_products` SET `product_page` = '".$pageid."', `login_redirect` = '".$pageid."' WHERE id = '".$product_id."'";
				$wpdb->query($sql);
				$options = get_option( 'am_settings', array() );
				if( !empty($options['wp_page_template'])) {
					update_post_meta( $pageid, '_wp_page_template', $options['wp_page_template'] );
					update_post_meta( $pageid, '_am_product_id', $product_id );
				}
			 }
			 
			 
			 //Insert Templates
			 $email_contents = '<p>Hallo [NAME],</p>

								<p>ein Klick fehlt noch! Bitte bestätige jetzt Deine E-Mail Adresse:</p>
								
								<p>[LINK]</p>
								
								<p>Dadurch weiß ich, dass diese E-Mail Adresse tatsächlich Dir gehört und kann Dir die gewünschten Informationen zusenden.</p>
									
								<p>Viele Grüße</p>
								
								<p>Max Mustermann</p>';
			 
			 $sql_template = "INSERT INTO `".$wpdb->prefix."am_newsletter` ( `template_name`, `from_name`, `from_email`, `subject`, `mail_content`, `company_name`, `address`, `link_tracking`, `type`, `status`, `created_date` ) 
			 VALUES ('Demo Email Template', 'Test Company Name', 'test@gmail.com', 'Test Subject', '". $email_contents."', 'Demo Company Name', 'Demo Address', '1', 'email_series', '0', '".$created_date."')";
			 $wpdb->query($sql_template);
			 
			 
			 $sql_template22 = "INSERT INTO `".$wpdb->prefix."am_newsletter` ( `template_name`, `from_name`, `from_email`, `subject`, `mail_content`, `company_name`, `address`, `link_tracking`, `type`, `status`, `created_date` ) 
			 VALUES ('Demo Email Template', 'Test Company Name', 'test@gmail.com', 'Test Subject', '". $email_contents."', 'Demo Company Name', 'Demo Address', '1', 'newsletter', '0', '".$created_date."')";
			 $wpdb->query($sql_template22);
			 
			
			  update_option('load_demo_contents', 'yes');
			  $message =  "Demo Contents Loaded Successfully";
			  
		}//End Load Demo Contents
		
		
		if(isset($_REQUEST['action']) && $_REQUEST['action']=='delete_demo_contents'){
			
			   global $wpdb;
			
			   $wpdb->query("TRUNCATE TABLE `".$wpdb->prefix."am_modules`");
			   $wpdb->query("TRUNCATE TABLE `".$wpdb->prefix."am_product_course_structure`");
			   $wpdb->query("TRUNCATE TABLE `".$wpdb->prefix."am_products`");
			   $wpdb->query("TRUNCATE TABLE `".$wpdb->prefix."am_newsletter`");
				
			   $sql2 = "DELETE FROM `".$wpdb->prefix."posts` WHERE `post_type` = 'lessons' ";
			   $wpdb->query($sql2);
				
			   delete_option('load_demo_contents');
			   $message =  "Demo Contents Deleted Successfully";
			   
		}//End Delete Demo Contents
		
		
		if(isset($_REQUEST['action']) && $_REQUEST['action']=='update_theme_files') {
			 
		copy( AM_PLUGIN_PATH."templates/front/am_products_template.php",get_template_directory()."/am_products_template.php" );
        copy( AM_PLUGIN_PATH."templates/front/am_offers_template.php",get_template_directory()."/am_offers_template.php" );
		
		}
			
        
        if( isset($_POST['btnsave']) && $_POST['btnsave'] != "" ) {
            
            $exclude = array('btnsave');
            $options = get_option( 'am_settings', array() );
			
		   /* Changes by ilyaskhan for Default page templates 
			* on 27-02-2017
			*/
			$_POST['wp_page_template'] = "am_products_template.php";
			$_POST['wp_offer_page_template'] = "am_offers_template.php";
		   /* End Changes here by ilyaskhan
		    * on 27-02-2017
		    */
			
            
            foreach( $_POST as $k => $v ) {
                if( !in_array( $k, $exclude )) {
                    $options[$k] = html_entity_decode(stripslashes($v));
                }
            }
			
			/*
			//Update User Data
			wp_update_user( array(
				'ID' => $_POST[ 'user_id' ],
				'display_name' => $_POST[ 'sender_name' ],
				'user_email' => $_POST[ 'sender_email' ]
		    )); 
            */
            update_option( 'am_settings', $options );
            $message = 'Settings Saved Successfully!';
			
			
			
			/////////////////////////////////////////////////////////////////////
			//////////////////******Check Plugin License Key *****///////////////
			/////////////////////////////////////////////////////////////////////
			if($_POST['am_license_key'] !=""){
				
				$license_key = $_POST['am_license_key'];
				
				$check_license = $this->am_varify_license_key($license_key);
				
			
				
				if($check_license){
				
				?>	
                
				<script>
                window.location = "admin.php?page=am&msg";
                </script>	
                    
                <?php
				    	
				}else{ ?>
                
                <script>
                window.location = "admin.php?page=am&error";
                </script>	
					
			<?php	}
			
			}
			/////////////////////////////////////////////////////////////////////
			//////////////////****** End Check Plugin License Key *****//////////
			/////////////////////////////////////////////////////////////////////
			
        }
        
        wp_enqueue_script('wp-color-picker');
        wp_enqueue_script('media-upload');
        wp_enqueue_script('thickbox');
        wp_enqueue_style('thickbox');
        wp_enqueue_style( 'wp-color-picker' );
        
        $fonts = $this->am_get_html_fonts();
            
        $data = $this->am_get_digistore24_products();
        
        $templates = get_page_templates();
        
        $options = get_option( 'am_settings', array() );
	
		
		
		/* Changes by ilyaskhan for Prefill User information in Serder fields 
		 * on 27-02-2017
		 */
		$current_user = wp_get_current_user();
		/* End Changes here by ilyaskhan
		 * on 27-02-2017
		 */
		
		$is_valid_license_key=$this->am_varify_license_key($options['am_license_key']);
		
	
        
        require_once AM_PLUGIN_PATH.'templates/admin/settings.php';
        
        $this->load_javascript();
    }
        
    public function am_reports() {
        
    }
    
    private function load_javascript() {
        require_once AM_PLUGIN_PATH.'templates/admin/load_media_upload_js.php';        
    }
	
	
	public function am_send_preview_email() {
		
		$send_preview_email = $_REQUEST['send_preview_email'];
		
		$from_name = $_REQUEST['from_name'];
		$from_email = $_REQUEST['from_email'];
		$subject = $_REQUEST['subject'];
		$company_name = $_REQUEST['company_name'];
		$address = $_REQUEST['address'];
		
		$email_contents = $_REQUEST['email_contents']."<p>Impressum:<br>{accountaddress}</p>";
		$bodyText = "";
		
		$recipients = array($send_preview_email);
		$response = Send_Elastic_Email($recipients, $subject, $from_email, $from_name, $bodyText, $email_contents);
		
		/*echo "<pre>";
		print_r($response);
		exit;*/
		
		if($response->error ==""){
			echo "1";
		}else{
			echo $response->error;	
		}
		
		exit;
    }
	
	public function am_save_elastic_api()
	{
		update_option( 'elastic_email_subaccount_apikey',$_POST['api_key']);
		
		echo "1";
		
		exit;
		
		
	}
	
	
	// By Ali //
	public function GetEmailTemplate(){
		
		$Template_ID = $_POST['Template_ID'];
		
		global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE type = 'email_series' AND id = '".$Template_ID."'";
        $GetEmail_Template = $wpdb->get_row($sql);
		echo  json_encode($GetEmail_Template); exit;
	}// End of GetEmailTemplate
	
	public function GetNewsletterTemplate(){
				
		
		$Template_ID = $_POST['Template_ID'];
		ob_end_clean();
		global $wpdb;
        $sql = "SELECT * FROM `".$wpdb->prefix."am_newsletter` WHERE type = 'newsletter' AND id = '".$Template_ID."'";
        $GetEmail_Template = $wpdb->get_row($sql);
		//file_put_contents(dirname(__file__)."/testing.log",print_r($GetEmail_Template,true));
		echo  json_encode($GetEmail_Template); exit;
	}// END of GetNewsletterTemplate
	
	public function IsNewsletter_exist($id){
				
		$Template_ID = $id;
		
		global $wpdb;
        $sql = "SELECT id FROM `".$wpdb->prefix."am_newsletter` WHERE type = 'newsletter' AND status='0' AND id = '".$Template_ID."'";
        $GetEmail_Template = $wpdb->get_row($sql);
		if(empty($GetEmail_Template)){ return false;} else { return true;}
	}
	
	public function nooffcaontacts(){
		ob_end_clean();
		global $wpdb;		
		$sereailize  =  $_REQUEST['array'];
		parse_str($sereailize, $array);
				//Get Filtered Contacts
			 	$filtered_contacts = $this->am_get_filtered_contacts($array,"active");
				$count  = count($filtered_contacts);
				echo $count; 
		exit;				
	}// END of nooffcaontacts
	
	
   public function sendmail(){
		ob_end_clean();
		global $wpdb;	 
		$sereailize  =  $_REQUEST['array'];
		parse_str($sereailize, $post);
		$status = 1;
		
		//Get Filtered Contacts
		$filtered_contacts = $this->am_get_filtered_contacts($post,"active");
		
		
		
		if($_REQUEST['action_page']== 'Add_NewsLetter'){
		
		$created_date = date('Y-m-d G:i:s');
		if($post['trigger_email_type'] =='instant'){
			$trigger_date_time = date("Y-m-d G:i:s");
		}else{
			$trigger_date_time = date("Y-m-d G:i:s", strtotime($post['trigger_date_time']));
		}
				
		$sql = "INSERT INTO `".$wpdb->prefix."am_newsletter` (`template_name`, `from_name`, `from_email`, `subject`, `mail_content`, `company_name`, `address`, `link_tracking`, `send_preview_email`, `type`, `trigger_email_type`, `trigger_date_time`, `status`, `created_date` ) VALUES ('".$post['template_name']."', '".$post['from_name']."', '".$post['from_email']."', '".$post['subject']."', '".$_REQUEST['mail_content']."', '".$post['company_name']."', '".$post['address']."', '".$post['link_tracking']."', '".$post['send_preview_email']."', 'newsletter', '".$post['trigger_email_type']."', '".$trigger_date_time."', '".$status."', '".$created_date."')";
		
		$wpdb->query($sql);
		
		$newsletter_id = $wpdb->insert_id;
				
		/////////////////////////////////////////////////////////////////////
		//////////////////****** Insert Email Contacts *****////////////////
		////////////////////////////////////////////////////////////////////
		foreach($filtered_contacts as $contact){
			
		//Insert Data into DB
		$sql_query = "INSERT INTO `".$wpdb->prefix."am_newsletter_schedules` (`newsletter_id`, `contact_id`, `schedule_date`, `status`) 
				VALUES ('".$newsletter_id."', '".$contact->id."', '".$trigger_date_time."', '0')";

		$wpdb->query($sql_query);
		$schedule_id = $wpdb->insert_id;	
			
		
		$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_filtered_contacts` (`schedule_id`, `newsletter_id`, `transactionid`, `messageid`, `contact_id`,`sent_status`,`opened`,`clicked`, `status`, `created_date`) VALUES ('".$schedule_id."', '".$newsletter_id."', '".$contact->transactionid."', '".$contact->messageid."', '".$contact->id."', '".$contact->sent_status."', '0','0', '".$contact->email_status."', '".$created_date."')";
		$wpdb->query($sql_tags);
		
		}
		/////////////////////////////////////////////////////////////////////
		//////////////////****** End Insert Email Contacts *****////////////
		////////////////////////////////////////////////////////////////////
				
		//Insert Tags
		$post_tags = $post['tags_id'];
		foreach($post_tags as $key=>$tag){
			
		$tag_id = $key;
		$tag_value = $tag;	
		
		$sql_tags = "INSERT INTO `".$wpdb->prefix."am_newsletter_tags` (`newsletter_id`, `tag_id`, `value`) VALUES ('".$newsletter_id."', '".$tag_id."', '".$tag_value."')";
		$wpdb->query($sql_tags);
		
		}
				
		//Insert opended email
		$opened_emails = $post['opened_emails'];
		
		if(count($opened_emails)>0){
		foreach($opened_emails as $key=>$opened){
			
		$email_id = $key;
		$email_value = $opened;	
		
		$sql_opened = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'opened')";
		$wpdb->query($sql_opened);
		
		}
		}
				
		//Insert clicked email
		$clicked_emails = $post['clicked_emails'];
		if(count($clicked_emails)>0){
		foreach($clicked_emails as $key=>$clicked){
			
		$email_id = $key;
		$email_value = $clicked;	
		
		$sql_clicked = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'clicked')";
		$wpdb->query($sql_clicked);
		
		}
		}
				
		//Insert sent email
		$sent_emails = $post['sent_emails'];
		if(count($sent_emails)>0){
		foreach($sent_emails as $key=>$sent){
			
		$email_id = $key;
		$email_value = $sent;	
		
		$sql_sent = "INSERT INTO `".$wpdb->prefix."am_newsletter_emails_tags` (`newsletter_id`, `email_id`, `email_value`, `email_type`) VALUES ('".$newsletter_id."', '".$email_id."', '".$email_value."', 'sent')";
		$wpdb->query($sql_sent);
		
		}
		}
				
		//Insert Lesson Finished
		$lesson_finished = $post['lesson_finished'];
		if(count($lesson_finished)>0){
		foreach($lesson_finished as $key=>$lesson){
			
		$lesson_id = $key;
		$lesson_value = $lesson;	
		
		$sql_lesson = "INSERT INTO `".$wpdb->prefix."am_newsletter_lesson_tags` (`newsletter_id`, `lesson_id`, `lesson_value`) VALUES ('".$newsletter_id."', '".$lesson_id."', '".$lesson_value."')";
		$wpdb->query($sql_lesson);
		
		}
		}
				
		//Insert Purchased Products
		$purchased_product = $post['purchased_product'];
		if(count($purchased_product)>0){
		foreach($purchased_product as $key=>$product){
			
		$product_id = $key;
		$product_value = $product;	
		
		$sql_product = "INSERT INTO `".$wpdb->prefix."am_newsletter_product_tags` (`newsletter_id`, `product_id`, `product_value`) VALUES ('".$newsletter_id."', '".$product_id."', '".$product_value."')";
		$wpdb->query($sql_product);
		
		}
		}
				
		//Insert Opted forms
		$opted_in = $post['opted_in'];
		if(count($opted_in)>0){
		foreach($opted_in as $key=>$opted){
			
		$opted_id = $key;
		$opted_value = $opted;	
		
		$sql_opted = "INSERT INTO `".$wpdb->prefix."am_newsletter_optedfrom_tags` (`newsletter_id`, `opted_id`, `opted_value`) VALUES ('".$newsletter_id."', '".$opted_id."', '".$opted_value."')";
		$wpdb->query($sql_opted);
		
		}
		}
				
		//Insert Survey
		$survey_filter = $post['survey_filter'];
		if(count($survey_filter)>0){
		foreach($survey_filter as $key=>$survey){
			
		$survey_id = $key;
		$survey_value = $survey;	
		
		$sql_survey = "INSERT INTO `".$wpdb->prefix."am_newsletter_survey_tags` (`newsletter_id`, `survey_id`, `survey_value`) VALUES ('".$newsletter_id."', '".$survey_id."', '".$survey_value."')";
		$wpdb->query($sql_survey);
		
		}
		}
			
		// $url = admin_url()."admin.php?page=am_newsletter&action=edit&id=".$newsletter_id;
			$url = admin_url()."admin.php?page=am_newsletter";		
		
			/*if($post['trigger_email_type'] =='instant'){
			//	execute_schduler();
				$site_url=get_site_url()."?action=get_newsletter_schedules";
				//echo $site_url;
				wp_remote_get($site_url);

			}*/				
		
		}else{
		
		//Send Instant Message
		//print_r("here");
		$fromName  = $post['from_name']; 
		$fromEmail = $post['from_email']; 
		$subject   = $post['subject'];
		$company_name   = $post['company_name'];
		$address   = $post['address'];
		$bodyHtml  = $_REQUEST['mail_content'];
					
		if(count($filtered_contacts)>0){
		
			//file_put_contents(dirname(__file__)."/contacts.log",print_r($filtered_contacts,true),FILE_APPEND);
			foreach($filtered_contacts as $key => $contact){
			
				$schedule_id = $contact->id;
				$contact_name = $contact->name;
				$to_email = $contact->email_address;
				$recipients = array($to_email);
				$bodyText = "Text body";
				
				if (strpos($bodyHtml,'[NAME]') !== false)
				{
					$bodyHtml=str_replace('[NAME]', $contact_name ,$bodyHtml);
				}
				if (strpos($bodyHtml,'[EMAIL]') !== false)
				{
					$bodyHtml=str_replace('[EMAIL]', $to_email ,$bodyHtml);
				}
				if (strpos($bodyHtml,'[LINK]') !== false)
				{
					$bodyHtml=str_replace('[LINK]', $subcribelink ,$bodyHtml);
				}
				if($company_name != '')
				{
					if (strpos($bodyHtml,'[COMPANY]') !== false)
					{
						$bodyHtml=str_replace('[COMPANY]', $company_name ,$bodyHtml);
					}
				}
				if($address != '')
				{
					if (strpos($bodyHtml,'[ADDRESS]') !== false)
					{
						$bodyHtml=str_replace('[ADDRESS]', $address ,$bodyHtml);
					}
				}
				
				$Email_contents = $bodyHtml.'<p>Impressum:<br>{accountaddress}</p>';		
				
				$response = Send_Elastic_Email($recipients, $subject, $fromEmail, $fromName, $bodyText, $Email_contents);
				
				if($response->error !=""){
					
					echo $response->error;	
					exit;
				}
			}
		}
		
		}
		
		echo "1"."|".$url;
		exit;
				
	}// END of sendmail
	
	
	public function generate_password($length){
		
		//Generate Password
		$password='';
		$possible = "123467890abcdfghjkmnpqrtvwxyzABCDFGHJKLMNPQRTVWXYZ";
		$maxlength = strlen($possible);
		if ($length > $maxlength) {
			  $length = $maxlength;
			}
		$i = 0; 
		while ($i < $length) { 
			$char = substr($possible, mt_rand(0, $maxlength-1), 1);
			if (!strstr($password, $char)) { 
				$password .= $char;
				$i++;
			}
		}
		
		return $password;
	
	}//End generate_password
	
	
	public function send_user_credentails(){
		
		global $wpdb;
		
		$current_user = wp_get_current_user();	
		$sender_name = $current_user->display_name;
		$sender_email = $current_user->user_email;	
			
		$user_email  =  $_REQUEST['user_email'];
		
		$user = get_user_by('email',$user_email);
		$userId = $user->ID;
		$name = $user->data->display_name;
		
		$password = $this->generate_password(8);
		
		$mail_content = 'Hallo '.$name.',<br>

						 wie angefragt - hier Deine neuen Zugangsdaten:
						
						 Benutzer:
						 '.$user_email.'
						
						 Passwort:
						 '.$password.'
						
						 Viele Grüße,
						 '.$sender_name.' ';
		
		$body = nl2br($mail_content."<p>Impressum:<br>{accountaddress}</p>");
		$subject = "Dein neues Passwort";
		$blogname    = "Access Member"; 
		
		$email_address =  array($user_email);
		$response = Send_Elastic_Email($email_address, $subject, $sender_email, $blogname, $text, $body);
		
		if($response->error !=""){
			
			echo $response->error;
			exit;
			
		}else{
		
			wp_set_password( $password, $userId );
			
			echo "1";
			exit;
		}
						
	}// END of send_user_credentails
	
	
	public function am_auto_connect_elasticEmail() {
		
		$elastick_email_apikey = '8535ff91-62a5-48dd-af75-92e04c77af41';
	 	$admin_email = get_option('admin_email');
		
		//Generate Password
		$password='';
		$length = 8;
		$possible = "123467890abcdfghjkmnpqrtvwxyzABCDFGHJKLMNPQRTVWXYZ";
		$maxlength = strlen($possible);
		if ($length > $maxlength) {
			  $length = $maxlength;
			}
		$i = 0; 
		while ($i < $length) { 
		$char = substr($possible, mt_rand(0, $maxlength-1), 1);
		if (!strstr($password, $char)) { 
		$password .= $char;
		$i++;
		}
		}
		
		$url = 'https://api.elasticemail.com/v2/account/addsubaccount';
		$data = array(
					'apikey' => $elastick_email_apikey,
					'email' => $admin_email,
					'password' => $password,
					'confirmPassword' => $password,
					'requiresEmailCredits' => 'False',
					'enableLitmusTest' => 'False',
					'requiresLitmusCredits' => 'False',
					'maxContacts' => '20000',
					'dailySendLimit	' => '41000'
			
				);
		
		//use key 'http' even if you send the request to https://...
		$options = array(
			'http' => array(
				'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
				'method'  => 'POST',
				'content' => http_build_query($data)
			)
		);
		
		$context  = stream_context_create($options);
		$result = file_get_contents($url, false, $context);
		$result_arr = json_decode($result);
		$sub_account_api_key = $result_arr->data;
		
		
		if($result_arr->success ==1){
		
		update_option('elastic_email_subaccount_apikey', $sub_account_api_key);
		update_option( 'elastic_subAccount', 'yes');
		
		echo '1';
		exit;
		
		}else{
			
		//update_option( 'elastic_subAccount', 'no');	
		
		echo $result_arr->error;
		exit;
			
		}//end if account created
		
		
    }//End am_auto_connect_elasticEmail
	
	
	public function am_get_action_tag_filter_contacts() {
		
		$sereailize  =  $_REQUEST['Form_data'];
		parse_str($sereailize, $Form_data);
		
		//Get Filtered Contacts
		$filtered_contacts = $this->am_get_filtered_contacts($Form_data,'active');
		$count  = count($filtered_contacts);
		
		
		//file_put_contents(dirname(__file__)."/tags.log",print_r($Form_data,true),FILE_APPEND);
		
		
		
		//Tags
		if(!empty($Form_data['tags_id'])){
			$tags_id = $Form_data['tags_id'];
			foreach($tags_id as $key=>$tag){
				$id = $key;
				$value = $tag;
				if($value =='yes'){
					$tages_included .= $id."," ;	
				}else{
					$tages_excluded .= $id."," ;	
				}
			}
		}
		
		
		
		
		if($tages_included !=""){
		$tages_included = explode(',',rtrim($tages_included,','));
		}
		if($tages_excluded !=""){
		$tages_excluded = explode(',',rtrim($tages_excluded,','));
		}
		
		if(count($tages_included)>0){
			for($i=0; $i<count($tages_included); $i++){
				$tag_name = $this->get_tag_name($tages_included[$i]);
				$included_tags_string .= $tag_name.', ';	
			}
		}
		if(count($tages_excluded)>0){
			for($i=0; $i<count($tages_excluded); $i++){
				$tag_name = $this->get_tag_name($tages_excluded[$i]);
				$excluded_tags_string .= trim($tag_name).',';	
			}
		}
		
		//file_put_contents(dirname(__file__)."/tages_excluded.log",$excluded_tags_string."\n",FILE_APPEND);
		
		
		//Opened Emails
		if(!empty($Form_data['opened_emails'])){
			$opened_emails = $Form_data['opened_emails'];
			foreach($opened_emails as $key=>$email){
				$id = $key;
				$value = $email;
				if($value =='yes'){
					$opened_emails_included .= $id."," ;	
				}else{
					$opened_emails_excluded .= $id."," ;	
				}
			}
		}
		if($opened_emails_included !=""){
		$opened_emails_included = explode(',',rtrim($opened_emails_included,','));
		}
		if($opened_emails_excluded !=""){
		$opened_emails_excluded = explode(',',rtrim($opened_emails_excluded,','));
		}
		
		if(count($opened_emails_included)>0){
			for($i=0; $i<count($opened_emails_included); $i++){
				$name = $this->get_email_templete_subject($opened_emails_included[$i]);
				$opened_emails_included_string .= $name.', ';	
			}
		}
		if(count($opened_emails_excluded)>0){
			for($i=0; $i<count($opened_emails_excluded); $i++){
				$name = $this->get_email_templete_subject($opened_emails_excluded[$i]);
				$opened_emails_excluded_string .= $name.', ';	
			}
		}
		
		
		//Clicked Emails
		if(!empty($Form_data['clicked_emails'])){
			$clicked_emails = $Form_data['clicked_emails'];
			foreach($clicked_emails as $key=>$email){
				$id = $key;
				$value = $email;
				if($value =='yes'){
					$clicked_emails_included .= $id."," ;	
				}else{
					$clicked_emails_excluded .= $id."," ;	
				}
			}
		}
		if($clicked_emails_included !=""){
		$clicked_emails_included = explode(',',rtrim($clicked_emails_included,','));
		}
		if($clicked_emails_excluded !=""){
		$clicked_emails_excluded = explode(',',rtrim($clicked_emails_excluded,','));
		}
		
		if(count($clicked_emails_included)>0){
			for($i=0; $i<count($clicked_emails_included); $i++){
				$name = $this->get_email_templete_subject($clicked_emails_included[$i]);
				$clicked_emails_included_string .= $name.', ';	
			}
		}
		if(count($clicked_emails_excluded)>0){
			for($i=0; $i<count($clicked_emails_excluded); $i++){
				$name = $this->get_email_templete_subject($clicked_emails_excluded[$i]);
				$clicked_emails_excluded_string .= $name.', ';	
			}
		}
		
		
		//Send Emails
		if(!empty($Form_data['sent_emails'])){
			$sent_emails = $Form_data['sent_emails'];
			foreach($sent_emails as $key=>$email){
				$id = $key;
				$value = $email;
				if($value =='yes'){
					$sent_emails_included .= $id."," ;	
				}else{
					$sent_emails_excluded .= $id."," ;	
				}
			}
		}
		if($sent_emails_included !=""){
		$sent_emails_included = explode(',',rtrim($sent_emails_included,','));
		}
		if($sent_emails_excluded !=""){
		$sent_emails_excluded = explode(',',rtrim($sent_emails_excluded,','));
		}
		
		if(count($sent_emails_included)>0){
			for($i=0; $i<count($sent_emails_included); $i++){
				$name = $this->get_email_templete_subject($sent_emails_included[$i]);
				$sent_emails_included_string .= $name.', ';	
			}
		}
		if(count($sent_emails_excluded)>0){
			for($i=0; $i<count($sent_emails_excluded); $i++){
				$name = $this->get_email_templete_subject($sent_emails_excluded[$i]);
				$sent_emails_excluded_string .= $name.', ';	
			}
		}
		
		
		
		//Lesson Finished
		if(!empty($Form_data['lesson_finished'])){
			$lesson_finished = $Form_data['lesson_finished'];
			foreach($lesson_finished as $key=>$lesson){
				$id = $key;
				$value = $lesson;
				if($value =='yes'){
					$lesson_finished_included .= $id."," ;	
				}else{
					$lesson_finished_excluded .= $id."," ;	
				}
			}
		}
		if($lesson_finished_included !=""){
		$lesson_finished_included = explode(',',rtrim($lesson_finished_included,','));
		}
		if($lesson_finished_excluded !=""){
		$lesson_finished_excluded = explode(',',rtrim($lesson_finished_excluded,','));
		}
		
		if(count($lesson_finished_included)>0){
			for($i=0; $i<count($lesson_finished_included); $i++){
				$name = get_the_title($lesson_finished_included[$i]);
				$lesson_finished_included_string .= $name.', ';	
			}
		}
		if(count($lesson_finished_excluded)>0){
			for($i=0; $i<count($lesson_finished_excluded); $i++){
				$name = get_the_title($lesson_finished_excluded[$i]);
				$lesson_finished_excluded_string .= $name.', ';	
			}
		}
		
		
		
		//Purchased Products
		if(!empty($Form_data['purchased_product'])){
			$purchased_product = $Form_data['purchased_product'];
			foreach($purchased_product as $key=>$product){
				$id = $key;
				$value = $product;
				if($value =='yes'){
					$purchased_product_included .= $id."," ;	
				}else{
					$purchased_product_excluded .= $id."," ;	
				}
			}
		}
		if($purchased_product_included !=""){
		$purchased_product_included = explode(',',rtrim($purchased_product_included,','));
		}
		if($purchased_product_excluded !=""){
		$purchased_product_excluded = explode(',',rtrim($purchased_product_excluded,','));
		}
		
		if(count($purchased_product_included)>0){
			for($i=0; $i<count($purchased_product_included); $i++){
				$name = $this->get_product_name($purchased_product_included[$i]);
				$purchased_product_included_string .= $name.', ';	
			}
		}
		if(count($purchased_product_excluded)>0){
			for($i=0; $i<count($purchased_product_excluded); $i++){
				$name = $this->get_product_name($purchased_product_excluded[$i]);
				$purchased_product_excluded_string .= $name.', ';	
			}
		}
		
		
		
		//Optin Form
		if(!empty($Form_data['opted_in'])){
			$opted_in = $Form_data['opted_in'];
			foreach($opted_in as $key=>$form){
				$id = $key;
				$value = $form;
				if($value =='yes'){
					$opted_in_included .= $id."," ;	
				}else{
					$opted_in_excluded .= $id."," ;	
				}
			}
		}
		if($opted_in_included !=""){
		$opted_in_included = explode(',',rtrim($opted_in_included,','));
		}
		if($opted_in_excluded !=""){
		$opted_in_excluded = explode(',',rtrim($opted_in_excluded,','));
		}
		
		if(count($opted_in_included)>0){
			for($i=0; $i<count($opted_in_included); $i++){
				$name = $this->get_optid_form_name($opted_in_included[$i]);
				$opted_in_included_string .= $name.', ';	
			}
		}
		if(count($opted_in_excluded)>0){
			for($i=0; $i<count($opted_in_excluded); $i++){
				$name = $this->get_optid_form_name($opted_in_excluded[$i]);
				$opted_in_excluded_string .= $name.', ';	
			}
		}
		
		
		
		//Survey Filter
		if(!empty($Form_data['survey_filter'])){
			$survey_filter = $Form_data['survey_filter'];
			foreach($survey_filter as $key=>$survey){
				$id = $key;
				$value = $survey;
				if($value =='yes'){
					$survey_filter_included .= $id."," ;	
				}else{
					$survey_filter_excluded .= $id."," ;	
				}
			}
		}
		if($survey_filter_included !=""){
		$survey_filter_included = explode(',',rtrim($survey_filter_included,','));
		}
		if($survey_filter_excluded !=""){
		$survey_filter_excluded = explode(',',rtrim($survey_filter_excluded,','));
		}
		
		if(count($survey_filter_included)>0){
			for($i=0; $i<count($survey_filter_included); $i++){
				$name = $this->get_survey_name($survey_filter_included[$i]);
				$survey_filter_included_string .= $name.', ';	
			}
		}
		if(count($survey_filter_excluded)>0){
			for($i=0; $i<count($survey_filter_excluded); $i++){
				$name = $this->get_survey_name($survey_filter_excluded[$i]);
				$survey_filter_excluded_string .= $name.', ';	
			}
		}
		
		
		$reponse = '<p>'.__( 'Total Contacts Found', 'am' ).' : '.$count.'</p>';
		
		$reponse .='<span style="color: #45c545;">'.__( 'Included', 'am' ).': </span><br />';
		if($included_tags_string !=""){
		$reponse .='<p>'.__( 'Tags', 'am' ).': <span style="font-weight: 100;">'.rtrim($included_tags_string,', ').'</span></p>';
		}
		if($opened_emails_included_string !=""){
		$reponse .='<p>'.__( 'Opened', 'am' ).': <span style="font-weight: 100;">'.rtrim($opened_emails_included_string,', ').'</span></p>';
		}
		if($clicked_emails_included_string !=""){
		$reponse .='<p>'.__( 'Clicked', 'am' ).': <span style="font-weight: 100;">'.rtrim($clicked_emails_included_string,', ').'</span></p>';
		}
		if($sent_emails_included_string !=""){
		$reponse .='<p>'.__( 'Sent', 'am' ).': <span style="font-weight: 100;">'.rtrim($sent_emails_included_string,', ').'</span></p>';
		}
		if($lesson_finished_included_string !=""){
		$reponse .='<p>'.__( 'Lesson', 'am' ).': <span style="font-weight: 100;">'.rtrim($lesson_finished_included_string,', ').'</span></p>';
		}
		if($purchased_product_included_string !=""){
		$reponse .='<p>'.__( 'Products', 'am' ).': <span style="font-weight: 100;">'.rtrim($purchased_product_included_string,', ').'</span></p>';
		}
		if($opted_in_included_string !=""){
		$reponse .='<p>'.__( 'Optin Forms', 'am' ).': <span style="font-weight: 100;">'.rtrim($opted_in_included_string,', ').'</span></p>';
		}
		if($survey_filter_included_string !=""){
		$reponse .='<p>'.__( 'Survey', 'am' ).': <span style="font-weight: 100;">'.rtrim($survey_filter_included_string,', ').'</span></p>';
		}
		
		
		$reponse .='<span style="color: red;">'.__( 'Excluded', 'am' ).': </span><br />';
		if($excluded_tags_string !=""){
		$reponse .='<p>'.__( 'Tags', 'am' ).': <span style="font-weight: 100;">'.rtrim($excluded_tags_string,', ').'</span></p>';
		}
		if($opened_emails_excluded_string !=""){
		$reponse .='<p>'.__( 'Opened', 'am' ).': <span style="font-weight: 100;">'.rtrim($opened_emails_excluded_string,', ').'</span></p>';
		}
		if($clicked_emails_excluded_string !=""){
		$reponse .='<p>'.__( 'Clicked', 'am' ).': <span style="font-weight: 100;">'.rtrim($clicked_emails_excluded_string,', ').'</span></p>';
		}
		if($sent_emails_excluded_string !=""){
		$reponse .='<p>'.__( 'Sent', 'am' ).': <span style="font-weight: 100;">'.rtrim($sent_emails_excluded_string,', ').'</span></p>';
		}
		if($lesson_finished_excluded_string !=""){
		$reponse .='<p>'.__( 'Lesson', 'am' ).': <span style="font-weight: 100;">'.rtrim($lesson_finished_excluded_string,', ').'</span></p>';
		}
		if($purchased_product_excluded_string !=""){
		$reponse .='<p>'.__( 'Products', 'am' ).': <span style="font-weight: 100;">'.rtrim($purchased_product_excluded_string,', ').'</span></p>';
		}
		if($opted_in_excluded_string !=""){
		$reponse .='<p>'.__( 'Optin Forms', 'am' ).': <span style="font-weight: 100;">'.rtrim($opted_in_excluded_string,', ').'</span></p>';
		}
		if($survey_filter_excluded_string !=""){
		$reponse .='<p>'.__( 'Survey', 'am' ).': <span style="font-weight: 100;">'.rtrim($survey_filter_excluded_string,', ').'</span></p>';
		}
		
		echo $reponse;
		exit;	
		
	}//End am_get_action_tag_filter_contacts
	
	public function Pagination_limit($items,$limit) {
		
		if($items > 0) {
				$p = new pagination;
				$p->items($items);
				$p->limit($limit); // Limit entries per page
				$p->target("admin.php?page=am_email_series"); 
				$p->currentPage($_GET[$p->paging]); // Gets and validates the current page
				$p->calculate(); // Calculates what to show
				$p->parameterName('paging');
				$p->adjacents(1); //No. of page away from the current page
						 
				if(!isset($_GET['paging'])) {
					$p->page = 1;
				} else {
					$p->page = $_GET['paging'];
				}
				//Query for limit paging
				$limit = "LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit;	 
		} 
		return $p.'-'.$limit;
	}
	
	//am_generate_auto_key
	public function am_generate_auto_key(){
		
		$randnumber = '';
		$totalChar = 40;  //length of random number
		$salt = "0123456789abckefghijklmnopqrstuvwxyz";  // salt to select chars
		srand((double)microtime()*1000000); // start the random generator
		$password=""; // set the inital variable
		
		for ($i=0;$i<$totalChar;$i++)  // loop and create number
		$randnumber = $randnumber. substr ($salt, rand() % strlen($salt), 1);
		
		echo $randnumber;
		exit;
		
	}//end am_generate_auto_key
	
}

$am_admin = new AM_Admin();